#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <algorithm>
#include <cassert>
#include <random>
#include <ctime>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <deque>
#else
#include <bits/stdc++.h>
#include <bits/extc++.h>
#endif

#define all(q) q.begin(), q.end()
#define dind(p) p.first][p.second

using namespace std;
constexpr int CNT_BITS = 10;
constexpr int MOD_BITS = (1 << CNT_BITS) - 1;
constexpr int MAXN = 32;
constexpr int MAXK = 8;
constexpr int MAXM = (int)1e5;
bool painted[MAXN][MAXN];
int to_paint[MAXN][MAXN];
int cnt_painted;
int n, k, m;

void move(int x, int y) {
	for (int i = x; i < n; ++i) {
		for (int j = y; j < n; ++j) {
			if (painted[i][j])
				continue;
			painted[i][j] = true;
			++cnt_painted;
		}
	}
}

void make_move(int x, int y) {
	cout << x + 1 << ' ' << y + 1 << endl;
	move(x, y);
}

void get_move() {
	int x, y;
	cin >> x >> y;
	move(x - 1, y - 1);
}

void reset_desk() {
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j)
			painted[i][j] = false;
	cnt_painted = 0;
}

int to_int(const string &s) {
	int ans = 0;
	for (const char &c : s)
		ans = (ans << 1) + (c - '0');
	return ans;
}

void encode() {
	cin >> n >> k >> m;

	string s;
	cin >> s;
	if (m % CNT_BITS != 0) {
		int to_add = CNT_BITS - m % CNT_BITS;
		m += to_add;
		for (int i = 0; i < to_add; ++i)
			s.push_back('0');
	}
	vector<int> to_send;
	for (int i = 0; i < m; i += CNT_BITS)
		to_send.push_back(to_int(s.substr(i, CNT_BITS)));

	int game_num = 0;
	for (size_t i = 0; i < to_send.size();) {
		if (cnt_painted == n * n) {
			reset_desk();
			++game_num;
			if (game_num & 1)
				get_move();
		}

		for (int i = n - 1; i >= 0; --i) {
			for (int j = n - 1; j >= 0; --j) {
				to_paint[i][j] = !painted[i][j];
				if (i + 1 < n)
					to_paint[i][j] += to_paint[i + 1][j];
				if (j + 1 < n)
					to_paint[i][j] += to_paint[i][j + 1];
				if (i + 1 < n && j + 1 < n)
					to_paint[i][j] += to_paint[i + 1][j + 1];
			}
		}

		vector<pair<int, int>> pos((1 << CNT_BITS), make_pair(-1, -1));
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; ++j) {
				if (i == 0 && j == 0)
					continue;
				if (painted[i][j])
					continue;
				int mask = (i + j) & MOD_BITS;
				if (pos[mask] == make_pair(-1, -1) || to_paint[dind(pos[mask])] > to_paint[i][j])
					pos[mask] = make_pair(i, j);
			}
		}

		if (pos[to_send[i]] == make_pair(-1, -1)) {
			make_move(0, 0);
		} else {
			make_move(pos[to_send[i]].first, pos[to_send[i]].second);
			get_move();
			++i;
		}
	}

	if (cnt_painted < n * n) {
		make_move(0, 0);
	}

	cout << 0 << endl;
}

string to_bin(int x) {
	string ans = "";
	while (x || ans.length() < CNT_BITS) {
		ans.push_back('0' + (x & 1));
		x >>= 1;
	}
	reverse(all(ans));
	return ans;
}

void decode() {
	cin >> n >> k >> m;
	int q;
	cin >> q;
	string ans;

	int turn = 0, game = 0;
	int x, y;
	while (game < q) {
		cin >> x >> y;
		--x, --y;
		if (x == 0 && y == 0) {
			++game;
			turn = 0;
			continue;
		}
		if ((game & 1) == (turn & 1))
			ans += to_bin((x + y) & MOD_BITS);
		++turn;
	}

	cout << ans.substr(0, m) << endl;
}

int main(int argc, char *argv[]) {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int run_number;
	cin >> run_number;
	if (run_number == 1)
		encode();
	else
		decode();

	return 0;
}