#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 33;
int n, k, m;
int a[N][N];

void reset()
{
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= n; j++)
        {
            a[i][j] = 0;
        }
    }
}

void place(int x, int y)
{
    for (int i = x; i <= n; i++)
    {
        for (int j = y; j <= n; j++)
        {
            a[i][j] = 1;
        }
    }
}

pair<int, int> find_rows()
{
    for (int r = n; r >= 1; r--)
    {
        if (a[r][1] == 0)
        {
            for (int c = n; c >= 1; c--)
            {
                if (a[r][c] == 0)
                {
                    return {r, c};
                }
            }
        }
    }
    return {-1, -1};
}

pair<int, int> find_cols()
{
    for (int c = n; c >= 1; c--)
    {
        if (a[1][c] == 0)
        {
            for (int r = n; r >= 1; r--)
            {
                if (a[r][c] == 0)
                {
                    return {r, c};
                }
            }
        }
    }
    return {-1, -1};
}

pair<int, int> first_turn_gen(string &s, int &i)
{
    int x = n, y = n;
    if (i < s.size())
    {
        if (s[i] == '1') x -= 1;
        i++;
    }
    if (i < s.size())
    {
        if (s[i] == '1') x -= 2;
        i++;
    }
    if (i < s.size())
    {
        if (s[i] == '1') y -= 1;
        i++;
    }
    if (i < s.size())
    {
        if (s[i] == '1') y -= 2;
        i++;
    }
    return {x, y};
}

void first_turn_parce(string &s)
{
    int x, y;
    cin >> x >> y;
    int dx = n - x, dy = n - y;
    if (dx & 1) s += "1"; else s += "0";
    if (dx & 2) s += "1"; else s += "0";
    if (dy & 1) s += "1"; else s += "0";
    if (dy & 2) s += "1"; else s += "0";
    place(x, y);
    cin >> x >> y;
    place(x, y);
}

void play_game(int t, string &s, int &i)
{
    reset();
    if (t == 0)
    {
        pair<int, int> ft = first_turn_gen(s, i);
        cout << ft.first << " " << ft.second << endl;
        int x, y;
        cin >> x >> y;
        place(ft.first, ft.second);
        place(x, y);
        while (1)
        {
            int want = 0;
            if (i < s.size() && s[i] == '1') want = 1;
            pair<int, int> gR = find_rows();
            pair<int, int> gC = find_cols();
            if (a[1][1] == 1) return;
            if (gR == gC)
            {
                cout << gR.first << " " << gR.second << endl;
                if (gR.first == 1 && gR.second == 1)
                    return;
                int x, y;
                cin >> x >> y;
                place(gR.first, gR.second);
                place(x, y);
            }
            else
            {
                if (want == 0)
                {
                    int cnt = 1;
                    i++;
                    while (gR.second > 1 && i < s.size() && s[i] == '0')
                        gR.second--, i++, cnt++;
                    cout << gR.first << " " << gR.second << endl;
                    place(gR.first, gR.second);
                    int x, y;
                    cin >> x >> y;
                    place(x, y);
                }
                else
                {
                    int cnt = 1;
                    i++;
                    while (gC.first > 1 && i < s.size() && s[i] == '1')
                        gC.first--, i++, cnt++;
                    cout << gC.first << " " << gC.second << endl;
                    place(gC.first, gC.second);
                    int x, y;
                    cin >> x >> y;
                    place(x, y);
                }
            }
        }
    }
    else
    {
        int x, y;
        cin >> x >> y;
        place(x, y);
        while (1)
        {
            int want = 0;
            if (i < s.size() && s[i] == '1') want = 1;
            if (a[1][1] == 1) return;
            pair<int, int> gR = find_rows();
            pair<int, int> gC = find_cols();
            if (gR == gC)
            {
                cout << gR.first << " " << gR.second << endl;
                if (gR.first == 1 && gR.second == 1)
                    return;
                int x, y;
                cin >> x >> y;
                place(gR.first, gR.second);
                place(x, y);
            }
            else
            {
                if (want == 0)
                {
                    int cnt = 1;
                    i++;
                    while (gR.second > 1 && i < s.size() && s[i] == '0')
                        gR.second--, i++, cnt++;
                    cout << gR.first << " " << gR.second << endl;
                    place(gR.first, gR.second);
                    int x, y;
                    cin >> x >> y;
                    place(x, y);
                }
                else
                {
                    int cnt = 1;
                    i++;
                    while (gC.first > 1 && i < s.size() && s[i] == '1')
                        gC.first--, i++, cnt++;
                    cout << gC.first << " " << gC.second << endl;
                    place(gC.first, gC.second);
                    int x, y;
                    cin >> x >> y;
                    place(x, y);
                }
            }
        }
    }
}

void restore_game(int t, string &s)
{
    reset();
    if (t == 0)
    {
        first_turn_parce(s);
        while (1)
        {
            if (a[1][1] == 1) return;
            pair<int, int> gR = find_rows();
            pair<int, int> gC = find_cols();
            if (gR == gC)
            {
                int x, y;
                cin >> x >> y;
                place(x, y);
                if (x == 1 && y == 1)
                    return;
                cin >> x >> y;
                place(x, y);
            }
            else
            {
                pair<int, int> in;
                cin >> in.first >> in.second;
                if (in.first == gR.first)
                {
                    int cnt = gR.second - in.second + 1;
                    s += string(cnt, '0');
                }
                else
                {
                    int cnt = gC.first - in.first + 1;
                    s += string(cnt, '1');
                }
                place(in.first, in.second);
                int x, y;
                cin >> x >> y;
                place(x, y);
            }
        }
    }
    else
    {
        int x, y;
        cin >> x >> y;
        place(x, y);
        while (1)
        {
            if (a[1][1] == 1) return;
            pair<int, int> gR = find_rows();
            pair<int, int> gC = find_cols();
            if (gR == gC)
            {
                int x, y;
                cin >> x >> y;
                place(x, y);
                if (x == 1 && y == 1)
                    return;
                cin >> x >> y;
                place(x, y);
            }
            else
            {
                pair<int, int> in;
                cin >> in.first >> in.second;
                if (in.first == gR.first)
                {
                    int cnt = gR.second - in.second + 1;
                    s += string(cnt, '0');
                }
                else
                {
                    int cnt = gC.first - in.first + 1;
                    s += string(cnt, '1');
                }
                place(in.first, in.second);
                int x, y;
                cin >> x >> y;
                place(x, y);
            }
        }
    }
}

int main()
{
    int t;
    cin >> t;
    cin >> n >> k >> m;
    // n == 32, k == 8, m == 100000
    if (t == 1)
    {
        string s;
        cin >> s;
        int i = 0;
        while (i < m)
        {
            play_game(0, s, i);
            if (i >= m) break;
            play_game(1, s, i);
            if (i >= m) break;
        }
        cout << 0 << endl;
        return 0;
    }
    else
    {
        int g;
        cin >> g;
        string s = "";
        for (int i = 0; i < g; i++)
        {
            if (i % 2 == 0) restore_game(0, s);
            else restore_game(1, s);
        }
        for (int i = 0; i < m; i++)
        {
            cout << s[i];
        }
        cout << endl;
    }
}
