#define _CRT_SECURE_NO_WARNINGS



#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <queue>
#include <map>



#define ll long long
#define all(a) a.begin(), a.end()


using namespace std;


int n;
vector<vector<int>> ch;
vector<int> p;
vector<vector<int>> dp;
vector<vector<int>> d;
map<int, int> btrs;
vector<int> cmp_btrs;

int mxk;
int msm;


void mrg_dp2(vector<int> &d1, vector<int> &d2, vector<int> &rs) {
	for (int i = 0; i < msm; ++i) {
		if (d1[i] >= msm - 1) {
			rs[i] = min(rs[i], msm);
		}
		else {
			rs[i] = min(rs[i], d2[d1[i] + 1]);
		}
	}
}


void solve_k2(int v) {
	if (ch[v].size() > 0) {
		// dp[v].assign(msm, msm);
		for (auto dv : d[v]) {
			dp[v][dv] = dv;
		}
		for (int i = msm - 1; i >= 0; --i) {
			if (dp[v][i] == msm) {
				dp[v][i] = dp[v][i + 1];
			}
		}
	}
	else {
		for (auto to : ch[v]) {
			solve_k2(to);
		}
		if (ch[v].size() == 1) {
			dp[v] = dp[ch[v][0]];
		}
		else {
			mrg_dp2(dp[ch[v][0]], dp[ch[v][1]], dp[v]);
			mrg_dp2(dp[ch[v][1]], dp[ch[v][0]], dp[v]);
		}
	}
}


void solve_k2() {
	dp.assign(n, vector<int>(msm, msm));
	solve_k2(0);
	bool ok = false;
	for (int i = 0; i < msm; ++i) {
		if (dp[0][i] < msm) {
			ok = true;
		}
	}
	if (ok) {
		cout << "Yes" << "\n";
	}
	else {
		cout << "No" << "\n";
	}
}


int32_t main() {
	cin >> n;
	ch.resize(n);
	p.resize(n);
	dp.resize(n);
	d.resize(n);
	mxk = 0;
	msm = 0;
	for (int i = 0; i < n; ++i) {
		int t;
		cin >> t;
		if (t == 1) {
			int k;
			cin >> k;
			mxk = max(mxk, k);
			ch[i].resize(k);
			for (int j = 0; j < k; ++j) {
				int c;
				cin >> c;
				--c;
				ch[i][j] = c;
			}
		}
		else if (t == 2) {
			int m;
			cin >> m;
			msm += m;
			d[i].resize(m);
			for (int j = 0; j < m; ++j) {
				cin >> d[i][j];
				btrs.emplace(d[i][j], 0);
			}
		}
	}
	cmp_btrs.resize(msm);
	int c = 0;
	for (auto& p : btrs) {
		p.second = c;
		cmp_btrs[c++] = p.first;
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < d[i].size(); ++j) {
			d[i][j] = btrs[d[i][j]];
		}
	}
	if (mxk <= 2) {
		solve_k2();
	}
	return 0;
}

/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80 10
2 2 40 70
1 2 3 2
2 4 30 90 91 92
*/