#define _CRT_SECURE_NO_WARNINGS



#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <queue>
#include <map>



#define ll long long
#define all(a) a.begin(), a.end()


using namespace std;


int n;
vector<vector<int>> ch;
vector<int> p;
vector<vector<int>> dp;
vector<vector<int>> d;
map<int, int> btrs;
vector<int> cmp_btrs;
vector<vector<int>> prm;
vector<vector<int>> res;

int mxk;
int msm;


void print_res() {
	for (auto& x : res) {
		for (auto y : x) {
			cout << y << " ";
		}
		cout << "\n";
	}
}


void mrg_dp2(vector<int> &d, vector<int> &rs, vector<int> &prm_rs, int x) {
	for (int i = 0; i < msm; ++i) {
		int j = i;
		for (int c = 0; c < d.size(); ++c) {
			if (j < msm) {
				j = dp[d[c]][j] + 1;
			}
		}
		--j;
		if(rs[i] > j){
			rs[i] = j;
			prm_rs[i] = x;
		}
	}
}


void rec_res_k2(int v, int x) {
	if (ch[v].size() == 0) {
		res[v].push_back(cmp_btrs[dp[v][x]]);
	}
	else {
		int k = ch[v].size();
		vector<int> prmt(k);
		for (int i = 0; i < k; ++i) {
			prmt[i] = i;
		}
		for (int c = 0; c < prm[v][x]; ++c) {
			next_permutation(prmt.begin(), prmt.end());
		}
		for (int i = 0; i < k; ++i) {
			res[v].push_back(ch[v][prmt[i]]);
			rec_res_k2(ch[v][prmt[i]], x);
			x = dp[ch[v][prmt[i]]][x] + 1;
		}
	}
}


void solve_k2(int v) {
	if (ch[v].size() == 0) {
		// dp[v].assign(msm, msm);
		for (auto dv : d[v]) {
			dp[v][dv] = dv;
		}
		for (int i = msm - 1; i >= 0; --i) {
			if (dp[v][i] == msm && i + 1 < msm) {
				dp[v][i] = dp[v][i + 1];
			}
		}
	}
	else {
		int k = ch[v].size();
		for (auto to : ch[v]) {
			solve_k2(to);
		}
		vector<int> prmt(k);
		for (int i = 0; i < k; ++i) {
			prmt[i] = i;
		}
		for (int x = 0; true; ++x) {
			vector<int> md(k);
			for (int i = 0; i < k; ++i) {
				md[i] = ch[v][prmt[i]];
			}
			mrg_dp2(md, dp[v], prm[v], x);
			if (!next_permutation(prmt.begin(), prmt.end())) {
				break;
			}
		}
	}
}


void solve_k2() {
	dp.assign(n, vector<int>(msm, msm));
	prm.resize(n, vector<int>(msm, false));
	solve_k2(0);
	bool ok = false;
	for (int i = 0; i < msm; ++i) {
		if (dp[0][i] < msm) {
			ok = true;
			res.resize(n);
			rec_res_k2(0, i);
			break;
		}
	}
	if (ok) {
		cout << "Yes" << "\n";
		print_res();
	}
	else {
		cout << "No" << "\n";
	}
}


int32_t main() {
	cin >> n;
	ch.resize(n);
	p.resize(n);
	dp.resize(n);
	d.resize(n);
	mxk = 0;
	msm = 0;
	for (int i = 0; i < n; ++i) {
		int t;
		cin >> t;
		if (t == 1) {
			int k;
			cin >> k;
			mxk = max(mxk, k);
			ch[i].resize(k);
			for (int j = 0; j < k; ++j) {
				int c;
				cin >> c;
				--c;
				ch[i][j] = c;
			}
		}
		else if (t == 2) {
			int m;
			cin >> m;
			msm += m;
			d[i].resize(m);
			for (int j = 0; j < m; ++j) {
				cin >> d[i][j];
				btrs.emplace(d[i][j], 0);
			}
		}
	}
	cmp_btrs.resize(msm);
	int c = 0;
	for (auto& p : btrs) {
		p.second = c;
		cmp_btrs[c++] = p.first;
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < d[i].size(); ++j) {
			d[i][j] = btrs[d[i][j]];
		}
	}
	solve_k2();
	return 0;
}

/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80 10
2 2 40 70
1 2 3 2
2 4 30 90 91 92
*/

/*
3
1 2 2 3
2 1 1
2 1 2
*/

/*
5
1 2 2 3
2 1 2
1 2 4 5
2 1 1
2 1 3
*/