#include <bits/stdc++.h>

using namespace std;

void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

typedef long long ll;

template<typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (auto &u : a) {
        in >> u;
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& a) {
    for (auto &u : a) {
        out << u << ' ';
    }
    return out;
}

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) ((int)x.size())
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eb emplace_back
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

const int MAXN = 1e5 + 15;

vi adj[MAXN];
vi can[MAXN];
pi what[MAXN];
int n;

void Answer() {
    cout << "Yes\n";
    for (int i = 1; i <= n; ++i) {
        if (can[i].empty()) {
            cout << adj[i] << '\n';
        } else {
            cout << what[i].first << '\n';
        }
    }
    exit(0);
}
bool flag = 1;

void DFS(int v) {
    if (adj[v].empty()) {
        return;
    }
    int mn = -1, mx = -1;
    for (auto u : adj[v]) {
        DFS(u);
        if (!flag) {
            return;
        }
        if (what[u].first <= mx) {
            flag = 0;
            return;
        }
        mx = what[u].second;
        if (mn == -1) {
            mn = what[u].first;
        }
    }
    what[v] = {mn, mx};
}

void Try(int v) {
    if (v == n + 1) {
        flag = 1;
        DFS(1);
        if (flag) {
            Answer();
        }
        return;
    }
    if (adj[v].empty()) {
        Try(v + 1);
        return;
    }
    sort(all(adj[v]));
    do{
        Try(v + 1);
    }while(next_permutation(all(adj[v])));
}

void Choose(int v) {
    if (v == n + 1) {
        Try(1);
        return;
    }
    if (can[v].empty()) {
        Choose(v + 1);
        return;
    }
    for (auto u : can[v]) {
        what[v] = {u, u};
        Choose(v + 1);
    }
}

void Solve() {
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        int who;
        cin >> who;
        int k;
        cin >> k;
        if (who == 1) {
            forn(j, k) {
                int x;
                cin >> x;
                adj[i].eb(x);
            }
        } else {
            forn(j, k) {
                int x;
                cin >> x;
                can[i].eb(x);
            }
        }
    }
    Choose(1);
    cout << "No";
}

signed main() {
//    freopen("/tmp/game.in", "r", stdin);
//    freopen("/tmp/game.out", "w", stdout);
    int start = clock();
    IO();
    Solve();
#ifdef DIVAN
    int Timeme = (clock() - start + 999) / 1000;
    cout << '\n' << "TIME: " << Timeme;
#endif
    return 0;
}
