#include <bits/extc++.h>

using namespace std;

typedef long long ll;
typedef double dl;
typedef vector<int> vi;

#define nl '\n'
#define all(a) (a).begin(), (a).end()
#define minq(a, b) (a) = min(a, b)
#define maxq(a, b) (a) = max(a, b)
#define sz(a) (int((a).size()))
#define forn(i, n) for (int i = 0; i < (n); i++)

void IO() {
#ifdef SEVA
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
}

const int K = 256;

bool del[K][K];

bool IsLower(const string &a, const string &b) {
    for (int i = sz(a) - 1, j = sz(b) - 1; i >= 0 && j >= 0; i--, j--) {
        if (a[i] < b[j])
            return true;
        if (a[i] > b[j])
            return false;
    }
    return sz(a) < sz(b);
}

const int N = 10000 + 10;

struct Node {
    int min;
    int pos;
};

void Upd(Node &a, const Node &b) {
    if (b.min < a.min || b.min == a.min && b.pos < a.pos) {
        a.min = b.min;
        a.pos = b.pos;
    }
}

Node tree[4 * N];

void Upd(int v) {
    tree[v].min = INT_MAX;
    Upd(tree[v], tree[v * 2]);
    Upd(tree[v], tree[v * 2 + 1]);
}

void Build(const string &s) {
    for (int i = 0; i < sz(s); i++) {
        tree[i + N].min = s[i] - 'a';
        tree[i + N].pos = i;
    }
    for (int i = N - 1; i > 0; i--) {
        Upd(i);
    }
}

int Query(int l, int r) {
    Node ans;
    ans.min = INT_MAX;
    l += N, r += N;
    while (l <= r) {
        if (l & 1) Upd(ans, tree[l++]);
        if (!(r & 1)) Upd(ans, tree[r--]);
        l >>= 1, r >>= 1;
    }
    return ans.pos;
}

string dp[N];

void Solve() {
    int k, n;
    cin >> k >> n;
    for (char a = 'a'; a < 'a' + k; a++) {
        for (char b = 'a'; b < 'a' + k; b++) {
            char c;
            cin >> c;
            del[a][b] = c == '1';
        }
    }
    string s;
    cin >> s;
    Build(s);
    vector<pair<char, int>> st;
    for (int i = n - 1; i >= 0; i--) {
        while (!st.empty() && del[s[i]][st.back().first]) {
            st.pop_back();
        }
        if (st.empty()) {
            dp[i] = string(1, s[i]);
        } else {
            int r = st.empty() ? n - 1 : st.back().second;
            int pos = Query(i + 1, r);
            string& ans = dp[i];
            ans += s[i];
            ans += dp[pos];
//            for (int j = i + 1; j < (st.empty() ? n : st.back().second + 1); j++) {
//                string lans;
//                lans += s[i];
//                lans += dp[j];
//                minq(ans, lans);
//            }
//            dp[i] = ans;
        }
        st.emplace_back(s[i], i);
    }

    cout << dp[0] << nl;

}

signed main() {
    IO();
    Solve();
    return 0;
}