#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <stack>

using namespace std;

#define range(i, n) for (int i = 0; i < (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)
#define prange(i, n) for (int i = 1; i <= (n); ++i)

#define all(a) a.begin(), a.end()

typedef pair<int, int> pii;
#define fi first
#define se second
#define pb push_back

void setup() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

void solve();
int main() {
    setup();
    int t = 1;
//    cin >> t;
    range(i, t) {
        solve();
    }
    return 0;
}

const int MAXN = 1e5 + 10;
int n, m;
string s;
set<int> bad[MAXN];
set<int> good[MAXN];
vector<int> where_g[MAXN];
vector<int> where_b[MAXN];



void solve() {
    cin >> n >> m;
    cin >> s;
    range(i, n) {
        int k; cin >> k;
        range(_, k) {
            int a; char c;
            cin >> a >> c;
            --a;
            if (c == s[a]) {
                good[i].insert(a);
                where_g[a].pb(i);
            } else {
                bad[i].insert(a);
                where_b[a].pb(i);
            }
        }
    }
    range(i, m) {
        if (where_g[i].empty()) {
            cout << -1 <<endl;
            return;
        }
    }
    stack<int> gg;
    range(i, n) {
        if (bad[i].empty()) gg.push(i);
    }
    vector<int> ans;
    ans.reserve(n);
    while (!gg.empty()) {
        int i = gg.top();
        gg.pop();
        for (auto gi : good[i]) {
            for (auto bi : where_b[gi]) {
                bad[bi].erase(gi);
                if (bad[bi].empty()) {
                    gg.push(bi);
                }
            }
            where_b[gi].resize(0);
        }
        ans.pb(i);
    }
    if (ans.size() != n) {
        cout << -1 << endl;
        return;
    }
    for (auto i : ans) {
        cout << i + 1 << ' ';
    }
    cout << endl;
}
