#include <iostream>

#include <algorithm>

#include <vector>
#include <string>

using namespace std;

typedef long long ll;

vector<vector<int>> g;
vector<int> q;

bool comp(vector<int> a, vector<int> b) {
	return a.back() < b.back();
}

vector<int> dfs(int v) {
	if (g[v].size() == 0) {
		vector<int> tmp;
		tmp.push_back(q[v]);
		return tmp;
	}

	vector<vector<int>> buf;
	for (auto to : g[v]) {
		buf.push_back(dfs(to));
	}

	sort(buf.begin(), buf.end(), comp);

	vector<int> res;
	for (auto i : buf) {
		for (auto j : i) {
			res.push_back(j);
		}
	}

	return res;
}

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);
	
	int n; cin >> n;
	g.resize(n);
	vector<vector<int>> qs(n);
	for (int i = 0; i < n; i++) {
		char type; cin >> type;
		if (type == '1') {
			int k; cin >> k;
			for (int j = 0; j < k; j++) {
				int u; cin >> u;
				u--;
				g[i].push_back(u);
			}
		}
		else {
			int m; cin >> m;
			for (int j = 0; j < m; j++) {
				int u; cin >> u;
				qs[i].push_back(u);
			}
		}
	}

	for (int tmp = 0; tmp < 1e5; tmp++) {
		q.assign(n, -1);
		for (int i = 0; i < n; i++) {
			if (qs[i].size() > 0) {
				q[i] = qs[i][rand() % qs[i].size()];
			}
		}

		vector<int> res = dfs(0);
		bool flag = true;
		for (int i = 1; i < res.size(); i++) {
			if (res[i] < res[i - 1]) {
				flag = false;
				break;
			}
		}

		if (flag) {
			cout << "Yes";
			return 0;
		}
	}

	cout << "No";

	return 0;
}