#include <iostream>

#include <algorithm>

#include <vector>
#include <string>

using namespace std;

typedef long long ll;

vector<vector<int>> g;
vector<int> q;

vector<vector<int>> ans;

bool comp(pair<vector<int>, int> a, pair<vector<int>, int> b) {
	return a.first.back() < b.first.back();
}

vector<int> dfs(int v) {
	if (g[v].size() == 0) {
		vector<int> tmp;
		tmp.push_back(q[v]);
		ans[v].push_back(q[v]);
		return tmp;
	}

	vector<pair<vector<int>, int>> buf;
	for (auto to : g[v]) {
		buf.push_back({ dfs(to), to });
	}

	sort(buf.begin(), buf.end(), comp);

	vector<int> res;
	for (auto i : buf) {
		ans[v].push_back(i.second + 1);
		for (auto j : i.first) {
			res.push_back(j);
		}
	}

	return res;
}

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);
	
	int n; cin >> n;
	g.resize(n);
	vector<vector<int>> qs(n);
	for (int i = 0; i < n; i++) {
		char type; cin >> type;
		if (type == '1') {
			int k; cin >> k;
			for (int j = 0; j < k; j++) {
				int u; cin >> u;
				u--;
				g[i].push_back(u);
			}
		}
		else {
			int m; cin >> m;
			for (int j = 0; j < m; j++) {
				int u; cin >> u;
				qs[i].push_back(u);
			}
		}
	}

	for (int tmp = 0; tmp < 4e5; tmp++) {
		q.assign(n, -1);
		ans.assign(n, vector<int>());
		for (int i = 0; i < n; i++) {
			if (qs[i].size() > 0) {
				q[i] = qs[i][rand() % qs[i].size()];
			}
		}

		vector<int> res = dfs(0);
		bool flag = true;
		for (int i = 1; i < res.size(); i++) {
			if (res[i] < res[i - 1]) {
				flag = false;
				break;
			}
		}

		if (flag) {
			cout << "Yes\n";
			for (auto i : ans) {
				for (auto j : i) {
					cout << j << ' ';
				}
				cout << "\n";
			}
			return 0;
		}
	}

	cout << "No";

	return 0;
}