#include <iostream>
#include <vector>
#define ll long long

using namespace std;

const ll P1 = 179;
const ll M1 = 1e9 + 1329;
const ll P2 = 239;
const ll M2 = 1e9 + 9;

vector <ll> pref1, pw1, pref2, pw2;
ll q;

struct symbol{
    int nt, pv; //next prev
};

ll hash_f1(int l, int r) {
    q = (pref1[r] - pref1[l] * pw1[r - l]) % M1;
    if (q < 0) q += M1;
    return q;
}

ll hash_f2(int l, int r) {
    q = (pref2[r] - pref2[l] * pw2[r - l]) % M2;
    if (q < 0) q += M2;
    return q;
}

signed main() {
    ios_base::sync_with_stdio(false);
    int k, n; cin >> k >> n;
    pw1.assign(n + 2, 1);
    pref1.assign(n + 1, 0);
    pw2.assign(n + 2, 1);
    pref2.assign(n + 1, 0);
    for (int i = 1; i < n + 2; ++i) {
        pw1[i] = pw1[i - 1] * P1;
        if (pw1[i] >= M1) {
            pw1[i] %= M1;
        }
    }
    for (int i = 1; i < n + 2; ++i) {
        pw2[i] = pw2[i - 1] * P2;
        if (pw2[i] >= M2) {
            pw2[i] %= M2;
        }
    }
    bool c[k][k];
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char b; cin >> b;
            c[i][j] = b - '0';
        }
    }
    vector <char> s(n);
    vector <bool> p(n, 1);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    vector <symbol> a(n);
    for (int i = 0; i < n; ++i) {
        a[i] = {i - 1, i + 1};
    }
    int ind = n - 1;
    while (ind != 0) {
        //cout << ind << "\n";
        if (c[s[a[ind].nt] - 'a'][s[ind] - 'a']) {
            p[ind] = 0;
            if (a[ind].pv == n) {
                ind = a[ind].nt;
            } else {
                a[a[ind].pv].nt = a[ind].nt;
                a[a[ind].nt].pv = a[ind].pv;
                ind = a[ind].pv;
            }
        } else {
            ind = a[ind].nt;
        }
    }
    for (int i = 0; i < n; ++i) {
        a[i] = {i - 1, i + 1};
    }
    vector <int> st(n), mp(n);
    int l = 0, pm = -1;
    ind = n - 1;
    while (ind != 0) {
        pref1[l + 1] = (pref1[l] * P1 + s[ind]);
        if (pref1[l + 1] >= M1) {
            pref1[l + 1] %= M1;
        }
        pref2[l + 1] = (pref2[l] * P2 + s[ind]);
        if (pref2[l + 1] >= M2) {
            pref2[l + 1] %= M2;
        }
        st[l] = ind;
        if (p[ind]) {
            pm = l;
            mp[l] = l;
        } else if (pm != -1) {
            int L = 0, R = mp[l - 1] + 2;
            while (R - L > 1) {
                int MID = (L + R) / 2;
                if (hash_f1(l + 1 - MID, l + 1) == hash_f1(mp[l - 1] + 1 - MID, mp[l - 1] + 1) && hash_f2(l + 1 - MID, l + 1) == hash_f2(mp[l - 1] + 1 - MID, mp[l - 1] + 1)) {
                    L = MID;
                } else {
                    R = MID;
                }
            }
            if (L == mp[l - 1] + 1) {
                mp[l] = mp[l - 1];
            } else {
                if (s[st[l - L]] < s[st[mp[l - 1] - L]]) {
                    mp[l] = l;
                } else {
                    mp[l] = mp[l - 1];
                }
            }
        } else {
            mp[l] = -1;
        }
        if (c[s[a[ind].nt] - 'a'][s[ind] - 'a']) {
            if (mp[l] == l) {
                pm = l;
                l++;
                ind = a[ind].nt;
            } else {
                if (l == pm + 1) {
                    ind = a[ind].nt;
                } else {
                    a[a[ind].pv].nt = a[ind].nt;
                    a[a[ind].nt].pv = a[ind].pv;
                    ind = a[ind].pv;
                    l--;
                }
            }
        } else {
            ind = a[ind].nt;
            l++;
        }
    }
    cout << s[0];
    while (l > 0) {
        cout << s[st[l - 1]];
        l--;
    }
}
/*
3 7
010
001
100
abacaba

3 5
010
001
100
bcacb
*/
