#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <set>
#include <map>

#define sqr(x) ((x) * (x))
#define mp make_pair
#define pb push_back
#define endl '\n'
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vii;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)5e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;
const int P = 37;
const int K = 19;

vi p(N);
vvi h(N, vi(K));
vvi nxt(N, vi(K));

int dfs1(int x, string& s, vector<vc>& a, vc& used, int n, vvi& g) {
	used[x] = 1;
	int i = x + 1;
	while (i < n) {
		if (!a[s[x] - 'a'][s[i] - 'a'])
			break;
		g[x].pb(i);
		i = dfs1(i, s, a, used, n, g);
	}
	return i;
}

int min1(int x, int y, string& s, int n) {
	if (x == -1)
		return y;
	if (y == -1)
		return x;
	if (x == n)
		return x;
	if (y == n)
		return y;
	for (int i = K - 1; i >= 0; --i) {
		if (nxt[x][i] == n || nxt[y][i] == n || h[x][i] != h[y][i])
			continue;
		x = nxt[x][i];
		y = nxt[y][i];
	}
	if (s[x] < s[y])
		return x;
	if (s[x] > s[y])
		return y;
	if (nxt[x][0] == n)
		return x;
	return y;
}

void dfs(int x, string& s, vector<vc>& a, vector<int>& ans, int n, int& mn, vvi& g) {
	mn = -1;
	for (int i : g[x]) {
		int mn1 = -1;
		dfs(i, s, a, ans, n, mn1, g);
		mn = min1(mn, mn1, s, n);
	}
	if (x == n - 1)
		mn = n;
	else
		mn = min1(mn, x + 1, s, n);
	ans[x] = mn;
	nxt[x][0] = mn;
	h[x][0] = s[x];
	for (int k = 1; k < K; ++k) {
		if (nxt[x][k - 1] == n) {
			nxt[x][k] = n;
			h[x][k] = h[x][k - 1];
			continue;
		}
		nxt[x][k] = nxt[nxt[x][k - 1]][k - 1];
		h[x][k] = ((ll)h[x][k - 1] + (ll)h[nxt[x][k - 1]][k - 1] * (ll)p[(1 << (k - 1))] % (ll)MOD) % (ll)MOD;
	}
	return;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	p[0] = 1;
	for (int i = 1; i < N; ++i)
		p[i] = ((ll)p[i - 1] * (ll)P) % (ll)MOD;

	int k, n;
	cin >> k >> n;
	vector<vc> a(k, vc(k));
	for (int i = 0; i < k; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < k; ++j)
			if (s[j] == '1')
				a[i][j] = 1;
	}
	string s;
	cin >> s;
	vector<int> ans(n);
	vi rt;
	vvi g(n);
	vc used(n);
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			rt.pb(i);
			dfs1(i, s, a, used, n, g);
		}
	}
	reverse(rt.begin(), rt.end());
	for (int i = 0; i < n; ++i)
		reverse(g[i].begin(), g[i].end());
	for (int i : rt) {
		int mn = -1;
		dfs(i, s, a, ans, n, mn, g);
	}
	string res;
	int cur = 0;
	while (cur != n) {
		res += s[cur];
		cur = ans[cur];
	}
	cout << res;

	return 0;
}