#pragma GCC optimize("Ofast")

#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <bitset>

using namespace std;

#define endl '\n'

const int Base = 555;
const int BigBase = 2e4;

int n;
vector<int> e[Base];
vector<int> upd[Base];
vector<int> ans[Base];
int inv[Base];

vector<int> dfs(int x)
{
	ans[x].clear();
	vector<int> updates;
	if (e[x].empty())
	{
		updates.push_back(inv[x]);
		ans[x].push_back(inv[x]);
		return updates;
	}

	vector<pair<int, int>> allUpd;
	for (auto v : e[x])
	{
		vector<int> dUpd = dfs(v);
		if (dUpd.empty())
		{
			return dUpd;
		}

		for (auto u : dUpd)
		{
			allUpd.push_back(make_pair(u, v));
		}
	}

	sort(allUpd.begin(), allUpd.end());

	bool used[Base];
	for (int i = 1; i <= n; i++)
	{
		used[i] = false;
	}
	int last = -1;
	vector<int> noAns;
	for (auto u : allUpd)
	{
		if (last != u.second)
		{
			last = u.second;
			ans[x].push_back(u.second);
			if (used[u.second])
			{
				return noAns;
			}
			used[u.second] = true;
		}
		updates.push_back(u.first);
	}

	return updates;
}

void check()
{
	vector<int> s = dfs(1);

	if (!s.empty())
	{
		cout << "Yes" << endl;
		for (int i = 1; i <= n; i++)
		{
			for (auto r : ans[i])
			{
				cout << r << ' ';
			}
			cout << endl;
		}
		exit(0);
	}
}

void rec(int x)
{
	if (x == n + 1)
	{
		check();
		return;
	}

	if (upd[x].empty())
	{
		inv[x] = -1;
		rec(x + 1);
		return;
	}

	for (auto i : upd[x])
	{
		inv[x] = i;
		rec(x + 1);
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n;

	for (int i = 1; i <= n; i++)
	{
		int type;
		cin >> type;
		int k;
		cin >> k;
		for (int j = 0; j < k; j++)
		{
			int x;
			cin >> x;
			if (type == 1)
			{
				e[i].push_back(x);
			}
			else
			{
				upd[i].push_back(x);
			}
		}
	}
	
	rec(1);

	cout << "No" << endl;

	return 0;
}