#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <utility>
#include <set>
#include <map>

using namespace std;

const long long P = 179, MOD = 1e9 + 7, MAXN = 3e5;
vector<long long> prefh;
long long ppow[MAXN];
string s, ans;

long long geth(int left, int right) {
    if (left == 0) {
        return prefh[right];
    }
    return (MOD + prefh[right] - (prefh[left - 1] * ppow[right - left + 1]) % MOD) % MOD;
}

int best(int x, int y) {
    int left = 0, right = min(x, y) + 1;
    while (right - left > 1) {
        int mid = (left + right) / 2;
        if (geth(x - mid + 1, x) == geth(y - mid + 1, y)) {
            left = mid;
        }
        else {
            right = mid;
        }
    }
    if (left == min(x, y)) {
        return left;
    }
    if (ans[x - left] < ans[y - left]) {
        return x;
    }
    else {
        return y;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int k, n;
    cin >> k >> n;
    vector<vector<char>> can(k, vector<char>(k));
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            cin >> can[i][j];
        }
    }
    cin >> s;
    ans = "$";
    prefh.emplace_back((long long)'$');
    ppow[0] = 1;
    for (int i = 1; i < MAXN; ++i) {
        ppow[i] = ppow[i - 1] * P % MOD;
    }
    for (int i = n - 1; i >= 0; --i) {
        int how = 0;
        int howcan = 0;
        while (ans[ans.size() - 1 - howcan] != '$' && can[s[i] - 'a'][ans[ans.size() - 1 - howcan] - 'a'] == '1') {
            ++howcan;
            int val = best(ans.size() - 1 - how, ans.size() - 1 - howcan);
            if (val == ans.size() - 1 - howcan) {
                how = howcan;
            }
        }
        for (int j = 0; j < how; ++j) {
            ans.pop_back();
            prefh.pop_back();
        }
        ans += s[i];
        prefh.emplace_back((prefh.back() * P + (long long)s[i]) % MOD);
    }
    reverse(ans.begin(), ans.end());
    ans.pop_back();
    cout << ans << "\n";

    return 0;
}
