#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <random>

using namespace std;

vector<vector<int>> graph;
vector<vector<int>> answ;
vector<int> check(int v, int pred, vector<int> news) {
	if (news[v] != -1) {
		answ[v] = vector<int>(1, news[v]);
		return vector<int>(2, news[v]);
	}
	else {
		vector<pair<vector<int>, int>> to_merge;
		for (auto& other : graph[v]) {
			if (other == pred) continue;
			to_merge.push_back({ check(other, v, news), other });
			if (to_merge[to_merge.size() - 1].first.empty()) return vector<int>(0);
		}

		sort(to_merge.begin(), to_merge.end(), [](pair<vector<int>, int>& a, pair<vector<int>, int>& b) {
			return a.first[0] < b.first[0];
			});
		int Min = to_merge[0].first[0];
		int Max = to_merge[to_merge.size() - 1].first[1];
		for (int i = 1; i < to_merge.size(); i++) {
			if (to_merge[i].first[0] < to_merge[i - 1].first[1]) return vector<int>(0);
		}
		answ[v].clear();
		for (auto& elem : to_merge) {
			answ[v].push_back(elem.second + 1);
		}
		vector<int> answ(2);
		answ[0] = Min;
		answ[1] = Max;
		return answ;
	}
}



int main() {
	int n;
	cin >> n;
	graph = vector<vector<int>>(n);
	answ = vector<vector<int>>(n);
	vector<vector<int>> arg(n);
	vector<int> manager;
	vector<int> leafs;
	for (int i = 0; i < n; i++) {
		int type;
		cin >> type;
		if (type == 1) {
			manager.push_back(i);
			int k;
			cin >> k;
			for (int j = 0; j < k; j++) {
				int p;
				cin >> p;
				p--;
				graph[i].push_back(p);
				graph[p].push_back(i);
			}
		}
		else {
			leafs.push_back(i);
			int m;
			cin >> m;
			for (int j = 0; j < m; j++) {
				int a;
				cin >> a;
				arg[i].push_back(a);
			}
		}
	}

	mt19937 rnd(1);
	bool ok = false;
	vector<int> news(n, -1);
	for (int test = 0; test < 50000; test++) {
		news = vector<int>(n, -1);
		for (auto& v : leafs) {
			news[v] = arg[v][rnd() % (arg[v].size())];
		}
		vector<int> answ = check(0, -1, news);
		if (!answ.empty()) {
			ok = true;
			break;
		}
	}
	if (!ok) {
		cout << "NO\n";
	}
	else {
		cout << "YES\n";
		for (auto& line : answ) {
			for (auto& elem : line) cout << elem << " ";
			cout << endl;
		}
	}
}