#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>

using namespace std;

const char EMPTY = 'a' - 1;
const char MAX = 'z' + 1;

const int MAX_N = 557;

bool matrix[27][27];

inline bool canDelete(const char &a, const char &b) {
    assert(0 <= a - EMPTY && a - EMPTY < 27);
    assert(0 <= b - EMPTY && b - EMPTY < 27);
    return matrix[a - EMPTY][b - EMPTY];
}

int dp[MAX_N][MAX_N];

bool canDeleteSubstr(const string &s, int l, int r) {
    if (dp[l][r] != 0) {
        return dp[l][r] == 1;
    }
    if (l >= r) {
        dp[l][r] = 1;
    } else if (l + 1 == r) {
        dp[l][r] = (canDelete(s[l], s[r]) ? 1 : 2);
    } else {
        bool can = false;
        for (int i = r - 1; i >= l; i--) {
            if (canDelete(s[i], s[r])) {
                if (canDeleteSubstr(s, i, r - 1)) {
                    if (canDeleteSubstr(s, l, i)) {
                        can = true;
                        break;
                    }
                }
            }
        }
        dp[l][r] = (can ? 1 : 2);
    }
    return dp[l][r] == 1;
}

int main() {
    int k, n; cin >> k >> n;
    for (int i = 1; i <= k; i++) {
        for (int j = 1; j <= k; j++) {
            char x; cin >> x;
            if (x == '1') {
                matrix[i][j] = true;
            } else {
                matrix[i][j] = false;
            }
        }
    }
    string s; cin >> s;
    s += EMPTY;
    string ans = "";
    char currentMinChar = s[0];
    vector<int> currentMinCharPos = {0};
    while (currentMinChar != EMPTY) {
        ans.push_back(currentMinChar);
        char nextMinChar = MAX;
        vector<int> nextMinCharPos;
        for (int posInd = 0; posInd < currentMinCharPos.size(); posInd++) {
            int pos = currentMinCharPos[posInd];
            int nxt = (posInd == currentMinCharPos.size() - 1 ? s.length() - 1 : currentMinCharPos[posInd + 1]);
            for (int i = pos + 1; i <= nxt; i++) {
                if (canDeleteSubstr(s, pos, i - 1)) {
                    nextMinChar = min(nextMinChar, s[i]);
                } else {
                    break;
                }
            }
        }
        for (int posInd = 0; posInd < currentMinCharPos.size(); posInd++) {
            int pos = currentMinCharPos[posInd];
            int nxt = (posInd == currentMinCharPos.size() - 1 ? s.length() - 1 : currentMinCharPos[posInd + 1]);
            for (int i = pos + 1; i <= nxt; i++) {
                if (canDeleteSubstr(s, pos, i - 1)) {
                    if (s[i] == nextMinChar) {
                        nextMinCharPos.push_back(i);
                    }
                } else {
                    break;
                }
            }
        }
        assert(nextMinChar != MAX);
        currentMinChar = nextMinChar;
        currentMinCharPos = nextMinCharPos;
        sort(nextMinCharPos.begin(), nextMinCharPos.end());
        nextMinCharPos.resize(unique(nextMinCharPos.begin(), nextMinCharPos.end()) - nextMinCharPos.begin());
    }
    cout << ans << endl;
}
