#include <iostream>
#include <vector>

using namespace std;

void query(int x, int y) {
    cout << x << ' ' << y << endl;
}

void getAnswer(int &x, int &y) {
    cin >> x >> y;
}

void playLikeFirst(int n, string &s, int &bits) {
    query(n, n);
    while (bits > 0) {
        int x, y; getAnswer(x, y);
        if (x == 1 && y == 1) {
            return;
        }
        if (x == 1) {
            query(x, y - 1);
            if (y - 1 == 1) {
                return;
            }
        } else if (y == 1) {
            query(x - 1, y);
            if (x - 1 == 1) {
                return;
            }
        } else {
            int ind = s.length() - bits;
            bits--;
            if (s[ind] == '0') {
                query(x - 1, y);
            } else {
                query(x, y - 1);
            }
        }
    }
    int x, y; getAnswer(x, y);
    if (x == 1 && y == 1) {
        return;
    }
    query(1, 1);
}

void playLikeSecond(int n, string &s, int &bits) {
    while (bits > 0) {
        int x, y; getAnswer(x, y);
        if (x == 1 && y == 1) {
            return;
        }
        if (x == 1) {
            query(x, y - 1);
            if (y - 1 == 1) {
                return;
            }
        } else if (y == 1) {
            query(x - 1, y);
            if (x - 1 == 1) {
                return;
            }
        } else {
            int ind = s.length() - bits;
            bits--;
            if (s[ind] == '0') {
                query(x - 1, y);
            } else {
                query(x, y - 1);
            }
        }
    }
    int x, y; getAnswer(x, y);
    if (x == 1 && y == 1) {
        return;
    }
    query(1, 1);
}

void firstLaunch() {
    int n, k, m; cin >> n >> k >> m;
    string s; cin >> s;
    int bits = m;
    bool first = true;
    while (bits > 0) {
        if (first) {
            playLikeFirst(n, s, bits);
            first = false;
        } else {
            playLikeSecond(n, s, bits);
            first = true;
        }
    }
    cout << 0 << endl;
}

string decodeLikeFirst(int n, vector<pair<int, int>> &game, int &bits) {
    int ptr = 2;
    int m = game.size();
    string res;
    while (ptr < m && bits > 0) {
        int x1 = game[ptr - 1].first, y1 = game[ptr - 1].second;
        int x2 = game[ptr].first, y2 = game[ptr].second;
        ptr += 2;
        if (x1 == 1 || y1 == 1) {
            continue;
        }
        bits--;
        if (x2 + 1 == x1) {
            res += "0";
        } else {
            res += "1";
        }
    }
    return res;
}

string decodeLikeSecond(int n, vector<pair<int, int>> &game, int &bits) {
    int ptr = 1;
    int m = game.size();
    string res;
    while (ptr < m && bits > 0) {
        int x1 = game[ptr - 1].first, y1 = game[ptr - 1].second;
        int x2 = game[ptr].first, y2 = game[ptr].second;
        ptr += 2;
        if (x1 == 1 || y1 == 1) {
            continue;
        }
        bits--;
        if (x2 + 1 == x1) {
            res += "0";
        } else {
            res += "1";
        }
    }
    return res;
}

void secondLaunch() {
    int n, k, m; cin >> n >> k >> m;
    int g; cin >> g;
    vector<vector<pair<int, int>>> moves(g);
    int x, y;
    for (int i = 0; i < g; i++) {
        cin >> x >> y;
        while (x != 1 || y != 1) {
            moves[i].push_back({x, y});
            cin >> x >> y;
        }
    }
    int bits = m;
    bool first = true;
    int i = 0;
    string ans;
    while (bits > 0) {
        if (first) {
            ans += decodeLikeFirst(n, moves[i], bits);
        } else {
            ans += decodeLikeSecond(n, moves[i], bits);
        }
        first = !first;
        i++;
    }
    cout << ans << endl;
}

int main() {
    int t; cin >> t;
    if (t == 1) {
        firstLaunch();
    }
    if (t == 2) {
        secondLaunch();
    }
}
