#define _CRT_SECURE_NO_WARNINGS
//#pragma comment(linker, "/stack:100000000")

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

using namespace std;

const int INF = 1000000009;

vector <int> g[100010];
int dp[2010][2010];
vector <int> up[100010];
vector <int> ups;

void DFS(int v)
{
	if (g[v].size() == 0)
	{
		for (int i = 0; i < ups.size(); ++i)
		{
			int ind = lower_bound(up[v].begin(), up[v].end(), i) - up[v].begin();
			if (ind < up[v].size())
			{
				dp[v][i] = up[v][ind];
			}
			else
			{
				dp[v][i] = INF;
			}
		}
		return;
	}
	sort(g[v].begin(), g[v].end());
	for (int to : g[v])
	{
		DFS(to);
	}
	do
	{
		for (int i = 0; i < ups.size(); ++i)
		{
			int f = i;
			for (int to : g[v])
			{
				f = dp[to][f];
				if (f == INF)
				{
					break;
				}
			}
			dp[v][i] = min(dp[v][i], f);
		}
	} while (next_permutation(g[v].begin(), g[v].end()));
}

signed main()
{
	for (int i = 0; i < 2010; ++i)
	{
		for (int j = 0; j < 2010; ++j)
		{
			dp[i][j] = INF;
		}
	}

	ios::sync_with_stdio(0);
	cin.tie();
	cout.tie();
	freopen("input.txt", "r", stdin);

	int n;
	cin >> n;
	for (int i = 0; i < n; ++i)
	{
		int key;
		cin >> key;
		if (key == 1)
		{
			int k;
			cin >> k;
			for (int j = 0; j < k; ++j)
			{
				int x;
				cin >> x;
				x--;
				g[i].push_back(x);
			}
		}
		else
		{
			int k;
			cin >> k;
			for (int j = 0; j < k; ++j)
			{
				int x;
				cin >> x;
				up[i].push_back(x);
				ups.push_back(x);
			}
			sort(up[i].begin(), up[i].end());
		}
	}
	sort(ups.begin(), ups.end());
	ups.resize(unique(ups.begin(), ups.end()) - ups.begin());
	map <int, int> change;
	for (int i = 0; i < ups.size(); ++i)
	{
		change[ups[i]] = i;
	}

	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < up[i].size(); ++j)
		{
			up[i][j] = change[up[i][j]];
		}
	}

	DFS(0);

	if (dp[0][0] != INF)
	{
		cout << "Yes";
	}
	else
	{
		cout << "No";
	}

	return 0;
}