#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <iomanip>
#include <random>
#include <queue>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define left left228
#define right right228
#define next next228
#define prev prev228
#define all(v) v.begin(), v.end()

bool isSorted(vector<int> v) {
	for (int i = 0; i < (int)v.size() - 1; ++i) {
		if (v[i] >= v[i + 1]) {
			return false;
		}
	}
	return true;
}

const int N = 100 * 1000 + 228;

int n;
vector<int> g[N], pro[N], ord[N];
int type[N], the[N];

bool can = true;

vector<int> dfs(int v) {
	vector< pair<vector<int>, int> > list;
	for (int to : g[v]) {
		vector<int> cur = dfs(to);
		list.push_back({cur, to});
	}
	if (g[v].empty()) {
		return {the[v]};
	}
	sort(all(list), [&] (pair<vector<int>, int> A, pair<vector<int>, int> B) {
		return A.first[0] < B.first[0];
	});
	vector<int> vect;
	for (auto P : list) {
		for (int x : P.first) {
			vect.push_back(x);
		}
	}
	if (isSorted(vect)) {
		ord[v].clear();
		for (auto P : list) {
			ord[v].push_back(P.second);
		}
		return vect;
	}
	can = false;
	return {{-1, -1}};
}

void Try() {
	can = true;
	vector<int> ans = dfs(1);

	if (can) {
		cout << "Yes" << endl;
		for (int v = 1; v <= n; ++v) {
			if (type[v] == 1) {
				for (int x : ord[v]) {
					cout << x << ' ';
				}
				cout << '\n';
			} else {
				cout << the[v] << endl;
			}
		}
		exit(0);
	}
}

void gen(int v) {
	if (v == n + 1) {
		Try();
	}
	if (type[v] == 1) {
		gen(v + 1);
	} else {
		for (int x : pro[v]) {
			the[v] = x;
			gen(v + 1);
		}
	}
}

void solve() {
	gen(1);
	cout << "No" << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		cin >> type[i];
		if (type[i] == 1) {
			int k;
			cin >> k;
			for (int j = 0; j < k; ++j) {
				int x;
				cin >> x;
				g[i].push_back(x);
			}
		} else {
			int k;
			cin >> k;
			for (int j = 0; j < k; ++j) {
				int x;
				cin >> x;
				pro[i].push_back(x);
			}
		}
	}

	solve();
	return 0;
}


/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
2 2 40 70
1 2 3 2
2 4 30 90 91 92

3
1 2 2 3
2 1 1
2 1 2


5
1 2 2 3
2 1 2
1 2 4 5
2 1 1
2 1 3

*/