#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <assert.h>
#include <cmath>

using namespace std;
typedef long long LL;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	int n, m;
	cin >> n >> m;

	string key;
	cin >> key;

	vector<vector<char>> cards(n, vector<char>(m, 0));

	for (int i = 0; i < n; i++)
	{
		int k;
		cin >> k;

		for (int j = 0; j < k; j++)
		{
			int a;
			char c;
			cin >> a >> c;
			a--;
			if (key[a] == c) {
				cards[i][a] = (char)1;
			}
			else {
				cards[i][a] = -1;
			}
		}
	}

	vector<bool> used(n, false);
	vector<bool> blocked(m, false);

	vector<int> order(n);
	for (int i = 0; i < n; i++)
	{
		bool foundAny = false;
		for (int j = 0; j < n; j++)
		{
			if (used[j]) continue;

			bool canUse = true;

			for (int k = 0; k < m; k++)
			{
				if (blocked[k]) continue;
				if (cards[j][k] == -1) {
					canUse = false;
					break;
				}
			}

			if (canUse) {
				for (int k = 0; k < m; k++)
				{
					if (cards[j][k] == 1) {
						blocked[k] = true;
					}
				}

				order[i] = j;
				used[j] = true;
				foundAny = true;
				break;
			}
		}

		if (!foundAny) {
			cout << -1 << endl;
			return 0;
		}
	}

	for (int i = 0; i < m; i++)
	{
		if (!blocked[i]) {
			cout << -1 << endl;
			return 0;
		}
	}

	for (auto id : order)
	{
		cout << id + 1 << " ";
	}
	cout << endl;
	return 0;
}
