//#pragma GCC optimize("Ofast")
#include <iostream>
#include <string>
#include <cmath>
#include <random>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <array>
#include <cstdio>
#include <climits>

int N, K, M;
struct state
{
	std::vector<int> data;
	bool operator < (const state& rhs) const
	{
		return data < rhs.data;
	}
};
std::vector<state> bot_moves(state x)
{
	std::vector<state> ans;
	for(int move = 0; move < N; move++)
	for(int mval = 1; mval <= N; mval++)
	{
		state y = x;
		if(x.data[move] >= mval) continue;
		int cost = 0;
		for(int i = 0; i <= move; i++)
		{
			cost += mval - x.data[i];
			y.data[i] = mval;
		}
		if(cost > K) continue;
		ans.push_back(y);
	}
	if(ans.size() == 0)
	{
		ans.push_back((state){std::vector<int>(N, N)});
	}
	return ans;
}
FILE* oppfile;
std::mt19937 mt;
std::pair<int,int> get_opponent_move(state& st)
{
	std::vector<std::pair<int,int>> moves;
	for(int move = 0; move < N; move++)
	for(int mval = 1; mval <= N; mval++)
	{
		if(st.data[move] >= mval) continue;
		moves.push_back({move, mval});
	}
	auto[m,mv] = moves[mt()%moves.size()];
	//fprintf(oppfile, "%d %d\n", 33 - (m+1), 33 - mv);
	return {m, mv};
}
//std::map<state, double> cache;
//double isize(state x) //should only be invoked with the all-zero state, with mt unseeded!
//{
//	if(cache.count(x)) return cache[x];
//	std::vector<double> e_inf;
//	for(int move = 0; move < N; move++)
//	for(int mval = 1; mval <= N; mval++)
//	{
//		state y = x;
//		if(x.data[move] >= mval) continue;
//		for(int i = 0; i <= move; i++)
//		{
//			y.data[i] = mval;
//		}
//		double sum = 0;
//		int cnt = 0;
//		std::vector<state>&& bm = bot_moves(y);
//		//assume the bot actually moves randomly
//		if(bm.size() == 0) { e_inf.push_back(0); continue; }
//		state to = bm[mt() % bm.size()];
//		e_inf.push_back(isize(to));
//		//for(state to : bot_moves(y))
//		//{
//		//	double sz = isize(to);
//		//	sum += sz; cnt++;
//		//}
//		////printf("cnt=%d\n", cnt);
//		//e_inf.push_back(cnt == 0 ? 0 : sum / cnt);
//	}
//	if(e_inf.size() == 0)
//		return 0;
//	//printf("%d\n", e_inf.size());
//	//choose moves randomly for now
//	double ans = std::log2(e_inf.size());
//	double sum = 0;
//	for(double x : e_inf) sum += x;
//	return cache[x] = ans + sum / e_inf.size();
//}
struct long_int
{
	std::vector<uint32_t> data;
	long_int operator + (const long_int& rhs) const
	{
		long_int res = *this;
		int carry = 0;
		for(int i = 0; i < data.size(); i++)
		{
			uint64_t s = data[i] + rhs.data[i] + carry;
			res.data[i] = s;
			if(s >> 32 & 1)
				carry = 1;
		}
		return res;
	}
	long_int operator + (uint32_t x) const
	{
		long_int res = *this;
		int carry = (uint64_t(x) + data[0]) >> 32;
		res.data[0] += x;
		int i = 1;
		while(carry)
		{
			uint64_t s = uint64_t(data[i]) + carry;
			res.data[i] = s;
			if(s >> 32 & 1)
				carry = 1;
			i++;
		}
		return res;
	}
	long_int operator * (uint32_t x) const
	{
		long_int res = *this;
		uint32_t carry = 0;
		for(int i = 0; i < data.size(); i++)
		{
			uint64_t s = uint64_t(x) * data[i] + carry;
			res.data[i] = s;
			carry = s >> 32;
		}
		return res;
	}
	uint32_t operator % (uint32_t x) const
	{
		//by-digit modulo
		uint64_t mul = 1;
		uint64_t ans = 0;
		for(int i = 0; i < data.size(); i++)
		{
			ans += data[i] * mul;
			ans %= x;
			mul <<= 32;
			mul %= x;
		}
		return ans;
	}
	std::pair<long_int,uint32_t> divmod (uint32_t x) const
	{
		long_int res { std::vector<uint32_t>(data.size()) };
		//long_int mid = *this;
		//divide right-to-left
		uint64_t cur = 0;
		for(int i = data.size(); i --> 0;)
		{
			cur <<= 32;
			cur += data[i];
			res.data[i] += cur / x;
			cur %= x;
		}
		return { res, cur };
	}
	bool is_zero()
	{
		for(uint32_t x : data)
			if(x) return false;
		return true;
	}
};
int main()
{
	//oppfile = fopen("opp.txt", "w");
	//freopen("/tmp/game.in", "r", stdin);
	//freopen("/tmp/game.out", "w", stdout);
	//move randomly at each state
	//encode the data in the random choices
	int t; std::cin >> t;
	std::cin >> N >> K >> M;
	if(t == 1)
	{
		std::string msgs; std::cin >> msgs;
		//fprintf(stderr, "%d %d %d %d\n", N, K, M, msgs.size());
		long_int num { std::vector<uint32_t>(msgs.size() / 32) }; //32 divides 1e5
		for(int i = 0; i < M; i++)
		{
			num.data[i/32] |= (msgs[i]-'0') << (i % 32);
			//e.g. i=0 sets lsb, i=32 sets lsb of 1
		}
		bool first_turn = true;
		while(!num.is_zero())
		{
			state st = { std::vector<int>(N) };
			bool my_turn = first_turn;
			bool done = false;
			while(!done)
			{
				//for(int el : st.data)
				//	fprintf(stderr, "%3d", el);
				//fprintf(stderr, "\n");
				if(my_turn)
				{
					std::vector<std::pair<int,int>> moves;
					for(int move = 0; move < N; move++)
					for(int mval = 1; mval <= N; mval++)
					{
						if(st.data[move] >= mval) continue;
						int cost = 0;
						for(int i = 0; i <= move; i++)
							cost += std::max(0, mval - st.data[i]);
						if(cost >= 3) continue;
						moves.push_back({move, mval});
					}
					auto[nnum, mi] = num.divmod(moves.size());
					num = nnum;
					//printf("%d %d\n", mi, moves.size());
					//for(int i = 0; i < M; i++)
					//	printf("%d", num.data[i/32]>>(i%32) & 1);
					//printf("\n");
					auto[move, mval] = moves[mi];
					printf("%d %d\n", 33 - (move + 1), 33 - mval);
					//fprintf(stderr, "%d %d\n", 33 - (move + 1), 33 - mval);
					fflush(stdout);
					for(int i = 0; i <= move; i++)
						st.data[i] = std::max(st.data[i], mval);
					if(move == N-1 && mval == N)
						done = true;
				}
				else
				{
					int move, mval;
					scanf("%d%d", &move, &mval);
					move--;
					move = 31 - move; mval = 33 - mval;
					//auto[move, mval] = get_opponent_move(st);
					for(int i = 0; i <= move; i++)
						st.data[i] = std::max(st.data[i], mval);
					if(move == N-1 && mval == N)
						done = true;
				}
				my_turn = !my_turn;
			}
			first_turn = !first_turn;
		}
		printf("0\n");
	}
	if(t == 2)
	{
		int G; std::cin >> G;
		long_int num { std::vector<uint32_t>(M / 32) }; //32 divides 1e5
		std::vector<std::pair<int,int>> rec;
		bool first_turn = true;
		while(G --> 0)
		{
			state st = { std::vector<int>(N) };
			bool done = false;
			bool my_turn = first_turn;
			while(!done)
			{
				int move,mval;
				scanf("%d%d", &move, &mval);
				//printf("move %d, mval=%d, me=%d\n", move, mval, (int)my_turn);
				move--;
				move = 31 - move; mval = 33 - mval;
				if(my_turn)
				{
					std::vector<std::pair<int,int>> moves;
					for(int move = 0; move < N; move++)
					for(int mval = 1; mval <= N; mval++)
					{
						if(st.data[move] >= mval) continue;
						int cost = 0;
						for(int i = 0; i <= move; i++)
							cost += std::max(0, mval - st.data[i]);
						if(cost >= 3) continue;
						moves.push_back({move, mval});
						//moves.push_back({move, mval});
					}
					int mi = -1;
					for(int i = 0; i < moves.size(); i++)
						if(moves[i].first == move && moves[i].second == mval)
							mi = i;
					rec.push_back({mi, moves.size()});
				}
				//num = num * moves.size() + mi;
				//printf("%d\n", num);
				for(int i = 0; i <= move; i++)
					st.data[i] = std::max(st.data[i], mval);
				if(move == N-1 && mval == N) done = true;
				my_turn = !my_turn;
			}
			first_turn = !first_turn;
		}
		std::reverse(rec.begin(), rec.end());
		for(auto[mi,ms] : rec)
		{
			num = num * ms + mi;
			//printf("%d %d\n", mi, ms);
			//for(int i = 0; i < M; i++)
			//	printf("%d", num.data[i/32]>>(i%32) & 1);
			//printf("\n");
		}
		for(int i = 0; i < M; i++)
			printf("%d", num.data[i/32]>>(i%32) & 1);
		printf("\n");
	}
}

//num = 123
//move 3, then move 2, then move 1
//reconstructing:
