//#pragma GCC optimize("Ofast")
//#define _GLIBCXX_DEBUG
#include <iostream>
#include <string>
#include <cmath>
#include <random>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <array>
#include <cstdio>
#include <climits>

std::vector<std::vector<int>> children;
std::vector<int> type;
std::vector<int> cur;
struct cert
{
	std::vector<int> perm;
	std::vector<cert*> ccerts;
	int min, max;
};
std::vector<cert*> try_cur(int at)
{
	std::vector<cert*> ans;
	if(type[at] == 2)
	{
		for(int i : children[at])
		{
			cert* c = new cert { {i}, {}, i, i };
			ans.push_back(c);
		}
		return ans;
	}
	int ccnt = children[at].size();
	std::vector<int> perm(ccnt);
	for(int i = 0; i < ccnt; i++)
		perm[i] = i;
	do
	{
		//try all combinations of all outputs, and all permutations
		std::vector<std::vector<cert*>> c_out(ccnt);
		for(int i = 0; i < ccnt; i++)
			c_out[i] = try_cur(children[at][i]);
		std::vector<int> cur(ccnt);
		int64_t time = 1;
		for(auto& v : c_out) time *= v.size();
		for(int i = 0; i < time; i++)
		{
			//try this permutation and these certificates.
			int max = -1000;
			bool ok = true;
			for(int j : perm)
			{
				cert* cc = c_out[j][cur[j]];
				if(cc->min < max) ok = false;
				max = cc->max;
			}
			//for(int j : perm) printf("%d ", j);
			//printf(",");
			//for(int el : cur) printf("%d ", el);
			//printf(": %d\n", ok);
			//for(int i = 0; i < ccnt; i++)
			//	printf("%d-%d ", c_out[i][cur[i]]->min, c_out[i][cur[i]]->max);
			//printf("\n");
			if(ok)
			{
				cert* nc = new cert { perm, {}, c_out[perm[0]][cur[perm[0]]]->min, max };
				nc->ccerts.resize(ccnt);
				for(int j = 0; j < ccnt; j++)
					nc->ccerts[j] = c_out[j][cur[j]];
				ans.push_back(nc);
			}
			for(int j = 0; j < ccnt; j++)
			{
				cur[j]++;
				if(cur[j] == c_out[j].size()) cur[j] = 0; else break;
			}
		}
	} while(std::next_permutation(perm.begin(), perm.end()));
	return ans;
}
std::vector<cert*> pcerts;
void place(int at, cert* c)
{
	pcerts[at] = c;
	if(type[at] == 2) return;
	int ccnt = children[at].size();
	//for(int ci = 0; ci < ccnt; ci++)
	//first in perm goes first
	//for(int el : c->perm) printf("%d ", el); printf("\n");
	for(int i = 0; i < ccnt; i++)
	{
		place(children[at][c->perm[i]], c->ccerts[c->perm[i]]);
	}
}
int main()
{
	int n; std::cin >> n;
	children.resize(n);
	type.resize(n);
	for(int i = 0; i < n; i++)
	{
		int t, k; std::cin >> t >> k;
		type[i] = t;
		children[i].resize(k);
		for(int& c : children[i]) std::cin >> c, c -= t == 1;
	}
	//iterate over consultants' actions
	//int64_t time = 1;
	//for(int i = 0; i < n; i++)
	//	if(type[i] == 2) time *= children[i].size();
	//cur.resize(n);
	//for(int i = 0; i < time; i++)
	//{
		std::vector<cert*> cs = try_cur(0);
		//printf("%d\n", cs.size());
		if(cs.size() != 0)
		{
			printf("Yes\n");
			cert* cur = cs[0];
			pcerts.resize(n);
			place(0, cur);
			for(int i = 0; i < n; i++)
			{
				for(int el : pcerts[i]->perm)
				{
					if(type[i] == 1)
						printf("%d ", children[i][el]+1);
					else printf("%d ", el);
				}
				printf("\n");
			}
			return 0;
		}
	//	for(int j = 0; j < n; j++)
	//	{
	//		cur[j]++;
	//		if(type[j] == 1 || cur[j] >= children[j].size())
	//			cur[j] = 0;
	//		else break;
	//	}
	//}
	printf("No\n");
}
