#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define sz(v) (int)(v).size()

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;

const ll INF = ll(2e9) + 100100, LINF = ll(1e18) + 100100;
const double EPS = 1e-9, PI = atan2(0.0, -1.0);
const int MAXN = signed(1e5) + 100, MAXLOG = 20;

struct SegmentTree {
    int n;
    vector<pair<int, int>> t;

    SegmentTree() {}

    SegmentTree(int _n) {
        n = _n;
        t.resize(4 * n, {-INF, INF});
    }

    inline int lson(int v) {
        return v * 2 + 1;
    }

    inline int rson(int v) {
        return v * 2 + 2;
    }

    inline void relax(int v) {
        t[v].first = min(t[lson(v)].first, t[rson(v)].first);
        t[v].second = max(t[lson(v)].second, t[rson(v)].second);
    }

    pair<int, int> get(int v, int tl, int tr, int l, int r) {
        if (r <= tl || tr <= l) return {INF, -INF};
        if (l <= tl && tr <= r) return t[v];

        int tm = (tl + tr) / 2;
        pair<int, int> a = get(lson(v), tl, tm, l, r);
        pair<int, int> b = get(rson(v), tm, tr, l, r);

        return {min(a.first, b.first), max(a.second, b.second)};
    };

    inline pair<int, int> get(int l, int r) {
        return get(0, 0, n, l, r + 1);
    }

    void update(int v, int tl, int tr, int pos, int x) {
        if (tr - tl == 1) {
            if (x == -1) t[v] = {-INF, INF};
            else t[v] = {x, x};
        }
        else {
            int tm = (tl + tr) / 2;

            if (pos < tm) update(lson(v), tl, tm, pos, x);
            else update(rson(v), tm, tr, pos, x);

            relax(v);
        }
    }

    inline void update(int pos, int x) {
        update(0, 0, n, pos, x);
    }
};

int n;
vector<vector<int>> can, pos;
string s, ans, cur;
SegmentTree segtree;

void rec(int i) {
    if (i == n) {
        if (ans.empty()) ans = cur;
        else ans = min(ans, cur);
        return;
    }

    int idx = s[i] - 'a';
    int tempPlace = -1;

    for (auto good : can[idx]) {
        for (auto place : pos[good]) {
            if (i < place) break;
            pair<int, int> temp = segtree.get(place + 1, i - 1);
            if (temp.first < place || temp.second == INF) continue;
            tempPlace = place;
            break;
        }

        if (tempPlace != -1) break;
    }

    if (tempPlace != -1) {
        segtree.update(i, tempPlace);
        rec(i + 1);
        segtree.update(i, -1);
    }

    cur += s[i];
    rec(i + 1);
    cur.pop_back();
}

signed main() {
    fastio;

    int k; cin >> k >> n;
    can.resize(k);

    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char x; cin >> x;
            if (x == '1') can[j].push_back(i);
        }
    }

    pos.resize(k);
    cin >> s;

    for (int i = 0; i < sz(s); ++i) {
        int temp = s[i] - 'a';
        pos[temp].push_back(i);
    }

    segtree = SegmentTree(n);
    rec(0);

    cout << ans;

    return 0;
}