#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
using namespace std;

const int INF = 1e9;
const int MOD = 228228227;

void get_answer(vector <pair <int, int>> &deletions, vector <int> &s, vector <bool> &deleted, vector <int> &answer, vector <int> &prevs, vector <int> &nexts, int n) {
    vector <int> new_s;
    for (int i = 0; i < n; i++) {
        if (deleted[i]) continue;
        new_s.push_back(s[i]);
    }

    if (new_s < answer) {
        answer = new_s;
    }

    for (auto [i, j]: deletions) {
        for (int k = 0; k < n; k++) {
            if (deleted[k]) continue;
            if (s[k] == j && prevs[k] != -1 && s[prevs[k]] == i) {
                deleted[k] = true;

                if (nexts[k] < n) prevs[nexts[k]] = prevs[k];
                nexts[prevs[k]] = nexts[k];

                get_answer(deletions, s, deleted, answer, prevs, nexts, n);

                if (nexts[k] < n) prevs[nexts[k]] = k;
                nexts[prevs[k]] = k;

                deleted[k] = false;
            }
        }
    }
}

inline void get_rekt(map <int, map <int, bool>> &deletions, vector <int> &s, vector <bool> &deleted, int a, int b) {
    if (!deletions[a][b]) return;

    for (int i = 0; i < (int) s.size(); i++) {
        if (deleted[i]) continue;
        if (s[i] != a) continue;

        for (int j = i + 1; j < (int) s.size(); j++) {
            if (deleted[j]) continue;
            if (s[j] == b) {
                deleted[j] = true;
            } else {
                break;
            }
        }
    }
}

inline void solve() {
    int k, n;
    cin >> k >> n;

    map <int, map <int, bool>> deletions;

    char x;
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            cin >> x;

            if (x == '1') {
                deletions[i][j] = true;
            }
        }
    }

    string str_s;
    cin >> str_s;

    vector <int> s(n);
    for (int i = 0; i < n; i++) {
        s[i] = str_s[i] - 'a';
    }

    vector <bool> deleted(n);
    get_rekt(deletions, s, deleted, 1, 1);
    get_rekt(deletions, s, deleted, 0, 1);
    get_rekt(deletions, s, deleted, 1, 0);
    get_rekt(deletions, s, deleted, 1, 1);

    for (int i = 0; i < n; i++) {
        if (deleted[i]) continue;
        cout << (char)('a' + s[i]);
    }

    cout << '\n';
}

signed main() {
    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    solve();
}
