#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <cassert>
using namespace std;
typedef long long ll;

const int send = 1;

int n, k, m;

inline void set(vector <vector <bool>>& a, int i, int j)
{
	for (int x = i; x <= n; ++x)
	{
		for (int y = j; y <= n; ++y)
		{
			a[x][y] = true;
		}
	}
}

inline void move_my(vector <vector <bool>>& a, int i, int j)
{
	cout << i << ' ' << j << endl;
	set(a, i, j);
}

inline void move_bot(vector <vector <bool>>& a)
{
	int i, j;
	cin >> i >> j;

	/*vector <pair <int, int>> free;
	for (int i = 1; i <= n; ++i)
	{
		for (int j = 1; j <= n; ++j)
		{
			if (!a[i][j])
			{
				free.push_back({ i, j });
			}
		}
	}
	random_shuffle(free.begin(), free.end());
	int i = free[0].first;
	int j = free[0].second;
	cout << i << ' ' << j << endl;*/
	set(a, i, j);
}

inline void print(vector <vector <bool>>& a)
{
	for (int i = n; i >= 1; --i)
	{
		for (int j = 1; j <= n; ++j)
		{
			cout << a[i][j];
		}
		cout << endl;
	}
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	int t;
	cin >> t;

	if (t == 1)
	{

		cin >> n >> k >> m;

		vector <int> code(m);

		for (int i = 0; i < m; ++i)
		{
			char c;
			cin >> c;
			code[i] = c - '0';
		}

		int to_code = 0;

		bool my_turn = true;
		while (to_code < m)
		{
			vector <vector <bool>> bad(n + 1, vector <bool>(n + 1));
			bool turn = my_turn;

			int done = 0;

			while (!bad[1][1])
			{
				if (turn)
				{
					if (done)
					{
						move_my(bad, 1, 1);
						break;
					}
					while (true)
					{
						int i = rand() % 16 + 1;
						int j = rand() % 16 + 1;
						if (i == 1 && j == 1) continue;
						if (bad[i][j]) continue;

						if (code[to_code]) move_my(bad, i, j);
						else move_my(bad, 1, 1);
						to_code++;
						break;
					}
					++done;
				}
				else
				{
					move_bot(bad);
				}
				turn = !turn;
				//print(bad);
			}

			my_turn = !my_turn;
		}

		assert(false);
		int F;
		while (cin >> F);

		cout << 0 << endl;
		return 0;
	}
	else
	{
		cin >> n >> k >> m;

		vector <int> code(m);

		int to_code = 0;

		bool my_turn = true;
		while (to_code < m)
		{
			vector <vector <bool>> bad(n + 1, vector <bool>(n + 1));
			bool turn = my_turn;

			int done = 0;

			while (!bad[1][1])
			{
				if (turn)
				{
					if (done)
					{
						int i, j;
						cin >> i >> j;
						break;
					}

					int i, j;
					cin >> i >> j;

					set(bad, i, j);
					if (make_pair(i, j) != make_pair(1, 1))
					{
						code[to_code] = 1;
					}

					to_code++;

					++done;
				}
				else
				{
					int i, j;
					cin >> i >> j;
					set(bad, i, j);
				}
				turn = !turn;
				//print(bad);
			}

			my_turn = !my_turn;
		}

		int F;
		while (cin >> F);

		for (int i = 0; i < m; ++i)
		{
			cout << code[i];
		}
		cout << endl;
		return 0;
	}
}