#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define ALL(x) (x).begin(), (x).end()

int mode;
int n;
vector<vector<bool>> field;
bool game_started = false;
int games = 0;
int k, m;

pair<pair<int, int>, int> try_to_paint_k(int k) {
    pair<int, int> some_possible_turn;
    for (int x = 0; x < n; ++x) {
        for (int y = 0; y < n; ++y) {
            if (field[x][y]) continue;
            int cnt = 0;
            for (int i = x; i < n; ++i) {
                for (int j = y; j < n; ++j) {
                    if (!field[i][j]) cnt++;
                }
            }
            if (cnt == k) {
                return make_pair(make_pair(x, y), k);
            }
            if (cnt == 1) {
                some_possible_turn = make_pair(x, y);
            }
        }
    }
    return make_pair(some_possible_turn, 1);
}

void paint_to_turn(int x, int y) {
    for (int i = x; i < n; ++i) {
        for (int j = y; j < n; ++j) {
            field[i][j] = true;
        }
    }
}

int how_much_was_painted(int x, int y) {
    int cnt = 0;
    for (int i = x; i < n; ++i) {
        for (int j = y; j < n; ++j) {
            if (!field[i][j]) cnt++;
            field[i][j] = true;
        }
    }
    return cnt;
}

void process_ai_turn() {
    int x, y;
    cin >> x >> y;
    if (x == 1 && y == 1) {
        game_started = false;
        field.clear();
    } else {
        paint_to_turn(x, y);
    }
}

bool make_next_turn(int need_to_paint) {
    if (!game_started) {
        games++;
        game_started = true;
        field.resize(n, vector<bool>(n, false));
        if (games % 2 == 0) {
            process_ai_turn();
        }
    }
    auto result = try_to_paint_k(need_to_paint);
    cout << result.first.first + 1 << ' ' << result.first.second + 1 << endl;
    if (result.first.first * result.first.second != 1) {
        process_ai_turn();
    } else {
        game_started = false;
    }
    return result.second == need_to_paint;
}

void talker() {
    string message;
    cin >> message;
    int cur_next_char = 0;
    while (cur_next_char < m) {
        string next_chunk = message.substr(cur_next_char, min(3, m - cur_next_char));
        int need_to_paint = 0;
        int _cp = 0;
        for (int i = ((int) next_chunk.size() - 1); i >= 0; --i) {
            if (next_chunk[i] == '1') {
                need_to_paint += 1 << _cp;
            }
            _cp++;
        }
        need_to_paint += 2;
        if (make_next_turn(need_to_paint)) {
            cur_next_char += 3;
        }
    }
    while (game_started) {
        make_next_turn(1);
    }
    int q;
    if (games % 2 == 0) {
        cin >> q >> q;
    }
    cout << 0 << endl;
}

void listener() {
    int g_cnt;
    cin >> g_cnt;
    vector<int> numbers;
    for (int i = 0; i < g_cnt; ++i) {
        field.clear();
        field.resize(n, vector<bool>(n, false));
        int x, y;
        cin >> x >> y;
        x--; y--;
        int ind = 0;
        while (x * y != 1) {
            int q = how_much_was_painted(x, y);
            if ((ind % 2) == (i % 2)) {
                numbers.emplace_back(q);
            }
            cin >> x >> y;
        }
    }
    string ans;
    for (int e : numbers) {
        e -= 2;
        if (e < 0) continue;
        for (int i = 0; i < 3; ++i) {
            if (e & (1 << (3 - i - 1))) {
                ans += '1';
            } else {
                ans += '0';
            }
        }
    }
    ans = ans.substr(0, m);
    cout << ans << endl;
}

int solve() {
    if (!(cin >> mode))
        return 1;
    cin >> n >> k >> m;
    if (mode == 1) {
        talker();
    } else {
        listener();
    }
    return 0;
}

int main() {

    int tests = 1;
    // cin >> tests;
    for (int i = 1; i <= tests; ++i) {
        if (solve())
            break;
#ifdef LOCAL
        cout << "-------------------------\n";
#endif
    }
}
