#include <algorithm>
#include <iostream>
#include <set>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

const int N = 5e5 + 7;
const int K = 26;

int k, n;
char g[K][K];
int a[N];
vector<int> dp[N];

string solve() {
  dp[n] = {};
  vector<int> stack = {};
  for (int i = n - 1; i >= 0; --i) {
    while (!stack.empty() && g[a[i]][a[stack.back()]]) {
      stack.pop_back();
    }
    int mx = (stack.empty() ? n : stack.back());
    dp[i] = dp[i + 1];
    for (int j = i + 2; j <= mx; ++j) {
      dp[i] = min(dp[i], dp[j]);
    }
    stack.push_back(i);
    dp[i].insert(dp[i].begin(), a[i]);
  }
  string res;
  for (int x : dp[0]) {
    res.push_back(x + 'a');
  }
  return res;
}

void gen_test() {
  k = 5;
  n = 7;
  for (int i = 0; i < k; ++i) {
    for (int j = 0; j < k; ++j) {
      g[i][j] = rand() % 2;
    }
  }
  for (int i = 0; i < n; ++i) {
    a[i] = rand() % k;
  }
}

string stupid_solve(vector<int> arr) {
  string res = "";
  for (int x : arr) {
    res.push_back(x + 'a');
  }
  for (int i = 1; i < SZ(arr); ++i) {
    if (g[arr[i - 1]][arr[i]]) {
      int x = arr[i];
      arr.erase(arr.begin() + i);
      res = min(res, stupid_solve(arr));
      arr.insert(arr.begin() + i, x);
    }
  }
  return res;
}

void print_test() {
  cout << k << ' ' << n << '\n';
  for (int i = 0; i < k; ++i) {
    for (int j = 0; j < k; ++j) {
      cout << (int)g[i][j];
    }
    cout << '\n';
  }
  for (int i = 0; i < n; ++i) {
    cout << (char)(a[i] + 'a');
  }
  cout << '\n';
}

void stresstest() {
  int test_n = 1;
  while (true) {
    cout << "TEST #" << test_n++ << '\n';
    gen_test();
    if (solve() != stupid_solve(vector<int>(a, a + n))) {
      cout << "FAIL\n";
      print_test();
      cout << "MY ANS: " << solve() << '\n';
      cout << "R8 ANS: " << stupid_solve(vector<int>(a, a + n)) << '\n';
      system("pause");
    } else {
      cout << "SUCCES\n";
    }
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cout.tie(NULL);
  // stresstest();
  cin >> k >> n;
  for (int i = 0; i < k; ++i) {
    for (int j = 0; j < k; ++j) {
      cin >> g[i][j];
      g[i][j] -= '0';
    }
  }
  for (int i = 0; i < n; ++i) {
    char c;
    cin >> c;
    a[i] = c - 'a';
  }
  cout << solve() << '\n';
  return 0;
}
/*
4 6
0001
1110
0110
1010
adcbda
MY ANS: abd
R8 ANS: a
*/
/*
4 6

abcd
a0001
b1110
c0110
d1010

adcbda
MY ANS: abd
R8 ANS: a
*/
