#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <numeric>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 7;

void Dfs(int v, vector <vector <int>> &g, vector <bool>& used, vector <int>& ts) {
	used[v] = true;
	for (auto i : g[v]) {
		if (!used[i]) {
			Dfs(i, g, used, ts);
		}
	}
	ts.push_back(v);
}

void Solve() {
	int n, m; string s;
	cin >> n >> m >> s;
	vector <vector <int>> cor(m);
	vector <vector <int>> incor(m);
	vector <vector <pair <int, char>>> init(n);
	for (int i = 0; i < n; i++) {
		int t;
		cin >> t;
		for (int j = 0; j < t; j++) {
			int a; char c;
			cin >> a >> c;
			a--;
			init[i].push_back({ a, c });
			if (s[a] == c) cor[a].push_back(i);
			else incor[a].push_back(i);
		}
	}

	vector <vector <int>> g(n);
	for (int i = 0; i < m; i++) {
		if (cor[i].empty()) {
			cout << -1;
			return;
		}
		for (auto f : incor[i]) {
			for (auto s : cor[i]) {
				g[f].push_back(s);
			}
		}
	}
	vector <bool> used(n);
	vector <int> ts;

	for (int i = 0; i < n; i++) {
		if (!used[i]) Dfs(i, g, used, ts);
	}


	string st;
	for (int i = 0; i < m; i++) st += " ";
	for (auto pos : ts) {
		for (auto j : init[pos])
			if (st[j.first] == ' ') st[j.first] = j.second;
	}
	if (st == s) {
		for (auto pos : ts)
			cout << pos + 1 << " ";
		return;
	}
	cout << -1;
}

void Easy() {
	int n, m; string s;
	cin >> n >> m >> s;

	vector <pair <vector <pair <int, char>>, int>> v(n);

	for (int i = 0; i < n; i++) {
		int t;
		cin >> t;
		v[i] = { {}, i+1 };
		for (int j = 0; j < t; j++) {
			int a; char c;
			cin >> a >> c;
			a--;
			v[i].first.push_back({ a, c });
		}
	}

	sort(v.begin(), v.end());

	do {
		string st;
		for (int i = 0; i < m; i++) st += " ";
		for (auto u : v) {
			for (auto j : u.first)
				if (st[j.first] == ' ') st[j.first] = j.second;
		}
		if (st == s) {
			for (auto u : v)
				cout << u.second << " ";
			return;
		}

	} while (next_permutation(v.begin(), v.end()));
	cout << -1;
}


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	Solve();
}