#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include "bits/stdc++.h"
#define ll long long
#define vi vector<ll>
#define vvi vector<vi>
#define mp make_pair
#define pii pair<ll, ll>
#define pb push_back
#define all(x) x.begin(), x.end()
#define mn(a, b) a = min(a, b)
const ll MAXN = 32;

using namespace std;

int matr[MAXN][MAXN];

void clear_matr() {
    for (int i = 0; i < MAXN; ++i) {
        for (int j = 0; j < MAXN; ++j) {
            matr[i][j] = 0;
        }
    }
}

bool color(int i, int j) {
    if (matr[i][j]) return 0;
    for (int ii = i; ii < MAXN; ++ii) {
        for (int jj = j; jj < MAXN; ++jj) {
            matr[ii][jj] = 1;
        }
    }
    return 1;
}

pii interact(ll x, ll y) {
    cout << x + 1 << " " << y + 1 << "\n";
    cout.flush();
    cin >> x >> y;
    return mp(x - 1, y - 1);
}

string to_bit(int x) {
    string ans(5, '0');
    for (int i = 4; i > -1; --i) {
        if (1 << i & x) ans[4 - i] = '1';
    }
    return ans;
}

int from_bit(string x) {
    int ans = 0;
    for (int i = 0; i < 5; ++i) {
        ans <<= 1;
        ans += (x[i] - '0');
    }
    return ans;
}

void solve() {
    int t; cin >> t;
    int n, k, m; cin >> n >> k >> m;
    if (t == 1) {
        int games = 0;
        bool game_ended = 0;
        string s; cin >> s;
        int ptr = 0;
        while (ptr != s.size()) {
            game_ended = 0;
            int y = from_bit(s.substr(ptr, 5));
            ptr += 5;
            bool say = 0;
            for (int x = MAXN - 1; x > -1; --x) {
                if (x == 0 && y == 0) continue;
                if (color(x, y)) {
                    pii play = interact(x, y);
                    color(play.first, play.second);
                    say = 1;
                    if (play.first == 0 && play.second == 0) {
                        clear_matr();
                        ++games;
                        game_ended = 1;
                        if (games % 2) {
                            int x, y; cin >> x >> y;
                            --x, --y;
                            color(x, y);
                        }
                        break;
                    }
                    break;
                }
            }
            if (!say) {
                interact(0, 0);
                game_ended = 1;
                ++games;
                clear_matr();
                if (games % 2) {
                    int x, y; cin >> x >> y;
                    --x, --y;
                    color(x, y);
                }
                ptr -= 5;
            }
        }
        int x, y;
        if (!game_ended) {
            interact(0, 0);
            while (cin >> x >> y);
        }
        cout << "0\n";
        cout.flush();
    } else {
        int g; cin >> g;
        int x, y; bool play = 1;
        int cnt = 0;
        string ans;
        while (cin >> x >> y) {
            if (x == 1 && y == 1) {
                ++cnt;
                play = (cnt % 2) ^ 1;
                continue;
            }
            --x, --y;
            if (play) ans += to_bit(y);
            play ^= 1;
        }
        cout << ans << "\n";
        cout.flush();
    }
}

int main() {
#ifdef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    freopen("\\\\.\\pipe\\game.in", "r", stdin);
    freopen("\\\\.\\pipe\\game.out", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    cout.precision(30);
    solve();

    return 0;
}
