#include <_msvc_all_public_headers.hpp>

using namespace std;
using ll = long long;
#define all(o) o.begin(), o.end()


void solve() {
    int n, m; cin >> n >> m;
    string s; cin >> s;
    vector<string> q(n, string(m, ' '));
    vector<vector<int8_t>> ok(n, vector<int8_t>(m, 1));
    vector<int> oks(n, m);
    vector<bool> cur_oks(m, false);
    vector<bool> filled(m, false);

    for (int i = 0; i < n; ++i) {
        int k; cin >> k;
        for (int j = 0; j < k; ++j) {
            int index; char c; cin >> index >> c; index--;
            q[i][index] = c;
            if (c != s[index]) {
                ok[i][index] = false;
                oks[i]--;
            }
        }
    }

    multimap<int, int, greater<>> strings;
    for (int i = 0; i < n; ++i) {
        strings.insert({oks[i], i});
    }

    vector<int> result;

    for (int i = 0; i < n; ++i) {
        auto p = strings.begin();
        if (p->first != m) {
            cout << "-1\n";
            return;
        }
        strings.erase(p);
        int s_i = p->second;
        result.push_back(s_i);
        for (int j = 0; j < m; ++j) {
            if (q[s_i][j] != ' ') {
                filled[j] = true;
            }
            if (q[s_i][j] == s[j] && !cur_oks[j]) {
                cur_oks[j] = true;
                for (int k = 0; k < n; ++k) {
                    if (!ok[k][j]) {
                        ok[k][j] = true;
                        strings.erase(strings.find(oks[k]));
                        oks[k]++;
                        strings.insert({oks[k], k});
                    }
                }
            }
        }
    }

    for (int i = 0; i < m; ++i) {
        if (!filled[i]) {
            cout << "-1\n";
            return;
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << result[i] + 1 << " ";
    }
    cout << "\n";
}

int main() {
#if ELT
    freopen("../A.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
    int q; cin >> q;
    for (int i = 0; i < q; i++) {
        // cout << " -- TEST " << i + 1 << " --\n";
        solve();
    }
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(0);
    solve();
#endif
    return 0;
}