#include <bits/stdc++.h>
#include <random>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ld;
#define mp make_pair
#define pb push_back
#define all(x) x.begin(), x.end()

vector<vector<int>> g;
vector<int> t;
vector<pair<int, int>> borders;
int n;

bool ok = true;

void dfs(int v) {
    vector<pair<int, int>> cur;
    for (int u : g[v]) {
        dfs(u);
        cur.pb(borders[u]);
    }
    sort(all(cur));
    for (int i = 1; i < cur.size(); ++i) {
        if (cur[i].first < cur[i - 1].second) {
            ok = false;
        }
    }
    if (t[v] == 1)
        borders[v] = mp(cur[0].first, cur.back().second);
}

vector<vector<int>> ans;

void dfs_recovery(int v) {
    if (t[v] == 1) {
        vector<pair<pair<int, int>, int>> cur;
        for (int u : g[v]) {
            dfs_recovery(u);
            cur.pb(mp(borders[u], u));
        }
        sort(all(cur));
        borders[v] = mp(cur[0].first.first, cur.back().first.second);
        for (int i = 0; i < cur.size(); ++i) {
            ans[v].pb(cur[i].second);
        }
    } else {
        ans[v].pb(borders[v].first);
    }
}

inline void SOLVE() {
    cin >> n;
    g.resize(n);
    t.resize(n);
    borders.resize(n, mp(2e9, -2e9));
    vector<pair<int, int>> all_variants;
    ans.resize(n);
    for (int i = 0; i < n; ++i) {
        int type;
        cin >> type;
        if (type == 1) {
            int k;
            cin >> k;
            for (int j = 0; j < k; ++j) {
                int u;
                cin >> u;
                u--;
                g[i].pb(u);
            }
        } else {
            int m;
            cin >> m;
            for (int j = 0; j < m; ++j) {
                int x;
                cin >> x;
                all_variants.pb(mp(x, i));
            }
        }
        t[i] = type;
    }
    for (int i = 0; i < (1 << all_variants.size()); ++i) {
        vector<bool> used(n);
        borders.assign(n, mp(2e9, -2e9));
        bool f = true;
        for (int j = 0; j < all_variants.size(); ++j) {
            if ((i >> j) & 1) {
                int val = all_variants[j].first;
                int id = all_variants[j].second;
                if (used[id])
                    f = false;
                else {
                    used[id] = true;
                    borders[id] = mp(val, val);
                }
            }
        }
        for (int i = 0; i < n; ++i) {
            if (t[i] == 2 && !used[i])
                f = false;
        }
        if (f) {
            ok = true;
            dfs(0);
            if (ok) {
                cout << "Yes\n";
                dfs_recovery(0);
                for (int e = 0; e < n; ++e) {
                    for (int elem : ans[e]) {
                        if (t[e] == 1) {
                            cout << elem + 1 << ' ';
                        } else
                            cout << elem;
                    }
                    cout << '\n';
                }
                return;
            }

        }
    }
    cout << "No";
}

inline void FASTIO() {
    cin.tie(NULL);
    ios::sync_with_stdio(false);
}

int main() {
#ifdef GOSHA
    freopen("../IO/input.txt", "r", stdin);
    freopen("../IO/output.txt", "w", stdout);
#endif
    FASTIO();
    SOLVE();
}