#include <iostream>
#include <cstring>
#include <vector>
#include <string>
#include <cassert>
#include <algorithm>

using namespace std;

int k, n;
bool** a;

string* ans;
int* tree, b;

inline void build_tree(int n)
{
	b = 1;
	while (b < n)
		b *= 2;
	tree = new int[2 * b];
	for (int i = 1; i < 2 * b; i++)
		tree[i] = -1;
}

inline void update(int t)
{
	if (tree[t * 2] == -1 || tree[t * 2 + 1] == -1)
	{
		tree[t] = (tree[t * 2] == -1 ? tree[t * 2 + 1] : tree[t * 2]);
		return;
	}
	if (ans[tree[t * 2]] < ans[tree[t * 2 + 1]])
		tree[t] = tree[t * 2];
	else
		tree[t] = tree[t * 2 + 1];
}

inline void add(int pos)
{
	int t = b + pos;
	tree[t] = pos;
	t /= 2;
	while (t > 0)
	{
		update(t);
		t /= 2;
	}
}

inline int get_min_from(int i, int j)
{
	if (i == -1 || j == -1)
		return (i == -1 ? j : i);
	if (ans[i] < ans[j])
		return i;
	else
		return j;
}

inline int get_min(int t, int tl, int tr, int left, int right)
{
	if (left >= right)
		return -1;
	if (tl == left && tr == right)
		return tree[t];
	int mid = (tl + tr) / 2;
	return get_min_from(get_min(t * 2, tl, mid, left, min(right, mid)), get_min(t * 2 + 1, mid, tr, max(left, mid), right));
}

int main()
{
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	char c;
	cin >> k >> n;
	a = new bool* [k];
	for (int i = 0; i < k; i++)
	{
		a[i] = new bool[k];
		for (int j = 0; j < k; j++)
		{
			cin >> c;
			a[i][j] = (c == '1');
		}
	}
	int* str = new int[n];
	for (int i = 0; i < n; i++)
	{
		cin >> c;
		str[i] = c - 'a';
	}
	bool** dp = new bool* [n + 1];
	for (int i = 0; i <= n; i++)
	{
		dp[i] = new bool[n + 1];
		memset(dp[i], 0, (n + 1) * sizeof(bool));
		dp[i][i] = 1;
	}
	
	
	for (int len = 1; len <= n; len++)
	{
		for (int i = 0, j = len; j <= n; i++, j++)
		{
			if (i == 0)
				continue;
			for (int k = i; k < j && !dp[i][j]; k++)
			{
				if (a[str[i - 1]][str[k]] && dp[i][k] && dp[k + 1][j])
					dp[i][j] = 1;
			}
		}
	}

	int* right = new int[n];
	for (int i = 0; i < n; i++)
	{
		right[i] = i + 1;
		while (right[i] < n && a[str[i]][str[right[i]]])
			right[i]++;
	}

	for (int i = n - 1; i >= 0; i--)
	{
		int max_j = right[i];
		for (int j = i + 1; j < right[i]; j++)
			max_j = max(max_j, right[j]);
		right[i] = max_j;
		while (right[i] < n && a[str[i]][str[right[i]]])
			right[i] = right[right[i]];
	}

	ans = new string[n];
	build_tree(n);
	for (int i = n - 1; i >= 0; i--)
	{
		if (right[i] == n)
			ans[i] = char('a' + str[i]);
		else
		{
			int j = get_min(1, 0, b, i, right[i] + 1);
			ans[i] = char('a' + str[i]) + ans[j];

		}
		add(i);
		/*ans[i] += char('a' + str[i]);
		if (right[i] == n)
			continue;
		int best_j = -1;
		for (int j = i + 1; j < n; j++)
		{
			if (right[i] >= j && (best_j == -1 || ans[j] < ans[best_j]))
				best_j = j;
		}
		ans[i] += ans[best_j];*/
	}
	cout << ans[0] << "\n";
}
 