#include <iostream>
#include <set>
#include <vector>
#include <cassert>

using namespace std;

struct cmp
{
	bool operator() (const pair<int, int>& a, const pair<int, int>& b) const
	{
		int sa = a.first + a.second, sb = b.first + b.second;
		if (sa == sb)
			return a.first > b.first;
		return (sa > sb);
	}
};

int n;
set<pair<int, int>, cmp> free_cells[2][2];

void fill_free_cells()
{
	free_cells[0][0].clear();
	free_cells[0][1].clear();
	free_cells[1][0].clear();
	free_cells[1][1].clear();
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j <= n; j++)
		{
			free_cells[i % 2][j % 2].insert({ i, j });
		}
	}
}

void remove_in_rect(int i, int j)
{
	for (int ii = i; ii <= n; ii++)
	{
		for (int jj = j; jj <= n; jj++)
		{
			free_cells[ii % 2][jj % 2].erase({ ii, jj });
		}
	}
}

int main()
{
	int num;
	cin >> num;
	int k, m;
	cin >> n >> k >> m;
	vector<bool> message;
	bool i_first = 1;
	pair<int, int> cell;
	if (num == 1)
	{
		char c;
		for (int i = 0; i < m; i++)
		{
			cin >> c;
			message.push_back(c == '1');
		}
		message.push_back(0);
		int i = 0;
		fill_free_cells();
		while (i < m)
		{
			int sz = free_cells[message[i]][message[i + 1]].size();
			int s = free_cells[0][0].size() + free_cells[0][1].size() + free_cells[1][0].size() + free_cells[1][1].size();
			auto it = free_cells[message[i]][message[i + 1]].begin();
			if (sz == 0 || (it->first == 1 && it->second == 1))
			{
				if (s >= 1)
					cout << "1 1" << endl;
				fill_free_cells();
				i_first = !i_first;
				if (!i_first)
				{
					cin >> cell.first >> cell.second;
					remove_in_rect(cell.first, cell.second);
				}
				continue;
			}
			cell = *it;
			free_cells[message[i]][message[i + 1]].erase(it);
			cout << cell.first << " " << cell.second << endl;
			remove_in_rect(cell.first, cell.second);
			cin >> cell.first >> cell.second;
			remove_in_rect(cell.first, cell.second);
			i += 2;
		}
		int s = free_cells[0][0].size() + free_cells[0][1].size() + free_cells[1][0].size() + free_cells[1][1].size();
		if (s > 0)
			cout << "1 1" << endl;
		cout << "0" << endl;
	}
	else
	{
		int plays;
		cin >> plays;
		while (message.size() < m)
		{
			cin >> cell.first >> cell.second;
			if (cell.first == 1 && cell.second == 1)
			{
				i_first = !i_first;
				if (!i_first)
					cin >> cell.first >> cell.second;
				continue;
			}
			message.push_back(cell.first % 2);
			message.push_back(cell.second % 2);
			cin >> cell.first >> cell.second;
			if (cell.first == 1 && cell.second == 1)
			{
				i_first = !i_first;
				if (!i_first)
					cin >> cell.first >> cell.second;
			}
		}
		//while (cin >> cell.first >> cell.second);
		for (int i = 0; i < m; i++)
			cout << message[i];
		cout << endl;
	}
}
