#include <iostream>
#include <vector>

using namespace std;

#define int long long
#define ll long long

#define pii pair<int, int>
#define ft first
#define sd second
#define mp make_pair

struct card {
	vector<int> poss;
	vector<bool> good;
	int goodcnt;
	int cnt;
	card() {};
	card(int k) {
		poss.resize(k);
		good.resize(k);
		cnt = k;
		goodcnt = 0;
	}
};

void solve() {
	int n, m;
	cin >> m >> n;
	string s;
	cin >> s;
	vector<card> cards(m);
	vector<int> stack;
	vector<vector<int>> reverse(n);
	for (int i = 0; i < m; i++) {
		int k;
		cin >> k;
		cards[i] = card(k);
		for (int j = 0; j < k; j++) {
			char val;
			cin >> cards[i].poss[j] >> val;
			cards[i].poss[j]--;
			if (val == s[cards[i].poss[j]]) {
				cards[i].good[j] = true;
				cards[i].goodcnt++;
			}
			else {
				reverse[cards[i].poss[j]].push_back(i);
			}
		}
		if (cards[i].goodcnt == cards[i].cnt)
			stack.push_back(i);
	}
	vector<bool> covered(n, false);
	vector<int> ans;
	while (stack.size() > 0) {
		int cur = stack.back();
		stack.pop_back();
		ans.push_back(cur + 1);
		for (int pos: cards[cur].poss)
			if (!covered[pos]) {
				covered[pos] = true;
				for (int better : reverse[pos]) {
					cards[better].goodcnt++;
					if (cards[better].goodcnt == cards[better].cnt)
						stack.push_back(better);
				}
			}
	}
	if (ans.size() < m) {
		cout << -1;
		return;
	}
	for (int i = 0; i < n; i++)
		if (!covered[i]) {
			cout << -1;
			return;
		}
	for (int i = 0; i < m; i++)
		cout << ans[i] << ' ';
}

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	// cin >> t;
	while (t--)
		solve();
}