#include <iostream>
#include <vector>
#include <string>
#include <set>

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;
typedef pair <int, int> pii;

int board[33][33];

void move(int x, int y) {
  for (int i = x; i <= 32; i++) {
    for (int j = y; j <= 32; j++) {
      if (board[i][j]) {
        break;
      }
      board[i][j] = 1;
    }
  }
}

void opp_move() {
  int x, y;
  cin >> x >> y;
  move(x, y);
}

void new_game() {
  for (int i = 1; i <= 32; i++) {
    for (int j = 1; j <= 32; j++) {
      board[i][j] = 0;
    }
  }
}

void win() {
  cout << 1 << ' ' << 2 << endl;
  int x, y;
  cin >> x >> y;
  cout << 2 << ' ' << 1 << endl;
  cin >> x >> y;
}

bool my_move(int digit) {
  int cnt = 0;
  for (int i = 1; i <= 32; i++) {
    cnt += board[i][1];
    cnt += board[1][i];
  }
  if (cnt) {
    win();
    return false;
  }
  for (int i = 32; i >= 1; i--) {
    for (int j = 32; j >= 1; j--) {
      if (board[i][j]) {
        continue;
      }
      if (((i + j) & 1) == (digit & 1)) {
        cout << i << ' ' << j << endl;
        move(i, j);
        return true;
      }
    }
  }
}

int main() {
  int type;
  cin >> type;
  int a, b, len;
  cin >> a >> b >> len;
  if (type == 1) {
    string s;
    cin >> s;
    bool i_am_second = false;
    int iter = 0;
    while (iter < len) {
      if (i_am_second) {
        opp_move();
      }
      while (iter < len && my_move(s[iter] - '0')) {
        iter++;
        opp_move();
      }
      if (iter == len) {
        win();
      }
      new_game();
      i_am_second = !i_am_second;
    }
    if (i_am_second) {
      int x, y;
      cin >> x >> y;
    }
    cout << 0 << endl;
  } else {
    int n;
    cin >> n;
    bool i_am_second = false;
    string ans;
    for (int i = 0; i < n; i++) {
      vector <pair <int, int>> mda;
      int x = 123, y = 123;
      while (!(x == 1 && y == 1)) {
        cin >> x >> y;
        mda.push_back({x, y});
      }
      for (int j = (i_am_second ? 1 : 0); j + 4 < (int)mda.size(); j += 2) {
        ans += (char)((mda[j].first + mda[j].second) % 2 + '0');
      }
      i_am_second = !i_am_second;
    }
    cout << ans << endl;
  }
  return 0;
}

/*

1 2
30 1
2 1
1 1

31 31
1 2
30 2
2 1
1 1

1 1

0

 */