#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

using namespace std;

using ll = int;
template <typename T>
using v = vector<T>;
template <typename A, typename B>
using pa = pair<A, B>;

v<v<ll>> children;
v<bool> manager;
v<v<ll>> upgrades;

ll dpv[2000][1 << 8][2000];
bool was[2000][1 << 8][2000];
ll ans[2000][1 << 8][2000];
ll dcdp[2000][1 << 8][2000];

ll dp(ll vert, ll mask, ll ma) {
	if (was[vert][mask][ma]) {
		return dpv[vert][mask][ma];
	}
	else if (manager[vert]) {
		was[vert][mask][ma] = true;
		ll mami = -1;
		ll maans = 0;
		ll macdp = 0;
		if (mask == 0) {
			mami = ma;
		}
		else {
			for (ll i = 0; i < children[vert].size(); ++i) {
				if (mask & (1 << i)) {
					ll cdp = dp(children[vert][i], (1 << children[children[vert][i]].size()) - 1, ma);
					if (cdp != -1) {
						ll ocdp = dp(vert, mask ^ (1 << i), cdp);
						if (ocdp != -1) {
							if (mami == -1 || ocdp > mami) {
								mami = ocdp;
								maans = i;
								macdp = cdp;
							}
						}
					}
				}
			}
		}
		ans[vert][mask][ma] = maans;
		dcdp[vert][mask][ma] = macdp;
		return dpv[vert][mask][ma] = mami;
	}
	else {
		was[vert][mask][ma] = true;
		ll res = -1;
		for (ll i = 0; i < upgrades[vert].size(); ++i) {
			if (upgrades[vert][i] <= ma) {
				res = max(res, upgrades[vert][i]);
			}
		}
		return dpv[vert][mask][ma] = ans[vert][mask][ma] = res;
	}
}

v<v<ll>> ansres;

void ansdfs(ll vert, ll ma) {
	if (manager[vert]) {
		ll cmask = (1 << children[vert].size()) - 1;
		ll cma = ma;
		while (cmask != 0) {
			ll cov = ans[vert][cmask][cma];
			//cout << cov << endl;
			ansres[vert].push_back(children[vert][cov]);
			ansdfs(children[vert][cov], cma);
			ll cocdp = dcdp[vert][cmask][cma];
			cmask ^= (1 << cov);
			cma = cocdp;
		}
		reverse(ansres[vert].begin(), ansres[vert].end());
	}
	else {
		ansres[vert].push_back(ans[vert][0][ma]);
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ll n;
	cin >> n;
	children = v<v<ll>>(n);
	manager = v<bool>(n);
	upgrades = v<v<ll>>(n);
	v<ll> compress;
	for (ll i = 0; i < n; ++i) {
		ll t;
		cin >> t;
		manager[i] = (t == 1);
		if (t == 1) {
			ll k;
			cin >> k;
			children[i] = v<ll>(k);
			for (ll j = 0; j < k; ++j) {
				cin >> children[i][j];
				--children[i][j];
			}
		}
		else {
			ll m;
			cin >> m;
			upgrades[i] = v<ll>(m);
			for (ll j = 0; j < m; ++j) {
				cin >> upgrades[i][j];
				compress.push_back(upgrades[i][j]);
			}
		}
	}
	sort(compress.begin(), compress.end());
	for (ll i = 0; i < n; ++i) {
		if (!manager[i]) {
			for (ll j = 0; j < upgrades[i].size(); ++j) {
				upgrades[i][j] = lower_bound(compress.begin(), compress.end(), upgrades[i][j]) - compress.begin();
			}
		}
	}
	ll d = dp(0, (1 << children[0].size()) - 1, compress.size() - 1);
	if (d == -1) {
		cout << "No";
	}
	else {
		cout << "Yes\n";
		ansres = v<v<ll>>(n);
		ansdfs(0, compress.size() - 1);
		for (ll i = 0; i < n; ++i) {
			if (manager[i]) {
				for (ll j = 0; j < ansres[i].size(); ++j) {
					cout << (ansres[i][j] + 1) << ' ';
				}
				cout << '\n';
			}
			else {
				cout << compress[ansres[i][0]] << '\n';
			}
		}
	}
}