/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,mmx,abm,avx,avx2,popcnt")
*/

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <utility>
#include <functional>
#include <numeric>
#include <chrono>
#include <random>
#include <cassert>


#define int long long
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fx(x, a) for (auto &x : a)
#define siz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define pb push_back
#define ppb pop_back()
#define mp make_pair
#define left left1337
#define right right1337


#ifdef LOCAL 
	#define dbg(x) cout << #x << " : " << x << endl
#else
	#define dbg(x)
#endif

using namespace std;

template<typename T1, typename T2> inline void mine(T1 & x, const T2 &y) {if (y < x) x = y;}
template<typename T1, typename T2> inline void maxe(T1 & x, const T2 &y) {if (x < y) x = y;}


typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef vector<char> vch;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef string str;
typedef vector<str> vs;
typedef vector<vch> vvch;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

int n, k, m;
const int N = 32;
bool col[N][N];

void init() {
	memset(col, 0, sizeof(col));
}
void paint(int i, int j) {
	assert(!col[i][j]);
	for (int ii = i; ii < n; ++ii) {
		for (int jj = j; jj < n; ++jj) {
			col[ii][jj] = 1;
		}
	}
}

void out(int i, int j) {
	cout << j + 1 << ' ' << i + 1 << endl;
	paint(i, j);
}

void read() {
	int j, i;
	cin >> j >> i;
	paint(i - 1, j - 1);
}

vi make(int i) {
	vi lol;
	if (i == 0)
		lol.pb(0);
	while (i > 0) {
		lol.pb(i & 1);
		i /= 2;
	}
	reverse(all(lol));
	return lol;
}

void play() {
	str s;
	cin >> s;
	fx(x, s) x -= '0';
	int ptr = 0;
	int game = 1;
	while (true) {
		init();
		bool we = game & 1;
		if (ptr == m) {
			if (!we) {
				read();
			}
			cout << 0 << endl;
			exit(0);
		}
		while (!col[0][0]) {
			if (we) {	
				vpii can;
				fi(0, n) fj(0, n) if (!col[i][j]) can.pb({i, j});
				//dbg(siz(can));
				if (ptr < m && siz(can) > 1) {
					int best = 0;
					int bestsz = -1;
					for (int i = 0; i < siz(can); ++i) {
						//dbg(i);
						vi lol = make(i);
						//if (i == 15) dbg(i);
						if (siz(lol) > m - ptr) continue;
						//if (i == 15) dbg(i);
						if (siz(lol) <= bestsz) continue;
						//if (i == 15) dbg(i);
						bool ok = true;
						for (int j = 0; j < siz(lol) && ok; ++j) {
							ok &= lol[j] == s[ptr + j];
						}
						if (ok) {
							bestsz = lol.size();
							best = i;
						}
					}
					//dbg(best);
					//dbg(bestsz);
					ptr += bestsz;
					out(can[best].first, can[best].second);
				} else {
					out(0, 0);
				}
			} else {
				read();
			}
			we = !we;
		}
		++game;
	}

}

void solve() {
	int games;
	cin >> games;
	str ans(m, '0');
	int ptr = 0;
	for (int game = 1; game <= games; ++game) {
		init();
		bool we = game & 1;
		while (!col[0][0]) {
			if (we) {	
				vpii can;
				fi(0, n) fj(0, n) if (!col[i][j]) can.pb({i, j});
				int j, i;
				cin >> j >> i;
				--i, --j;	
				if (ptr < m && siz(can) > 1) {
					int x = -1;
					for (int it = 0; it < siz(can); ++it) {
						if (can[it] == mp(i, j)) {
							x = it;
							break;
						}
					}
					assert(x != -1);
					vi lol = make(x);
					fx(x, lol) {
						ans[ptr++] = x;
					}
				} else {
					assert(i == 0 && j == 0);
				}
				paint(i, j);
			} else {
				read();
			}
			we = !we;
		}
	}
	fx(x, ans) x += '0';
	cout << ans << endl;
}

int32_t main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int type;
	cin >> type;
	cin >> n >> k >> m;
	if (type == 1) {
		play();
	} else {
		solve();
	}
}