#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll =long long;

vector<vector<pair< ll, ll>>> dp;

void dfs(ll v, vector<ll>& used, vector<vector<ll>>& g)
{
	used[v] = 1;
	vector<ll> u;
	for (auto mem : g[v])
	{
		if (!used[mem])
		{
			dfs(mem, used, g);
			u.push_back(mem);
		}
	}
	if (u.size() == 1)
		dp[v] = dp[u[0]];
	if (u.size() == 2)
	{
		for (auto p1 : dp[u[0]])
			for (auto p2 : dp[u[1]])
			{
				if (p1.first >= p2.second)
					dp[v].push_back({ p2.first, p1.second });
				if (p2.first >= p1.second)
					dp[v].push_back({ p1.first, p2.second });
			}
	}
}

signed main()
{
	ll n; cin >> n;
	dp.resize(n);
	vector<vector<ll>> g(n);
	for (ll i = 0; i < n; ++i)
	{
		ll t; cin >> t;
		if (t == 1)
		{
			ll k; cin >> k;
			while (k--)
			{
				ll a; cin >> a;
				a--;
				g[i].push_back(a);
			}
		}
		else
		{
			ll m; cin >> m;
			while (m--)
			{
				ll a; cin >> a;
				dp[i].push_back({ a,a });
			}
		}
	}
	vector<ll> used(n, 0);
	dfs(0, used, g);
	if (dp[0].empty())
		cout << "No\n";
	else
		cout << "Yes\n";

	return 0;
}