#include <iostream>
#include <vector>
#include <queue>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

ll n, m;
string s;

const ll SZ = 1e5 + 100;

ll cnt[SZ];
vector<ll> bad[SZ];
vector<ll> good[SZ];
bool clr[SZ];

int main() {
	fastInp;

	cin >> n >> m;

	cin >> s;

	vector<bool> how(m);

	queue<ll> q;
	for (int i = 0; i < n; i++) {
		ll k;
		cin >> k;
		for (int j = 0; j < k; j++) {
			ll ind;
			char c;
			cin >> ind >> c;
			ind--;
			if (s[ind] != c) {
				cnt[i]++;
				bad[ind].push_back(i);
			}
			else {
				good[i].push_back(ind);
			}
		}

		if (cnt[i] == 0) q.push(i);
	}

	vector<ll> perm;
	while (!q.empty()) {
		ll v = q.front();
		perm.push_back(v);
		q.pop();

		for (auto g : good[v]) {
			if (clr[g]) continue;
			how[g] = 1;
			clr[g] = 1;
			for (auto b : bad[g]) {
				cnt[b]--;
				if (cnt[b] == 0) q.push(b);
			}
		}
	}
	bool fl = 1;

	vector<bool> used(n);
	for (int i = 0; i < s.size(); i++) {
		if (!how[i]) fl = 0;
	}

	if (fl) {
		for (auto c : perm) {
			cout << c + 1 << " ";
			used[c] = 1;
		}

		for (int i = 0; i < n; i++) {
			if (!used[i]) cout << i + 1 << " ";
		}
	}
	else {
		cout << "-1";
	}

	return 0;
}

/*
1 1
a
1 1 a

3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f

2 2
aa
2 1 a 2 b
2 1 b 2 a
*/