#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <set>
#include <ctime>
#include <queue>
#include <deque>
#include <fstream>
#include <iomanip>
#include <bitset>
// #pragma GCC optimize("O2,O3,Ofast")
// #define int long long
using namespace std;
typedef long long ll;
typedef long double ld;
const int inf = 1e9 + 7;
const ll l_inf = (ll)inf * (ll)inf;
const ld eps = 1e-6;


void print(const string& s) {
    for (char ch : s) {
        cout << (char)(ch + 'a');
    }
    cout << "\n";
}

const int MAXK = 26;
const int MAXN = 5e5;
int k, n;
bool A[MAXK][MAXK];
string s;
const int MAXV = MAXN + MAXK * (MAXN + 1) + MAXN;
vector<int> G[MAXV];



int V(int j, int i) {
    return n + j * (n + 1) + i;
}


void add_edge(int a, int b) {
    G[a].push_back(b);
}


string dp[MAXN];
bitset<MAXV> used;


void dfs(int v) {
    used[v] = true;
    bool flag = true;
    for (int u : G[v]) {
        if (!used[u]) {
            dfs(u);
        }
        if (flag || dp[u] < dp[v]) {
            flag = false;
            dp[v] = dp[u];
        }
    }
    if (v < n) {
        dp[v] = s[v] + dp[v];
    }
}


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    cin >> k >> n;
    for (int i = 0; i < k; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < k; ++j) {
            A[i][j] = s[j] == '1';
        }
    }
    //
    cin >> s;
    for (int i = 0; i < n; ++i) {
        s[i] -= 'a';
    }
    //
    vector<vector<int>> right(k, vector<int>(n + 1, 0));
    for (int i = n - 1; i >= 0; --i) {
        add_edge(i, V(s[i], i + 1));
        for (int j = 0; j < k; ++j) {
            add_edge(V(j, i), i);
            if (!A[j][s[i]]) {
                continue;
            }
            int x = 1 + right[s[i]][i + 1];
            add_edge(V(j, i), V(s[i], i + 1));
            right[j][i] = x + right[j][i + x];
            add_edge(V(j, i), V(j, i + x));
        }
    }
    dfs(0);
    print(dp[0]);
    /*
    string res;
    res.push_back(s[0]);
    vector<int> V = {0};
    while (true) {
        vector<int> V_;
        for (int i = 0; i < V.size(); ++i) {
            int v = V[i];
            if (G[v].empty()) {
                print(res);
                return 0;
            }
            //
            for (int u : G[v]) {
                if (u < n) {
                    V_.push_back(u);
                } else {
                    V.push_back(u);
                }
            }
        }
    } */
    cerr << 1.0 * clock() / CLOCKS_PER_SEC << "\n";
    return 0;
}