#include <cstdio>
#include <vector>
#include <algorithm>
#include <ctime>
using namespace std;
#define IN 1
#define OUT 2

const int N = (int) 3e5 + 10;
int n, m, u, v;
bool used[N];
vector<int> all[N], adj[N], radj[N];
vector< vector<int> > result;

int dfs(int v, int p = -1) {
  used[v] = true;
  vector<int> ins, outs;
  if ((p != -1) && (find(adj[v].begin(), adj[v].end(), p) != adj[v].end())) {
    ins.push_back(p);
  }
  if ((p != -1) && (find(radj[v].begin(), radj[v].end(), p) != radj[v].end())) {
    outs.push_back(p);
  }
  for (int u : all[v]) {
    if (used[u]) continue;
    int ans = dfs(u, v);
    if (ans == -1) return -1;
    if (ans == IN) {
      ins.push_back(u);
    } else if (ans == OUT) {
      outs.push_back(u);
    }
  }
  while (!ins.empty() && !outs.empty()) {
    result.push_back({outs.back(), v, v, ins.back()});
    ins.pop_back();
    outs.pop_back();
  }
  if (ins.empty() && outs.empty()) {
    return 0;
  }
  if ((int) ins.size() == 1) {
    return OUT;
  }
  if ((int) outs.size() == 1) {
    return IN;
  }
  return -1;
}

int main() {
  double start = clock();
  scanf("%d%d", &n, &m);
  for (int i = 0; i < m; ++i) {
    scanf("%d%d", &u, &v), --u, --v;
    adj[u].push_back(v);
    radj[v].push_back(u);
    all[u].push_back(v);
    all[v].push_back(u);
  }
  fprintf(stderr, "%.2lf\n", ((clock() - start) / CLOCKS_PER_SEC));
  for (int i = 0; i < n; ++i) {
    if (!used[i] && (dfs(i) != 0)) {
      printf("No\n");
      return 0;
    }
  }
  fprintf(stderr, "%.2lf\n", ((clock() - start) / CLOCKS_PER_SEC));
  printf("Yes\n");
  for (const auto& v : result) {
    for (int x : v) {
      printf("%d ", x + 1);
    }
    printf("\n");
  }
  fprintf(stderr, "%.2lf\n", ((clock() - start) / CLOCKS_PER_SEC));
  return 0;
}
