#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <cassert>

using namespace std;

const int N = 3e5 + 7;

int used[N];
int deg[N];
vector<int> g[N];

set<pair<int, int>> s;
set<pair<int, int>> S;

vector<int> in[N];
vector<int> out[N];

vector<pair<pair<int, int>, pair<int, int>>> ans;

signed main() {

	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g[u].push_back(v);
		g[v].push_back(u);
		s.insert({u, v});
	}
	for (int i = 0; i < n; i++) {
		sort(g[i].begin(), g[i].end());
		g[i].resize(unique(g[i].begin(), g[i].end()) - g[i].begin());
		deg[i] = g[i].size();
		S.insert({deg[i], i});
	} 
	while (!S.empty()) {
		int v = S.begin()->second;
		S.erase(S.begin());
		//cout << v + 1 << endl;
		used[v] = 1;
		vector<int> alive;
		for (auto t : g[v]) {
			if (!used[t]) {
				alive.push_back(t);
			}
		}
		assert((int)alive.size() <= 1);
		if (alive.empty()) {
			continue;
		} 
		int u = alive[0];
		if (s.count({v, u})) out[v].push_back(u);
		if (s.count({u, v})) in[v].push_back(u);
		sort(in[v].begin(), in[v].end(), [&](int i, int j) {
			return used[i] < used[j];
		});
		sort(out[v].begin(), out[v].end(), [&](int i, int j) {
			return used[i] < used[j];
		});
		while (!in[v].empty() && !out[v].empty()) {
			// cerr << "pair " << endl;
			// cerr << in[v].back() + 1 << ' ' << v + 1 << ' ' << out[v].back() + 1 << endl;
			ans.push_back({{in[v].back(), v}, {v, out[v].back()}});
			in[v].pop_back();
			out[v].pop_back();
		}
		for (auto t : out[v]) {
			in[t].push_back(v);
		}
		for (auto t : in[v]) {
			out[t].push_back(v);
		}
		for (auto t : alive) {
			S.erase({deg[t], t});
			deg[t]--;
			S.insert({deg[t], t});
		}
	}
	if ((int)ans.size() * 2 == m) {
		cout << "Yes\n";
		for (auto [f, s] : ans) {
			cout << f.first + 1 << ' ' << f.second + 1 << ' ' << s.first + 1 << ' ' << s.second + 1 << '\n';
		}
	} else {
		cout << "No\n";
	}
}