#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pii pair<int, int>
#define ff first
#define ss second

#define left left777
#define right right777
#define dist dist777
#define prev prev777
#define tm tm777

using namespace std;

mt19937 rnd(time(nullptr));

const ll INF = 1e18 + 10;
const int inf = 1e9 + 10, N = 1e4 + 10, P = 1e9 + 7, X = 2007;

struct Vert {
    vector<int> qr;
    int sum;
};

Vert tree[3 * N];
int h[N], n, q, x[N], used[N], cnt[N][2];
pii seg[N][2];
vector<int> to_kick;

void add_qr(int t, int l, int r, int x, int y, int id, int tp) {
    if (y <= l || r <= x) {
        return;
    }
    if (x <= l && r <= y) {
        tree[t].qr.push_back(id * 2 + tp);
        cnt[id][tp]++;
        return;
    }
    int mid = (l + r) / 2;
    add_qr(t * 2 + 1, l, mid, x, y, id, tp);
    add_qr(t * 2 + 2, mid, r, x, y, id, tp);
}

void kick(int t, int l, int r, int x) {
    if (x < l || r <= x) {
        return;
    }
    tree[t].sum--;
    if (tree[t].sum == 0) {
        for (int p : tree[t].qr) {
            int id = p / 2, tp = p % 2;
            cnt[id][tp]--;
            if (cnt[id][tp] == 0 && !used[id]) {
                used[id] = 1;
                to_kick.push_back(id);
            }
        }
        tree[t].qr = {};
    }
    if (l + 1 != r) {
        int mid = (l + r) / 2;
        kick(t * 2 + 1, l, mid, x);
        kick(t * 2 + 2, mid, r, x);
    }
}

void build(int t, int l, int r) {
    tree[t].qr = {};
    tree[t].sum = r - l;
    if (l + 1 != r) {
        int mid = (l + r) / 2;
        build(t * 2 + 1, l, mid);
        build(t * 2 + 2, mid, r);
    }
}

void solve() {
    cin >> n >> q;
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> h[i];
    }
    for (int i = 0; i < n; i++) {
        if (x[i] - h[i] >= x[0]) {
            int l = -1, r = i;
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (x[mid] <= x[i] - h[i]) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            seg[i][0] = {l + 1, i - 1};
        } else {
            seg[i][0] = {-1, -1};
        }
        if (x[i] + h[i] <= x[n - 1]) {
            int l = i, r = n;
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (x[mid] >= x[i] + h[i]) {
                    r = mid;
                } else {
                    l = mid;
                }
            }
            seg[i][1] = {i + 1, r - 1};
        } else{
            seg[i][1] = {-1, -1};
        }
    }
    /*cout << "seg\n";
    for (int i = 0; i < n; i++) {
        for (int t = 0; t < 2; t++) {
            cout << seg[i][t].ff << ' ' << seg[i][t].ss << " | ";
        }
        cout << "\n";
    }*/
    while (q--) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        to_kick = {};
        build(0, l, r + 1);
        for (int i = l; i <= r; i++) {
            used[i] = 0;
            for (int t = 0; t < 2; t++) {
                cnt[i][t] = 0;
                int x = seg[i][t].ff, y = seg[i][t].ss, len = y - x + 1;
                if (x == -1 && y == -1) {
                    continue;
                }
                if (len <= 0) {
                    if (!used[i]) {
                        used[i] = 1;
                        to_kick.push_back(i);
                    }
                } else {
                    add_qr(0, l, r + 1, x, y + 1, i, t);
                }
            }
        }
        int ans = 0;
        while (to_kick.size()){
            int id = to_kick.back();
            to_kick.pop_back();
            ans++;
            kick(0, l, r + 1, id);
        }
        cout << ans << "\n";
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    //freopen("input.txt", "r", stdin);

    //cout << setprecision(15) << fixed();
    solve();
    return 0;
}
