#include <iostream>
#include <vector>

using namespace std;

#define v vector
#define int long long

int n;
v<string> lst;
v<int> d;

const int SIZE = 26;

void init() {
    cin >> n;
    lst.resize(n);
    for (int i = 0; i < n; i++) cin >> lst[i];
}

void build_d() {
    d.resize(26);
    int base = 1;
    for (int i = 0; i < 13; i++) {
        for (int j = 0; j < 2; j++) {
            d[i * 2 + j] = base * (1 + j * 4);
        }
        base *= 10;
    }
}


void solve(string &s) {
    v<int> pref_max(n, 0);
    for (int i = n - 1; i >= 0; i--) {
        if (s[i] != '?') {
            pref_max[i] = s[i] - 'A';
        }
        if (i + 1 < n) {
            pref_max[i] = max(pref_max[i], pref_max[i + 1]);
        }
    }


    v<int> pos;
    pos.push_back(-1);
    int k = 0;
    for (int i = 0; i < s.size(); i++) {
        if (s[i] == '?') {
            k++;
            pos.push_back(i);
        }
    }

    v<int> get_max(s.size());
    int it = pos.size() - 1;
    int mx = 0;
    for (int i = s.size() - 1; i >= 0; i--) {
        if (it != -1 && i == pos[it]) {
            mx = 0;
            it--;
        }
        get_max[i] = mx;
        mx = max(mx, (int)(s[i] - 'A'));
    }

    v<v<int>> cost(SIZE, v<int> (k, 0));
    for (int i = 0; i < SIZE; i++) {
        for (int j = 0; j < k; j++) {
            mx = i;
            cost[i][j] = d[i];
            for (int x = pos[j + 1] - 1; x > pos[j]; x--) {
                int id = s[x] - 'A';
                if (id < mx) {
                    cost[i][j] -= d[id];
                } else {
                    cost[i][j] += d[id];
                }
                mx = max(mx, id);
            }
        }
    }


    v<v<int>> dp(SIZE, v<int> (k + 1, 0));
    v<v<int>> pr(SIZE, v<int> (k + 1, -1));
    for (int i = 1; i <= k; i++) {
        for (int j = SIZE - 1; j >= 0; j--) {
            int mx_id = -1;
            int lft = max(j, pref_max[pos[i]]);
            for (int x = lft; x < SIZE; x++){
                if (mx_id == -1 || dp[x][i - 1] > dp[mx_id][i - 1]) mx_id = x;
            }
            dp[j][i] = dp[mx_id][i - 1] + cost[j][i - 1];
            pr[j][i] = mx_id;
        }
    }

    int opt = -1;
    for (int i = 0; i < SIZE; i++) {
        if (opt == -1 || dp[i][k] > dp[opt][k]) opt = i;
    }

    int res = dp[opt][k];
    for (int i = s.size() - 1; i >= pos.back() + 1; i--) {
        int id = s[i] - 'A';
        if (id < get_max[i]) {
            res -= d[id];
        } else {
            res += d[id];
        }
    }

    it = k;
    for (int i = 0; i < k; i++) {
        s[pos[it]] = 'A' + opt;
        opt = pr[opt][it];
        it--;
    }
    cout << res << "\n";
    cout << s << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    init();
    build_d();

    for (int i = 0; i < n; i++) {
        solve(lst[i]);
    }
    return 0;
}


/*
4
BBBC
????
A?B?C?D
YYYYY?
 */

/*
1
A?B?C?D
 */

/*
1
BBBC
 */

/*
1
YYYYY?
 */
