#include <iostream>
#include <string>
#include <vector>
#include <stack>
#include <queue>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <set>
using namespace std;
#define cap(x) (x).size()
#define pb push_back
#define all(x) (x).begin(), (x).end()
using ll = long long;
const int N = 3e5 + 100;
vector<int> g[N];
set<int> in[N], out[N];
int used[N];
vector<vector<int>> ans;
void dfs(int v, int p = -1) {
	used[v] = 1;
	vector<int> i, o;
	for (int to : g[v]) if (to != p) {
		dfs(to, v);
		if (in[v].count(to) && in[to].count(v)) {
			ans.pb({ v, to, to, v });
		}
		else if (in[v].count(to)) {
			i.pb(to);
		}
		else if (out[v].count(to)) {
			o.pb(to);
		}
	}
	while (cap(i) && cap(o)) {
		int x = i.back();
		int y = o.back();
		ans.pb({ x, v, v, y });
		i.pop_back();
		o.pop_back();
	}
	if (!cap(i) && !cap(o)) return;
	if (p == -1) {
		cout << "No\n";
		exit(0);
	}
	if (max(cap(i), cap(o)) > 1) {
		cout << "No\n";
		exit(0);
	}
	else if (cap(i) == 1) {
		if (out[v].count(p)) {
			out[v].erase(p);
			in[p].erase(v);
			ans.pb({ i[0], v, v, p });
		}
		else {
			cout << "No\n";
			exit(0);
		}
	}
	else if (cap(o) == 1) {
		if (in[v].count(p)) {
			in[v].erase(p);
			out[p].erase(v);
			ans.pb({ p, v, v, o[0] });
		}
		else {
			cout << "No\n";
			exit(0);
		}
	}
}
int main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		g[x].pb(y);
		g[y].pb(x);
		in[y].insert(x);
		out[x].insert(y);
	}
	for (int i = 1; i <= n; i++) {
		sort(all(g[i]));
		g[i].erase(unique(all(g[i])), g[i].end());
	}
	for (int i = 1; i <= n; i++) if (!used[i]) dfs(i);
	assert(cap(ans) * 2 == m);
	cout << "Yes\n";
	for (auto e : ans) {
		for (int i : e) cout << i << ' ';
		cout << '\n';
	}
	return 0;
}

/*

5 6
1 2
2 1
1 5
2 3
2 4
4 2
*/