#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif // LOCAL

#include <bits/stdc++.h>
#define int long long
#define all(a) (a).begin(), (a).end()
typedef long long ll;
using namespace std;

const int INF = 2e18;

int n, m;
vector<pair<int, int>> edges;
vector<vector<int>> in, out, v;
vector<pair<int, int>> ans;
vector<int> s1, s2;
vector<int> used;
vector<int> mt;

bool run(int u, vector<int> &used) {
    used[u] = 1;
    for (int i : v[u]) {
        if (mt[i] == -1 || (!used[mt[i]] && run(mt[i], used))) {
            mt[i] = u;
            return 1;
        }
    }
    return 0;
}

bool kuhn() {
    /*
    for (int i : s1) {
        cout << i << ' ';
    }
    cout << endl;
    for (int i : s2) {
        cout << i << ' ';
    }
    cout << endl << endl;*/
    mt.resize(m, -1);
    vector<int> used;

    for (int i : s1) {
        used.assign(m, 0);
        run(i, used);
    }
    for (int i : s2) {
        if (mt[i] == -1) {
            return 0;
        }
        ans.emplace_back(i, mt[i]);
        //cout << i << ' ' << mt[i] << endl;
    }
    return 1;
}

void dfs(int u, int col) {
    used[u] = 1;
    (col == 1 ? s1 : s2).emplace_back(u);
    for (int i : v[u]) {
        if (used[i]) continue;
        //cout << i << ' ' << u << ' ' << col << endl;
        dfs(i, 3 - col);
    }
}

signed main() {
#ifdef LOCAL
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#else
    ios_base::sync_with_stdio(0);cin.tie(0);
#endif // LOCAL

    cin >> n >> m;
    edges.resize(m);
    v.resize(m);
    in.resize(n);
    out.resize(n);
    used.resize(m, 0);
    for (int i = 0; i < m; ++i) {
        int fr, to;
        cin >> fr >> to;
        edges[i] = make_pair(fr, to);
        fr--, to--;
        for (int j : in[to]) {
            v[i].emplace_back(j);
            v[j].emplace_back(i);
        }
        for (int j : out[fr]) {
            v[i].emplace_back(j);
            v[j].emplace_back(i);
        }
        in[fr].emplace_back(i);
        out[to].emplace_back(i);
    }

    for (int i = 0; i < m; ++i) {
        s1.clear(), s2.clear();
        if (!used[i]) {
            dfs(i, 1);
        }
        if (!kuhn()) {
            cout << "No";
            return 0;
        }
    }
    cout << "Yes\n";
    for (auto i : ans) {
        cout << edges[i.first].first << ' ' << edges[i.first].second << ' ' <<
        edges[i.second].first << ' ' << edges[i.second].second << '\n';
    }
    return 0;
}
