#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INF = 1e9;
const ll INFLL = 1e18;

struct Edge{
    ll to, tm;
    ll is_bridge;
};

void dfs(int v, int p, int &T, vector<vector<Edge> > &g, vector<ll> &in, vector<ll> &out, vector<ll> &up)
{
    in[v] = up[v] = T++;
    for (auto e : g[v])
    {
        int u = e.to;
        if (in[u] == 0)
        {
            dfs(u, v, T, g, in, out, up);
            up[v] = min(up[v], up[u]);
        }
        else if (u != p)
        {
            up[v] = min(up[v], in[u]);
        }
    }
    out[v] = T++;
}

void dfs(int v, int cl, vector<int> &color, vector<vector<Edge> > &g)
{
    color[v] = cl;
    for (auto e : g[v])
    {
        if (e.is_bridge == 1) continue;
        int u = e.to;
        if (color[u] == -1) dfs(u, cl, color, g);
    }
}

void dfs2(int v, int p, vector<ll> &ans, vector<vector<pair<ll, ll> > > &g)
{
    for (auto e : g[v]) if (e.first != p)
    {
        int u = e.first;
        ans[u] = min(ans[u], min(ans[v], e.second));
        dfs2(u, v, ans, g);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector<vector<Edge> > g(n);
    for (int i = 0; i < m; i++)
    {
        ll ft, to, tm;
        cin >> ft >> to >> tm;
        ft--, to--;
        g[ft].push_back({to, tm, 0});
        g[to].push_back({ft, tm, 0});
    }
    vector<ll> in(n), out(n), up(n);
    int T = 1;
    dfs(0, 0, T, g, in, out, up);

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < g[i].size(); j++)
        {
            Edge e = g[i][j];
            int v = i, u = e.to;
            if (in[v] <= in[u] && out[u] <= out[v] && up[u] == in[u]) g[i][j].is_bridge = 1;
            if (in[u] <= in[v] && out[v] <= out[u] && up[v] == in[v]) g[i][j].is_bridge = 1;
        }
    }

    //cout << "Passed 1" << endl;

    vector<int> color(n, -1);
    ll cl = 0;
    for (int i = 0; i < n; i++)
    {
        if (color[i] == -1)
        {
            dfs(i, cl, color, g);
            cl++;
        }
    }

    //cout << "Passed 2" << endl;

    vector<vector<pair<ll, ll> > > comp_g(cl);
    vector<ll> ans(cl, INFLL);
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < g[i].size(); j++)
        {
            Edge e = g[i][j];
            int v = i, u = e.to;
            if (color[v] == color[u]) ans[color[v]] = min(ans[color[v]], e.tm);
            else
            {
                //cout << "OK" << endl;
                //cout << v << " " << u << " " << color[v] << " " << color[u] << " " << cl << endl;
                comp_g[color[v]].push_back({color[u], e.tm});
                comp_g[color[u]].push_back({color[v], e.tm});
                //cout << "NOT OK" << endl;
            }
        }
    }

    //cout << "Passed 3" << endl;

    dfs2(color[0], color[0], ans, comp_g);

    //cout << "Passed 4" << endl;

    exit(0);

    for (int i = 1; i < n; i++)
    {
        cout << ans[color[i]] + INF << " ";
    }
}



/*
5 4
1 2 1000000000
1 3 1000000000
2 4 5
1 5 1000000000
*/
