#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0, q = 0;
	cin >> n >> q;

	vector<int> x(n), h(n);
	for (int i = 0; i < n; ++i)
		cin >> x[i] >> h[i];

	vector<vector<int>> fromLeft(n), fromRight(n);
	vector<int> cntLeft(n), cntRight(n);
	for (int i = 0; i < n; ++i)
	{
		for (int j = i - 1; j >= 0 && x[j] > x[i] - h[i]; --j)
			fromLeft[j].push_back(i), ++cntLeft[i];
		for (int j = i + 1; j < n && x[j] < x[i] + h[i]; ++j)
			fromRight[j].push_back(i), ++cntRight[i];
		if (x[i] - x[0] < h[i])
			++cntLeft[i];
		if (x.back() - x[i] < h[i])
			++cntRight[i];
	}

	int l = 0, r = 0;
	for (int query = 0; query < q; ++query)
	{
		cin >> l >> r;
		--l;

		vector<int> active(n, 1);
		vector<int> cRight(cntRight), cLeft(cntLeft);
		vector<int> curVar;
		int ans = 0, prevAns = -1;
		for (int i = l; i < r; ++i)
		{
			if (cRight[i] == 0 || cLeft[i] == 0)
			{
				curVar.push_back(i);
				active[i] = 0;
				++ans;
			}
		}
		
		while (!curVar.empty())
		{
			int i = curVar.back();
			curVar.pop_back();

			for (int j : fromLeft[i])
			{
				--cLeft[j];
				if (j < r && cLeft[j] == 0 && active[j])
				{
					active[j] = 0;
					curVar.push_back(j);
					++ans;
				}
			}

			for (int j : fromRight[i])
			{
				--cRight[j];
				if (j >= l && cRight[j] == 0 && active[j])
				{
					active[j] = 0;
					curVar.push_back(j);
					++ans;
				}
			}
		}

		cout << ans << "\n";
	}

	return 0;
}