#include <iostream>
#include <vector>
#include <algorithm>
#include "numeric"
#include "set"
#include "map"
using namespace std;
#define all(x) (x).begin(), (x).end()
typedef long long ll;
vector<vector<int>> g;
map<pair<int, int>, bool> edge;
vector<int> comp;
vector<int> batya;
vector<int> to, out;
bool ok = true;
vector<pair<int, int>> ans;
void die() {
    cout << "No";
    exit(0);
}
void dfsbatya(int v, int p) {
    batya[v] = p;
    for (auto i : g[v]) {
        if (i != p)
            dfsbatya(i, v);
    }
}
pair<int, int> dfsans(int v, int p) {
    vector<int> tome, fromme;
    for (auto i : g[v]) {
        if (i == p)
            continue;
        auto [a, b] = dfsans(i, v);
        if (a != 0)
            tome.push_back(a);
        if (b != 0)
            fromme.push_back(b);
    }
    while (!tome.empty() and !fromme.empty()) {
        ans.push_back({tome.back(), fromme.back()});
        tome.pop_back();
        fromme.pop_back();
    }
    if (tome.size() > 1 or fromme.size() > 1) {
        die();
    }
    if (!tome.empty()) {
        if (out[v] == 0)
            die();
        ans.push_back({tome.back(), out[v]});
        out[v] = 0;
    }
    if (!fromme.empty()) {
        if (to[v] == 0)
            die();
        ans.push_back({to[v], fromme.back()});
        to[v] = 0;
    }
    return {out[v], to[v]};
}
void dfscomp(int v, int p, int c) {
    comp[v] = c;
    for (auto u : g[v]) {
        if (u != p)
            dfscomp(u, v, c);
    }
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    int m;
    cin >> m;
    vector<pair<int, int>> ee(m);
    g.assign(n, {});
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;b--;
        if (edge[minmax(a, b)] == 0) {
            edge[minmax(a, b)] = 1;
            g[a].push_back(b);
            g[b].push_back(a);
        }
        ee.push_back({a, b});
    }
    comp.assign(n, -1);
    int c = 0;
    for (int i = 0; i < n; ++i) {
        if (comp[i] == -1) {
            dfscomp(i, -1, c++);
            if (i != 0) {
                g[0].push_back(i);
                g[i].push_back(0);
            }
        }
    }
    batya.assign(n, -1);
    dfsbatya(0, -1);
    to.assign(n, 0);
    out.assign(n, 0);
    int num = 0;
    for (auto [u, v] : ee) {
        num++;
        if (batya[u] == v) {
            out[u] = num;
        } else {
            to[v] = num;
        }
    }
    dfsans(0, -1);
    cout << "Yes\n";
    for (auto [l, r] : ans){
        l--;r--;
        cout << ee[l].first + 1 << ' ' << ee[l].second + 1 << ' ' << ee[r].first + 1 << ' ' << ee[r].second + 1 << '\n';
    }
}