#include <bits/stdc++.h>

#define all(a) a.begin(), a.end()

const int inf = 0x3f3f3f3f;
using ll = long long;
const ll llinf = 0x3f3f3f3f3f3f3f3f;
using pii = std::pair<int, int>;

const int MAXN = 5e5;

struct edge {
    int to, real, id;

    edge(int to, int real, int id) : to(to), real(real), id(id) {}

    edge() : to(-1), real(-1), id(-1) {}

    bool operator<(const edge &e) const {
        return std::tie(to, real, id) < std::tie(e.to, e.real, e.id);
    }
};

std::vector<edge> g[MAXN];

bool usedV[MAXN], used[MAXN];

std::set<pii> down[MAXN];
std::set<pii> vertical[MAXN];

std::vector<std::pair<pii, pii>> ans;
int cntOut[MAXN];

bool inPairSet(int v, int val) {
    auto it = lower_bound(all(g[v]), edge(val, 1, -inf));
    return it != g[v].end() && it->to == val && it->real == 1;
}

void dfs(int v, int p) {
    usedV[v] = true;

    std::vector<pii> nowVertical;

    for (auto &[i, real, id] : g[v]) {
        if (i == p) continue;

        if (inPairSet(i, v)) {
            assert(real == 0);
            auto it = lower_bound(all(g[i]), edge(v, 1, -inf));
            nowVertical.emplace_back(i, it->id);
        }

        if (!usedV[i]) dfs(i, v);

        if (real) {
            while (!down[i].empty() && used[down[i].begin()->second]) {
                down[i].erase(down[i].begin());
            }

            if (down[i].size() > 1) {
                std::cout << "No\n";
                exit(0);
            }

            if (!down[i].empty()) {
                ans.emplace_back(std::make_pair(v, i),
                                 std::make_pair(i, down[i].begin()->first));
                used[down[i].begin()->second] = 1;
                used[id] = 1;
                down[i].erase(down[i].begin());
            }
        }

        if (!real) {
            while (!vertical[i].empty() && used[vertical[i].begin()->second]) {
                vertical[i].erase(vertical[i].begin());
            }

            if (vertical[i].size() > 1) {
                std::cout << "No\n";
                exit(0);
            }

            if (!vertical[i].empty()) {
                if (inPairSet(i, v)) {
                    auto[u, id1] = *vertical[i].begin();
                    ans.emplace_back(std::make_pair(u, i), std::make_pair(i, v));
                    vertical[i].erase(vertical[i].begin());
                    used[id] = used[id1] = true;
                } else {
                    std::cout << "No\n";
                    exit(0);
                }
            }
        }
    }

    for (auto &[i, real, id] : g[v]) {
        if (i != p && real == 1) down[v].insert(std::make_pair(i, id));
    }

    for (auto &[i, id] : nowVertical) {
        if (used[id]) continue;

        while (!down[v].empty() && used[down[v].begin()->second]) down[v].erase(down[v].begin());
        if (!down[v].empty()) {
            ans.emplace_back(std::make_pair(i, v), std::make_pair(v, down[v].begin()->first));
            used[id] = used[down[v].begin()->second] = 1;
            down[v].erase(down[v].begin());
        }
    }

    for (auto &[i, id] : nowVertical) {
        if (!used[id]) vertical[v].insert(std::make_pair(i, id));
    }
}

int main() {
    int n, m;
    std::cin >> n >> m;

    std::map<pii, int> cntEdges;
    for (int i = 0; i < m; i++) {
        int a, b;
        std::cin >> a >> b;
        a--, b--;
        cntOut[a]++;
        g[a].emplace_back(b, 1, i);
        g[b].emplace_back(a, 0, i);
    }
    for (auto &i : g) std::sort(all(i));

    for (int i = 0; i < n; i++) if (!usedV[i]) dfs(i, i);

    if (*std::min_element(used, used + m) == 0) {
        std::cout << "No\n";
        return 0;
    }
    std::cout << "Yes\n";
    for (auto &i : ans) {
        std::cout << i.first.first + 1 << ' ' << i.first.second + 1 << ' ' << i.second.first + 1 << ' '
                  << i.second.second + 1 << '\n';
    }
}
