#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cstdlib>
#include <string>
#include <ctime>
#include <stack>
#include <list>


using namespace std;


#define int long long
#define ll long long
#define all(a) a.begin(), a.end()


struct tree {
	int x, h;
	bool to_dl = false;

	tree() : x(-1), h(-1), to_dl(false) {}
	tree(int x, int h) : x(x), h(h), to_dl(false) {}
};


int n, q;
vector<tree> trs;
vector<int> x;
vector<int> h;
vector<int> lx;
vector<int> rx;
vector<int> lcnt;
vector<int> rcnt;
vector<int> prvs;
vector<int> nxt;
vector<bool> dltd;
int _tl, _tr;




void cnt_lrx() {
	lx.resize(n);
	rx.resize(n);
	for (int i = 0; i < n; ++i) {
		lx[i] = upper_bound(all(x), x[i] - h[i]) - x.begin();
		rx[i] = lower_bound(all(x), x[i] + h[i]) - x.begin() - 1;
	}
	
}


bool cn_dlt(int i) {
	auto i1 = prvs[i];
	if (i1 >= 0 && x[i1] <= x[i] - h[i]) {
		return true;
	}
	auto i2 = nxt[i];
	if (i2 < n && x[i] + h[i] <= x[i2]) {
		return true;
	}
	return false;
}


void dlt(int i) {
	if (prvs[i] >= 0) {
		nxt[prvs[i]] = nxt[i];
	}
	if (nxt[i] < n) {
		prvs[nxt[i]] = prvs[i];
	}
}


int answer(int tl, int tr) {
	_tl = tl;
	_tr = tr;
	stack<int> d;
	for (int i = tl; i <= tr; ++i) {
		nxt[i] = i + 1;
		prvs[i] = i - 1;
		dltd[i] = false;
	}
	for (int i = tl; i <= tr; ++i) {
		if (cn_dlt(i)) {
			d.push(i);
			dltd[i] = true;
		}
	}
	int res = 0;
	while (!d.empty()) {
		++res;
		int i= d.top();
		d.pop();
		auto i1 = prvs[i];
		auto i2 = nxt[i];
		dlt(i);
		if (i1 >= tl && !dltd[i1] && cn_dlt(i1)) {
			d.push(i1);
			dltd[i1] = true;
		}
		if (i2 <= tr && !dltd[i2] && cn_dlt(i2)) {
			d.push(i2);
			dltd[i2] = true;
		}
	}
	return res;
}


int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> q;
	prvs.resize(n);
	nxt.resize(n);
	x.resize(n);
	h.resize(n);
	dltd.resize(n);
	trs.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> x[i] >> h[i];
		trs[i] = tree(x[i], h[i]);
	}
	cnt_lrx();
	while (q--) {
		int tl, tr;
		cin >> tl >> tr;
		--tl;
		--tr;

		cout << answer(tl, tr) << "\n";
	}
	return 0;
}

/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3
*/