import java.io.*;
import java.util.ArrayList;

public class E {
    private static final long[] vals = new long[26];
    static {
        vals[0] = 1;
        vals[1] = 5;
        for (int i = 2; i < 26; i++) {
            vals[i] = vals[i - 2] * 10;
        }
    }

    static long toLong(char[] moscowNum) {
        long res = 0;
        int lastIdx = moscowNum.length - 1;
        long max = vals[moscowNum[lastIdx] - 'A'];

        for (int i = lastIdx; i >= 0; i--) {
            int idx = moscowNum[i] - 'A';
            long num = vals[idx];

            if (num < max) res -= num;
            else {
                res += num;
                max = num;
            }
        }

        return res;
    }

    static long fixMoscowNum(char[] num) {
        long max = 0;
        ArrayList<Integer> ids = new ArrayList<>();

        for (int i = 0; i < num.length; i++) {
            char ch = num[i];
            if (ch == '?') {
                ids.add(i);
                
                num[i] = (char) (max + 'A');
            } else max = Math.max(max, num[i] - 'A');
        }

        char[] tmpNum = new char[num.length];
        System.arraycopy(num, 0, tmpNum, 0, num.length);
        max = toLong(tmpNum);

        for (int i : ids) {
            tmpNum[i] = 'Z';
            long val = toLong(tmpNum);

            if (val > max) {
                max = val;
                for (int j : ids) num[j] = tmpNum[j];
            }
        }

        return max;
    }

    public static void main(String[] args) throws IOException {
        BufferedReader r = new BufferedReader(new InputStreamReader(System.in));
        int q = Integer.parseInt(r.readLine());

        for (int i = 0; i < q; i++) {
            char[] num = r.readLine().toCharArray();
            System.out.print(fixMoscowNum(num));
            System.out.print('\n');
            for (char ch : num) System.out.print(ch);
            System.out.print('\n');
        }

        System.out.flush();
    }
}
