#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

long long vals[26];

long long toLong(const string &moscowNum) {
    long long res = 0;
    int lastIdx = (int) moscowNum.length() - 1;
    long long max = vals[moscowNum[lastIdx] - 'A'];

    for (int i = lastIdx; i >= 0; i--) {
        int idx = moscowNum[i] - 'A';
        long num = vals[idx];

        if (num < max) res -= num;
        else {
            res += num;
            max = num;
        }
    }

    return res;
}

long long
rec(const string &num, string &tmp, string &res, const vector<int> &ids, const vector<int> &prefix_maxes, int cur_max,
    int idx) {
    if (idx == ids.size()) {
        res = tmp;
        return toLong(res);
    }

    string best;
    long long max_ = -1000000000000000000LL;
    for (int ch = max((int) (unsigned char) num[ids[idx]], cur_max); ch <= 'Z'; ++ch) {
        if (ch - 'A' > prefix_maxes[prefix_maxes.size() - 1 - idx]) ch = 'Z';
        tmp[ids[idx]] = ch;
        long long val = rec(num, tmp, res, ids, prefix_maxes, max(cur_max, ch), idx + 1);

        if (val > max_) {
            best = res;
            max_ = val;
        }
    }

    res = best;
    return max_;
}

long long fixMoscowNum(string &num) {
    long long max_ = 0;
    vector<int> ids;

    vector<int> prefix_maxes;
    for (char ch : num) {
        if (ch == '?') {
            prefix_maxes.push_back(max_);
        } else max_ = max(max_, (long long) ch - 'A');
    }

    max_ = 0;
    for (int i = num.length() - 1; i >= 0; --i) {
        if (num[i] == '?') {
            ids.push_back(i);

            num[i] = (char) (max_ + 'A');
            if (i > 0) num[i] = max(num[i], num[i - 1]);
        } else max_ = max(max_, (long long) num[i] - 'A');
    }

//    string tmpNum = num;
//    max_ = toLong(tmpNum);
//
//    for (int i : ids) {
//        tmpNum[i] = 'Z';
//        long val = toLong(tmpNum);
//
//        if (val > max_) {
//            max_ = val;
//            for (int j : ids) num[j] = tmpNum[j];
//        }
//    }
//
//    return max_;

    string tmp = num;
    string const_num = num;
    return rec(const_num, tmp, num, ids, prefix_maxes, 0, 0);
}

int main() {
    vals[0] = 1;
    vals[1] = 5;
    for (int i = 2; i < 26; i++) {
        vals[i] = vals[i - 2] * 10;
    }

    int q;
    cin >> q;

    for (int i = 0; i < q; i++) {
        string num;
        cin >> num;
        cout << fixMoscowNum(num) << "\n" << num << "\n";
    }

    cout.flush();
}
