#include <bits/stdc++.h>

using namespace std;

#ifndef SEVA
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#endif
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2,mmx,abm,fma,popcnt,tune=native")

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;
typedef vector<int> vi;
typedef pair<int, int> pi;

#define nl '\n'
#define all(a) (a).begin(), (a).end()
#define minq(a, b) (a) = min(a, b)
#define maxq(a, b) (a) = max(a, b)
#define forn(i, n) for (int i = 0; i < (n); i++)
#define sz(a) int((a).size())

void IO() {
#ifdef SEVA
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
}

struct Tree {
    int x, h;

    int l() const {
        return x - h;
    }

    int r() const {
        return x + h;
    }
};

const int N = (int)1e4 + 10;

vi g[N];
int used[N];
int timer;
int stCntL[N], stCntR[N], cntL[N], cntR[N];

int Go(int v, int l, int r) {
    if (v < l || r < v)
        return 0;
    used[v] = timer;
    int ans = 1;
    for (auto& to : g[v]) {
        if (used[to] == timer)
            continue;
        if (to < v) {
            assert(cntR[to] != 0);
            cntR[to]--;
            if (cntR[to] == 0)
                ans += Go(to, l, r);
        }
        else {
            assert(cntL[to] != 0);
            cntL[to]--;
            if (cntL[to] == 0)
                ans += Go(to, l, r);
        }
    }
    return ans;
}

void Solve() {
    int n, q;
    cin >> n >> q;
    vector<Tree> tree(n);
    for (auto&[x, h] : tree) {
        cin >> x >> h;
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (tree[j].l() < tree[i].x) {
                g[i].emplace_back(j);
                stCntL[j]++;
//                break;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = i - 1; j >= 0; j--) {
            if (tree[j].r() > tree[i].x) {
                g[i].emplace_back(j);
                stCntR[j]++;
//                break;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (tree[i].l() < tree[0].x)
            stCntL[i] = INT_MAX;
        if (tree[i].r() > tree[n - 1].x)
            stCntR[i] = INT_MAX;
    }
    forn(query, q) {
        timer++;
        int l, r;
        cin >> l >> r;
        l--, r--;
        for (int i = 0; i < n; i++)
            cntL[i] = stCntL[i], cntR[i] = stCntR[i];
        int ans = 0;
        for (int i = l; i <= r; i++) {
            if (used[i] == timer || (cntL[i] != 0 && cntR[i] != 0))
                continue;
            ans += Go(i, l, r);
        }
        cout << ans << nl;
    }
}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    forn(i, t) {
        Solve();
    }
}