#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <cstring>

using namespace std;

const int maxn = 6e3 + 100;

int used[maxn];
vector <pair<int, int>> g[maxn];
vector <pair<int, int>> g2[maxn];
vector <pair<int, int>> gr;
int par[maxn];
int counter;
int color;

bool dfs(int v) {
	used[v] = color;
	for (auto i : g[gr[v].second]) {
		if (used[i.second] == color || par[i.second] == v || used[par[i.second]] == color) continue;
		if (par[i.second] < 0) {
			par[i.second] = v;
			par[v] = i.second;
			used[i.second] = color;
			return 1;
		}
		used[i.second] = 1;
		if (dfs(par[i.second])) {
			par[i.second] = v;
			par[v] = i.second;
			return 1;
		}
	}
	for (auto i : g2[gr[v].first]) {
		if (used[i.second] == color || par[i.second] == v || used[par[i.second]] == color) continue;
		if (par[i.second] < 0) {
			par[i.second] = v;
			par[v] = i.second;
			used[i.second] = color;
			return 1;
		}
		used[i.second] = 1;
		if (dfs(par[i.second])) {
			par[i.second] = v;
			par[v] = i.second;
			return 1;
		}
	}
	return 0;
}

int main() {
	counter = -1; color = 0;
	memset(par, -1, sizeof(par));
	memset(used, 0, sizeof(used));
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int f, s;
		cin >> f >> s;
		--f; --s;
		g[f].push_back(make_pair(s, ++counter));
		g2[s].push_back(make_pair(f, counter));
		gr.push_back(make_pair(f, s));
	}
	int cnt = 0;
	while (1) {
		int lastcnt = cnt;
		++color;
		for (int i = 0; i < counter; i++) {
			if ((par[i] < 0) && used[i] != color) {
				if (dfs(i)) cnt++;
			}
		}
		if (lastcnt == cnt) break;
	}
	if (cnt == m / 2) {
		cout << "Yes\n";
		++color;
		for (int i = 0; i < m; i++) {
			if (used[i] == color) continue;
			cout << gr[i].first + 1 << " " << gr[i].second + 1 << " " << gr[par[i]].first + 1 << " " << gr[par[i]].second + 1 << "\n";
			used[i] = color;
			used[par[i]] = color;
		}
	}
	else {
		cout << "No";
	}
	return 0;
}