#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>
#include <set>

using namespace std;

const int maxn = 5e5;
vector <pair<int, int>> g[maxn];
int ans[maxn];

void dfs(int v, int m1, int m2, int p) {
	ans[v] = m1 + m2;
	for (auto i : g[v]) {
		if (i.first == p) continue;
		dfs(i.first, min(m1, i.second), max(m2, i.second), v);
	}
}

int main(){
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int f, s, v;
		cin >> f >> s >> v;
		--f; --s;
		g[f].push_back(make_pair(s, v));
		g[s].push_back(make_pair(f, v));
	}
	if (m == n - 1) {
		dfs(0, 1e9, -1e9, -1);
		for (int i = 1; i < n; i++) {
			cout << ans[i] << "\n";
		}
	}
	else {
		int k = g[0][0].second;
		bool f = 1;
		for (auto i : g[0]) {
			f &= (k == i.second);
		}
		if (f) {
			if (k == 0) {
				vector <int> dist(n, 1e9);
				vector <int> used(n, 0);
				dist[0] = 0;
				set <pair <int, int>> k;
				for (int i = 0; i < n; i++) {
					k.insert(make_pair(dist[i], i));
				}
				for (;!k.empty();) {
					auto q = *k.begin();
					for (auto i : g[q.second]) {
						if (used[i.first]) continue;
						k.erase(make_pair(dist[i.first], i.first)); 
						dist[i.first] = min(dist[i.first], max(q.first, i.second));
						k.insert(make_pair(dist[i.first], i.first));
					}
					used[q.second] = 1;
					k.erase(q);
				}
				for (int i = 1; i < n; i++) {
					cout << dist[i] << "\n";
				}
			}
			else if (k == 1e9){
				vector <int> used(n, 0);
				vector <int> dist(n, 1e9);
				dist[0] = 0;
				set <pair <int, int>> k;
				for (int i = 0; i < n; i++) {
					k.insert(make_pair(dist[i], i));
				}
				for (; !k.empty();) {
					auto q = *k.begin();
					for (auto i : g[q.second]) {
						if (used[i.first]) continue;
						k.erase(make_pair(dist[i.first], i.first));
						dist[i.first] = min(dist[i.first], min(q.first, i.second));
						k.insert(make_pair(dist[i.first], i.first));
					}
					used[q.second] = 1;
					k.erase(q);
				}
				for (int i = 1; i < n; i++) {
					cout << dist[i] + 1e9 << "\n";
				}
			}
		}
	}
}