#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

#pragma optimize("0fast");

using namespace std;

#define int long long

vector<int> from[150000];
bool banned[1000][1000];
vector<int> to[150000];
vector<pair<int, int>> ans_beb, ans;
vector<pair<int, int>> path;
vector<bool> visited;

void dfs(int u)
{
	visited[u] = 1;
	for (int i = 0; i < from[u].size(); i++)
	{
		if (banned[u][from[u][i]]) continue;
		//cout << u << " " << i << " not banned (" << u + 1 << " -> " << from[u][i] + 1 << ")" << endl;
		banned[u][from[u][i]] = 1;
		path.push_back({u, from[u][i]});
		dfs(from[u][i]);
		path.pop_back();
	}

	if (path.size() > ans_beb.size())
	{
		ans_beb.resize(path.size());
		for (int i = 0; i < path.size(); i++)
			ans_beb[i] = path[i];
	}
}

int32_t main()
{
	ios::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	int n, m;
	cin >> n >> m;

	for (int i = 0; i < m; i++)
	{
		int u, v;
		cin >> u >> v;
		from[u - 1].push_back(v - 1);
		to[v - 1].push_back(u - 1);
	}
	
	visited.resize(n);
	for (int i = 0; i < n; i++)
		visited[i] = 0;

	vector<pair<int, int>> bad;
	for (int i = 0; i < n; i++)
	{
		if (from[i].empty())
		{
			bool f = false;
			for (int j = 0; j < to[i].size(); j++)
			{
				if (banned[to[i][j]][i]) continue;
				if (f) break;
				for (int z = 0; z < to[to[i][j]].size(); z++)
				{
					if (!banned[to[to[i][j]][z]][to[i][j]])
					{
						banned[to[i][j]][i] = 1;
						banned[to[to[i][j]][z]][to[i][j]] = 1;
						bad.push_back({ to[to[i][j]][z] , to[i][j] });
						bad.push_back({ to[i][j] , i});
						//cout << "BAN " << to[to[i][j]][z] + 1 << " -> " << to[i][j] + 1 << " -> " << i + 1 << endl;
						f = true;
						break;
					}
				}
			}
		}
	}

	bool f = true;
	vector<pair<int, int>> nu_ya(n);
	for (int i = 0; i < n; i++)
		nu_ya[i] = { to[i].size(), i };
	sort(nu_ya.begin(), nu_ya.end());
	for (int i = 0; i < n; i++)
	{
		if (visited[nu_ya[i].second]) continue;
		dfs(nu_ya[i].second);
		for (auto& x : ans_beb)
		{
			banned[x.first][x.second] = 1;
			ans.push_back(x);
		}
		if (ans_beb.size() % 2 == 1)
			ans.pop_back();
		ans_beb.clear();
	}
	
	//cout << ans.size() << " " << bad.size() << endl;
	if ((int)(ans.size()) + (int)(bad.size()) != m)
		cout << "No";
	else
	{
		cout << "Yes\n";

		for (int i = 0; i + 1 < bad.size(); i += 2)
		{
			cout << bad[i].first + 1 << " " << bad[i].second + 1 << " ";
			cout << bad[i + 1].first + 1 << " " << bad[i + 1].second + 1 << endl;
		}
		//cout << "those were bad" << endl;
		for (int i = 0; i + 1 < ans.size(); i += 2)
		{
			cout << ans[i].first + 1 << " " << ans[i].second + 1 << " ";
			cout << ans[i + 1].first + 1 << " " << ans[i + 1].second + 1 << endl;
		}
	}
}