#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

#pragma optimize("0fast");

using namespace std;

#define int long long

vector<int> from[150000];
vector<bool> banned_from[150000];
vector<int> to[150000];
vector<pair<int, int>> ans_beb, ans;
vector<pair<int, int>> path;
vector<bool> visited;

void dfs(int u)
{
	visited[u] = 1;
	for (int i = 0; i < from[u].size(); i++)
	{
		if (banned_from[u][i]) continue;
		//cout << u << " " << i << " not banned (" << u + 1 << " -> " << from[u][i] + 1 << ")" << endl;
		banned_from[u][i] = 1;
		path.push_back({u, from[u][i]});
		dfs(from[u][i]);
		banned_from[u][i] = 0;
		path.pop_back();
	}

	if (path.size() > ans_beb.size())
	{
		ans_beb.resize(path.size());
		for (int i = 0; i < path.size(); i++)
			ans_beb[i] = path[i];
	}
}

int32_t main()
{
	ios::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	int n, m;
	cin >> n >> m;

	for (int i = 0; i < m; i++)
	{
		int u, v;
		cin >> u >> v;
		from[u - 1].push_back(v - 1);
		banned_from[u - 1].push_back(0);
		to[v - 1].push_back(u - 1);
	}
	
	visited.resize(n);
	for (int i = 0; i < n; i++)
		visited[i] = 0;


	for (int i = 0; i < n; i++)
	{
		if (visited[i]) continue;
		dfs(i);
		for (auto& x : ans_beb)
			ans.push_back(x);
		if (ans_beb.size() % 2 == 1)
			ans.pop_back();
		ans_beb.clear();
	}

	//cout << ans.size() << " " << bad.size() << endl;
	if (ans.size() + bad.size() != m)
		cout << "No";
	else
	{
		cout << "Yes\n";

		for (int i = 0; i + 1 < bad.size(); i += 2)
		{
			cout << bad[i].first + 1 << " " << bad[i].second + 1 << " ";
			cout << bad[i + 1].first + 1 << " " << bad[i + 1].second + 1 << endl;
		}
		//cout << "those were bad" << endl;
		for (int i = 0; i + 1 < ans.size(); i += 2)
		{
			cout << ans[i].first + 1 << " " << ans[i].second + 1 << " ";
			cout << ans[i + 1].first + 1 << " " << ans[i + 1].second + 1 << endl;
		}
	}
}