#include <iostream>
#include <vector>
#include <queue>

#define int long long

using namespace std;

struct wood{
    int x, h;
};

int MAXN = 10003;
vector <bool> visited(MAXN);
vector <wood> trees;
int n, q;

bool check(int id) {
    int x = trees[id].x, h = trees[id].h;
    bool ch_l = true, ch_r = true;
    for (int i = 0; i < n + 2; ++i) {
        if (visited[i])
            continue;
        ch_l = ch_l && !(x - h < trees[i].x && trees[i].x < x);
        ch_r = ch_r && !(x < trees[i].x && trees[i].x < x + h);
    }
    return ch_l || ch_r;
}

signed main() {
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        if (i == 0)
            trees.push_back({2 * x - 1, 2 * y});
        trees.push_back({2 * x, 2 * y});
    }
    trees.push_back(trees.back());
    trees.back().x += 1;
    for (int i = 0; i < q; ++i) {
        int x, y;
        cin >> x >> y;
        int ans = 0;
        queue <int> a;
        vector <pair <int, int>> b(y - x + 1);
        for (int j = x; j <= y; ++j) {
            a.push(j);
            b[j - x] = {j - 1, j + 1};
        }
        b[0].first = -1;
        b.back().second = -1;
        while (a.size() > 0) {
            int j = a.front();
            //cout << j << " " << check(j) << endl;
            a.pop();
            if (visited[j])
                continue;
            if (check(j)) {
                visited[j] = true;
                ans++;
                int lf = b[j - x].first;
                int rg = b[j - x].second;
                if (lf != -1){
                    b[lf - x].second = rg;
                    a.push(lf);
                }
                if (rg != -1) {
                    b[rg - x].first = lf;
                    a.push(rg);
                }
            }
        }
        for (int j = x; j <= y; ++j) {
            visited[j] = false;
        }
        cout << ans << endl;
    }
}
