#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cassert>
#define int long long
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
using namespace std;

map<char, int> cost;

void calc() {
	cost['A'] = 1;
	for (char c = 'C'; c <= 'Z'; c += 2) {
		cost[c - 1] = cost[c - 2] * 5;
		cost[c] = cost[c - 2] * 10;
	}
	cost['Z'] = 5e12;
}

int calc2(string s, int l, int r) {
	int n = s.size();
	vi mx(n);
	mx[n - 1] = s[n - 1];
	for (int i = n - 2; i > -1; --i)
		if (s[i] != '?')
			mx[i] = max((int)s[i], mx[i + 1]);
	int res = 0;
	for (int i = l; i <= r; ++i) {
		if (mx[i] > s[i])
			res -= cost[s[i]];
		else
			res += cost[s[i]];
	}
	return res;
}

void solve() {
	string s;
	cin >> s;
	int n = s.size();
	int last = -1;
	vi ind;
	vvi m;
	for (int i = 0; i < n; ++i)
		if (s[i] == '?') {
			ind.push_back(i); m.push_back({});
			string ss = s;
			for (int c = 'A'; c <= 'Z'; ++c) {
				ss[i] = c;
				int curr = calc2(ss, last + 1, i);
				m.back().push_back(curr);
			}
			last = i;
		}
	int k = ind.size();
	vvi dp(k + 1, vi(26, -4e18));
	vvi pr(k + 1, vi(26, -4e18));
	dp[0][25] = 0;
	for (int i = 0; i < k; ++i)
		for (int c = 0; c < 26; ++c)
			if (dp[i][c] != (int)-4e18) {
				for (int nc = 0; nc <= c; ++nc) {
					if (dp[i][c] + m[i][nc] > dp[i + 1][nc]) {
						dp[i + 1][nc] = dp[i][c] + m[i][nc];
						pr[i + 1][nc] = c;
					}
				}
			}
	int mx = -4e18, c;
	for (int cc = 0; cc < 26; ++cc)
		if (dp[k][cc] > mx) {
			mx = dp[k][cc];
			c = cc;
		}
	for (int i = k - 1; i > -1; --i) {
		s[ind[i]] = c + 'A';
		c = pr[i + 1][c];
		assert(c > 0);
	}
	cout << calc2(s, 0, n - 1) << "\n" << s << "\n";
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	calc();
	int t;
	cin >> t;
	while (t--)
		solve();
}