#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
#define int ll

const int INF = 1e9;

int n, m;
vector<vector<int>> g;
vector<vector<int>> t;

vector<int> ans;

class DSU {
public:
	int sz;
	vector<int> parent;
	vector<int> rank;

	DSU(int _sz) {
		sz = _sz;

		parent = vector<int>(sz); for ( int i = 0; i < sz; ++i ) parent[i] = i;
		rank = vector<int>(sz, 1);
	}

	int find(int v) {
		if ( parent[v] == v ) return v;

		return parent[v] = find(parent[v]);
	}

	void join(int u, int v) {
		u = find(u); v = find(v);

		if ( u == v ) return;

		if ( rank[u] < rank[v] ) swap(u, v);

		parent[v] = u;

		if ( rank[u] == rank[v] ) rank[u]++;
	}
};

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> m;
	
	g = vector<vector<int>>(n, vector<int>(0));
	t = vector<vector<int>>(n, vector<int>(0));
	ans = vector<int>(n, 2 * INF);

	int _u, _v, _t;
	vector<tuple<int, int, int>> edges;
	for ( int i = 0; i < m; ++i ) {
		cin >> _u >> _v >> _t;
		_u--; _v--;

		g[_u].push_back(_v);
		g[_v].push_back(_u);

		t[_u].push_back(_t);
		t[_v].push_back(_t);

		edges.push_back({_t, _u, _v});
	}

	DSU dsu(n);
	vector<int> deg(n, 0);
	int u, v, tm;
	int mn, mx;

	for ( int mask = 0; mask < (1<<m); ++mask ) {
		dsu = DSU(n);
		fill(deg.begin(), deg.end(), 0);
		mn = INF; mx = 0;

		for ( int i = 0; i < m; ++i ) {
			if ( (mask & (1<<i)) == 0 ) continue;

			tie(tm, u, v) = edges[i];

			dsu.join(u, v);
			deg[u]++; deg[v]++;

			mn = min(mn, tm);
			mx = max(mx, tm);
		}

		u = -1; v = -1;
		bool flag = false;
		for ( int x = 0; x < n; ++x ) {
			if ( deg[x] % 2 == 0 ) continue;

			if ( u == -1 ) {
				u = x;
			} else if ( v == -1 ) {
				v = x;
			} else {
				flag = true;
				break;
			}
		}
		if ( flag ) continue;
		if ( u > v ) swap(u, v);

		if ( u != 0 ) continue;
		if ( v == -1 ) continue;
		if ( v == 0 ) continue;
		
		if ( dsu.find(u) != dsu.find(v) ) continue;

		ans[v] = min(ans[v], mn + mx);
	}

	for ( int i = 1; i < n; ++i )
		cout << ans[i] << "\n";

	return 0;
}