#include <iostream>

#include <algorithm>

#include <string>
#include <vector>

using namespace std;

typedef long long ll;

ll val[26];

ll get(string& s, ll i) {
	char max_c = s[i];
	ll res = 0;
	for (ll j = i; j >= 0; j--) {
		if (s[j] == '?')
			continue;

		if (s[j] >= max_c) {
			res += val[s[j] - 'A'];
		}
		else {
			res -= val[s[j] - 'A'];
		}

		max_c = max(max_c, s[j]);
	}

	return res;
}

ll solve1(string s) {
	ll n = s.size();
	ll cnt[26] = { 0 };

	for (ll i = 0; i < n; i++) {
		if (s[i] != '?') {
			cnt[s[i] - 'A']++;
		}
		else {
			ll max_sum = 0, best_c = 'A';
			for (char c = 'A'; c <= 'Z'; c++) {
				s[i] = c;
				if (get(s, i) > max_sum) {
					max_sum = get(s, i);
					best_c = c;
				}
			}
			s[i] = best_c;
		}
	}

	return get(s, n - 1);
}

ll best_sum;
string ans;

void f(string s, ll i) {
	if (i == s.size()) {
		if (get(s, s.size() - 1) >= best_sum) {
			best_sum = get(s, s.size() - 1);
			ans = s;
		}
		return;
	}

	if (s[i] != '?')
		f(s, i + 1);
	else {
		for (char c = 'A'; c <= 'Z'; c++) {
			s[i] = c;
			f(s, i + 1);
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);
	
	ll cur = 1;
	for (ll i = 0; i < 26; i++) {
		val[i] = cur;
		if (i % 2 == 0)
			cur *= 5l;
		else
			cur *= 2l;
	}

	ll t; cin >> t;
	while (t--) {
		string s; cin >> s;
		ll n = s.size();

		best_sum = -2e18;
		ans = s;

		f(s, 0);

		cout << best_sum << '\n' << ans << '\n';
	}

	return 0;
}