#include <bits/stdc++.h>

using namespace std;

const int INF = 1000000000;


vector< vector< tuple<int, int, int> > > adj;
vector<int> used, tin, fup;
int curtm;
vector<bool> isbridge;

void dfs(int u, int pe) {
	used[u] = 1;
	tin[u] = curtm++;
	fup[u] = tin[u];
	for(auto [v, e, t]: adj[u]) {
		if(e == pe) {
			continue;
		}
		if(used[v] == 1) {
			fup[u] = min(fup[u], tin[v]);
		} else if(used[v] == 0) {
			dfs(v, e);
			fup[u] = min(fup[u], fup[v]);
			if(fup[v] > tin[u]) {
				isbridge[e] = true;
			}
		}
	}
	used[u] = 2;
}

vector<int> compof;
vector<int> minincomp;
vector< vector<int> > adjbr;
void dfs2(int u, int p, int c) {
	used[u] = 1;
	compof[u] = c;
	for(auto [v, e, t]: adj[u]) {
		if(v == p) {
			continue;
		}
		if(isbridge[e]) {
			minincomp.push_back(t);
			adjbr.emplace_back();
			adjbr[c].push_back(minincomp.size() - 1);
			dfs2(v, u, minincomp.size() - 1);
		} else {
			minincomp[c] = min(minincomp[c], t);
			if(!used[v]) {
				dfs2(v, u, c);
			}
		}
	}
}

vector<int> recmincomp;
void dfs3(int u, int curmin) {
	curmin = min(curmin, minincomp[u]);
	recmincomp[u] = curmin;
	for(int v: adjbr[u]) {
		dfs3(v, curmin);
	}
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, m;
	cin >> n >> m;

	adj.resize(n);
	for(int i = 0; i < m; i++) {
		int u, v, t;
		cin >> u >> v >> t;
		u--; v--;
		adj[u].emplace_back(v, i, t);
		adj[v].emplace_back(u, i, t);
	}

	used.resize(n);
	tin.resize(n);
	fup.resize(n);
	isbridge.resize(m);
	dfs(0, -1);

	used.clear();
	used.resize(n);
	minincomp.push_back(INF);
	adjbr.emplace_back();
	compof.resize(n);
	dfs2(0, -1, 0);

	recmincomp.resize(minincomp.size());
	dfs3(0, INF);

	for(int i = 1; i < n; i++) {
		cout << recmincomp[compof[i]] << "\n";
	}

	return 0;
}