#include <bits/stdc++.h>

using namespace std;

const int INF = 1000000000;


int n, m;


class DSU {
public:
	vector< vector<int> > items;
	vector<int> parent;

	DSU(int n) {
		items.resize(n);
		parent.resize(n);
		for(int i = 0; i < n; i++) {
			items[i].push_back(i);
			parent[i] = i;
		}
	}

	int get(int i) {
		return i == parent[i] ? i : parent[i] = get(parent[i]);
	}

	void unite(int u, int v) {
		u = get(u);
		v = get(v);
		assert(u != v);
		if(items[u].size() > items[v].size()) {
			swap(u, v);
		}
		for(int x: items[u]) {
			parent[x] = v;
			items[v].push_back(x);
		}
		items[u].clear();
	}
};


vector< vector< tuple<int, int, int> > > adj;
vector<int> used, tin, fup;
int curtm;
vector<bool> isbridge;

void dfs(int u, int pe) {
	used[u] = 1;
	tin[u] = curtm++;
	fup[u] = tin[u];
	for(auto [v, e, t]: adj[u]) {
		if(e == pe) {
			continue;
		}
		if(used[v] == 1) {
			fup[u] = min(fup[u], tin[v]);
		} else if(used[v] == 0) {
			dfs(v, e);
			fup[u] = min(fup[u], fup[v]);
			if(fup[v] > tin[u]) {
				isbridge[e] = true;
			}
		}
	}
	used[u] = 2;
}

vector<int> compof;
vector<int> minincomp;
vector< vector<int> > adjbr;
void dfs2(int u, int p, int c) {
	used[u] = 1;
	compof[u] = c;
	for(auto [v, e, t]: adj[u]) {
		if(v == p) {
			continue;
		}
		if(isbridge[e]) {
			minincomp.push_back(t);
			adjbr.emplace_back();
			adjbr[c].push_back(minincomp.size() - 1);
			dfs2(v, u, minincomp.size() - 1);
		} else {
			minincomp[c] = min(minincomp[c], t);
			if(!used[v]) {
				dfs2(v, u, c);
			}
		}
	}
}

vector<int> recmincomp;
void dfs3(int u, int curmin) {
	curmin = min(curmin, minincomp[u]);
	recmincomp[u] = curmin;
	for(int v: adjbr[u]) {
		dfs3(v, curmin);
	}
}


vector<int> ans;

void add_edge(int u, int v, int i, int t) {
	cerr << "Add edge " << u + 1 << "--" << v + 1 << " (" << i << ") " << t << endl;

	curtm = 0;
	used.clear();
	used.resize(n);
	tin.resize(n);
	fup.resize(n);
	isbridge.clear();
	isbridge.resize(m);
	dfs(0, -1);

	used.clear();
	used.resize(n);
	minincomp.clear();
	minincomp.push_back(INF);
	adjbr.clear();
	adjbr.emplace_back();
	compof.clear();
	compof.resize(n, -1);
	dfs2(0, -1, 0);

	recmincomp.resize(minincomp.size());
	dfs3(0, INF);

	for(int i = 1; i < n; i++) {
		if(compof[i] != -1) {
			ans[i] = min(ans[i], t + recmincomp[compof[i]]);
		}
	}
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> m;

	vector< vector< tuple<int, int, int> > > adj1(n);
	vector< tuple<int, int, int, int> > weights;
	for(int i = 0; i < m; i++) {
		int u, v, t;
		cin >> u >> v >> t;
		u--; v--;
		adj1[u].emplace_back(v, i, t);
		adj1[v].emplace_back(u, i, t);
		weights.emplace_back(t, u, v, i);
	}
	sort(weights.begin(), weights.end());


	ans.resize(n, INF * 2);

	adj.resize(n);
	compof.resize(n, -1);
	compof[0] = 0;

	DSU dsu(n);

	for(auto [t, u, v, i]: weights) {
		adj[u].emplace_back(v, i, t);
		adj[v].emplace_back(u, i, t);

		int u1 = dsu.get(u);
		int v1 = dsu.get(v);
		if(v1 == dsu.get(0)) {
			if(u1 == v1) {
				add_edge(u, v, i, t);
				continue;
			}
			swap(u1, v1);
		}
		if(u1 == dsu.get(0)) {
			for(int uu: dsu.items[v1]) {
				for(auto [vv, ii, tt]: adj[uu]) {
					add_edge(uu, vv, ii, tt);
				}
			}
		}
		if(u1 != v1) {
			dsu.unite(u1, v1);
		}
	}

	for(int i = 1; i < n; i++) {
		cout << ans[i] << "\n";
	}

	return 0;
}