#include<bits/stdc++.h>
#define int long long
#define p pair<int, int>
//#define endl '\n'
const int INF = 2000000001;

using namespace std;

vector<vector<p>> d;
vector<int> dist;
vector<bool> was;
vector<vector<int>> d1;

int DFS_easy(int vertex){
    was[vertex] = true;
    int ans = d1[vertex].size();
    for (int q: d1[vertex]){
        if (!was[q]){
            ans += DFS_easy(q);
        }
    }
    return ans;
}

vector<int> easy(int n, int m, vector<pair<p, int>> &input){
    d.assign(n, {});
    map<p, int> edge_map;
    vector<pair<p, int>> edge;
    for (int q = 0; q < m; q++){
        int x = input[q].first.first, y = input[q].first.second, z = input[q].second;
        edge_map[{x, y}]++, edge_map[{y, x}]++;
        d[x].push_back({y, z});
        d[y].push_back({x, z});
        edge.push_back({{x, y}, z});
    }
    dist.assign(n, INF);
    for (int q = 0; q < (1 << m); q++){
        int min1 = INF, max1 = -INF, num = 0;
        d1.assign(n, {}), was.assign(n, false);
        for (int q1 = 0; q1 < m; q1++){
            if ((q >> q1) & 1){
                min1 = min(min1, edge[q1].second), max1 = max(max1, edge[q1].second);
                d1[edge[q1].first.first].push_back(edge[q1].first.second);
                d1[edge[q1].first.second].push_back(edge[q1].first.first);
                num++;
            }
        }
        int num_now = DFS_easy(0)/2, ind = -1;
        if (num_now == num && d1[0].size() % 2 == 1){
            for (int q1 = 1; q1 < n; q1++){
                if (d1[q1].size() % 2 == 1 && ind == -1){
                    ind = q1;
                }else if (d1[q1].size() % 2 == 1){
                    ind = -1;
                    break;
                }
            }
            if (ind != -1){
                dist[ind] = min(dist[ind], min1+max1);
            }
        }
    }
    vector<int> dist1;
    for (int q = 1; q < n; q++){
        dist1.push_back(dist[q]);
    }
    return dist1;
}

vector<p> bridges;
vector<bool> was1, was2;
vector<int> tin, up;
int time1 = 0;
set<p> bridge;

void DFS_bridge(int vertex, int parent){
    was[vertex] = true, tin[vertex] = up[vertex] = time1++;
    for (p q: d[vertex]){
        if (!was[q.first]){
            DFS_bridge(q.first, vertex);
            up[vertex] = min(up[vertex], up[q.first]);
            if (up[q.first] > tin[vertex]){
                bridges.push_back({vertex, q.first});
            }
        }else if (q.first != parent){
            up[vertex] = min(up[vertex], tin[q.first]);
        }
    }
}

void DFS_ans(int vertex, int is){
    was1[vertex] = true, dist[vertex] = is;
    for (p q: d[vertex]){
        if (!was1[q.first] && bridge.find({vertex, q.first}) == bridge.end()){
            DFS_ans(q.first, is);
        }
    }
}

int DFS_hard(int vertex, int is, bool flag, bool may){
    if (!flag){
        was[vertex] = true;
    }else{
        was2[vertex] = true;
    }
    for (p q: d[vertex]){
        if (!flag){
            if (!was[q.first] && bridge.find({vertex, q.first}) == bridge.end()){
                is = min(is, DFS_hard(q.first, min(is, q.second), flag, false));
            }else if (bridge.find({vertex, q.first}) == bridge.end()){
                is = min(is, q.second);
            }
        }else{
            if (!was2[q.first]){
                DFS_hard(q.first, min(is, q.second), bridge.find({vertex, q.first}) == bridge.end(), bridge.find({vertex, q.first}) != bridge.end());
            }
        }
    }
    if (may){
        DFS_ans(vertex, is);
        DFS_hard(vertex, is, true, false);
    }
    return is;
}

vector<int> hard(int n, int m, vector<pair<p, int>> &input){
    d.assign(n, {}), time1 = 0, bridge = {}, bridges = {};
    map<p, int> edge_map;
    for (int q = 0; q < m; q++){
        int x = input[q].first.first, y = input[q].first.second, z = input[q].second;
        edge_map[{x, y}]++, edge_map[{y, x}]++;
        d[x].push_back({y, z});
        d[y].push_back({x, z});
    }
    dist.assign(n, INF), was.assign(n, false), tin.assign(n, -1), up.assign(n, -1);
    DFS_bridge(0, -1);
    for (p q: bridges){
        if (edge_map[q] == 1){
            bridge.insert(q);
            bridge.insert({q.second, q.first});
        }
    }
    was.assign(n, false), was1.assign(n, false), was2.assign(n, false);
    DFS_hard(0, INF, false, true);
    vector<int> dist1;
    for (int q = 1; q < n; q++){
        dist1.push_back(dist[q]+1000000000);
    }
    return dist1;
}

void solve(){
    int n, m;
    cin >> n >> m;
    vector<pair<p, int>> input;
    for (int q = 0; q < m; q++){
        int x, y, z;
        cin >> x >> y >> z;
        x--, y--;
        input.push_back({{x, y}, z});
    }
    vector<int> ans = hard(n, m, input);
    for (int q: ans){
        cout << q << endl;
    }
}

mt19937 randint(179);

void DFS_bool(int vertex){
    was[vertex] = true;
    for (int q: d1[vertex]){
        if (!was[q]){
            DFS_bool(q);
        }
    }
}

vector<pair<p, int>> gen(int n, int m, int k){
    vector<pair<p, int>> input;
    while (true){
        input = {};
        for (int q = 0; q < m; q++){
            int x = randint() % n, y = randint() % n;
            while (x == y){
                x = randint() % n, y = randint() % n;
            }
            input.push_back({{x, y}, randint() % k});
        }
        d1.assign(n, {}), was.assign(n, false);
        for (int q = 0; q < m; q++){
            d1[input[q].first.first].push_back(input[q].first.second);
            d1[input[q].first.second].push_back(input[q].first.first);
        }
        DFS_bool(0);
        bool flag = true;
        for (int q = 0; q < n; q++){
            if (!was[q]){
                flag = false;
                break;
            }
        }
        if (flag){
            break;
        }
    }
    for (int q = 0; q < m; q++){
        if (input[q].first.first == 0 || input[q].first.second == 0){
            input[q].second = 1000000000;
        }
    }
    return input;
}

void debug(){
    int q2 = 0;
    while (true){
        if (q2 == 0){
            int q4 = 0;
        }
        cout << q2++ << endl;
        int n = 5, m = 6, k = 5;
        vector<pair<p, int>> input = gen(n, m, k);
        vector<int> ans1 = easy(n, m, input), ans2 = hard(n, m, input);
        if (ans1 != ans2){
            cout << endl << endl << endl;
            cout << n << ' ' << m << endl;
            for (pair<p, int> q: input){
                cout << q.first.first+1 << ' ' << q.first.second+1 << ' ' << q.second << endl;
            }
            break;
        }
    }
}

signed main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    //debug();
    return 0;
}
/*
3 3
1 2 2
1 3 1
2 3 1

7 10
1 2 2
1 2 8
2 3 3
3 4 5
3 5 4
4 5 4
6 5 7
6 4 4
1 7 6
6 7 9

4 4
1 2 2
3 2 0
2 4 3
4 3 1

*/
