#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>

using namespace std;

typedef long long ll;

const ll N = 3e5 + 10;
const ll inf = 1e18;

ll x[N], h[N];
vector <ll> e1[N], e2[N];
ll sz1[N], sz2[N];
bool used[N];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll n, q;
	cin >> n >> q;
	for (ll i = 1; i <= n; i++) {
		cin >> x[i] >> h[i];
	}
	x[0] = x[1];
	x[n + 1] = x[n];
	for (ll y = 0; y < q; y++) {
		ll ans = 0;
		ll l, r;
		cin >> l >> r;
		for (ll i = l; i <= r; i++) {
			e1[i].clear(); e2[i].clear();
			sz1[i] = 0; sz2[i] = 0;
			used[i] = 0;
		}
		for (ll i = l; i <= r; i++) {
			ll j = i + 1;
			while (j <= r + 1 && x[i] + h[i] > x[j]) {
				sz1[i]++;
				e1[j].push_back(i);
				j++;
			}
		}
		for (ll i = l; i <= r; i++) {
			ll j = i - 1;
			while (j >= l - 1 && x[i] - h[i] < x[j]) {
				sz2[i]++;
				e2[j].push_back(i);
				j--;
			}
		}
		queue <ll> o;
		for (ll i = l; i <= r; i++) {
			if (sz1[i] == 0 || sz2[i] == 0) {
				o.push(i);
			}
		}
		while (!o.empty()) {
			bool f = 0;
			ll i = o.front(); o.pop();
			if (used[i]) {
				continue;
			}
			if (sz1[i] == 0 && x[i] + h[i] <= x[n + 1]) {
				f = 1;
			}
			if (sz2[i] == 0 && x[i] - h[i] >= x[0]) {
				f = 1;
			}
			if (!f) {
				continue;
			}
			ans++;
			used[i] = 1;
			for (ll j = 0; j < e1[i].size(); j++) {
				sz1[e1[i][j]]--;
				if (sz1[e1[i][j]] == 0 && !used[e1[i][j]]) {
					o.push(e1[i][j]);
				}
			}
			for (ll j = 0; j < e2[i].size(); j++) {
				sz2[e2[i][j]]--;
				if (sz2[e2[i][j]] == 0 && !used[e2[i][j]]) {
					o.push(e2[i][j]);
				}
			}
		}
		cout << ans << '\n';
	}
}