#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cstring>

using namespace std;

//#define int long long
const int MAXN = 150020;
const long long INF = 1e8;

vector<pair<pair<int, int>, pair<int, int> > > ans;

vector<pair<int, int>> g1;
vector<pair<int, int>> g2;
vector<pair<int, int>> g[MAXN];

int d[MAXN];

void dfs(int v, int dnow) {
	d[v] = dnow;
	for (pair<int, int> p : g[v]) {
		if (d[p.first] == -1) {
			dfs(p.first, dnow + 1);
		}
	}
}

inline bool check(pair<int, int> e1, pair<int, int> e2) {
	return e1.second == e2.first || e2.second == e1.first;
}

int to[MAXN];
int used[MAXN];
bool kuhn(int v, int num) {
	for (int j = 0; j < g2.size(); ++j) {
		if (to[j] == -1 && used[j] < num && check(g1[v], g2[j])) {
			to[j] = v;
			return true;
		}
	}
	for (int j = 0; j < g2.size(); ++j) {
		if (used[j] < num && check(g1[v], g2[j])) {
			int tmp = to[j];
			to[j] = v;
			used[j] = num;
			if (kuhn(tmp, num)) return true;
			to[j] = tmp;
		}
	}
	return false;
}

signed main() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int v, u;
		cin >> v >> u;
		--v; --u;
		g[v].push_back(make_pair(u, 1));
		g[u].push_back(make_pair(v, -1));
	}
	memset(d, -1, sizeof d);
	for (int v = 0; v < n; ++v) {
		if (d[v] == -1) dfs(v, 0);
	}
	for (int v = 0; v < n; ++v) {
		for (pair<int, int> p : g[v]) {
			if (p.second == 1) {
				if (d[v] & 1) {
					g2.push_back(make_pair(v, p.first));
				}
				else {
					g1.push_back(make_pair(v, p.first));
				}
			}
		}
	}
	if (g1.size() != g2.size()) {
		cout << "No\n";
		return 0;
	}
	memset(to, -1, sizeof to);
	memset(used, 0, sizeof used);
	int num = 1;
	for (int i = 0; i < g1.size(); ++i) {
		if (!kuhn(i, num)) {
			cout << "No\n";
			return 0;
		}
		++num;
	}
	cout << "Yes\n";
	for (int i = 0; i < g2.size(); ++i) {
		cout << g2[i].first + 1 << " " << g2[i].second + 1 << " " << g1[to[i]].first + 1 << " " << g1[to[i]].second + 1 << "\n";
	}
}
/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2
*/

/*
4 4
2 1
2 3
2 4
4 2
*/