#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <stack>
#include <queue>

using namespace std;

#define endl '\n'
#define int long long

struct Node
{
	int mindist = INT_MAX;
	vector<pair<int, int>> to;
};

vector<Node> graph;

void task()
{
	int n, m;
	cin >> n >> m;

	graph.resize(n);

	for (int i = 0; i < m; i++)
	{
		int x, y, p;
		cin >> x >> y >> p;
		x--;
		y--;

		graph[x].to.push_back({ y, p });
		graph[y].to.push_back({ x, p });
	}

	priority_queue<pair<int, int>> q;

	for (int i = 0; i < graph[0].to.size(); i++)
	{
		q.push({ graph[0].to[i].first, (int)0 });
		graph[graph[0].to[i].first].mindist = 0;
	}

	while (!q.empty())
	{
		int v = q.top().first;
		int p = q.top().second;
		q.pop();

		for (int i = 0; i < graph[v].to.size(); i++)
		{
			int u = graph[v].to[i].first;
			int cost = graph[v].to[i].second;

			if (graph[u].mindist > max(p, cost))
			{
				graph[u].mindist = max(p, cost);
				q.push({ u, max(p, cost) });
			}
		}
	}

	for (int i = 0; i < graph[0].to.size(); i++)
	{
		graph[graph[0].to[i].first].mindist = 1e9;
	}

	for (int i = 1; i < n; i++)
	{
		cout << graph[i].mindist + 1000000000 << endl;
	}
}

long main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	task();

	return 0;
}

/*6 6
1 2 1000000000
1 4 1000000000
2 3 5
4 5 3
4 6 4
5 6 2*/