#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ft first
#define sd second
#define pb push_back
#define eb emplace_back
#define all(x) (x).begin(), (x).end()

const int INF = 1e9 + 1;

void dfs1(int i, int par, vector<int> &mn, vector<int> &mx, vector<vector<pair<int, int>>> &graph){
    for (auto edge : graph[i]){
        if (edge.ft == par)
            continue;
        mn[edge.ft] = min(mn[i], edge.sd);
        mx[edge.ft] = max(mx[i], edge.sd);
        dfs1(edge.ft, i, mn, mx, graph);
    }
}

void Dij(int start, vector<int> &dist, vector<vector<pair<int, int>>> &graph){
    set<pair<int, int>> st;
    st.insert({0, start});
    while (!st.empty()){
        pair<int, int> p = *(st.begin());
        st.erase(st.begin());
        int v = p.sd, curr_mx = p.ft;
        for (auto edge : graph[v]){
            if (dist[edge.ft] > max(curr_mx, edge.sd)){
                st.erase({dist[edge.ft], edge.ft});
                dist[edge.ft] = max(curr_mx, edge.sd);
                st.insert({dist[edge.ft], edge.ft});
            }
        }
    }
}

void Dij2(int start, vector<int> &dist, vector<vector<pair<int, int>>> &graph){
    set<pair<int, int>> st;
    st.insert({INF, start});
    while (!st.empty()){
        pair<int, int> p = *(st.begin());
        st.erase(st.begin());
        int v = p.sd, curr_mx = p.ft;
        for (auto edge : graph[v]){
            if (dist[edge.ft] > min(curr_mx, edge.sd)){
                st.erase({dist[edge.ft], edge.ft});
                dist[edge.ft] = min(curr_mx, edge.sd);
                st.insert({dist[edge.ft], edge.ft});
            }
        }
    }
}

signed main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> graph(n);
    int a, b, w;
    bool zeros = true;
    for (int i = 0; i < m; i++){
        cin >> a >> b >> w;
        a--; b--;
        graph[a].eb(b, w);
        graph[b].eb(a, w);
        if ((a == 0 || b == 0) && w != 0)
            zeros = false;
    }
    if (m == n - 1){
        vector<int> mn(n, INF);
        vector<int> mx(n, -INF);
        dfs1(0, 0, mn, mx, graph);
        for (int i = 1; i < n; i++)
            cout << mn[i] + mx[i] << "\n";
    }
    else if (zeros){
        vector<int> dist(n, INF);
        Dij(0, dist, graph);
        for (int i = 1; i < n; i++)
            cout << dist[i] << "\n";
    }
    else{
        vector<int> dist(n, 0);
        Dij2(0, dist, graph);
        for (int i = 1; i < n; i++)
            cout << dist[i] + 1e9 << "\n";
    }
    return 0;
}