//#pragma GCC optimize("O3")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")

#define ll long long
#define u unsigned
#define frr(x,y) for(int y=0;y<int(x);y++)
#define fr(x) frr(x,i)
#define frin fr(n)

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <vector>
#include <cassert>
#include <string>
#include <bitset>

using namespace std;

ll n, m, k, t, x, y, z, a, b, c, d, l, r;
vector<ll>f, p, dp;

vector<pair<int, int>>edge;
vector<vector<int>>g;
vector<vector<int>>to;

bitset<6000>dola;
bitset<6000>used;

void dfs(int v)
{
	used[v] = 1;
	for (auto& x : g[edge[v].second])
	{
		if (!used[x])
		{
			dola[x] = !dola[v];
			dfs(x);
		}
	}
}

bool kuhn(int v)
{
	if (used[v])
		return 0;
	used[v] = 1;
	for (auto& x : g[edge[v].second])
	{
		if (p[x] == -1 || kuhn(p[x]))
		{
			p[x] = v;
			return 1;
		}
	}
	for (auto& x : to[edge[v].first])
	{
		if (p[x] == -1 || kuhn(p[x]))
		{
			p[x] = v;
			return 1;
		}
	}
	return 0;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie();
	cout.tie();
	cin >> n >> m;
	g.resize(n);
	to.resize(n);
	p.resize(m);
	fr(m)
	{
		cin >> a >> b;
		a--, b--;
		edge.push_back({ a,b });
		g[a].push_back(i);
		to[b].push_back(i);
	}
	fr(m)
		if(!used[i])
			dfs(i);
	used = 0;
	p.assign(m, -1);
	fr(m)
	{
		if (!dola[i])
		{
			used = 0;
			if (!kuhn(i))
			{
				cout << "No";
				return 0;
			}
		}
	}
	cout << "Yes\n";
	fr(m)
	{
		if (dola[i])
		{
			if (edge[p[i]].second == edge[i].first)
				cout << edge[p[i]].first + 1 << " " << edge[p[i]].second + 1 << " " << edge[i].first + 1 << " " << edge[i].second + 1 << "\n";
			else if (dge[i].second == edge[p[i]].first)
				cout << edge[i].first + 1 << " " << edge[i].second + 1 << " " << edge[p[i]].first + 1 << " " << edge[p[i]].second + 1 << "\n";
			else
				assert(false);
		}
	}

}
