#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define int ll

#define pii pair<int, int>
#define vi vector<int>
#define vpii vector<pii>
#define vvi vector<vi>

const int N = 5005;
const ll INF = 1e18;

int w[N][N];
void solve() {
	for (int i = 0; i < N; ++i) {
		for (int j = 0; j < N; ++j) {
			w[i][j] = INF;
		}
	}
	int n, m; cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int x, y, t; cin >> x >> y >> t;
		--x, --y;
		w[x][y] = w[y][x] = min(w[x][y], t);
	}

	vi p;
	for (int i = 0; i < n; ++i) p.push_back(i);
	vi d(n, INF);
	do {

		if (p[0] != 0) {
			break;
		}
		int minn = INF, maxx = -INF;
		for (int i = 1; i < n; ++i) {
			minn = min(minn, w[p[i - 1]][p[i]]);
			maxx = max(maxx, w[p[i - 1]][p[i]]);
			d[p[i]] = min(d[p[i]], minn + maxx);
		}

	} while (next_permutation(p.begin(), p.end()));

	for (int i = 1; i < n; ++i) {
		cout << d[i] << '\n';
	}

}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);
	int t = 1; //cin >> t;
	while (t--) {
		solve();
	}
}

/*

3 3
1 2 2
1 3 1
2 3 1

4 4
1 2 2
3 2 0
2 4 3
4 3 1


*/