#include <bits/stdc++.h>

using namespace std;

typedef long long ll;


map<pair<int, int>, int> mp;



void dfs(int v, vector<bool> & used, vector<vector<int>> & g, vector<vector<bool>> & dp) {
    used[v] = true;
    int cntup = 0, cntdwn = 0;
    bool dead = false;
    for (auto to : g[v]) {
        if (used[to]) continue;
        dfs(to, used, g, dp);

        if (mp[{to, v}]) {
            if  (dp[to][0]) {
                continue;
            }
            if (dp[to][1]) {
                cntup++;
                continue;
            }
            if (dp[to][2]) {
                cntdwn++;
                continue;
            }
            dead = true;
        } else {
            if (dp[to][0]) {
                cntdwn++;
                continue;
            }
            if (dp[to][1]) {
                continue;
            }
            dead = true;
        }
    }
    // cout << v << " " << cntup << " " << cntdwn << endl;

    if (dead) {
        dp[v][0] = false;
        dp[v][1] = false;
        dp[v][2] = false;
        return;
    }
    if (cntup == cntdwn) {
        dp[v][0] = true;
        dp[v][1] = false;
        dp[v][2] = false;
        return;
    }
    if (cntup == cntdwn + 1) {
        dp[v][0] = false;
        dp[v][1] = false;
        dp[v][2] = true;
        return;
    }
    if (cntdwn == cntup + 1) {
        dp[v][0] = false;
        dp[v][1] = true;
        dp[v][2] = false;
        return;
    }
    dp[v][0] = false;
    dp[v][1] = false;
    dp[v][2] = false;
    return;
}


int walk(int v, vector<bool> & used, vector<vector<int>> & g, vector<vector<bool>> & dp, vector<pair<int, int>> & ans, int need) {
    vector<int> cntup, cntdwn;
    used[v] = true;
    // cout << v << " " << dp[v][0] << " " << dp[v][1] << " " << dp[v][2] << endl;
    for (auto to : g[v]) {
        if (used[to]) continue;
        if (mp[{to, v}]) {
            if (dp[to][0]) {
                walk(to, used, g, dp, ans, 0);
                ans.emplace_back(mp[{to, v}], mp[{v, to}]);
                continue;
            }
            if (dp[to][1]) {
                int tt = walk(to, used, g, dp, ans, 1);
                ans.emplace_back(mp[{v, to}], tt);
                cntup.push_back(to);
                continue;
            }
            if (dp[to][2]) {
                int tt = walk(to, used, g, dp, ans, 2);
                ans.emplace_back(tt, mp[{to, v}]);
                cntdwn.push_back(to);
            }
        } else {
            if (dp[to][0]) {
                walk(to, used, g, dp, ans, 0);
                cntdwn.push_back(to);
                continue;
            }
            if (dp[to][1]) {
                int tt = walk(to, used, g, dp, ans, 0);
                ans.emplace_back(mp[{v, to}], tt);
            }
        }
    }
    if (need == 0) {
        int nn = cntup.size();
        assert(cntdwn.size() == nn);
        for (int i = 0; i < nn; i++) {
            ans.emplace_back(mp[{cntup[i], v}], mp[{v, cntdwn[i]}]);
        }
        return -1;
    }
    if (need == 1) {
        int nn = cntup.size();
        assert(cntdwn.size() == nn + 1);
        for (int i = 0; i < nn; i++) {
            ans.emplace_back(mp[{cntup[i], v}], mp[{v, cntdwn[i]}]);
        }
        return mp[{v, cntdwn.back()}];
    }

    if (need == 2) {
        int nn = cntdwn.size();
        assert(cntup.size() == nn + 1);
        for (int i = 0; i < nn; i++) {
            ans.emplace_back(mp[{cntup[i], v}], mp[{v, cntdwn[i]}]);
        }
        return mp[{cntup.back(), v}];
    }
}






int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m; cin >> n >> m;
    vector<vector<int>> g(n);
    vector<pair<int, int>> eg;
    for (int i = 0; i < m; i++) {
        int a, b; cin >> a >> b;
        a--; b--;
        eg.emplace_back(a, b);
        g[a].push_back(b);
        mp[make_pair(a, b)] = i + 1;
    }
    vector<vector<bool>> dp(n, vector<bool>(3, true));
    vector<bool> used(n);
    vector<bool> usd(n);
    vector<pair<int, int>> ans;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, used, g, dp);
            if (!dp[i][0]) {
                cout << "No" << endl;
                return 0;
            } else {
                walk(i, usd, g, dp, ans, 0);
            }
        }
    }
    cout << "Yes" << endl;
    for (auto el : ans) {
        int i1 = el.first - 1, i2 = el.second - 1;
        // cout << i1 << " " << i2 << endl;
        cout << eg[i1].first + 1 << " " << eg[i1].second + 1 << " ";
        cout << eg[i2].first + 1 << " " << eg[i2].second + 1 << endl;
    }




    return 0;
}
