#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <set>
#include <map>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> gin(n), gout(n);
    vector<pair<int, int>> elist(m);
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        --v;
        --u;
        gout[v].emplace_back(u, i);
        gin[u].emplace_back(v, i);
        elist[i] = {v, u};
    }
    if (n <= 20 && m <= 20) {
        vector<bool> can(1 << m, false);
        vector<pair<int, int>> p(1 << m, {-1, -1});
        can[0] = true;
        for (int mask = 0; mask < (1 << m); ++mask) {
            if (!can[mask]) {
                continue;
            }
            for (int mid = 0; mid < n; ++mid) {
                for (auto ein : gin[mid]) {
                    if ((1 << ein.second) & mask) {
                        continue;
                    }
                    for (auto eout : gout[mid]) {
                        if ((1 << eout.second) & mask) {
                            continue;
                        }
                        can[(1 << ein.second) | (1 << eout.second) | mask] = true;
                        p[(1 << ein.second) | (1 << eout.second) | mask] = {ein.second, eout.second};
                    }
                }
            }
        }
        if (!can.back()) {
            cout << "No\n";
        }
        else {
            cout << "Yes\n";
            int masknow = (1 << m) - 1;
            while (masknow != 0) {
                pair<int, int> enow = p[masknow];
                masknow ^= (1 << enow.first);
                masknow ^= (1 << enow.second);
                cout << elist[enow.first].first + 1 << " " <<
                elist[enow.first].second + 1 << " " <<
                elist[enow.second].first + 1 << " " <<
                elist[enow.second].second + 1 << "\n";
            }
        }
    }

    return 0;
}
