#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <unordered_set>
#include <set>

using namespace std;
int MAX = 2000000000;

struct edge {
	int other = 0;
	bool front = false;
	bool back = false;
};


vector<vector<edge>> graph;
vector<int> used;

deque<int> answ;

// returns what need: [0: nothing, 1: to_child, 2: to_parent
int dfs(int v, int pred) {
	if (used[v]) return 0; // never happen
	used[v] = 1;
	for (auto& other : graph[v]) {
		if (other.other == pred) continue;
		int ans = dfs(other.other, v);
		if (ans == 1) {
			if (!other.front) throw 1;
			else {
				answ.push_back(v);
				answ.push_back(other.other);
				other.front = false;
			}
		}
		if (ans == 2) {
			if (!other.back) throw 2;
			else {
				answ.push_back(other.other);
				answ.push_back(v);
				other.back = false;
			}
		}
	}
	vector<int> forward;
	vector<int> backward;
	for (auto& other : graph[v]) {
		if (other.other == pred) continue;
		if (other.front) forward.push_back(other.other);
		if (other.back) backward.push_back(other.other);
	}
	if (abs((int)forward.size() - (int)backward.size()) > 1) throw 3;
	for (int i = 0; i < (int)min(forward.size(), backward.size()); i++) {
		answ.push_back(backward[i]);
		answ.push_back(v);
		answ.push_back(v);
		answ.push_back(forward[i]);
	}
	if (forward.size() == backward.size()) return 0;
	if (forward.size() > backward.size()) {
		answ.push_back(v);
		answ.push_back(forward[forward.size() - 1]);
		return 1;
	}
	if (forward.size() < backward.size()) {
		answ.push_back(backward[backward.size() - 1]);
		answ.push_back(v);
		return 2;
	}
	return 0;
}

bool operator<(pair<int, edge>& a, pair<int, edge>& b) {
	return a.first < b.first;
}
bool operator<(const edge& a, const edge& b) {
	return a.other < b.other;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int n, m;
	cin >> n >> m;
	graph = vector<vector<edge>>(n);
	set<pair<int, edge>> input;
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		edge now, test;
		now.other = b;
		test.other = a;
		now.front = true;
		test.front = true;
		if (input.find({ b, test }) != input.end()) {
			input.erase({ b, test });
			test.back = true;
			now.back = true;
			graph[a].push_back(now);
			graph[b].push_back(test);
		}
		else {
			input.insert({ a, now });
		}
	}
	for (auto& p : input) {
		graph[p.first].push_back(p.second);
		edge twink;
		twink.other = p.first;
		twink.back = true;
		graph[p.second.other].push_back(twink);
	}

	used = vector<int>(n, false);
	try {
		for (int i = 0; i < n; i++) {
			if (!used[i]) {
				int ans = dfs(i, -1);
				if (ans != 0) throw 4;
			}
		}
		cout << "Yes\n";
		int cnt = 0;
		while (!answ.empty()) {
			cnt++;
			cout << answ.front() + 1 << " ";
			answ.pop_front();
			if (cnt % 4 == 0) {
				cout << "\n";
				cnt = 0;
			}
		}
	}
	catch (int a) {
		cout << "No\n";
	}

}