#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <random>
#include <set>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef vector<ll> vi;
typedef vector<vi> vvi;

const ll mx1 = 26, inff = 4e18;

#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define vec vector

void run() {
	ll n, q;
	cin >> n >> q;
	vi x(n), h(n);
	for (ll i = 0; i < n; ++i) {
		cin >> x[i] >> h[i];
	}
	vi lf(n), rg(n), t_lf, t_rg;
	vi dl(n), dr(n), t_dl, t_dr;
	lf[0] = -1;
	dl[0] = 0;
	for (ll i = 1; i < n; ++i) {
		lf[i] = i - 1;
		dl[i] = x[i] - x[i - 1];
	}
	rg[n - 1] = n;
	dr[n - 1] = 0;
	for (ll i = 0; i < n - 1; ++i) {
		rg[i] = i + 1;
		dr[i] = x[i + 1] - x[i];
	}
	t_lf = lf;
	t_rg = rg;
	t_dl = dl;
	t_dr = dr;
	vi used(n, 0);
	for (ll ii = 0; ii < q; ++ii) {
		ll l, r;
		cin >> l >> r;
		l--, r--;
		queue<ll> qu;
		for (ll i = l; i <= r; ++i) {
			used[i] = 0;
			if (dl[i] >= h[i] || dr[i] >= h[i]) {
				qu.push(i);
				used[i] = 1;
			}
		}
		ll ans = 0;
		while (!qu.empty()) {
			ll v = qu.front();
			qu.pop();
			ans++;
			if (lf[v] >= l) {
				rg[lf[v]] = rg[v];
				dr[lf[v]] += dr[v];
				if (!used[lf[v]] && dr[lf[v]] >= h[lf[v]]) {
					qu.push(lf[v]);
					used[lf[v]] = 1;
				}
			}
			if (rg[v] <= r) {
				lf[rg[v]] = lf[v];
				dl[rg[v]] += dl[v];
				if (!used[rg[v]] && dl[rg[v]] >= h[rg[v]]) {
					qu.push(rg[v]);
					used[rg[v]] = 1;
				}
			}
		}
		cout << ans << '\n';
		for (ll i = l; i <= r; ++i) {
			used[i] = 0;
			lf[i] = t_lf[i];
			rg[i] = t_rg[i];
			dl[i] = t_dl[i];
			dr[i] = t_dr[i];
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll tkk = 1, kk = 0;
	//cin >> tkk;
	while (kk++ < tkk) {
		run();
		//cout << '\n';
	}
	return 0;
}

/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3
*/