#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <cmath>
#include <cstring>

using namespace std;

#define int long long
#define fi first
#define se second
#define all(x) x.begin(),x.end()

vector<vector<pair<int,int>>> gr;
vector<int> ans, dsu;

int lead(int v) {
    return (v == dsu[v] ? v : dsu[v] = lead(dsu[v]));
}
bool un(int v, int u) {
    v = lead(v);
    u = lead(u);
    if (v != u) {
        dsu[u] = v;
        return 1;
    } else {
        return 0;
    }
}

void dfs(int v, int mn = 1e9, int mx = -1e9, int p=-1) {
    ans[v] = mn + mx;
    for (auto [i, c] : gr[v]) {
        if (i != p) {
            dfs(i, min(mn, c), max(mx, c), v);
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    gr.resize(n);
    ans.resize(n);
    dsu.resize(n);
    for (int i = 0; i < n; ++i) {
        dsu[i] = i;
    }
    vector<vector<int>> E;
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        u--; v--;
        E.push_back({c, u, v});
    }

    sort(all(E));
    for (auto i : E) {
        if (un(i[1], i[2])) {
            gr[i[1]].push_back({i[2], i[0]});
            gr[i[0]].push_back({i[1], i[0]});
        }
    }
    dfs(0);
    for (int i = 1; i < n; ++i) cout << ans[i] << "\n";
}
