#include <iostream>
#include <vector>
#include <unordered_set>
#include <numeric>

#pragma GCC target("avx,avx2,sse,sse2,sse4.2")

using namespace std;

struct Tree {
    explicit Tree() {
    }
    int x, h;
    Tree(int x_, int h_) : x(x_), h(h_) {

    }
};

inline int answer(const vector<Tree> &trees) __attribute__((optimize("O3")));
inline int answer(const vector<Tree> &trees, int l, int r) {
    int n = trees.size();
    vector<bool> used(r - l + 1, false);
    used[0] = used[r - l] = true;
    unordered_set<int> extractable;
    vector<int> next(r - l + 1);
    iota(next.begin(), next.end(), 1);
    vector<int> prev(r - l + 1);
    iota(prev.begin(), prev.end(), -1);
    for (int i = l + 1; i < r; ++i) {
        if (trees[i].x + trees[i].h <= trees[next[i - l] + l].x ||
            trees[i].x - trees[i].h >= trees[prev[i - l] + l].x) {
            extractable.insert(i);
        }
    }
    int ans = 0;
    while (!extractable.empty()) {
        //Extract

        int i = *extractable.begin();
        extractable.erase(i);
        ans += 1;
        used[i - l] = true;

        // Determine trees to update
        int prv = prev[i - l];
        int nxt = next[i - l];
        
        // Update links
        next[prv] = nxt;
        prev[nxt] = prv;

        //Do stuff
        
        if (!used[prv]) {
            if (trees[prv + l].x + trees[prv + l].h <= trees[nxt + l].x) {
                extractable.insert(prv + l);
            }
        }
        if (!used[nxt]) {
            if (trees[nxt + l].x - trees[nxt + l].h >= trees[prv + l].x) {
                extractable.insert(nxt + l);
            }
        }
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q; cin >> n >> q;
    vector<Tree> trees;
    int x1, h1; cin >> x1 >> h1;
    trees.emplace_back(x1, h1);
    trees.emplace_back(x1, h1);
    for (int i = 1; i < n; ++i) {
        int x, h; cin >> x >> h;
        trees.emplace_back(x, h);
    }
    Tree last = trees.back();
    trees.emplace_back(last);
    for (int i = 0; i < q; ++i) {
        int l, r; cin >> l >> r;
        //vector<Tree> query;
        //for (int i = l - 1; i <= r + 1; i++) {
           // query.emplace_back(trees[i]);
        //}
        cout << answer(trees, l - 1, r + 1) << endl;
    }
}
