#include <iostream>
#include <vector>

using namespace std;

const int INF = 1e9 + 228;

int main() {
    int n, m; cin >> n >> m;
    vector<vector<Edge>> graph(n);
    for (int i = 0; i < m; i++) {
        int f, t, w; cin >> f >> t >> w;
        f--; t--;
        graph[f].emplace_back(f, t, w);
        graph[t].emplace_back(t, f, w);
    }
    vector<int> dist(n, INF);
    set<pair<int, int>> verticesSet;
    dist[0] = 0;
    for (int i = 0; i < n; i++) {
        verticesSet.insert({dist[i], i});
    }
    while (!verticesSet.empty()) {
        auto x = *verticesSet.begin();
        verticesSet.erase(x);
        int v = x.second;
        int d = x.first;
        for (Edge e : graph[v]) {
            int u = e.to;
            int w = e.weight;
            if (verticesSet.find({dist[u], u}) != verticesSet.end()) {
                if (dist[u] > max(d, w)) {
                    verticesSet.erase({dist[u], u});
                    dist[u] = max(d, w);
                    verticesSet.insert({dist[u], u});
                }
            }
        }
    }
    for (int i = 1; i < n; i++) {
        cout << dist[i] << endl;
    }
}
