#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <utility>
#include <queue>
#define pb push_back
#define eb emplace_back
using namespace std;
using vi  = vector<int>;
using pii  = pair<int, int>;


struct Edge
{
    int to, t;
    Edge(int _to, int _t):
        to(_to), t(_t) {}
};


constexpr int N{300000};
constexpr int INF{1000000000};
vector<Edge> E[N];
bool used[N];
int ans[N];


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    setvbuf(stdout, nullptr, _IOFBF, 8192);
    setvbuf(stdin , nullptr, _IOFBF, 8192);

    int n, m;
    scanf("%d %d", &n, &m);

    for (int i = 0; i < m; i++)
    {
        int u, v, t;
        scanf("%d %d %d", &u, &v, &t);
        u--; v--;
        E[u].eb(v, t);
        E[v].eb(u, t);
    }

    queue<tuple<int,int,int>> q;
    q.emplace(0, INF, 0);
    used[0] = true;

    while (!q.empty())
    {
        auto [v, mnv, mxv] = q.front();
        q.pop();

        ans[v] = mnv + mxv;

        for (auto [u, t] : E[v])
        {
            if (!used[u])
            {
                used[u] = true;
                q.emplace(u, min(mnv, t), max(mxv, t));
            }
        }
    }

    for (int i = 1; i < n; i++)
        printf("%d ", ans[i]);

    return 0;
}
/*
4 3
1 2 1
2 3 5
3 4 0
*/

