//
// Created by roi on 09.04.2021.
//

#include <bits/stdc++.h>

using namespace std;

using ll = long long;

template<typename T>
using vec = vector<T>;

#define int ll

const int N = 3e5 + 10;
const ll INFL = 4'000'000'000'000'000'000;

vec<pair<int, int>> g[N];

int ans[N];

void dfs(int u, int p, int mx, int mn) {
  ans[u] = mx + mn;
  for (auto [v, t] : g[u]) {
    if (v == p) continue;
    dfs(v, u, max(mx, t), min(mn, t));
  }
}

struct DSU {
  vec<int> pr, sz;
  DSU(int n) : pr(n, -1), sz(n, 1) {}
  int get(int u) {
    if (pr[u] == -1) {
      return u;
    }
    return pr[u] = get(pr[u]);
  }
  bool join(int u, int v) {
    u = get(u);
    v = get(v);
    if (u == v)
      return false;
    if (sz[v] > sz[u])
      swap(u, v);
    pr[v] = u;
    sz[u] += sz[v];
    return true;
  }
};

void run() {
  int n, m;
  cin >> n >> m;
  vec<tuple<int, int, int>> edges;
  for (int i = 0; i < m; i++) {
    int u, v, t;
    cin >> u >> v >> t;
    u--, v--;
    edges.emplace_back(t, u, v);
  }
  sort(edges.begin(), edges.end());
  DSU d(n);
  for (auto [t, u, v] : edges) {
    if (d.join(u, v)) {
      g[u].emplace_back(v, t);
      g[v].emplace_back(u, t);
    }
  }
  dfs(0, 0, -INFL, INFL);
  for (int i = 1; i < n; i++) {
    cout << ans[i] << '\n';
  }
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#else
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
#endif
  run();
  return 0;
}