#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
using namespace std;
#define int long long
const int MAX = 400000;
const int INF = 1e18;
int t;
string s;
int n, m, a, b;
int dep[MAX], used[MAX];
vector<int> edges_in[MAX], edges_out[MAX];
set<pair<int, int>> edges_in2[MAX], edges_out2[MAX];
int in1[MAX], in2[MAX], in3[MAX];
set<int> set1;
set<pair<int,int>> set2, set3;
vector<pair<int, int>> ans;
void dfs(int v, int de) {
	used[v] = 1;
	dep[v] = de;
	for (auto i : edges_in[v]) {
		if (!used[i]) {
			dfs(i, de + 1);
		}
	}
	for (auto i : edges_out[v]) {
		if (!used[i]) {
			dfs(i, de + 1);
		}
	}
}
void check(int v) {
	if (edges_out2[v].size() == 1 && edges_in2[v].size() == 1) {
		if (!in1[v]) {
			in1[v] = true;
			set1.insert(v);
		}
	}
	else {
		if (in1[v]) {
			in1[v] = false;
			set1.erase(v);
		}
	}
	if (edges_out2[v].size() == 0 && edges_in2[v].size() == 1) {
		if (!in2[v]) {
			in2[v] = true;
			set2.insert({ -dep[v], v });
		}
	}
	else {
		if (in2[v]) {
			in2[v] = false;
			set2.erase({ -dep[v], v });
		}
	}
	if (edges_out2[v].size() == 1 && edges_in2[v].size() == 0) {
		if (!in3[v]) {
			in3[v] = true;
			set3.insert({ -dep[v], v });
		}
	}
	else {
		if (in3[v]) {
			in3[v] = false;
			set3.erase({ -dep[v], v });
		}
	}
}
void del(int a, int b) {
	edges_in2[b].erase({ -dep[a], a });
	edges_out2[a].erase({ -dep[b], b });
	check(a);
	check(b);
}
signed main() {
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		cin >> a >> b;
		a--;
		b--;
		edges_out[a].push_back(b);
		edges_in[b].push_back(a);
	}
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			dfs(i, 0);
		}
	}
	for (int i = 0; i < n; i++) {
		for (auto j : edges_in[i]) {
			edges_in2[i].insert({ -dep[j], j });
		}
		for (auto j : edges_out[i]) {
			edges_out2[i].insert({ -dep[j], j });
		}
	}
	for (int i = 0; i < n; i++) {
		check(i);
	}
	while (set1.size() > 0 || set2.size() > 0 || set3.size() > 0) {
		if (set1.size() > 0) {
			auto it = set1.begin();
			int active = (*it);
			auto it2 = edges_out2[active].begin();
			auto it3 = edges_in2[active].begin();
			ans.push_back({ active, (*it2).second });
			ans.push_back({ (*it3).second, active });
			del(active, (*it2).second);
			del((*it3).second, active);
			continue;
		}
		if (set2.size() > 0) {
			auto it = set2.begin();
			int active = (*it).second;
			auto it2 = edges_in2[active].begin();
			int pr = (*it2).second;
			if (edges_in2[pr].size() == 0) {
				cout << "No";
				return 0;
			}
			auto it3 = edges_in2[pr].begin();
			int pr2 = (*it3).second;
			ans.push_back({ pr2, pr });
			ans.push_back({ pr, active });
			del(pr2, pr);
			del(pr, active);
			continue;
		}
		if (set3.size() > 0) {
			auto it = set3.begin();
			int active = (*it).second;
			auto it2 = edges_out2[active].begin();
			int pr = (*it2).second;
			if (edges_out2[pr].size() == 0) {
				cout << "No";
				return 0;
			}
			auto it3 = edges_out2[pr].begin();
			int pr2 = (*it3).second;
			ans.push_back({ active, pr });
			ans.push_back({ pr, pr2 });
			del(active, pr);
			del(pr, pr2);
			continue;
		}
	}
	if (ans.size() != m) {
		cout << "No";
		return 0;
	}
	cout << "Yes" << endl;
	for (int i = 0; i < m / 2; i++) {
		cout << ans[i * 2].first + 1 << " " << ans[i * 2].second + 1 << " " << ans[i * 2 + 1].first + 1 << " " << ans[i * 2 + 1].second + 1 << endl;
	}
	return 0;
}