#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <queue>
#include <random>
#include <iomanip>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define int long long
#define left left228
#define right right228
#define all(v) v.begin(), v.end()

const int N = 300 * 1000 + 7;
const int INF = 1e18 + 228;

int n, m;
vector< pair<int, int> > g[N];

int mint[N];
int maxt[N];

void treefs(int v, int tMin = INF, int tMax = -INF, int par = -1) {
	mint[v] = tMin;
	maxt[v] = tMax;
	for (pair<int, int> go : g[v]) {
		int to = go.first;
		int t = go.second;

		if (to != par) {
			treefs(to, min(tMin, t), max(tMax, t), v);
		}
	}
}


struct edge
{
	int u, v, t;
	edge() {}
	edge(int _u, int _v, int _t) {
		u = _u;
		v = _v;
		t = _t;
	}
};

vector< edge > edges;

int T[N];
bool can[21][(1 << 20) + 1];
int min_t[(1 << 20) + 3];
int max_t[(1 << 20) + 3];

void solve() {
	for (int v = 1; v <= n; ++v) {
		for (int mask = 0; mask < (1 << m); ++mask) {
			can[v][mask] = false;
		}
	}
	for (int mask = 1; mask < (1 << n); ++mask) {
		min_t[mask] = INF;
		max_t[mask] = -INF;

		for (int i = 0; i < m; ++i) {
			if ((mask >> i) & 1) {
				uin(min_t[mask], T[i]);
				uax(max_t[mask], T[i]);
			}
		}
	}
	can[1][0] = true;
	for (int v = 1; v <= n; ++v) {
		for (int mask = 0; mask < (1 << m); ++mask) {
			if (can[v][mask]) {
				for (pair<int, int> go : g[v]) {
					int to = go.first;
					int id = go.second;

					if ((mask >> id) & 1) {
						continue;
					}
					can[to][mask + (1 << id)] = true;
				}
			}
		}
	}

	for (int v = 2; v <= n; ++v) {
		int ans = INF;
		for (int mask = 1; mask < (1 << m); ++mask) {
			if (can[v][mask]) {
				ans = min(ans, min_t[mask] + max_t[mask]);
			}
		}
		cout << ans << '\n';
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m;

	for (int i = 0; i < m; ++i) {
		int u, v, t;
		cin >> u >> v >> t;
		g[u].emplace_back(v, i);
		g[v].emplace_back(u, i);
		T[i] = t;
		edges.emplace_back(u, v, t);
	}

	solve();
	return 0;
}


/*

4 4
1 2 2
3 2 0
2 4 3
4 3 1

*/