#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <queue>
#include <random>
#include <iomanip>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define int long long
#define left left228
#define right right228
#define all(v) v.begin(), v.end()

const int N = 300 * 1000 + 7;
const int INF = 1e18 + 228;

int n, m;
vector< pair<int, int> > g[N];

void solveTree() {
	exit(-1);
	vector<int> mint(n + 1);
	vector<int> maxt(n + 1);
	for (int i = 1; i <= n; ++i) {
		mint[i] = INF;
		maxt[i] = -INF;
	}
	queue<int> Q;
	Q.push(1);

	while (!Q.empty()) {
		int v = Q.front();
		Q.pop();
		for (auto [to, t] : g[v]) {
			if (mint[to] == INF) {
				Q.push(to);
			}
			mint[to] = min(mint[v], t);
			maxt[to] = max(maxt[v], t);
		}
	}
	for (int i = 2; i <= n; ++i) {
		cout << mint[i] + maxt[i] << ' ';
	}
	cout << '\n';
}

void solve() {
	if (m == n - 1) {
		solveTree();
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m;

	for (int i = 0; i < m; ++i) {
		int u, v, t;
		cin >> u >> v >> t;
		g[u].emplace_back(v, t);
		g[v].emplace_back(u, t);
	}

	solve();
	return 0;
}


/*


*/