#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <queue>
#include <random>
#include <iomanip>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define int long long
#define left left228
#define right right228
#define all(v) v.begin(), v.end()

const int N = 300 * 1000 + 7;
const int INF = 1e18 + 228;

int n, m;
vector< pair<int, int> > g[N];

int mint[N];
int maxt[N];

void dfs(int v, int tMin = INF, int tMax = -INF, int par = -1) {
	mint[v] = tMin;
	maxt[v] = tMax;
	for (pair<int, int> go : g[v]) {
		int to = go.first;
		int t = go.second;

		if (to != par) {
			dfs(to, min(tMin, t), max(tMax, t), v);
		}
	}
}

void solveTree() {
	for (int i = 1; i <= n; ++i) {
		mint[i] = INF;
		maxt[i] = -INF;
	}
	dfs(1);
	for (int i = 2; i <= n; ++i) {
		cout << mint[i] + maxt[i] << '\n';
	}
}

void solve() {
	if (m == n - 1) {
		solveTree();
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m;

	for (int i = 0; i < m; ++i) {
		int u, v, t;
		cin >> u >> v >> t;
		g[u].emplace_back(v, t);
		g[v].emplace_back(u, t);
	}

	solve();
	return 0;
}


/*


*/