#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("vtm")
#include <bits/stdc++.h>

using namespace std;

//#define int long long
typedef long double ld;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 _mt(seed);

const int INF = 1e9;

int n, m, tmp1, tmp2;
vector <vector <pair <int, int> > > g;
vector <int> used, ans, eused;
vector <vector <int> > edges;

void dfs1(int v, int mn, int mx) {
    used[v] = 1;
    for (auto &e : g[v]) {
        if (!used[e.first]) {
            tmp1 = min(mn, e.second), tmp2 = max(mx, e.second);
            ans[e.first] = tmp1 + tmp2;
            dfs1(e.first, tmp1, tmp2);
        }
    }
}

void gen(int v, int mn, int mx) {
    if (mn + mx < ans[v])
        ans[v] = mn + mx;
    for (auto &e : g[v]) {
        if (!eused[e.second]) {
            eused[e.second] = 1;
            gen(e.first, min(mn, edges[e.second][2]), max(mx, edges[e.second][2]));
            eused[e.second] = 0;
        }
    }
}

int32_t main()
{
    #ifdef LOCAL
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0); cout.tie(0);
    #endif
    cin >> n >> m;
    g.resize(n); ans.resize(n);
    used.resize(n); eused.resize(m);
    bool diff1 = true;
    for (int i = 0; i < m; i++) {
        int v, u, w;
        cin >> v >> u >> w;
        v--; u--;
        g[v].push_back({u, w});
        g[u].push_back({v, w});
        if (abs(v - u) > 1)
            diff1 = false;
    }
    bool allmn = true, allmx = true;
    for (auto &e : g[0]) {
        if (e.second)
            allmn = false;
        if (e.second < INF)
            allmx = false;
    }
    if (m == n - 1) {
        dfs1(0, INF, -INF);
    } else if (allmn) {
        fill(ans.begin() + 1, ans.end(), INF);
        set <pair <int, int> > s;
        s.insert({0, 0});
        while (!s.empty()) {
            auto p = *s.begin();
            s.erase(s.begin());
            for (auto &e : g[p.second]) {
                if (ans[e.first] > max(ans[p.second], e.second)) {
                    s.erase({ans[e.first], e.first});
                    ans[e.first] = max(ans[p.second], e.second);
                    s.insert({ans[e.first], e.first});
                }
            }
        }
    } else if (diff1) {
        vector <int> mn(n), mx(n);
        vector <int> emn(n), cnt(n);
        mn[0] = INF;
        for (int i = 1; i < n; i++) {
            int emin = emn[i] = INF;
            for (auto &e : g[i]) {
                if (e.first < i) {
                    if (e.second <= emin) {
                        emn[i] = emin;
                        emin = e.second;
                    } else if (e.second <= emn[i]) {
                        emn[i] = e.second;
                    }
                    cnt[i]++;
                }
            }
            mn[i] = min(mn[i - 1], emin);
            mx[i] = max(mx[i - 1], emin);
        }
        for (int i = 1; i < n; i++) {
            ans[i] = mn[i] + mx[i];
            int j = i + 1, cur = mx[i];
            while (j < n && cnt[j] > 1) {
                cur = max(cur, emn[j]);
                ans[i] = min(ans[i], mn[j] + cur);
                j++;
            }
        }
    } else {
        int cnt = 0;
        for (int i = 0; i < n; i++)
            for (auto &e : g[i])
                if (i < e.first)
                    edges.push_back({i, e.first, e.second, cnt++});
        for (int i = 0; i < n; i++)
            g[i].clear();
        vector <vector <int> > best(n, {INF, -1, INF, -1});
        for (auto &e : edges) {
            if (e[2] < best[e[0]][0]) {
                best[e[0]][2] = best[e[0]][0];
                best[e[0]][3] = best[e[0]][1];
                best[e[0]][0] = e[2];
                best[e[0]][1] = e[3];
            } else if (e[2] < best[e[0]][2]) {
                best[e[0]][2] = e[2];
                best[e[0]][3] = e[3];
            }
            if (e[2] < best[e[1]][0]) {
                best[e[1]][2] = best[e[1]][0];
                best[e[1]][3] = best[e[1]][1];
                best[e[1]][0] = e[2];
                best[e[1]][1] = e[3];
            } else if (e[2] < best[e[1]][2]) {
                best[e[1]][2] = e[2];
                best[e[1]][3] = e[3];
            }
        }
        for (int i = 0; i < n; i++) {
            if (best[i][1] >= 0)
                g[i].push_back({best[i][0], best[i][1]});
            if (best[i][3] >= 0)
                g[i].push_back({best[i][2], best[i][3]});
        }
        fill(ans.begin(), ans.end(), 2 * INF);
        gen(0, INF, 0);
    }
    for (int i = 1; i < n; i++)
        cout << ans[i] << "\n";
    return 0;
}
