#include <iostream>
#include <vector>
#include <sstream>
#include <set>
#include <map>
#include <assert.h>
#include <cmath>
#include <algorithm>

using namespace std;
typedef long long LL;
typedef unsigned long long ULL;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);


	int n, q;
	cin >> n >> q;

	vector<pair<LL, LL>> trees(n);

	vector<bool> canFall(n);

	for (int i = 0; i < n; i++)
	{
		LL x, h;
		cin >> x >> h;

		if (i > 0) {
			if (x - h >= trees[i - 1].first) {
				canFall[i] = true;
			}
			if (trees[i - 1].first + trees[i - 1].second <= x) {
				canFall[i - 1] = true;
			}
		}

		trees[i] = { x, h };
	}

	for (int i = 0; i < q; i++)
	{
		int l, r;
		cin >> l >> r;
		l--;

		vector<bool> isCut(r - l, false);
		vector<int> cutQueue;
		set<int> toCut;
		int cutCnt = 0;
		for (int j = l; j < r; j++)
		{
			if (canFall[j]) {
				cutQueue.push_back(j);
				toCut.insert(j);
			}
		}

		while (cutQueue.size() > 0) {
			int current = cutQueue.back();
			cutQueue.pop_back();
			toCut.erase(current);
			cutCnt++;

			isCut[current - l] = true;
			int nextId = current + 1;
			int prevId = current - 1;
			while (prevId >= l && isCut[prevId - l]) {
				prevId--;
			}
			while (nextId < r && isCut[nextId - l]) {
				nextId++;
			}
			if (nextId != r) {
				LL minX = prevId == -1 ? trees[0].first : trees[prevId].first;

				if (trees[nextId].first - trees[nextId].second >= minX) {
					if (toCut.find(nextId) == toCut.end()) {
						cutQueue.push_back(nextId);
						toCut.insert(nextId);
					}
				}
			}
			if (prevId != l - 1) {
				LL maxX = nextId == n ? trees.back().first : trees[nextId].first;

				if (trees[prevId].first + trees[prevId].second >= maxX) {
					if (toCut.find(prevId) == toCut.end()) {
						cutQueue.push_back(prevId);
						toCut.insert(prevId);
					}
				}
			}
		}

		cout << cutCnt << endl;
	}


	return 0;
}