//#define _GLIBCXX_DEBUG
#include <iostream>
#include <string>
#include <climits>
#include <set>
#include <random>
#include <cmath>
#include <cstdio>
#include <vector>
#include <array>

struct gadget
{
	int u, v, w;
};
std::vector<std::set<int>> graph;
std::vector<std::set<int>> rgraph;
std::vector<std::set<int>> ugraph;
std::vector<gadget> cur_ans;
std::vector<int> seen;
std::pair<bool, bool> dfs(int at, int prev) 
{
	seen[at] = true;
	bool has_up = graph[at].count(prev);
	printf("at=%d, prev=%d, has_up=%d\n", at, prev, (int)has_up);
	//returns {ok, has_up_edge}
	for(int to : ugraph[at])	
	{
		if(to == prev) continue;
		//if(graph[at].count(to) == 0) //down-edge missing. don't give up
		//	return {false, false};
		//if(rgraph[at].count(to) == 0) //up-edge missing
		//{
		//	if(has_up)
		//	{
		//		has_up = false;
		//	}
		//	return {false, false};
		//}
		auto[ok, to_has_up] = dfs(to, at);
		if(!to_has_up)
		{
			if(has_up)
			{
				has_up = false;
				cur_ans.push_back({prev, at, to});
			}
			else return {false, false};
		}
		else
			cur_ans.push_back({prev, to, prev});
	}
	return {true, has_up};
}
bool fail = false;
void dfs2(int at, int prev)
{
	seen[at]++;
	for(int v : graph[at])
	{
		if(v == prev) continue;
		if(graph[v].count(at) == 0) continue;
		dfs2(v, at);
	}
}
int main(int argc, char*argv[])
{
	//find m/2 non-intersecting paths of length 2
	//u,v -> v,w
	//create 'edges of length 2'
	//outdegree 0 -> every parent must be the middle of a gadget including this edge
	//indegree 0 -> same for children
	//find the gadget and delete it
	int n, m; std::cin >> n >> m;
	graph.resize(n);
	rgraph.resize(n);
	ugraph.resize(n);
	seen.resize(n);
	std::vector<int> outdeg(n), indeg(n);
	for(int i = 0; i < m; i++)
	{
		int u, v; scanf("%d%d", &u, &v); u--; v--;
		graph[u].insert(v);
		rgraph[v].insert(u);
		ugraph[u].insert(v);
		ugraph[v].insert(u);
		outdeg[u]++; indeg[v]++;
	}
	std::vector<gadget> ans;
	//each vertex has non-zero outdegree and indegree -> connected trees
	//for(int root = 0; root < n; root++)
	//{
	//	cur_ans.clear();
	//	auto[ok, ok2] = dfs(root, -1);
	//	if(!ok || !ok2) continue;
	//	printf("root %d ok\n", root);
	//}
	//find subtrees unreachable via half-edges
	//if a subtree can't be reached via half-edges, it can't be used for them
	for(int u = 0; u < n; u++)
	{
		for(int v : graph[u])
		{
			if(graph[v].count(u)) continue;
			dfs2(u, v);
			//mark vertices reachable via half-edges
		}
	}
	for(int el : seen) printf("%d ", el);
	for(int u = 0; u < n; u++)
	{
		if(seen[u]) continue;
		std::set<int> ngraphu = graph[u];
		for(int v : graph[u])
		{
			if(seen[v]) continue;
			if(graph[v].count(u) == 0) continue;
			ans.push_back({u, v, u});
			indeg[u]--; indeg[v]--; outdeg[u]--; outdeg[v]--;
			graph[v].erase(u);
			ngraphu.erase(v);
			rgraph[v].erase(u);
			rgraph[u].erase(v);
		}
		graph[u] = ngraphu;
	}
		
	bool ok = true;
	while(ok)
	{
		ok = false;
		//int minu = -1;
		//for(int u = 0; u < n; u++)
		//	if((minu == -1 || outdeg[u] < outdeg[minu]) && indeg[u] != 0) minu = u;
		for(int u = 0; u < n; u++)
		//if(minu == -1) break;
		//for(int u = minu; u == minu; u++)
		{
			//if(outdeg[u] != 0) continue;
			//printf("%d: outdeg %d\n", u, outdeg[u]);
			for(int p : rgraph[u])
			{
				if(indeg[p] == 0) continue;
				//printf("%d: valid parent\n", p);
				ok = true;
				int p2 = *rgraph[p].begin();
				ans.push_back({p2, p, u});
				indeg[u]--; indeg[p]--; outdeg[p]--; outdeg[p2]--;
				rgraph[u].erase(rgraph[u].find(p));
				rgraph[p].erase(rgraph[p].find(p2));
				graph[p].erase(graph[p].find(u));
				graph[p2].erase(graph[p2].find(p));
				break;
			}
		}
		//for(int u = 0; u < n; u++)
		//{
		//	if(indeg[u] != 0) continue;
		//	//printf("%d: outdeg 0\n", u);
		//	//some child must be
		//	for(int c : graph[u])
		//	{
		//		if(outdeg[c] == 0) continue;
		//		//printf("%d: valid parent\n", p);
		//		ok = true;
		//		int c2 = *graph[c].begin();
		//		ans.push_back({u, c, c2});
		//		indeg[c]--; indeg[c2]--; outdeg[u]--; outdeg[c]--;
		//		graph[u].erase(graph[u].find(c));
		//		graph[c].erase(graph[c].find(c2));
		//		rgraph[c].erase(rgraph[c].find(u));
		//		rgraph[c2].erase(rgraph[c2].find(c));
		//		break;
		//	}
		//}
	}
	for(int u = 0; u < n; u++)
	{
		for(int v : graph[u])
		{
			if(u > v) continue;
			if(graph[v].count(u) == 0) continue;
			ans.push_back({u, v, u});
			indeg[u]--; indeg[v]--; outdeg[u]--; outdeg[v]--;
			//graph[v].erase(u);
			//graph[u].erase(v);
			//rgraph[v].erase(u);
			//rgraph[u].erase(v);
		}
	}
	if(ans.size() != m / 2) { printf("No\n"); return 0; }
	printf("Yes\n");
	for(auto[u,v,w] : ans)
		printf("%d %d %d %d\n", u+1, v+1, v+1, w+1);
}
