#include <bits/stdc++.h>

using namespace std;

#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define sz(v) (int)(v).size()
#define int long long

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = ll(2e9) + 100100, LINF = ll(1e18) + 100100;
const double EPS = 1e-9, PI = atan2(0.0, -1.0);
const int MAXN = signed(1e5) + 100;

struct Trash {
    struct Letter {
        int minus, plus;

        Letter() {
            minus = plus = 0;
        }
    };

    int total;
    vector<Letter> l;

    Trash() {
        total = -LINF;
        l.resize('Z' - 'A' + 1);
    }
};

vector<int> cost('Z' - 'A' + 1);

inline void preprocess() {
    cost[0] = 1;

    for (int i = 1; i <= 'Z' - 'A'; ++i) {
        if (i & 1) cost[i] = cost[i - 1] * 5;
        else cost[i] = cost[i - 1] * 2;
    }
}

inline void solve() {
    string s; cin >> s;
    int n = sz(s); s = "#" + s;

    vector<char> maxLetter(1 + n, 'A');
    maxLetter[n] = s[n];
    for (int i = n - 1; i > 0; --i) maxLetter[i] = max(maxLetter[i + 1], s[i]);

    vector<vector<Trash>> dp(1 + n, vector<Trash>('Z' - 'A' + 1));
    vector<vector<int>> parent(1 + n, vector<int>(26, -1));
    dp[0][0].total = 0;

    for (int i = 1; i <= n; ++i) {
        if (s[i] != '?') {
            int add = cost[s[i] - 'A'];
            if (s[i] < maxLetter[i]) add = -add;

            int tempMax = -LINF, tempIdx;

            for (int j = 0; j <= 'Z' - 'A'; ++j) {
                if (dp[i - 1][j].total == -LINF) continue;

                if (tempMax < dp[i - 1][j].total) {
                    tempMax = dp[i - 1][j].total;
                    tempIdx = j;
                }
            }

            dp[i][s[i] - 'A'] = dp[i - 1][tempIdx];
            dp[i][s[i] - 'A'].total += add;
            parent[i][s[i] - 'A'] = tempIdx;

            if (add < 0) ++dp[i][s[i] - 'A'].l[s[i] - 'A'].minus;
            else ++dp[i][s[i] - 'A'].l[s[i] - 'A'].plus;
        }
        else {
            for (int letter = 0; letter <= 'Z' - 'A'; ++letter) {
                int add = cost[letter];
                if (letter < maxLetter[i] - 'A') add = -add;

                int tempMax = -LINF;
                Trash tempUpd;

                for (int j = 0; j <= 'Z' - 'A'; ++j) {
                    if (dp[i - 1][j].total == -LINF) continue;

                    Trash temp = dp[i - 1][j];

                    for (int k = 0; k <= 'Z' - 'A'; ++k) {
                        if (k < letter) {
                            temp.total -= 2 * temp.l[k].plus * cost[k];
                            temp.l[k].minus += temp.l[k].plus;
                            temp.l[k].plus = 0;
                        }
                        else {
                            break;
                        }
                    }

                    temp.total += add;
                    if (add < 0) ++temp.l[letter].minus;
                    else ++temp.l[letter].plus;

                    if (tempMax < temp.total) {
                        tempMax = temp.total;
                        tempUpd = temp;
                        parent[i][letter] = j;
                    }
                }

                dp[i][letter] = tempUpd;
            }
        }
    }

    int ans = -LINF, ansLetter;

    for (int i = 0; i < 26; ++i) {
        if (dp[n][i].total == -LINF) continue;

        if (ans < dp[n][i].total) {
            ans = dp[n][i].total;
            ansLetter = i;
        }
    }

    int i = n;
    string res;

    while (sz(res) < n) {
        res += char('A' + ansLetter);
        ansLetter = parent[i][ansLetter];
        --i;
    }

    reverse(res.begin(), res.end());

    cout << ans << "\n" << res << "\n";
}

signed main() {
    fastio;

    preprocess();
    int q; cin >> q;
    while (q--) solve();

    return 0;
}