#include <bits/stdc++.h>

using namespace std;

#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define sz(v) (int)(v).size()

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = ll(2e9) + 100100, LINF = ll(1e18) + 100100;
const double EPS = 1e-9, PI = atan2(0.0, -1.0);
const int MAXN = signed(1e5) + 100;

signed main() {
    fastio;

    int n, q; cin >> n >> q;
    map<int, int> t;
    vector<pair<int, int>> trees;

    for (int i = 0; i < n; ++i) {
        int x, h; cin >> x >> h;
        t[x] = h;
        trees.push_back({x, h});
    }

    while (q--) {
        int l, r; cin >> l >> r;
        --l, --r;

        queue<int> check;
        for (int i = l; i <= r; ++i) check.push(i);

        vector<bool> crashed(n, false);
        int ans = 0;

        while (!check.empty()) {
            int idx = check.front();
            pair<int, int> tree = trees[idx];
            check.pop();
            if (crashed[idx]) continue;

            bool to_left = true, to_right = true;

            if (tree == trees[0]) {
                to_left = false;
            }
            else {
                pair<int, int> leftiest = *prev(t.lower_bound(tree.first));
                if (!crashed[idx - 1] && tree.first - tree.second < leftiest.first && leftiest.first < tree.first) to_left = false;
            }

            if (tree == trees.back()) {
                to_right = false;
            }
            else {
                pair<int, int> rightiest = *t.upper_bound(tree.first);
                if (!crashed[idx + 1] && tree.first < rightiest.first && rightiest.first < tree.first + tree.second) to_right = false;
            }

            if (to_left || to_right) {
                ++ans;
                crashed[idx] = true;
            }

            if (to_left && idx != l && !crashed[idx - 1]) check.push(idx - 1);
            if (to_right && idx != r && !crashed[idx + 1]) check.push(idx + 1);
        }

        cout << ans << "\n";
    }

    return 0;
}