#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll INF = 1e18;
const ll MOD = 228228227;

map <char, ll> alphabet;

struct Fenwick {
    int n;
    vector <ll> tree, values;

    Fenwick (int n): n(n), tree(n), values(n) {}

    ll sum(int r) {
        ll result = 0;
        for (; r >= 0; r = (r & (r + 1)) - 1)
            result += tree[r];

        return result;
    }

    void add(int i, ll delta) {
        for (; i < n; i |= (i + 1))
            tree[i] += delta;
    }

    void update(int i, ll value) {
        ll delta = value - values[i];
        add(i, delta);
        values[i] = value;
    }
};

inline void solve() {
    string str_s;
    cin >> str_s;

    vector <char> s(str_s.begin(), str_s.end());

    int n = s.size();
    deque <pair <char, int>> maxdq;
    for (int i = 0; i < n; i++) {
        if (s[i] == '?') continue;
        while (!maxdq.empty() && s[i] > maxdq.back().first)
            maxdq.pop_back();

        maxdq.push_back({s[i], i});
    }

    Fenwick qsum(26), qcount(26), psum(26);

    deque <pair <char, int>> qchanges;

    ll answer = 0;
    for (int i = 0; i < n; i++) {
        if (!maxdq.empty() && maxdq.front().second == i)
            maxdq.pop_front();

        char maxright = !maxdq.empty() ? maxdq.front().first : 'A';

        if (s[i] == '?') {
            ll current_change, new_change = -INF, new_ch = '-';

            for (char c = maxright; c <= 'Z'; c++) {
                current_change = alphabet[c];
                current_change += qcount.sum(c - 'A' - 1) * alphabet[c] - qsum.sum(c - 'A' - 1);
                current_change -= psum.sum(c - 'A' - 1) * 2;

                if (current_change > new_change) {
                    new_change = current_change;
                    new_ch = c;
                }
            }

            for (char c = 'A'; c < new_ch; c++) {
                qcount.add(new_ch - 'A', qcount.values[c - 'A']);
                qcount.update(c - 'A', 0);
                qsum.update(c - 'A', 0);

                psum.update(c - 'A', 0);
            }

            while (!qchanges.empty() && qchanges.back().first < new_ch)
                    qchanges.pop_back();

            qcount.add(new_ch - 'A', 1);
            qchanges.push_back({new_ch, i});
            answer += new_change;
        } else {
            if (maxright > s[i]) {
                answer -= alphabet[s[i]];
            } else {
                answer += alphabet[s[i]];
                psum.add(s[i] - 'A', alphabet[s[i]]);
            }
        }
    }

    for (int i = 0; i < n; i++) {
        if (s[i] == '?') {
            while (qchanges.front().second < i)
                qchanges.pop_front();

            s[i] = qchanges.front().first;
        }
    }

    cout << answer << '\n';
    for (char x: s)
        cout << x;
    cout << '\n';
}

signed main() {
    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    alphabet['A'] = 1;
    for (char c = 'B'; c <= 'Z'; c++) {
        alphabet[c] = alphabet[(char)(c - 1)] * ((c - 'A') % 2 == 0 ? 2 : 5);
    }

    int t;
    cin >> t;

    while (t--)
    solve();
}
