#include <cassert>
#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>
using namespace std;


struct edge {
	int to, t, id;

	edge(int To, int T, int Id) {
		to = To;
		t = T;
		id = Id;
	}
};


void get_res(int v, int p, vector < vector < edge > >& g, vector < int >& res, set < pair < int, int > >& path) {
	if (!path.empty())
		res[v] = path.rbegin()->first + path.begin()->first;
	for (edge ed : g[v])
		if (ed.to != p) {
			path.insert({ ed.t, ed.id });
			get_res(ed.to, v, g, res, path);
			path.erase({ ed.t, ed.id });
		}
}


int main() {
	iostream::sync_with_stdio(0);

	int n, m;
	cin >> n >> m;

	vector < vector < edge > > g(n);
	for (int i = 0; i < m; i++) {
		int u, v, t;
		cin >> u >> v >> t;
		g[u - 1].push_back(edge(v - 1, t, i));
		g[v - 1].push_back(edge(u - 1, t, i));
	}

	if (m == n - 1) {
		set < pair < int, int > > path;
		vector < int > res;
		get_res(0, 0, g, res, path);
		for (int el : res)
			cout << el << "\n";
	}

	return 0;
}