#include <cassert>
#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <queue>
using namespace std;


struct edge {
	int to, t, id;

	edge(int To, int T, int Id) {
		to = To;
		t = T;
		id = Id;
	}
};


void get_res(int v, int p, vector < vector < edge > >& g, vector < int >& res, set < pair < int, int > >& path) {
	if (!path.empty())
		res[v] = path.rbegin()->first + path.begin()->first;
	for (edge ed : g[v])
		if (ed.to != p) {
			path.insert({ ed.t, ed.id });
			get_res(ed.to, v, g, res, path);
			path.erase({ ed.t, ed.id });
		}
}


int main() {
	iostream::sync_with_stdio(0);

	int n, m;
	cin >> n >> m;

	vector < vector < edge > > g(n);
	for (int i = 0; i < m; i++) {
		int u, v, t;
		cin >> u >> v >> t;
		g[u - 1].push_back(edge(v - 1, t, i));
		g[v - 1].push_back(edge(u - 1, t, i));
	}

	if (m == n - 1) {
		set < pair < int, int > > path;
		vector < int > res(n);
		get_res(0, 0, g, res, path);
		for (int i = 1; i < n; i++)
			cout << res[i] << "\n";
	}
	else {
		vector < bool > used(n, false);
		used[0] = true;
		queue < int > q;
		q.push(0);
		vector < int > d(n, -1);
		d[0] = 0;
		while (!q.empty()) {
			int v = q.front();
			q.pop();
			used[v] = false;

			for (edge ed : g[v]) {
				if (d[ed.to] == -1 || d[ed.to] > max(d[v], ed.t)) {
					d[ed.to] = max(d[v], ed.t);
					if (!used[ed.to]) {
						q.push(ed.to);
						used[ed.to] = true;
					}
				}
			}
		}
		for (int i = 1; i < n; i++)
			cout << d[i] << "\n";
	}

	return 0;
}