#include <bits/stdc++.h>

using namespace std;

#define x first
#define y second

const int N = 1.5e5 + 5;
const int INF = 1.6e18;

typedef pair <int, int> pii;

vector <int> coloring_g[N];
vector <int> white_edges;
int partner_right[2 * N];
int tiktak = 0;
bool has_partner_left[2 * N];
pii ind_to_edge[2 * N];
int used[2 * N];
vector <pii> g[N];
vector <pii> g2[N];
int color[N];

void ddfs(int v, int c)
{
    color[v] = c;
    for (int el : coloring_g[v])
        if (!color[el])
            ddfs(el, 3 - c);
}

bool dfs(int v)
{
//    cout << ind_to_edge[v].x << ' ' << ind_to_edge[v].y << endl;
//    cout << endl;
    used[v] = tiktak;
    for (auto el : g[ind_to_edge[v].y]) //edges ind_to_edge[v].y -> left_side
    {
        if (partner_right[el.y] == -1)
        {
            partner_right[el.y] = v;
//            cout << ind_to_edge[v].x << ' ' << ind_to_edge[v].y << " has a partner " << ind_to_edge[el.y].x << ' ' << ind_to_edge[el.y].y << endl;
            has_partner_left[v] = true;
            return true;
        }
    }
    for (auto el : g2[ind_to_edge[v].x]) //edges ind_to_edge[v].y -> left_side
    {
        if (partner_right[el.y] == -1)
        {
            partner_right[el.y] = v;
//            cout << ind_to_edge[v].x << ' ' << ind_to_edge[v].y << " has a partner " << ind_to_edge[el.y].x << ' ' << ind_to_edge[el.y].y << endl;
            has_partner_left[v] = true;
            return true;
        }
    }
    for (auto el : g[ind_to_edge[v].y])
    {
//        cout << ind_to_edge[v].x << ' ' << ind_to_edge[v].y << " tries a partner " << ind_to_edge[el.y].x << ' ' << ind_to_edge[el.y].y << endl;
        if (used[partner_right[el.y]] < tiktak && dfs(partner_right[el.y]))
        {
            has_partner_left[v] = true;
            partner_right[el.y] = v;
            return true;
        }
    }
    for (auto el : g2[ind_to_edge[v].x])
    {
//        cout << ind_to_edge[v].x << ' ' << ind_to_edge[v].y << " tries a partner " << ind_to_edge[el.y].x << ' ' << ind_to_edge[el.y].y << endl;
        if (used[partner_right[el.y]] < tiktak && dfs(partner_right[el.y]))
        {
            has_partner_left[v] = true;
            partner_right[el.y] = v;
            return true;
        }
    }
    return false;
}

int32_t main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i)
    {
        int a, b;
        cin >> a >> b;
        g[--a].emplace_back(--b, i);
        g2[b].emplace_back(a, i);
        ind_to_edge[i] = {a, b};
        coloring_g[a].push_back(b);
        coloring_g[b].push_back(a);
    }
    for (int i = 0; i < n; ++i)
        if (!color[i])
            ddfs(i, 1);
    for (int i = 0; i < n; ++i)
    {
        if (color[i] == 2)
            continue;
        for (auto el : g[i])
            white_edges.push_back(el.y);
    }
    fill(partner_right, partner_right + 2 * N, -1);
    bool did = true;
    while (did)
    {
        did = false;
        tiktak++;
        for (long long white_edge : white_edges)
            if (!used[white_edge] && !has_partner_left[white_edge])
                if (dfs(white_edge))
                {
//                    cout << ind_to_edge[white_edge].x << ' ' << ind_to_edge[white_edge].y << " Good" << endl;
                    did = true;
                }
    }
    for (long long white_edge : white_edges)
    {
        if (!has_partner_left[white_edge])
        {
            cout  << "No\n";
            exit(0);
        }
    }
    for (int i = 0; i < m; ++i)
    {
        if (color[ind_to_edge[i].x] == 2)
        {
            if (partner_right[i] == -1)
            {
                cout << "No\n";
                exit(0);
            }
        }
    }
    cout << "Yes\n";
    for (int i = 0; i < m; ++i)
        if (color[ind_to_edge[i].x] == 2)
            cout << ind_to_edge[i].x + 1 << ' ' << ind_to_edge[i].y + 1 << ' ' << ind_to_edge[partner_right[i]].x + 1 << ' '<< ind_to_edge[partner_right[i]].y + 1 << '\n';
    return 0;
}