#include <bits/stdc++.h>
using namespace std;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
typedef long long ll;
typedef long double ld;

#define int ll

const int N = 2e3 + 10, INF = 0x7f7f7f7f;

struct Edge {
	int v, w, i;
	int idx;
	char cut;
};

vector<Edge> g[N];
int tin[N], fup[N], used[N], mn[N], color[N], ans[N];
int timer = 15;

void dfs_mn(int u, int bound, int cc) {
	used[u] = 1;
	color[u] = cc;
	for (auto e : g[u]) {
		if (e.w > bound || e.cut == 1 || used[e.v])
			continue;
		mn[cc] = min(mn[cc], e.w);
		dfs_mn(e.v, bound, cc);
	}
}

void dfs_ans(int u, int bound, int cc = +INF) {
	used[u] = 1;
	cc = min(cc, mn[color[u]]);
	ans[u] = min(ans[u], bound + cc);
	for (auto e : g[u]) {
		if (e.w > bound || used[e.v])
			continue;
		dfs_ans(e.v, bound, min(cc, e.w));
	}
}

void dfs(int u, int bound, int p = -1) {
	used[u] = 1;
	fup[u] = tin[u] = timer++;
	for (auto &e : g[u]) {
		if (e.w > bound)
			continue;
		if (e.idx == p)
			continue;
		// cout << bound << "edge " << u << " " << e.v << endl;
		if (used[e.v] == 1) {
			fup[u] = min(tin[e.v], fup[u]);
		} else {
			// fup[e.v] = tin[u];
			dfs(e.v, bound, e.idx);
			fup[u] = min(fup[e.v], fup[u]);
			// cout << fup[e.v] << " " << tin[u] << endl;
			if (fup[e.v] > tin[u]) {
				// cout << bound << " cut from " << u << " " << e.v << endl;
				e.cut = 1;
				g[e.v][e.i].cut = 1;
			}
		}
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	set<int> weights;
	for (int i = 0; i < m; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		weights.insert(w);
		--u, --v;
		g[u].push_back({v, w, sz(g[v]), i, 0});
		g[v].push_back({u, w, sz(g[u]) - 1, i, 0});
	}
	fill(ans, ans + n, +INF);
	for (int bound : weights) {
		for (int u = 0; u < n; ++u)
			for (auto &e : g[u])
				e.cut = 0;
		fill(used, used + n, 0);
		dfs(0, bound);
		fill(used, used + n, 0);
		fill(mn, mn + n, +INF);
		int cc = 0;
		for (int u = 0; u < n; ++u)
			if (!used[u])
				dfs_mn(u, bound, cc++);
		// for (int u = 0; u < cc; ++u)
		// 	cout << mn[u] << " ";
		// cout << "\n";
		// for (int u = 0; u < n; ++u)
		// 	cout << color[u] << " ";
		// cout << "\n";
		fill(used, used + n, 0);
		dfs_ans(0, bound);
	}
	for (int i = 1; i < n; ++i)
		cout << ans[i] << "\n";
	return 0;
}