#include <iostream>
#include <vector>
#include <queue>
#include <set>

using namespace std;

struct Tree {
    long long x = 0, h = 0, ind = 0;

    Tree(long long x = 0, long long h = 0, long long i = 0) {
        this->x = x;
        this->h = h;
        ind = i;
    }

    inline bool operator<(Tree other) const {
        return x < other.x;
    }
};

//struct SegmentTree {
//    vector<int> tree_max, tree_min;
//
//    SegmentTree(int n) {
//        tree_max.resize(4 * n);
//        tree_min.resize(4 * n);
//        build_max(1, n, 1);
//    }
//
//    void build_max(int bin_left, int bin_right, int tree_ind) {
//        if (bin_left == bin_right) tree_max[tree_ind] = bin_left;
//        else {
//            int bin_medium = (bin_left + bin_right) / 2;
//            build_max(bin_left, bin_medium, tree_ind * 2);
//            build_max(bin_medium + 1, bin_right, tree_ind * 2 + 1);
//            tree_max[tree_ind] = max(tree_max[tree_ind * 2], tree_max[tree_ind * 2 + 1]);
//        }
//    }
//
//    void build_min(int bin_left, int bin_right, int tree_ind) {
//        if (bin_left == bin_right) tree_min[tree_ind] = bin_left;
//        else {
//            int bin_medium = (bin_left + bin_right) / 2;
//            build_min(bin_left, bin_medium, tree_ind * 2);
//            build_min(bin_medium + 1, bin_right, tree_ind * 2 + 1);
//            tree_min[tree_ind] = min(tree_min[tree_ind * 2], tree_min[tree_ind * 2 + 1]);
//        }
//    }
//
//    void update_max(int bin_left, int bin_right, int tree_ind, int pos, int val) {
//        if (bin_left == bin_right) tree_max[tree_ind] = val;
//        else {
//            int bin_medium = (bin_left + bin_right) / 2;
//            if (pos <= bin_medium) update_max(bin_left, bin_medium, tree_ind * 2, pos, val);
//            else update_max(bin_medium + 1, bin_right, tree_ind * 2 + 1, pos, val);
//            tree_max[tree_ind] = max(tree_max[tree_ind * 2], tree_max[tree_ind * 2 + 1]);
//        }
//    }
//
//    void update_min(int bin_left, int bin_right, int tree_ind, int pos, int val) {
//        if (bin_left == bin_right) tree_min[tree_ind] = val;
//        else {
//            int bin_medium = (bin_left + bin_right) / 2;
//            if (pos <= bin_medium) update_min(bin_left, bin_medium, tree_ind * 2, pos, val);
//            else update_min(bin_medium + 1, bin_right, tree_ind * 2 + 1, pos, val);
//            tree_min[tree_ind] = min(tree_min[tree_ind * 2], tree_min[tree_ind * 2 + 1]);
//        }
//    }
//
//    int get_max(int bin_left, int bin_right, int tree_ind, int req_left, int req_right) {
//        if (bin_left == req_left and bin_right == req_right) return tree_max[tree_ind];
//        else {
//            int bin_medium = (bin_left + bin_right) / 2;
//            if (req_right <= bin_medium) return get_max(bin_left, bin_medium, tree_ind * 2, req_left, req_right);
//            else if (req_left > bin_medium) return get_max(bin_medium + 1, bin_right, tree_ind * 2 + 1, req_left, req_right);
//            else return max(get_max(bin_left, bin_medium, tree_ind * 2, req_left, bin_medium),
//                            get_max(bin_medium + 1, bin_right, tree_ind * 2 + 1, bin_medium + 1, req_right));
//        }
//    }
//
//    int get_min(int bin_left, int bin_right, int tree_ind, int req_left, int req_right) {
//        if (bin_left == req_left and bin_right == req_right) return tree_min[tree_ind];
//        else {
//            int bin_medium = (bin_left + bin_right) / 2;
//            if (req_right <= bin_medium) return get_min(bin_left, bin_medium, tree_ind * 2, req_left, req_right);
//            else if (req_left > bin_medium) return get_min(bin_medium + 1, bin_right, tree_ind * 2 + 1, req_left, req_right);
//            else return min(get_min(bin_left, bin_medium, tree_ind * 2, req_left, bin_medium),
//                            get_min(bin_medium + 1, bin_right, tree_ind * 2 + 1, bin_medium + 1, req_right));
//        }
//    }
//};

vector<Tree> trees;
long long taken[5001], launch = 1;
long long n, x, h, qr, l, r, left_border, right_border;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> qr;
    for (int i = 0; i < n; i++) {
        cin >> x >> h;
        trees.emplace_back(x, h, i);
    }

    queue<Tree> q;
    Tree cur;
    long long count;
    set<Tree>::iterator left, right;

    while (qr--) {
        launch++;
        cin >> l >> r;
        set<Tree> temp;

        if (l == 1) left_border = trees[l - 1].x;
        else left_border = trees[l - 2].x;
        if (r == n) right_border = trees[r - 1].x;
        else right_border = trees[r].x;

        for (long long i = l - 1; i < r; i++) {
            if (i > 0 and trees[i].x - trees[i - 1].x >= trees[i].h) {
                q.push(trees[i]);
                taken[trees[i].ind] = launch;
            } else if (i < n - 1 and trees[i + 1].x - trees[i].x >= trees[i].h) {
                q.push(trees[i]);
                taken[trees[i].ind] = launch;
            }
            temp.insert(trees[i]);
        }
        count = 0;
        while (!q.empty()) {
            cur = q.front();
            left = temp.lower_bound(cur);
            right = left;
            right++;
            if (right != temp.end() and left != temp.begin()) {
                left--;

                // O(1)
                if (right->x - left->x >= right->h) {
                    if (taken[right->ind] != launch) {
                        q.push(*right);
                        taken[right->ind] = launch;
                    }
                }

                // O(1)
                if (right->x - left->x >= left->h) {
                    if (taken[left->ind] != launch) {
                        q.push(*left);
                        taken[left->ind] = launch;
                    }
                }
            } else if (right != temp.end()) {
                // O(1)
                if (right->h <= right->x - left_border) {
                    if (taken[right->ind] != launch) {
                        q.push(*right);
                        taken[right->ind] = launch;
                    }
                }
            } else if (left != temp.begin()) {
                // O(1)
                left--;
                if (left->h <= right_border - left->x) {
                    if (taken[left->ind] != launch) {
                        q.push(*left);
                        taken[left->ind] = launch;
                    }
                }
            }
            // O(log n)
            temp.erase(cur);
            count++;
            q.pop();
        }
        cout << count << '\n';
    }
}