#include <bits/stdc++.h>

#define ALL(x) (x).begin(), (x).end()

using namespace std;
using ll = long long;
const int MAX_N = 150000 + 566;

vector<pair<int, int>> graph_basic[MAX_N];

bool cyber_fail = false;
vector<bool> used;
vector<pair<pair<int, int>, pair<int, int>>> answer;

pair<int, int> dfs_to_require(int v, int pred) {           // 1 -- need to itself, -1 -- need from itself
    used[v] = true;
    int balance = 0;
    vector<pair<int, int>> edges_to, edges_from;
    set<int> who_requires_in, who_requires_out;
    map<int, int> to_who_required, from_who_required;

    for (auto [u, t] : graph_basic[v]) {
        if (u == pred || used[u]) continue;
        auto [b, f] = dfs_to_require(u, v);
        if (cyber_fail) return {-3 * MAX_N, -1};
        if (b == 1) {
            who_requires_in.insert(u);
            to_who_required[u] = f;
        } else if (b == -1) {
            who_requires_out.insert(u);
            from_who_required[u] = f;
        }
    }
    if (cyber_fail) return {-3 * MAX_N, -1};
    for (auto [u, t] : graph_basic[v]) {
        if (u == pred) continue;
        if (t == 1 && who_requires_in.count(u) != 0) {
            who_requires_in.erase(u);
            answer.emplace_back(make_pair(v, u), make_pair(u, to_who_required[u]));
            continue;
        }
        if (t == -1 && who_requires_out.count(u) != 0) {
            who_requires_out.erase(u);
            answer.emplace_back(make_pair(from_who_required[u], u), make_pair(u, v));
            continue;
        }

        balance += t;
        if (t == 1) {
            edges_to.emplace_back(make_pair(v, u));
        } else {
            edges_from.emplace_back(make_pair(u, v));
        }
    }

    for (int i = 0; i < min(edges_to.size(), edges_from.size()); ++i) {
        answer.emplace_back(edges_from[i], edges_to[i]);
    }

    if (abs(balance) > 1) {
        cyber_fail = true;
        return {-3 * MAX_N, -1};
    } else {
        if (balance == 0) {
            return {0, MAX_N + 1};
        } else if (balance == -1) {
            return {-1, edges_from.back().first};
        } else {
            return {1, edges_to.back().second};
        }
    }
}

int n, m;

int solve() {
    if (!(cin >> n >> m))
        return 1;
    used.clear();
    answer.clear();
    used.resize(n, false);
    for (int i = 0; i < n; ++i) {
        graph_basic[i].clear();
    }
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        graph_basic[a].emplace_back(make_pair(b, 1));
        graph_basic[b].emplace_back(make_pair(a, -1));
    }

    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            auto [b, f] = dfs_to_require(i, -1);
            if (b != 0) cyber_fail = true;
        }
    }
    if (cyber_fail) {
        cout << "No\n";
    } else {
        cout << "Yes\n";
        assert(answer.size() <= m / 2);
        for (auto e : answer) {
            cout << e.first.first + 1 << ' ' << e.first.second + 1 << ' ' << e.second.first + 1 << ' ' << e.second.second + 1 << '\n';
        }
    }

    return 0;
}


int main() {
#ifdef LOCAL
    freopen("B.in", "r", stdin);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    iostream::sync_with_stdio(false);

    int tests = 1e9;
    for (int i = 0; i < tests; ++i) {
        if (solve())
            break;

#ifdef LOCAL
        cout << "------------------------\n";
#endif
    }
}
