#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>

using namespace std;

#define SZ(c) (int)c.size()

#define int long long

const int N = 3e5 + 7;
const int A = 26;
const int INF = 3e18;

int arr[A];

void build_arr() {
  arr[0] = 1;
  for (int i = 1; i < A; ++i) {
    arr[i] = arr[i - 1] * (i % 2 ? 5 : 2);
  }
}

int n;
string s;

int dp[N][A];
pair<int, int> par[N][A];

void gen_test() {
  n = 5;
  s.resize(n);
  for (int i = 0; i < n; ++i) {
    s[i] = rand() % A + 'A';
  }
  for (int it = 0; it < 3; ++it) {
    s[rand() % n] = '?';
  }
}

int get() {
  int res = 0;
  int mx = 0;
  for (int i = n - 1; i >= 0; --i) {
    res += arr[s[i] - 'A'] * (s[i] - 'A' < mx ? -1 : +1);
    mx = max(mx, (int)(s[i] - 'A'));
  }
  return res;
}

int stupid_solve() {
  vector<int> ind;
  for (int i = 0; i < n; ++i) {
    if (s[i] == '?') {
      ind.push_back(i);
    }
  }
  vector<int> cur(SZ(ind));
  if (cur.empty()) {
    return get();
  }
  int mx = -INF;
  while (cur.back() != A) {
    for (int i = 0; i < SZ(ind); ++i) {
      s[ind[i]] = cur[i] + 'A';
    }
    mx = max(mx, get());
    int i = 0;
    ++cur[i];
    while (i < SZ(cur) - 1 && cur[i] == A) {
      cur[i] = 0;
      ++i;
      ++cur[i];
    }
  }
  for (int i = 0; i < SZ(ind); ++i) {
    s[ind[i]] = '?';
  }
  return mx;
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cout.tie(NULL);
  build_arr();
  int t;
  cin >> t;
  while (t--) {
    cin >> s;
    /*gen_test();
    cout << s << '\n';*/
    n = SZ(s);
    fill(dp[n], dp[n] + A, 0);
    for (int i = n - 1; i >= 0; --i) {
      for (int j = 0; j < A; ++j) {
        dp[i][j] = -INF;
      }
      for (int j = 0; j < A; ++j) {
        if (s[i] == '?') {
          for (int k = 0; k < A; ++k) {
            s[i] = 'A' + k;
            if (dp[i][max((int)(s[i] - 'A'), j)] <
                dp[i + 1][j] + arr[s[i] - 'A'] * (s[i] - 'A' < j ? -1 : +1)) {
              dp[i][max((int)(s[i] - 'A'), j)] =
                  dp[i + 1][j] + arr[s[i] - 'A'] * (s[i] - 'A' < j ? -1 : +1);
              par[i][max((int)(s[i] - 'A'), j)] = {s[i] - 'A', j};
            }
          }
          s[i] = '?';
        } else {
          if (dp[i][max((int)(s[i] - 'A'), j)] <
              dp[i + 1][j] + arr[s[i] - 'A'] * (s[i] - 'A' < j ? -1 : +1)) {
            dp[i][max((int)(s[i] - 'A'), j)] =
                dp[i + 1][j] + arr[s[i] - 'A'] * (s[i] - 'A' < j ? -1 : +1);
            par[i][max((int)(s[i] - 'A'), j)] = {s[i] - 'A', j};
          }
        }
      }
    }
    int j = max_element(dp[0], dp[0] + A) - dp[0];
    assert(stupid_solve() == dp[0][j]);
    cout << dp[0][j] << '\n';
    for (int i = 0; i < n; ++i) {
      cout << (char)(par[i][j].first + 'A');
      j = par[i][j].second;
    }
    cout << '\n';
  }
}
