#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <ios>
#include <cassert>
#include <queue>
using namespace std;

const int INF = 1e9;

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n, q;
	cin >> n >> q;
	vector<pair<int, int>> dependencies_cnt(n);
	vector<vector<int>> dependants(n);

	vector<int> coord(n), height(n);

	for (int i = 0; i < n; i++) {
		cin >> coord[i] >> height[i];
	}

	for (int i = 0; i < n; i++) {
		// left
		int left_dependencies = INF;
		int left_fall = coord[i] - height[i];
		if (left_fall >= coord[0]) {
			left_dependencies = 0;
			for (int j = i - 1; j >= 0; j--) {
				if (coord[j] <= left_fall)
					break;
				left_dependencies++;
				dependants[j].push_back(i);
			}
		}
		// right
		int right_dependencies = INF;
		int right_fall = coord[i] + height[i];
		if (right_fall <= coord[n - 1]) {
			right_dependencies = 0;
			for (int j = i + 1; j < n; j++) {
				if (coord[j] >= right_fall)
					break;
				right_dependencies++;
				dependants[j].push_back(i);
			}
		}

		dependencies_cnt[i] = { left_dependencies, right_dependencies };
	}

	vector<char> has_fallen(n);

	while (q--) {
		int l, r;
		cin >> l >> r;
		l--;
		fill(has_fallen.begin(), has_fallen.end(), false);
		int ans = 0;
		vector<pair<int, int>> cur_dependencies_cnt = dependencies_cnt;
		queue<int> q;
		for (int i = l; i < r; i++) {
			if (cur_dependencies_cnt[i].first == 0 || cur_dependencies_cnt[i].second == 0) {
				has_fallen[i] = true;
				q.push(i);
			}
		}

		while (!q.empty()) {
			int v = q.front();
			q.pop();
			ans++;

			for (int w : dependants[v]) {
				if (!(l <= w && w < r))
					continue;
				if (has_fallen[w])
					continue;
				int& dep_cnt =
					(w > v ? cur_dependencies_cnt[w].first : cur_dependencies_cnt[w].second);
				dep_cnt--;
				if (dep_cnt == 0) {
					has_fallen[w] = true;
					q.push(w);
				}
			}
		}

		cout << ans << "\n";
	}
}