#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <random>

#define int long long

using namespace std;

random_device rd;
mt19937_64 get_rand(rd());

int conv(char a) {
	a -= 'A';
	return (int)pow(10ll, a / 2) * (a % 2 ? 5 : 1);
}

void gen(string& s) {
	s.resize(get_rand() % 20 + 1);
	for (int i = 0; i < s.size(); i++)
		s[i] = get_rand() % 3 + 'X';

	for (int j = 0; j < 3; j++) {
		int i = get_rand() % s.size();
		s[i] = '?';
	}
}

pair <int, string> stup(string& s) {
	int ret = -4e18;
	string ss;
	for (char a = 'A'; a <= 'Z'; a++)
		for (char b = 'A'; b <= 'Z'; b++)
			for (char c = 'A'; c <= 'Z'; c++) {
				string t = s;
				int i = 0;
				for (; i < t.size(); i++) {
					if (t[i] == '?') {
						t[i] = a;
						break;
					}
				}
				for (; i < t.size(); i++) {
					if (t[i] == '?') {
						t[i] = b;
						break;
					}
				}
				for (; i < t.size(); i++) {
					if (t[i] == '?') {
						t[i] = c;
						break;
					}
				}

				int res = 0;
				set <int> st;
				for (int i = t.size() - 1; i >= 0; i--) {
					if (st.upper_bound(t[i]) != st.end())
						res -= conv(t[i]);
					else
						res += conv(t[i]);
					st.insert(t[i]);
				}

				if (res > ret)
					tie(ret, ss) = { res, t };
			}

	return { ret, ss };
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--) {
		string s;


		cin >> s;
		//gen(s);
		string s1 = s;

		int n = s.size();

		int dif = 0;
		vector <bool> used(n);
		{
			set <int> st;
			for (int i = n - 1; i >= 0; i--) {
				if (s[i] == '?')
					continue;
				if (st.upper_bound(s[i]) != st.end())
					used[i] = true, dif -= conv(s[i]);
				st.insert(s[i]);
			}
		}


		vector <vector <int>> dp(n, vector<int>(30, -4e18));
		vector <vector <bool>> f(n, vector<bool>(30));
		vector <vector <pair <int, int>>> p(n, vector<pair <int, int>>(30, { -1, -1 }));
		vector <int> sm(30);
		int pi = -1;
		set <int> st;
		for (int i = 0; i < n; i++)
			if (s[i] != '?')
				st.insert(s[i]);
		for (int i = 0; i < n; i++) {
			if (s[i] == '?') {
				if (pi != -1)
					for (char c = 'A'; c <= 'Z'; c++) {

						f[i][c - 'A'] = (st.upper_bound(c) == st.end());
						int cst = sm[25] - 2 * (c != 'A' ? sm[c - 'A' - 1] : 0) + (f[i][c - 'A'] ? conv(c) : -conv(c));

						for (char pc = c; pc <= 'Z'; pc++) {
							int nval =
								dp[pi][pc - 'A'];
								


							if (dp[i][c - 'A'] < nval + cst) {
								dp[i][c - 'A'] = nval + cst;
								p[i][c - 'A'] = { pi, pc - 'A' };
							}
						}
					}
				else
					for (char c = 'A'; c <= 'Z'; c++) {
						f[i][c - 'A'] = st.upper_bound(c) == st.end();
						dp[i][c - 'A'] = sm[25] - 2 * (c != 'A' ? sm[c - 'A' - 1] : 0) + (f[i][c - 'A'] ? conv(c) : -conv(c));
					}


				for (char c = 'A'; c <= 'Z'; c++)
					sm[c - 'A'] = 0;
				pi = i;
			}
			else {
				st.erase(s[i]);
				if (!used[i])
					for (char c = s[i]; c <= 'Z'; c++)
						sm[c - 'A'] += conv(s[i]);
			}
		}
		
		if (pi == -1) {
			cout << sm[25] + dif << '\n'<< s << '\n';
		}
		else {

			pair <int, pair <int, int>> res = { -4e18, make_pair(-1, -1) };
			for (char c = 'A'; c <= 'Z'; c++)
				res = max(res, { dp[pi][c - 'A'], p[pi][c - 'A'] });
			cout << res.first + dif + sm[25] << '\n';

			for (char c = 'A'; c <= 'Z'; c++)
				if (res == make_pair(dp[pi][c - 'A'], p[pi][c - 'A'])) {
					s[pi] = c;
					break;
				}
			auto [l, r] = res.second;
			while (l >= 0) {
				s[l] = r + 'A';
				tie(l, r) = p[l][r];
			}
			
			cout << s << '\n';
			//if (stup(s1).first != res.first + dif + sm[25]) {
			//	cout << s1 << ' ' << stup(s1).first << ' ' << res.first + dif + sm[25] << '\n';
			//	cout << stup(s1).second << ' ' << s << '\n';
			//}
		}
	}
	
	return 0;
}

