#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <random>
#include <array>
#include <ctime>
#include <chrono>
#include <tuple>
#include <numeric>

#define int long long

using namespace std;

random_device rd;
mt19937_64 get_rand(rd());

vector <pair <int, int>> g[300010];
int ans[300010];

void dfs(int v, int mn = 1e9 + 7, int mx = -1e9 - 7, int p = -1) {
	ans[v] = mn + mx;
	for (auto [u, w] : g[v])
		if (u != p)
			dfs(u, min(w, mn), max(w, mx), v);
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	srand(time(NULL));

	int n, q;
	cin >> n >> q;
	vector <int> x(n), h(n);
	for (int i = 0; i < n; i++)
		cin >> x[i] >> h[i];
	x.insert(x.begin(), x[0]);
	h.insert(h.begin(), 0);
	while (q--) {
		int l, r;
		cin >> l >> r;
		vector <bool> cut(n);
		for (int i = 0; i < n; i++)
			for (int j = l; j <= r; j++) {
				cut[j] = true;
				for (int k = l; k < j; k++)
					if (x[j] - h[j] < x[k] && !cut[k])
						cut[j] = false;
				for (int k = j + 1; k <= r; k++)
					if (x[j] + h[j] > x[k] && !cut[k])
						cut[j] = false;
			}

		cout << accumulate(cut.begin(), cut.end(), 0);
	}
	return 0;
}