#ifdef LOCAL
#define GLIBCXX_DEBUG
#endif
#include "bits/stdc++.h"
#define ll long long
#define vi vector<ll>
#define vvi vector<vi>
#define pii pair<ll, ll>
#define mp make_pair
#define all(x) x.begin(), x.end()
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)
#define pb push_back

const ll inf = 2e18;
const ll INF = 1e9;
const ll MAXN = 3e5 + 10;

using namespace std;

int ans[MAXN];
int bridge[MAXN];
int fup[MAXN];
int tin[MAXN];
int used[MAXN];
int id[MAXN];
int comp[MAXN];
int timer = 0;

struct edge{
    int v, u, t, ind;
    edge(int v, int u, int t, int ind): v(v), u(u), t(t), ind(ind) {}
    edge() {}
};

vector<edge> edges;
int cnt = 0;
vector<edge> graph[MAXN];

void dfs(int v, int p = -1) {
    fup[v] = tin[v] = timer++;
    used[v] = 1;
    for (edge e : graph[v]) {
        if (e.ind == p) continue;
        if (used[e.u]) {
            mn(fup[v], tin[e.u]);
            continue;
        }
        dfs(e.u, e.ind);
        mn(fup[v], fup[e.u]);
        if (fup[e.u] > tin[v]) bridge[e.ind] = 1;
    }
}

void comp_maker(int v, int i) {
    used[v] = 1;
    id[v] = i;
    for (auto e : graph[v]) {
        if (bridge[e.ind]) continue;
        mn(comp[i], e.t);
        if (used[e.u]) continue;
        comp_maker(e.u, i);
    }
}

void ans_counter(int v, int mine = INF + 1) {
    used[v] = 1;
    mn(ans[v], min(comp[v], mine));
    for (auto e : graph[v]) {
        if (used[e.u]) continue;
        ans_counter(e.u, min(ans[v], e.t));
    }
}

void solve() {
    int n, m; cin >> n >> m;
    for (int i = 0; i < MAXN; ++i) ans[i] = INF + 1;
    for (int i = 0; i < m; ++i) {
        int v, u, t; cin >> v >> u >> t;
        --v, --u;
        graph[v].pb(edge(v, u, t, cnt));
        graph[u].pb(edge(u, v, t, cnt));
        edges.push_back(edge(v, u, t, cnt));
        ++cnt;
    }
    dfs(0);
    for (int i = 0; i < n; ++i) {
        used[i] = 0;
        comp[i] = INF;
    }
    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;
        comp_maker(i, i);
    }
    for (int i = 0; i < n; ++i) {
        used[i] = 0;
    }
    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;
        ans_counter(i);
    }
    for (int i = 1; i < n; ++i) {
        cout << ans[i] + INF << "\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    cout.precision(30);

//    int t; cin >> t;
//    while (t--)
    solve();

    return 0;
}
