#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <random>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>

#define ll long long
#define ld long double

using namespace std;


const int N = 3e5 + 20;

vector<int>a[N];
bool used[N];
map<pair<int, int>, int>mp;
pair<int, int> ans[N];

void dfs(int v) {
	used[v] = 1;
	for (auto to : a[v]) {
		if (!used[to]) {
			ans[to].first = min(ans[v].first, mp[{to, v}]);
			ans[to].second = max(ans[v].second, mp[{to, v}]);
			dfs(to);
		}
	}
}

int main()
{
	int n, m;
	cin >> n >> m;
	set<pair<int, int>>st;
	int cnt = 0;
	for (int i = 0; i < m; ++i) {
		int x, y, w;
		cin >> x >> y >> w;
		if (st.find({ x, y }) == st.end() && st.find({ y, x }) == st.end()) {
			a[x - 1].push_back(y - 1);
			a[y - 1].push_back(x - 1);
			mp[{x - 1, y - 1}] = w;
			mp[{y - 1, x - 1}] = w;
			cnt += 1;
			st.insert({ x, y });
			st.insert({ y, x });
		}
		mp[{x - 1, y - 1}] = min(mp[{x - 1, y - 1}], w);
		mp[{y - 1, x - 1}] = min(mp[{y - 1, x - 1}], w);
	}
	set<pair<int, int>>s;
	s.insert({ 0, 0 });
	vector<int>dist(n, 1e9+4);
	dist[0] = 0;
	vector<int>used1(n);
	while (s.size() > 0) {
		int v = s.begin()->second;
		s.erase({ dist[v], v });
		used1[v] = 1;
		for (auto to : a[v]) {
			if (used1[to] == 0 && dist[to] >= max(dist[v], mp[{v, to}])) {
				s.erase({ dist[to], to });
				dist[to] = max(dist[v], mp[{v, to}]);
				s.insert({ dist[to], to });
			}
		}
	}
	for (int i = 1; i < n; ++i) {
		cout << dist[i] << '\n';
	}
}