#include <bits/stdc++.h>
using namespace std;


#define ll long long
#define pb push_back
#define all(x) x.begin(), x.end()


struct edge {
    int u, w;
};


void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<edge>> g(n);
    set<int> allW;
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[v].pb({u, w});
        g[u].pb({v, w});
        allW.insert(w);
    }
    vector<int> dist(n);

    function<void()> dijkstra = [&]() {
        dist.assign(n, 1e9 + 1);
        set<pair<int, int>> q;
        q.insert({0, 0});
        dist[0] = 0;
        while (!q.empty()) {
            auto p = *q.begin();
            q.erase(q.begin());
            int v = p.second;
            for (auto e : g[v]) {
                if (max(e.w, dist[v]) >= dist[e.u]) {
                    continue;
                }
                q.erase({dist[e.u], e.u});
                dist[e.u] = max(e.w, dist[v]);
                q.insert({dist[e.u], e.u});
            }
        }
    };

    dijkstra();
    for (int i = 1; i < n; i++) {
        cout << dist[i] << "\n";
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}
