#include <bits/stdc++.h>
using namespace std;


#define ll long long
#define pb push_back
#define all(x) x.begin(), x.end()


struct edge {
    int u, w;
    int index;
};


bool bit(int mask, int b) {
    return (mask & (1 << b)) != 0;
}


void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<edge>> g(n);
    vector<int> allW;
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[v].pb({u, w, i});
        g[u].pb({v, w, i});
        allW.pb(w);
    }
    vector<vector<int>> dp(n, vector<int>(1 << m));
    dp[0][0] = 1;
    for (int mask = 0; mask < (1 << m); mask++) {
        for (int v = 0; v < n; v++) {
            if (dp[v][mask] == 0) {
                continue;
            }
            for (auto e : g[v]) {
                if (bit(mask, e.index)) {
                    continue;
                }
                dp[e.u][mask | (1 << e.index)] = 1;
            }
        }
    }

    vector<int> answer(n, 1e9 + 1);

    function<void(int, int, int, int)> gen = [&](int i, int mn, int mx, int mask) {
        if (i == m) {
            for (int v = 0; v < n; v++) {
                if (dp[v][mask]) {
                    answer[v] = min(answer[v], mn + mx);
                }
            }
            return;
        }
        gen(i + 1, mn, mx, mask);
        gen(i + 1, min(mn, allW[i]), max(mx, allW[i]), mask | (1 << i));
    };

    gen(0, 1e9 + 1, 0, 0);
    for (int i = 1; i < n; i++) {
        cout << answer[i] << "\n";
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}
