#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>

using namespace std;

typedef long long int ll;

struct rst {
	ll l, r;
};

bool can_kill(vector<rst>& b, vector<ll>& h,ll x) {
	if (b[x].l >= h[x] || b[x].r >= h[x]) return true;
	return false;
}

void kill_tree(vector<rst>& b, vector<ll>& left, vector<ll>& right, vector<ll>& h,ll l,ll r,ll x, vector<bool>& killed) {
	killed[x] = true;
	ll y = left[x];
	ll z = right[x];
	if (y != -1) {
		b[y].r += b[x].r;
		right[y] = z;
	}
	if (z != -1) {
		b[z].l += b[x].l;
		left[z] = y;
	}
}

ll kill_l_r(vector<rst>& b, vector<ll>& h, vector<ll>& left, vector<ll>& right, ll l, ll r, vector<bool>& killed) {
	ll res = 0;
	bool wk = false;
	ll y = l;
	ll fl = l;
	for (ll j = l; j <= r; j++) {
		y = fl;
		while (y!= -1 && y <= r) {
			ll i = y;
			if (!killed[i] && can_kill(b, h, i)) {
				if (i == fl) fl = right[i];
				kill_tree(b, left, right, h, l, r, i, killed);
				wk = true;
			}
			y = right[y];
		}
		if (!wk) break;
		wk = false;
	}
	for (ll i = l; i <= r; i++) if (killed[i]) res++;
	return res;
}

int main() {
	ll n, q;
	cin >> n >> q;
	vector<ll> a(n);
	vector<rst> b(n);
	vector<ll> h(n);
	vector<bool> killed(n, false);
	vector<ll> left(n);
	vector<ll> right(n);
	for (ll i = 1; i < n; i++) {
		left[i] = i - 1;
		right[i - 1] = i;
	}
	left[0] = -1;
	right[n - 1] = -1;
	cin >> a[0] >> h[0];
	b[0].l = 0;
	for (ll i = 1; i < n; i++) {
		cin >> a[i] >> h[i];
		b[i].l = a[i] - a[i - 1];
		b[i - 1].r = b[i].l;
	}
	b[n - 1].r = 0;
	for (ll u = 0; u < q; u++) {
		ll l, r;
		cin >> l >> r;
		l--;
		r--;
		for (ll i = 0; i < n; i++) {
			if (i != 0) left[i] = i - 1;
			else left[i] = -1;
			if (i != n - 1) right[i] = i + 1;
			else right[i] = -1;
			killed[i] = false;
			if (i != 0) b[i].l = a[i] - a[i - 1];
			else b[i].l = 0;
			if (i != n - 1) b[i].r = a[i+1]-a[i];
			else b[i].r = 0;
		}
		ll res=kill_l_r(b, h, left, right, l, r, killed);
		cout << res << endl;
	}
}

/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3

5 3
1 5
3 1
4 2
5 3
6 1
1 5
5 5
1 1


1 1
100 100 
1 1
*/