#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

ll count(string s) {
	vector<ll> decrypt = { 1, 5 };
	for (int i = 0; i < 12; i++) {
		decrypt.push_back(decrypt[2 * i] * 10);
		decrypt.push_back(decrypt[2 * i + 1] * 10);
	}
	ll n = s.size();
	vector<vector<ll>> dp(n, vector<ll>(26));
	vector<int> suf(n);
	suf[n - 1] = s[n - 1] - 'A';
	for (int i = n - 2; i >= 0; i--)
		suf[i] = max(suf[i + 1], s[i] - 'A');
	ll p = s[0] - 'A';
	ll cur = decrypt[p];
	for (int i = 0; i <= p; i++) {
		if (suf[0] <= p)
			dp[0][i] = cur;
		else
			dp[0][i] = -cur;
	}
	for (int i = p + 1; i < 26; i++)
		dp[0][i] = -cur;
	for (int i = 1; i < n; i++) {
		ll a = s[i] - 'A';
		ll cur = decrypt[a];
		for (int j = 0; j <= a; j++) {
			if (suf[i] <= a)
				dp[i][j] = dp[i - 1][a] + cur;
			else
				dp[i][j] = dp[i - 1][a] - cur;
		}
		for (int j = a + 1; j < 26; j++)
			dp[i][j] = dp[i - 1][j] - cur;
	}
	ll mx = LLONG_MIN;
	for (int i = 0; i < 26; i++)
		mx = max(mx, dp[n - 1][i]);
	return mx;
}

int main() {
	ll t;
	string s;
	cin >> t;
	while (t--) {
		cin >> s;
		ll mx = LLONG_MIN;
		string tt;
		vector<ll> pos;
		for (int i = 0; i < s.size(); i++)
			if (s[i] == '?')
				pos.push_back(i);
		tt = s;
		if (pos.size() > 2)
			for (int i = 0; i < 26; i++)
				for (int j = 0; j < 26; j++)
					for (int k = 0; k < 26; k++) {
						s[pos[0]] = 'A' + i;
						s[pos[1]] = 'A' + j;
						s[pos[2]] = 'A' + k;
						ll cur = count(s);
						if (cur > mx) {
							mx = cur;
							tt = s;
						}
					}
		else if (pos.size() > 1)
			for (int j = 0; j < 26; j++)
				for (int k = 0; k < 26; k++) {
						s[pos[0]] = 'A' + j;
						s[pos[1]] = 'A' + k;
						ll cur = count(s);
						if (cur > mx) {
							mx = cur;
								tt = s;
						}
				}
		else if (pos.size())
			for (int k = 0; k < 26; k++) {
				s[pos[0]] = 'A' + k;
				ll cur = count(s);
				if (cur > mx) {
					mx = cur;
					tt = s;
				}
			}
		else mx = count(s);
		cout << mx << "\n" << tt << "\n";
	}
}