#include <bits/stdc++.h>
#include <ctime>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;
#define mp make_pair
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.begin(), x.end()
const int INF = 1e9;

struct Edge {
    int u;
    int id;

    Edge() {
        u = -1;
        id = -1;
    }

    Edge(int _u, int _id) : u(_u), id(_id) {};
};

vector<int> tin;
vector<int> fup;
vector<int> used;
vector<int> color;
vector<bool> is_bridge;
int timer = 0;
vector<vector<pair<int, ll>>> g;
vector<vector<Edge>> G;

void dfs(int v, int p) {
    fup[v] = tin[v] = timer++;
    used[v] = true;
    for (Edge e: G[v]) {
        if (!used[e.u]) {
            dfs(e.u, v);
            fup[v] = min(fup[v], fup[e.u]);
        } else if (used[e.u] && e.u != p)
            fup[v] = min(fup[v], tin[e.u]);
        if (e.u != p) {
            if (fup[e.u] > tin[v]) {
                is_bridge[e.id] = true;
            }
        }
    }
}


void dfs2(int v, int c) {
    used[v] = true;
    color[v] = c;
    for (Edge e : G[v]) {
        if (!used[e.u]) {
            if (is_bridge[e.id]) {
                dfs2(e.u, ++timer);
            } else
                dfs2(e.u, c);
        }
    }
}


inline void SOLVE() {
    int n, m;
    cin >> n >> m;
    g.resize(n);
    G.resize(n);
    is_bridge.resize(m);
    for (int i = 0; i < m; ++i) {
        int v, u, w;
        cin >> v >> u >> w;
        v--, u--;
        g[v].pb(mp(u, w));
        g[u].pb(mp(v, w));
        G[v].pb(Edge(u, i));
        G[u].pb(Edge(v, i));
    }
    if (n - m == 1) {
        vector<pair<int, int>> dp(n, mp(INF, -INF)); // mn and mx
        queue<int> q;
        q.push(0);
        vector<bool> used(n);
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            used[v] = true;
            for (auto[u, w] : g[v]) {
                if (!used[u]) {
                    dp[u] = mp(min(dp[v].first, int(w)), max(dp[v].second, int(w)));
                    q.push(u);
                }

            }
        }
        for (int i = 1; i < n; ++i) {
            cout << dp[i].first + dp[i].second << '\n';
        }
    } else if (g[0][0].second == 0) {
        // dijkstra
        set<pair<int, int>> s;
        vector<int> d(n, 2 * INF);
        vector<int> p(n, -1);
        d[0] = 0;
        s.insert(mp(d[0], 0));
        while (!s.empty()) {
            int v = s.begin()->second;
            s.erase(s.begin());
            for (auto[u, ww] : g[v]) {
                if (u != p[v] && d[u] > max(int(ww), d[v])) {
                    s.erase(mp(d[u], u));
                    d[u] = max(int(ww), d[v]);
                    p[u] = v;
                    s.insert(mp(d[u], u));
                }
            }
        }
        for (int i = 1; i < n; ++i) {
            cout << d[i] << '\n';
        }
    } else if (g[0][0].second == INF) {
        tin.resize(n);
        used.resize(n);
        fup.resize(n);
        timer = 0;
        dfs(0, 0);
        color.resize(n);
        timer = 0;
        used.assign(n, false);
        dfs2(0, timer);
        timer++;
        vector<int> mn_in_component(timer, INF);
        vector<vector<pair<int, int>>> ng(timer);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < g[i].size(); ++j) {
                int u = g[i][j].first;
                int w = g[i][j].second;
                if (color[i] == color[u]) {
                    mn_in_component[color[i]] = min(mn_in_component[color[i]], w);
                } else {
                    ng[color[i]].pb(mp(color[u], w));
                }
            }
        }
        used.assign(n, false);
        queue<int> q;
        q.push(0);
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            used[v] = true;
            for (pair<int, int> e : ng[v]) {
                if (!used[e.first]) {
                    mn_in_component[e.first] = min({mn_in_component[v], e.second, mn_in_component[e.first]});
                    q.push(e.first);
                }
            }
        }
        for (int i = 1; i < n; ++i) {
            cout << INF + mn_in_component[color[i]] << '\n';
        }
    }
}


inline void FASTIO() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
}


signed main() {
#ifdef GOSHA
    freopen("../IO/input.txt", "r", stdin);
    freopen("../IO/output.txt", "w", stdout);
#endif
    FASTIO();
    ll T = 1;
    // cin >> T;
    while (T--) {
        SOLVE();
    }
}