#include <bits/stdc++.h>
#include <ctime>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;
#define mp make_pair
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.begin(), x.end()
const int INF = 1e9;
vector<vector<pair<int, ll>>> g;

inline void SOLVE() {
    int n, m;
    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < m; ++i) {
        int v, u, w;
        cin >> v >> u >> w;
        v--, u--;
        g[v].pb(mp(u, w));
        g[u].pb(mp(v, w));
    }
    if (n - m == 1) {
        vector<pair<int, int>> dp(n, mp(INF, -INF)); // mn and mx
        queue<int> q;
        q.push(0);
        vector<bool> used(n);
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            used[v] = true;
            for (auto[u, w] : g[v]) {
                if (!used[u]) {
                    dp[u] = mp(min(dp[v].first, int(w)), max(dp[v].second, int(w)));
                    q.push(u);
                }

            }
        }
        for (int i = 1; i < n; ++i) {
            cout << dp[i].first + dp[i].second << '\n';
        }
    } else if (g[0][0].second == INF) {
        // dijkstra
        set<pair<int, int>> s;
        vector<int> d(n, 2 * INF);
        vector<int> p(n, -1);
        s.insert(mp(d[0], 0));
        while (!s.empty()) {
            int v = s.begin()->second;
            s.erase(s.begin());
            for (auto[u, ww] : g[v]) {
                if (u != p[v] && d[u] > min(int(ww), d[v])) {
                    s.erase(mp(d[u], u));
                    d[u] = min(int(ww), d[v]);
                    p[u] = v;
                    s.insert(mp(d[u], u));
                }
            }
        }
        for (int i = 1; i < n; ++i) {
            cout << INF + d[i] << '\n';
        }
    }
}


inline void FASTIO() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
}


int main() {
#ifdef GOSHA
    freopen("../IO/input.txt", "r", stdin);
    freopen("../IO/output.txt", "w", stdout);
#endif
    FASTIO();
    int T = 1;
    // cin >> T;
    while (T--) {
        SOLVE();
    }
}