#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <algorithm>

#define all(a) a.begin(), a.end()

using namespace std;

#define pii pair<int, int>
#define mp make_pair
#define ft first
#define sd second

const int MAX_N = 300000;

vector<pair<int, bool>> gr[MAX_N];
vector<int> p(MAX_N, -1), sz(MAX_N);
vector<short> used(MAX_N, false);
vector<bool> hasdown(MAX_N, false), hasup(MAX_N, false);
vector<int> gr1[MAX_N];

void dfs0(int v) {
	used[v] = true;
	sz[v] = 0;
	for (pii e: gr[v])
		if (e.ft != p[v]) {
			p[e.ft] = v;
			if (e.sd)
				hasup[e.ft] = true;
			else
				hasdown[e.ft] = true;
			sz[v]++;
			if (!used[e.ft]) {
				gr1[v].push_back(e.ft);
				dfs0(e.ft);
				sz[v] += sz[e.ft];
			}
		}
}

vector<pair<pii, pii>> ans;

int dfs1(int v) {
	used[v] = 2;
	vector<int> up, down;
	for (int u : gr1[v]) {
		int cur = dfs1(u);
		if (cur == -1)
			return -1;
		else if (cur == 1)
			down.push_back(u);
		else if (cur == 2)
			up.push_back(u);
	}
	while (up.size() && down.size()) {
		ans.push_back(mp(mp(up.back(), v), mp(v, down.back())));
		up.pop_back();
		down.pop_back();
	}
	if (up.size() > 1)
		return -1;
	if (down.size() > 1)
		return -1;
	if (up.size() == 1)
		if (hasup[v]) {
			hasup[v] = false;
			ans.push_back(mp(mp(up[0], v), mp(v, p[v])));
		}
		else
			return -1;
	if (down.size() == 1)
		if (hasdown[v]) {
			hasdown[v] = false;
			ans.push_back(mp(mp(p[v], v), mp(v, down[0])));
		}
		else
			return -1;
	if (hasup[v])
		if (hasdown[v]) {
			ans.push_back(mp(mp(v, p[v]), mp(p[v], v)));
			return 0;
		}
		else
			return 2;
	else if (hasdown[v])
		return 1;
	else
		return 0;
}

void solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		x--; y--;
		gr[x].push_back(mp(y, false));
		gr[y].push_back(mp(x, true));
	}
	for (int i = 0; i < n; i++)
		if (!used[i])
			dfs0(i);
	bool ans1 = true;
	for (int i = 0; i < n; i++)
		if (used[i] != 2) {
			int cur = dfs1(i);
			if (cur != 0) {
				ans1 = false;
				break;
			}
		}
	if (ans1) {
		cout << "Yes\n";
		for (auto c : ans)
			cout << c.ft.ft + 1 << ' '
			<< c.ft.sd + 1 << ' '
			<< c.sd.ft + 1 << ' '
			<< c.sd.sd + 1 << '\n';
	}
	else
		cout << "No";
	int one = 1;
	int zero = 0;
}

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
    // cin >> t;
	while (t--)
		solve();
}