#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <algorithm>

#define all(a) a.begin(), a.end()

using namespace std;

#define pii pair<int, int>
#define mp make_pair
#define ft first
#define sd second

const int MAX_N = 500000;

vector<int> L(MAX_N, -1), R(MAX_N, MAX_N);


void solve() {
	int n, q;
	cin >> n >> q;
	vector<int> x(n), h(n);
	for (int i = 0; i < n; i++)
		cin >> x[i] >> h[i];
	vector<vector<int>> dp(n, vector<int>(n, n + 1));
	for (int l = 0; l < n; l++) {
		vector<int> dp_left(n - l, n + 1), dp_right(n - l, n + 1);
		vector<vector<int>> messing_falling_to_right(n - l), messing_falling_to_left(n - l);
		vector<int> cnt_right(n - l), cnt_left(n - l);
		vector<bool> used(n - l);
		vector<int> stack;
		for (int i = l; i < n; i++) {
			cnt_left[i - l] = n + 1;
			cnt_right[i - l] = n + 1;
			if (x[i] - h[i] >= x[max(0, l - 1)]) {
				dp_left[i - l] = i;
				cnt_left[i - l] = 0;
				for (int j = i - 1; j >= l && x[j] > x[i] - h[i]; j--) {
					cnt_left[i - l]++;
					messing_falling_to_left[j - l].push_back(i);
				}
				if (cnt_left[i - l] == 0) {
					stack.push_back(i);
					used[i - l] = true;
				}
			}
			if (x[i] + h[i] <= x[n - 1]) {
				dp_right[i - l] = i;
				cnt_right[i - l] = 0;
				for (int j = i + 1; j < n && x[j] < x[i] + h[i]; j++) {
					cnt_right[i - l]++;
					messing_falling_to_right[j - l].push_back(i);
				}
				if (!used[i - l] && cnt_right[i - l] == 0) {
					stack.push_back(i);
					used[i - l] = true;
				}
			}
		}
		while (stack.size()) {
			int cur = stack.back();
			stack.pop_back();
			dp[l][cur] = min(dp_left[cur - l], dp_right[cur - l]);
			for (int u : messing_falling_to_left[cur - l]) {
				cnt_left[u - l]--;
				if (cnt_left[u - l] == 0 && !used[u - l]) {
					dp_left[u - l] = max(dp_left[u - l], dp[l][cur]);
					stack.push_back(u);
					used[u - l] = true;
				}
			}
			for (int u : messing_falling_to_right[cur - l]) {
				cnt_right[u - l]--;
				if (cnt_right[u - l] == 0 && !used[u - l]) {
					dp_right[u - l] = max(dp_right[u - l], dp[l][cur]);
					stack.push_back(u);
					used[u - l] = true;
				}
			}
		}
	}

	for (int i = 0; i < q; i++) {
		int l, r;
		cin >> l >> r;
		l--;
		int ans = 0;
		for (int j = l; j < r; j++)
			if (dp[l][j] < r)
				ans++;
		cout << ans << '\n';
	}
}

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	// cin >> t;
	while (t--)
		solve();
}