#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;
typedef pair <int, int> pii;
typedef vector <pii> vpii;
typedef vector <vpii> vvpii;

const int INF = 1e9;

map <pii, int> cnt;

int timer = 0;
vector <bool> used;
vi tin, up;
vvpii g;
vi mi, ma;

vvi ggg;

void dfs(int v, int p = -1) {
  for (auto [u, w] : g[v]) {
    if (u == p) {
      continue;
    }
    if (p == -1) {
      mi[u] = ma[u] = w;
    } else {
      mi[u] = min(mi[v], w);
      ma[u] = max(ma[v], w);
    }
    dfs(u, v);
  }
}

vector <pair <pii, int>> bridges;
vector <pair <pii, int>> others;

void find_bridges(int v, int p = -1) {
  used[v] = true;
  tin[v] = up[v] = timer++;
  for (auto [u, w] : g[v]) {
    if (u == p) {
      continue;
    }
    if (used[u]) {
      up[v] = min(up[v], tin[u]);
      others.push_back({{u, v}, w});
    } else {
      find_bridges(u, v);
      up[v] = min(up[v], up[u]);
      if (up[u] > tin[v] && cnt[{u, v}] == 1) {
        bridges.push_back({{u, v}, w});
      } else {
        others.push_back({{u, v}, w});
      }
    }
  }
}

vi col;

void recolor(int v, int c) {
  col[v] = c;
  for (int u : ggg[v]) {
    if (col[v] != col[u]) {
      recolor(u, c);
    }
  }
}

vvpii gggg;
vector <int> ans_comp;

void group3solve(int v, int p = -1) {
  for (auto [u, w] : gggg[v]) {
    if (u != p) {
      ans_comp[u] = min({ans_comp[u], w, ans_comp[v]});
      group3solve(u, v);
    }
  }
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n, m;
  cin >> n >> m;
  g.resize(n);
  vvi gg(n);
  bool group2 = true, group3 = true;
  bool group6 = true;
  vector <pair <int, pii>> e;
  for (int i = 0; i < m; i++) {
    int u, v, w;
    cin >> u >> v >> w;
    u--, v--;
    if (u > v) {
      swap(u, v);
    }
    if (u + 1 != v) {
      group6 = false;
    }
    gg[u].push_back(i);
    gg[v].push_back(i);
    e.push_back({w, {u, v}});
    g[u].push_back({v, w});
    g[v].push_back({u, w});
    cnt[{u, v}]++;
    cnt[{v, u}]++;
    if (u == 0) {
      if (w != 0) {
        group2 = false;
      }
      if (w != INF) {
        group3 = false;
      }
    }
  }
  if (group6) {
    vvi hm(n);
    for (auto &now : e) {
      hm[now.second.first].push_back(now.first);
    }
    for (int i = 0; i < n; i++) {
      sort(hm[i].begin(), hm[i].end());
      while (hm[i].size() > 2) {
        hm[i].pop_back();
      }
    }
    vector <int> min_pref(n, 1e9);
    vector <int> max_pref(n);
    for (int i = 1; i < n; i++) {
      min_pref[i] = min(min_pref[i - 1], hm[i - 1][0]);
      max_pref[i] = max(max_pref[i - 1], hm[i - 1][0]);
    }
    for (int v = 1; v < n; v++) {
      int mi = min_pref[v];
      int ma = max_pref[v];
      int ans = mi + ma;
      for (int u = v; u + 1 < n; u++) {
        if (hm[u].size() == 1) {
          break;
        }
        mi = min(mi, hm[u][0]);
        ma = max(ma, hm[u][1]);
        ans = min(ans, mi + ma);
      }
      cout << ans << '\n';
    }
    return 0;
  }
  if (group3) {
    used.assign(n, false);
    tin.resize(n), up.resize(n);
    find_bridges(0);
    ggg.resize(n);
    for (auto &now : others) {
      int u = now.first.first, v = now.first.second;
      ggg[u].push_back(v);
      ggg[v].push_back(u);
    }
    col.resize(n, -1);
    int cnt = 0;
    for (int v = 0; v < n; v++) {
      if (col[v] == -1) {
        recolor(v, cnt++);
      }
    }
    ans_comp.resize(cnt, INF);
    for (auto &now : others) {
      int c = col[now.first.first];
      int w = now.second;
      ans_comp[c] = min(ans_comp[c], w);
    }
    gggg.resize(cnt);
    for (auto &now : bridges) {
      int u = col[now.first.first];
      int v = col[now.first.second];
      int w = now.second;
      gggg[u].push_back({v, w});
      gggg[v].push_back({u, w});
    }
    group3solve(0);
    for (int v = 1; v < n; v++) {
      cout << ans_comp[col[v]] + INF << ' ';
    }
    return 0;
  }
  if (group2) {
    set <pair <int, int>> s;
    vector <int> d(n, INF);
    d[0] = 0;
    for (int v = 0; v < n; v++) {
      s.insert({d[v], v});
    }
    while (!s.empty()) {
      int v = s.begin()->second;
      s.erase(s.begin());
      for (auto [u, w] : g[v]) {
        if (max(d[v], w) < d[u]) {
          s.erase({d[u], u});
          d[u] = max(d[v], w);
          s.insert({d[u], u});
        }
      }
    }
    for (int v = 1; v < n; v++) {
      cout << d[v] << ' ';
    }
    return 0;
  }
  if (n <= 20 && m <= 20) {
    vi mi(1 << m, INF);
    vi ma(1 << m, 0);
    vi pos(1 << m, -1);
    pos[0] = 0;
    for (int mask = 0; mask < (1 << m); mask++) {
      if (pos[mask] == -1) {
        continue;
      }
      int v = pos[mask];
      for (int i : gg[v]) {
        if (mask & (1 << i)) {
          continue;
        }
        int u = (e[i].second.first ^ e[i].second.second ^ v);
        int w = e[i].first;
        int newmask = (mask + (1 << i));
        mi[newmask] = min(mi[mask], w);
        ma[newmask] = max(ma[mask], w);
        pos[newmask] = u;
      }
    }
    vector <int> ans(n, 2 * INF);
    for (int mask = 0; mask < (1 << m); mask++) {
      if (pos[mask] == -1) {
        continue;
      }
      int v = pos[mask];
      ans[v] = min(ans[v], mi[mask] + ma[mask]);
    }
    for (int v = 1; v < n; v++) {
      cout << ans[v] << ' ';
    }
    return 0;
  }
  mi.resize(n), ma.resize(n);
  dfs(0);
  for (int v = 1; v < n; v++) {
    cout << mi[v] + ma[v] << '\n';
  }
  return 0;
}

/*
3 3
 1 2 2
 1 3 1
 2 3 1
 */

/*
 6 7
 1 2 1000000000
 1 3 1000000000
 2 3 123
 3 4 12
 4 5 472
 4 6 283
 5 6 273
 */

/*
4 7
1 2 1
1 2 2
2 3 1
2 3 2
3 4 3
3 4 1
2 3 1
 */