#include <iostream>
#include <vector>
#include <set>

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;
typedef pair <int, int> pii;
typedef vector <pii> vpii;
typedef vector <vpii> vvpii;

const int INF = 1e9;

vvpii g;
vi mi, ma;

void dfs(int v, int p = -1) {
  for (auto [u, w] : g[v]) {
    if (u == p) {
      continue;
    }
    if (p == -1) {
      mi[u] = ma[u] = w;
    } else {
      mi[u] = min(mi[v], w);
      ma[u] = max(ma[v], w);
    }
    dfs(u, v);
  }
}

int main() {
  int n, m;
  cin >> n >> m;
  g.resize(n);
  vvi gg(n);
  bool group2 = true;
  vector <pair <int, pii>> e;
  for (int i = 0; i < m; i++) {
    int u, v, w;
    cin >> u >> v >> w;
    u--, v--;
    if (u > v) {
      swap(u, v);
    }
    gg[u].push_back(i);
    gg[v].push_back(i);
    e.push_back({w, {u, v}});
    g[u].push_back({v, w});
    g[v].push_back({u, w});
    if (u == 0) {
      if (w != 0) {
        group2 = false;
      }
    }
  }
  if (group2) {
    set <pair <int, int>> s;
    vector <int> d(n, INF);
    d[0] = 0;
    for (int v = 0; v < n; v++) {
      s.insert({d[v], v});
    }
    while (!s.empty()) {
      int v = s.begin()->second;
      s.erase(s.begin());
      for (auto [u, w] : g[v]) {
        if (max(d[v], w) < d[u]) {
          s.erase({d[u], u});
          d[u] = max(d[v], w);
          s.insert({d[u], u});
        }
      }
    }
    for (int v = 1; v < n; v++) {
      cout << d[v] << ' ';
    }
    return 0;
  }
  if (n <= 20 && m <= 20) {
    vi mi(1 << m, INF);
    vi ma(1 << m, 0);
    vi pos(1 << m, -1);
    pos[0] = 0;
    for (int mask = 0; mask < (1 << m); mask++) {
      if (pos[mask] == -1) {
        continue;
      }
      int v = pos[mask];
      for (int i : gg[v]) {
        if (mask & (1 << i)) {
          continue;
        }
        int u = (e[i].second.first ^ e[i].second.second ^ v);
        int w = e[i].first;
        int newmask = (mask + (1 << i));
        mi[newmask] = min(mi[mask], w);
        ma[newmask] = max(ma[mask], w);
        pos[newmask] = u;
      }
    }
    vector <int> ans(n, 2 * INF);
    for (int mask = 0; mask < (1 << m); mask++) {
      if (pos[mask] == -1) {
        continue;
      }
      int v = pos[mask];
      ans[v] = min(ans[v], mi[mask] + ma[mask]);
    }
    for (int v = 1; v < n; v++) {
      cout << ans[v] << '\n';
    }
    return 0;
  }
  mi.resize(n), ma.resize(n);
  dfs(0);
  for (int v = 1; v < n; v++) {
    cout << mi[v] + ma[v] << '\n';
  }
  return 0;
}

/*
3 3
 1 2 2
 1 3 1
 2 3 1
 */