#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <cassert>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e17;

ll n, m, k, q;

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

map <char, ll> h;

void init() {
	ll cur = 1;
	for (char c = 'A'; c <= 'Z'; ++c) {
		h[c] = cur;
		if (c & 1) {
			cur *= 5;
		}
		else {
			cur *= 2;
		}
	}
}

vector <vector <pair <ll, ll>>> g;
vector <vector <ll>> ng, tt;

vector <ll> mp;
vector <ll> color;

void dfs(int v) {
	for (auto& x : tt[v]) {
		if (color[x] == -1) {
			color[x] = !color[v];
			dfs(x);
		}
	}
}

vector <bool> used;

bool Kuhn(ll v) {
	if (used[v]) return false;
	used[v] = true;
	for (auto& x : ng[v]) {
		if (mp[x] == -1 || Kuhn(mp[x])) {
			mp[x] = v;
			return true;
		}
	}
	return false;
}

int main() {
	init();

	cin >> n >> m;
	g.resize(n);
	map <ll, pair <ll, ll>> rev;
	for (int i = 0; i < m; ++i) {
		ll a, b;
		cin >> a >> b;
		--a; --b;
		g[a].push_back({ b, i });
		rev[i] = { a, b };
	}
	tt.resize(m);
	ng.resize(m);
	for (int i = 0; i < n; ++i) {
		for (auto& x : g[i]) {
			for (auto& y : g[x.first]) {
				ng[x.second].push_back(y.second);
				tt[x.second].push_back(y.second);
				tt[y.second].push_back(x.second);
			}
		}
	}

	mp.resize(m, -1);
	color.assign(m, -1);
	for (int i = 0; i < m; ++i) {
		if (color[i] == -1) {
			color[i] = 0;
			dfs(i);
		}
	}

	//	for (auto& x : color) {
	//		cout << x << '\n';
	//	}

	vector <ll> f, s;
	for (int i = 0; i < m; ++i) {
		if (color[i] == 0) {
			f.push_back(i);
		}
		else {
			s.push_back(i);
		}
	}
	for (auto& x : f) {
		used.assign(m, false);
		Kuhn(x);
	}
	for (auto& x : mp) {
		cout << x << '\n';
	}
	ll cnt = 0;
	for (auto& x : s) {
		if (mp[x] == -1) {
			cout << "No\n";
			return 0;
		}
		++cnt;
	}
	if (cnt != f.size()) {
		cout << "No\n";
		return 0;
	}

	cout << "Yes\n";
	for (auto& x : s) {
		cout << rev[mp[x]].first + 1 << ' ' << rev[mp[x]].second + 1 << ' ' << rev[x].first + 1 << ' ' << rev[x].second + 1 << '\n';
	}

	return 0;
}
/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2

4 4
2 1
2 3
2 4
4 2

4 4
1 2
2 1
3 4
4 3
*/