#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <cassert>
#include <queue>
#include <numeric>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e17;

ll n, m, k, q;

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll g[10][10];

struct edge {
	ll v, u, c;

	edge(ll v = 0, ll u = 0, ll c = 0) : v(v), u(u), c(c) {};
};

bool ok(ll a, edge& b) {
	return a == b.v || a == b.u;
}

int main() {
	cin >> n >> m;
	for (int i = 0; i < 10; ++i) {
		for (int j = 0; j < 10; ++j) {
			g[i][j] = -INF;
		}
	}
	vector <edge> a;
	for (int i = 0; i < m; ++i) {
		ll x, y, z;
		cin >> x >> y >> z;
		--x; --y;
		a.push_back(edge(x, y, z));
	}
	vector <ll> perm(m);
	iota(perm.begin(), perm.end(), 0);
	
	vector <ll> ans(n, INF);

	do {
		if (a[0].v != 0 || a[0].u != 0) continue;
		ll mine = INF, maxe = -INF;
		for (int i = 0; i < m; ++i) {
			ll curv = curv ^ a[i].v ^ a[i].u;
			ll cost = a[i].c;
			if (i && ok(curv, a[i])) {
				maxi(maxe, cost);
				mini(mine, cost);
				mini(ans[curv], mine + maxe);
			}
			else {
				break;
			}
		}

	} while (next_permutation(perm.begin(), perm.end()));

	for (int i = 1; i < n; ++i) {
		cout << ans[i] << '\n';
	}

	return 0;
}