#include <iostream>
#include <iomanip>
#include <istream>
#include <ostream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <array>
#include <bitset>
#include <algorithm>
#include <functional>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <cmath>
#include <cassert>
#include <limits>
#include <time.h>

using namespace std;

template<typename T> ostream& operator<< (ostream& out, const vector<T>& a) {
	for (auto k : a) {
		out << k << " ";
	}
	return out;
}

template<typename T1, typename T2> bool chkmin(T1& a, const T2& b) {if (b < a) {a = b; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& a, const T2& b) {if (a < b) {a = b; return 1;} return 0;}

#define int long long 
#define pii pair<int, int>
#define pb push_back
#define ppb pop_back
#define all(a) a.begin(), a.end()

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
#else 
	#define dbg(x)
#endif

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 15e4;

int n, m;
vector<int> g[N];
int used[N];

set<pii> have;
vector<array<int, 4>> ans;

#define no() {cout << "No\n"; exit(0);}

void dfs(int v, int p = -1) {
	used[v] = 1;
	vector<int> kids;
	for (auto u : g[v]) {
		if (!used[u]) {
			dfs(u, v);
			kids.pb(u);
		}
	}
	vector<int> in, out;
	for (auto u : kids) {
		if (have.count({u, v})) {
			in.pb(u);
		}
		if (have.count({v, u})) {
			out.pb(u);
		}
	}
	int insz = in.size(), outsz = out.size();
	if (abs(insz - outsz) > 1) {
		no();
	}
	while (!in.empty() && !out.empty()) {
		ans.pb({in.back(), v, v, out.back()});
		have.erase({in.back(), v});
		have.erase({v, out.back()});
		in.ppb();
		out.ppb();
	}
	if (!in.empty()) {
		if (p == -1 || !have.count({v, p})) {
			no();
		}
		ans.pb({in.back(), v, v, p});
		have.erase({in.back(), v});
		have.erase({v, p});
	}
	if (!out.empty()) {
		if (p == -1 || !have.count({p, v})) {
			no();
		}
		ans.pb({p, v, v, out.back()});
		have.erase({v, out.back()});
		have.erase({p, v});
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--, v--;
		g[u].pb(v);
		g[v].pb(u);
		have.insert({u, v});
	}
	for (int i = 0; i < n; i++) {
		sort(all(g[i]));
		g[i].resize(unique(all(g[i])) - g[i].begin());
	}
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			dfs(i);
		}
	}
	cout << "Yes\n";
	for (auto k : ans) {
		for (auto v : k) {
			cout << v + 1 << " ";
		}
		cout << "\n";
	}
}
/*
5 6
1 2
2 1
1 5
2 3 
2 4
4 2

4 4
2 1 
2 3
2 4 
4 2

4 4 
1 2 
2 1 
3 4 
4 3  
*/