#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 3e5 + 123;
vector<pair<int, int>> edg[MAXN];

pair<int, int> pmg(pair<int, int> p1, pair<int, int> p2){
	return {min(p1.first, p2.first), max(p1.second, p2.second)};
}

void gr1dfs(int v, vector<int>& depth, vector<vector<int>>& redg, vector<vector<pair<int, int>>>& cst){
	for(int i = 1; depth[v] - (1 << i) >= 0; ++i){
		redg[v].push_back(redg[redg[v][i - 1]][i - 1]);
		cst[v].push_back(pmg(cst[v][i - 1], cst[redg[v][i - 1]][i - 1]));
	}
	for(auto [u, c] : edg[v]){
		if(redg[v].empty() || u != redg[v][0]){
			depth[u] = depth[v] + 1;
			redg[u].push_back(v);
			cst[u].push_back({c, c});
			gr1dfs(u, depth, redg, cst);
		}
	}
}


pair<int, int> gr1_w(int u, int v, vector<int>& depth, vector<vector<int>>& redg, vector<vector<pair<int, int>>>& cst){
	if(u == v)
		return {1e9, 0};
	if(depth[u] > depth[v]){
		int lb = 0, ub = redg[u].size();
		while(ub - lb > 1){
			int mb = (lb + ub) / 2;
			if(depth[u] - (1 << mb) >= depth[v])
				lb = mb;
			else
				ub = mb;
		}
		return pmg(cst[u][lb], gr1_w(redg[u][lb], v, depth, redg, cst));
	}
	if(depth[v] > depth[u])
		return gr1_w(v, u, depth, redg, cst);
	int lb = 0, ub = redg[u].size();
	while(ub - lb > 1){
		int mb = (lb + ub) / 2;
		if(redg[u][mb] == redg[v][mb])
			ub = mb;
		else
			lb = mb;
	}
	return pmg(pmg(cst[u][lb], cst[v][lb]), gr1_w(redg[u][lb], redg[v][lb], depth, redg, cst));
}

signed main(){
	int n, m;
	cin >> n >> m;
	while(m--){
		int u, v, t;
		cin >> u >> v >> t;
		--u, --v;
		edg[v].push_back({u, t});
		edg[u].push_back({v, t});
	}
	if(m == n - 1){
		vector<int> depth(n, 0);
		vector<vector<int>> redg(n);
		vector<vector<pair<int, int>>> cst(n);
		gr1dfs(0, depth, redg, cst);
		for(int i = 1; i < n; ++i){
			auto [a, b] = gr1_w(0, i, depth, redg, cst);
			cout << a + b << endl;
		}
	}

}
