#pragma GCC optimeze("Ofast")
#pragma GCC target("avx2")

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <numeric>
#include <queue>
#include <cstring>

using namespace std;

using ll = int;
template <typename T>
using v = vector<T>;
template <typename A, typename B>
using pa = pair<A, B>;

struct dsu {
	v<ll> parent;
	v<ll> rank;
	v<ll> L;
	v<ll> R;
	inline dsu(ll n) : parent(n), rank(n, 1), L(n), R(n) {
		iota(parent.begin(), parent.end(), 0ll);
		iota(L.begin(), L.end(), 0ll);
		iota(R.begin(), R.end(), 0ll);
	}

	inline ll get(ll vert) {
		if (parent[vert] == vert) {
			return vert;
		}
		else {
			return parent[vert] = get(parent[vert]);
		}
	}

	inline void unite(ll a, ll b) {
		a = get(a);
		b = get(b);
		if (a != b) {
			if (rand() & 1) {
				swap(a, b);
			}
			parent[b] = a;
			rank[a] += rank[b];
			L[a] = min(L[a], L[b]);
			R[a] = max(R[a], R[b]);
		}
	}
};

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ll n, q;
	cin >> n >> q;
	pa<ll, ll> trees[10000];
	for (ll i = 0; i < n; ++i) {
		ll xi, hi;
		cin >> xi >> hi;
		trees[i] = { xi, hi };
	}
	bool cut_down[10000], scheduled[10000];
	for (ll req = 0; req < q; ++req) {
		ll li, ri;
		cin >> li >> ri;
		--li;
		dsu d(ri - li);
		memset(cut_down, 0, sizeof(cut_down));
		memset(scheduled, 0, sizeof(scheduled));
		queue<ll> q;
		ll cnt = 0;
		for (ll i = 0; i < (ri - li); ++i) {
			if (!cut_down[i]) {
				ll L = i - 1;
				if (L >= 0 && cut_down[L]) {
					L = d.L[d.get(L)] - 1;
				}
				bool canLeft = L == -1 || trees[li + L].first <= trees[li + i].first - trees[li + i].second;
				canLeft &= li == 0 || trees[li - 1].first <= trees[li + i].first - trees[li + i].second;
				canLeft &= trees[0].first <= trees[li + i].first - trees[li + i].second;
				ll R = i + 1;
				if (R < (ri - li) && cut_down[R]) {
					R = d.R[d.get(R)] + 1;
				}
				bool canRight = R == (ri - li) || trees[li + R].first >= trees[li + i].first + trees[li + i].second;
				canRight &= ri == n || trees[ri].first >= trees[li + i].first + trees[li + i].second;
				canRight &= trees[n - 1].first >= trees[li + i].first + trees[li + i].second;
				if (canLeft || canRight) {
					if (!scheduled[i]) {
						scheduled[i] = true;
						q.push(i);
					}
				}
			}
		}
		while (!q.empty()) {
			ll ti = q.front();
			q.pop();
			cut_down[ti] = true;
			if (ti > 0 && cut_down[ti - 1]) {
				d.unite(ti, ti - 1);
			}
			if (ti < (ri - li) - 1 && cut_down[ti + 1]) {
				d.unite(ti, ti + 1);
			}
			{
				ll L = ti - 1;
				if (L >= 0 && cut_down[L]) {
					L = d.L[d.get(L)] - 1;
				}
				ll i = L;
				if (i >= 0) {
					if (!cut_down[i]) {
						ll L = i - 1;
						if (L >= 0 && cut_down[L]) {
							L = d.L[d.get(L)] - 1;
						}
						bool canLeft = L == -1 || trees[li + L].first <= trees[li + i].first - trees[li + i].second;
						canLeft &= li == 0 || trees[li - 1].first <= trees[li + i].first - trees[li + i].second;
						canLeft &= trees[0].first <= trees[li + i].first - trees[li + i].second;
						ll R = i + 1;
						if (R < (ri - li) && cut_down[R]) {
							R = d.R[d.get(R)] + 1;
						}
						bool canRight = R == (ri - li) || trees[li + R].first >= trees[li + i].first + trees[li + i].second;
						canRight &= ri == n || trees[ri].first >= trees[li + i].first + trees[li + i].second;
						canRight &= trees[n - 1].first >= trees[li + i].first + trees[li + i].second;
						if (canLeft || canRight) {
							if (!scheduled[i]) {
								scheduled[i] = true;
								q.push(i);
							}
						}
					}
				}
			}
			{
				ll R = ti + 1;
				if (R < (ri - li) && cut_down[R]) {
					R = d.R[d.get(R)] + 1;
				}
				ll i = R;
				if (i < (ri - li)) {
					if (!cut_down[i]) {
						ll L = i - 1;
						if (L >= 0 && cut_down[L]) {
							L = d.L[d.get(L)] - 1;
						}
						bool canLeft = L == -1 || trees[li + L].first <= trees[li + i].first - trees[li + i].second;
						canLeft &= li == 0 || trees[li - 1].first <= trees[li + i].first - trees[li + i].second;
						canLeft &= trees[0].first <= trees[li + i].first - trees[li + i].second;
						ll R = i + 1;
						if (R < (ri - li) && cut_down[R]) {
							R = d.R[d.get(R)] + 1;
						}
						bool canRight = R == (ri - li) || trees[li + R].first >= trees[li + i].first + trees[li + i].second;
						canRight &= ri == n || trees[ri].first >= trees[li + i].first + trees[li + i].second;
						canRight &= trees[n - 1].first >= trees[li + i].first + trees[li + i].second;
						if (canLeft || canRight) {
							if (!scheduled[i]) {
								scheduled[i] = true;
								q.push(i);
							}
						}
					}
				}
			}
			++cnt;
		}
		cout << cnt << '\n';
	}
}