#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <numeric>
#include <queue>

using namespace std;

using ll = int;
template <typename T>
using v = vector<T>;
template <typename A, typename B>
using pa = pair<A, B>;

v<v<pa<ll, ll>>> graph;
v<ll> edg;
v<bool> was;

v<ll> res;

void bruteforce(ll vert, ll L = -1, ll R = -1) {
	if (L != -1) {
		res[vert] = min(res[vert], L + R);
	}
	for (auto [overt, t] : graph[vert]) {
		if (!was[t]) {
			was[t] = true;
			ll nL, nR;
			if (L == -1) {
				nL = nR = edg[t];
			}
			else {
				nL = min(L, edg[t]);
				nR = max(R, edg[t]);
			}
			bruteforce(overt, nL, nR);
			was[t] = false;
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ll n, m;
	cin >> n >> m;
	graph = v<v<pa<ll, ll>>>(n);
	edg = v<ll>(m);
	for (ll i = 0; i < m; ++i) {
		ll ui, vi, ti;
		cin >> ui >> vi >> ti;
		--ui;
		--vi;
		graph[ui].push_back({ vi, i });
		graph[vi].push_back({ ui, i });
		edg[i] = ti;
	}
	was = v<bool>(m);
	res = v<ll>(n, 2e9);
	bruteforce(0);
	for (ll i = 1; i < n; ++i) {
		cout << res[i] << '\n';
	}
}