#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
using namespace std;

int n, m;
vector<vector<pair<int, int>>> graph;

void fixdfs(int v, int p = -1)
{
	vector<pair<int, int>> res;

	int k = graph[v].size();
	for (int i = 0; i < k; ++i)
	{
		if (graph[v][i].first == p) continue;

		pair<int, int> tek;
		tek.first = graph[v][i].first;
		tek.second += (1 << graph[v][i].second);
		if (i + 1 < k && graph[v][i + 1].first == tek.first)
			tek.second += (1 << graph[v][i + 1].second), ++i;

		res.push_back(tek);
	}
	graph[v] = res;

	for (auto& i : res)
		fixdfs(i.first, v);
}

vector<int> type;

bool get(int mask, int i)
{
	return ((mask >> i) & 1);
}

int Type(int v)
{
	if (type[v] != -2) return type[v];

	type[v] = -1;
	vector<int> type1, type2;

	for (auto& i : graph[v])
	{
		int u = i.first, d = i.second, c = Type(u);
		if (c == -1)
			return type[v] = -1;

		int rd = d;
		if (c == 1 && !get(rd, 0))
			return type[v] = -1;
		if (c == 1 && get(rd, 0))
			rd ^= 1;
		if (c == 2 && !get(rd, 1))
			return type[v] = -1;
		if (c == 2 && get(rd, 1))
			rd ^= 2;

		if (rd == 3) rd = 0;

		if (rd == 0) continue;
		if (rd == 1)
			type1.push_back(u);
		if (rd == 2)
			type2.push_back(u);
	}

	int x = type1.size(), y = type2.size();
	if (abs(x - y) > 1)
		return type[v] = -1;
	if (x == y)
		return type[v] = 0;
	if (x == y + 1)
		return type[v] = 1;
	if (x + 1 == y)
		return type[v] = 2;
}

int main()
{
	ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);

	cin >> n >> m;
	graph.resize(n);
	type.resize(n, -2);
	for (int i = 0; i < m; ++i)
	{
		int a, b; cin >> a >> b; --a; --b;
		graph[a].emplace_back(b, 0);
		graph[b].emplace_back(a, 1);
	}

	for (auto& i : graph)
		sort(i.begin(), i.end());
	fixdfs(0);

	cout << ((Type(0) == 0) ? "Yes" : "No") << '\n';

	return 0;
}