#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target(sse,avx,avx2)

#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <functional>
#include <map>
#include <bitset>
#include <utility>
#include <cstring>
#include <algorithm>
#include <chrono>
#include <random>
#include <cassert>

#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fx(x, a) for (auto &x : a)
#define mp make_pair
#define pb push_back
#define lb lower_bound
#define ub upper_bound
#define ppb pop_back()

#define all(x) x.begin(),x.end()
#define siz(x) (int)x.size()

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl
#else
	#define dbg(x)
#endif

using namespace std;


template<typename T1, typename T2> inline void mine(T1 &x, const T2 &y) {if (y < x) x = y;}
template<typename T1, typename T2> inline void maxe(T1 &x, const T2 &y) {if (x < y) x = y;}

typedef vector<int> vi;
typedef char ch;
typedef string str;
typedef pair<int, int> pii;
typedef vector<char> vch;
typedef vector<pii> vpii;
typedef vector<vi> vvi;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


const int N = 3e5 + 10;

pii e[N];
vi in[N];
vi out[N];
int col[N];
vi g[N];

void dfs(int v, int cur) {
	col[v] = cur;
	fx(to, g[v]) {
		if (col[to]) {
			assert(col[to] != cur);
		} else {
			dfs(to, 3 - cur);
		}
	}
}
int pr[N];
bool ok[N];

bool ku1(int v) {
	fx(to, g[v]) {
		if (pr[to] == -1) {
			pr[to] = v;
			return true;
		}
	}
	return false;
}

int timer = 1;
int used[N];

bool ku2(int v) {
	if (used[v] == timer) return false;
	used[v] = timer;
	fx(to, g[v]) {
		if (pr[to] == -1 || ku2(pr[to])) {
			pr[to] = v;
			return true;
		}
	}
	return false;
} 

void no() {
	cout << "No\n";
	exit(0);
}
int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a, --b;
		e[i] = {a, b};
		out[a].pb(i);
		in[b].pb(i);
	}
	fi(0, n) {
		fx(x, in[i]) {
			fx(y, out[i]) {
				g[x].pb(y);
				g[y].pb(x);
				//cout << x << ' ' << y << '\n';
			}
		}
	}
	int c1 = 0;
	int c2 = 0;
	fi(0, m) {
		if (!col[i]) {
			dfs(i, 1);
		}
		//dbg(col[i]);
		c1 += col[i] == 1;
		c2 += col[i] == 2;
	}
	if (c1 != c2) no();
	memset(pr, -1, sizeof(pr));
	fi(0, m) {
		if (col[i] == 1) {
			shuffle(all(g[i]), rng);
			ok[i] = ku1(i);
		}
		timer++;
	}
	fi(0, m) {
		if (col[i] == 1 && !ok[i]) {
			if (!ku2(i)) {
				no();
			}
		}
	}
	cout << "Yes\n";
	fi(0, m) {
		if (pr[i] != -1) {
			auto[a1, b1] = e[i];
			auto[a2, b2] = e[pr[i]];
			if (b1 != a2) {
				swap(a1, a2);
				swap(b1, b2);
			}
			++a1, ++b1, ++a2, ++b2;
			assert(b1 == a2);
			cout << a1 << ' ' << b1 << ' ' << a2 << ' ' << b2 << '\n';
		}
	}
}
