#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
using ll = long long;

vector<ll> mit, mat;

void dfs(ll v, vector<int> &used, vector<vector<pair<ll, ll>>>& g)
{
	used[v] = 1;
	for (auto u : g[v])
	{
		if (!used[u.first])
		{
			mit[u.first] = min(mit[v], u.second);
			mat[u.first] = max(mat[v], u.second);
			dfs(u.first, used, g);
		}
	}
}

signed main()
{
	ll n, m; cin >> n >> m;
	if (m == n - 1)
	{
		vector<vector<pair<ll, ll>>> g(n + 1);
		mit.assign(n, 1e18);
		mat.assign(n, 0);

		for (int i = 0; i < m; ++i)
		{
			ll u, v, t; cin >> u >> v >> t;
			--u; --v;

			g[u].push_back({ v, t });
			g[v].push_back({ u, t });
		}
		vector<int> used(n + 1, 0);
		dfs(0, used, g);
		for (int i = 1; i < n; ++i)
			cout << mit[i] + mat[i] << '\n';
	}
	else
	{
		vector<vector<pair<ll, ll>>> g(n + 1);

		for (int i = 0; i < m; ++i)
		{
			ll u, v, t; cin >> u >> v >> t;
			--u; --v;

			g[u].push_back({ v, t });
			g[v].push_back({ u, t });
		}

		vector<ll> d(n, 1e18);
		set<pair<ll, ll>> se;
		for (int i = 0; i < n; ++i)
			se.insert({ d[i],i });

		while (!se.empty())
		{
			ll v = se.begin()->second;

			for (auto ut : g[v])
			{
				if (min(d[v] , ut.second )< d[ut.first])
				{
					ll i = ut.first;
					se.erase({ d[i],i });
					d[i] = min(d[v], ut.second);
					se.insert({ d[i],i });
				}
			}

			se.erase({ d[v],v });
		}

		for (int i = 1; i < n; ++i)
			cout << d[i] + 1'000'000'000 << '\n';
	}

	return 0;
}