#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <tuple>
#include <map>
#include <queue>
#include <set>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

#define int long long

typedef long long ll;
typedef long double ld;

const ll SZ = 3e5 + 100, INF = INT64_MAX / 2 - 2;

ll n, m;
vector<vector<pair<ll, ll>>> gr;
ll ans[SZ];
ll par[SZ], shrd[SZ];

ll find(int v) {
	if (par[v] == v) return v;
	else return par[v] = find(par[v]);
}

void uni(int v, int u) {
	v = find(v);
	u = find(u);

	if (u != v) {
		par[u] = v;
	}
}

ll val[SZ];
vector<vector<pair<ll, ll>>> tree;

ll cur[SZ], prt[SZ], us[SZ];

void dfs2(int u) {
	queue<ll> q;

	for (int i = 0; i < n; i++) {
		us[i] = 0;
		cur[i] = INF;
	}
	u = find(u);
	q.push(u);
	us[u] = 1;

	while (!q.empty()) {
		ll v = q.front();
		q.pop();
		cur[v] = min(cur[v], val[v]);
		for (auto to : tree[v]) {
			if (to.first != prt[v]) {
				prt[to.first] = v;
				cur[to.first] = min(cur[to.first], min(cur[v], to.second));
			}
			if (!us[to.first]) {
				us[to.first] = 1;
				q.push(to.first);
			}
		}
	}

}

ll tin[SZ], tout[SZ], t = 0, dp[SZ];
bool used[SZ];
set<pair<int, int>> st;

void find_bridges(int v, int par = -1) {
	t++;
	tin[v] = t;
	dp[v] = tin[v];
	used[v] = 1;

	for (auto to : gr[v]) {
		if (!used[to.first]) {
			find_bridges(to.first, v);
			dp[v] = min(dp[v], dp[to.first]);
			if (dp[to.first] > dp[v]) {
				st.insert({ to.first, v });
			}
		}
		else if (to.first != par) {
			dp[v] = min(dp[v], dp[to.first]);
		}
	}

	t++;
	tout[v] = t;
}

bool u2[SZ];
void unit(int v, int col) {
	u2[v] = 1;

	uni(v, col);
	for (auto to : gr[v]) {
		if (!u2[to.first]) unit(to.first, col);
	}
}

map<pair<ll, ll>, ll> cnt;
signed main() {
	fastInp;

	cin >> n >> m;

	gr.resize(n);
	vector<tuple<ll, ll, ll>> e;
	for (int i = 0; i < m; i++) {
		ll u, v, t;
		cin >> u >> v >> t;
		u--; v--;
		e.push_back({ t, v, u });
	}

	for (int i = 0; i < n; i++) ans[i] = INF;
	sort(e.begin(), e.end());

	for (int i = 0; i < e.size(); i++) {
		ll u = get<2>(e[i]), v = get<1>(e[i]);
		if (u > v) swap(u, v);

		cnt[{u, v}]++;
		gr.clear();
		gr.resize(n);
		tree.clear();
		tree.resize(n);

		for (int j = 0; j <= i; j++) {
			ll u = get<2>(e[j]), v = get<1>(e[j]), t = get<0>(e[j]);
			gr[u].push_back({ v, t });
			gr[v].push_back({ u, t });
		}

		for (int i = 0; i < n; i++) {
			used[i] = 0;
			tin[i] = 0;
			tout[i] = 0;
			dp[i] = INF;
			val[i] = INF;
			par[i] = 0;
			u2[i] = 0;
			par[i] = i;
			t = 0;
		}

		vector<pair<ll, ll>> bad;
		st.clear();
		find_bridges(0);

		gr.clear();
		gr.resize(n);

		for (auto c : st) {
			if (cnt.find(c) != cnt.end()) {
				if (cnt[c] > 1) bad.push_back(c);
			}
			else if (cnt.find(make_pair(c.second, c.first)) != cnt.end()) {
				if (cnt[(make_pair(c.second, c.first))] > 1) bad.push_back(c);
			}
		}

		for (auto c : bad) {
			st.erase(c);
		}
		for (int j = 0; j <= i; j++) {
			ll u = get<2>(e[j]), v = get<1>(e[j]), t = get<0>(e[j]);

			if (st.find(make_pair(u, v)) == st.end() && st.find(make_pair(v, u)) == st.end()) {
				gr[u].push_back({ v, t });
				gr[v].push_back({ u, t });
			}
		}

		for (int i = 0; i < n; i++) {
			if (!u2[i]) unit(i, i);
		}

		tree.clear();
		tree.resize(n);
		for (int j = 0; j <= i; j++) {
			ll u = get<2>(e[j]), v = get<1>(e[j]), t = get<0>(e[j]);

			if (st.find(make_pair(u, v)) != st.end() || st.find(make_pair(v, u)) != st.end()) {
				tree[find(u)].push_back({ find(v), t });
				tree[find(v)].push_back({ find(u), t });
			}
			else {
				val[find(u)] = min(val[find(u)], t);
			}
		}

		dfs2(0);
		ll tt = i;
		for (int i = 0; i < n; i++) ans[i] = min(ans[i], cur[find(i)] + get<0>(e[tt]));
	}

	for (int i = 1; i < n; i++) cout << ans[i] << "\n";

	return 0;
}

/*
4 4
1 2 2
3 2 0
2 4 3
4 3 1

3 3
1 2 2
1 3 1
2 3 1

7 10
1 2 2
1 2 8
2 3 3
3 4 5
3 5 4
4 5 4
6 5 7
6 4 4
1 7 6
6 7 9
*/