#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <algorithm>

using namespace std;
#define int long long
#define mp make_pair
const int SZ = 1e5 + 4;
const int inf = 2e18;

string s;

void read() {
    cin >> s;
}

int dp[SZ][26];
int p[SZ][26];

void solve() {
    map<char, int> m;
    m['A'] = 1;
    for (char i = 'B'; i <= 'Z'; ++i) {
        if (i & 1) {
            m[i] = m[i - 1] * 2;
        } else {
            m[i] = m[i - 1] * 5;
        }
    }

    reverse(s.begin(), s.end());

    int n = s.size();
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j < 26; ++j) {
            dp[i][j] = -inf;
        }
    }

    if (s[0] == '?') {
        for (int i = 0; i < 26; ++i) {
            dp[0][i] = m['A' + i];
        }
    } else {
        dp[0][s[0] - 'A'] = m[s[0]];
    }
    for (int i = 1; i < n; ++i) {
        if (s[i] == '?') {
            for (char c = 'A'; c <= 'Z'; ++c) {
                for (char x = 'A'; x <= c; ++x) {
                    if (dp[i - 1][x - 'A'] != -inf) {
                        int tmp = dp[i - 1][x - 'A'] + m[c];
                        if (dp[i][c - 'A'] < tmp) {
                            dp[i][c - 'A'] = tmp;
                            p[i][c - 'A'] = x - 'A';
                        }
                    }
                }
            }
        } else {
            for (char c = 'A'; c <= s[i]; ++c) {
                if (dp[i - 1][c - 'A'] != -inf) {
                    int tmp = dp[i - 1][c - 'A'] + m[s[i]];
                    if (dp[i][s[i] - 'A'] < tmp) {
                        dp[i][s[i] - 'A'] = tmp;
                        p[i][s[i] - 'A' ] = c - 'A';
                    }
                }
            }
            for (char c = s[i] + 1; c <= 'Z'; ++c) {
                if (dp[i - 1][c - 'A'] != -inf) {
                    dp[i][c - 'A'] = dp[i - 1][c - 'A'] - m[s[i]];
                    p[i][c - 'A'] = c - 'A';
                }
            }
        }
    }

    int x = 0;
    for (int i = 0; i < 26; ++i) {
        if (dp[n - 1][i] > dp[n - 1][x]) x = i;
    }

    int ans = dp[n - 1][x];

    for (int i = n - 1; i >= 0; --i) {
        if (s[i] == '?') {
            s[i] = 'A' + x;
        }
        x = p[i][x];
    }

    reverse(s.begin(), s.end());

    cout << ans << "\n" << s << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t;
    cin >> t;
    while (t--) {
        read();
        solve();
    }

    return 0;
}
