//#pragma GCC optimize("Ofast")

#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <algorithm>
#include <cassert>
#include <queue>

//const int MAX_MEM = 1e9;
//char MEM[MAX_MEM];
//int m_pos = 0;
//
//void* operator new(size_t n) {
//    assert((m_pos += n) <= MAX_MEM);
//    return (void*) (MEM + m_pos - n);
//}
//
//void operator delete(void*) {}

using namespace std;
#define int long long
#define mp make_pair
const int SZ = 3e5 + 4;
const int inf = 2e18;

int n, m;
vector<set<int>> g;
set<pair<int, int>> e;

void read() {
    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        e.insert({u, v});
    }
}

vector<pair<int, int>> rm;
vector<pair<pair<int, int>, pair<int, int>>> ans;

int sz[SZ];

void getsz(int u, int p = -1) {
    sz[u] = 0;
    for (int v : g[u]) {
        if (v == p) continue;
        getsz(v, u);
        sz[u] += sz[v];
        sz[u] += e.count({u, v});
        sz[u] += e.count({v, u});
    }
}

pair<int, int> down(int u, int p = -1) {
    for (int v : g[u]) {
        if (v == p) continue;
        if (e.count({u, v}) && !e.count({v, u})) {
            if (!(sz[v] & 1)) {
                return mp(u, v);
            }
        }
    }

    for (int v : g[u]) {
        if (v == p) continue;
        if (e.count({u, v}) && e.count({v, u})) {
            return mp(u, v);
        }
    }

    return {-1, -1};
}

pair<int, int> up(int u, int p = -1) {
    for (int v : g[u]) {
        if (v == p) continue;
        if (e.count({v, u}) && !e.count({u, v})) {
            if (!(sz[v] & 1)) {
                return mp(v, u);
            }
        }
    }

    for (int v : g[u]) {
        if (v == p) continue;
        if (e.count({u, v}) && e.count({v, u})) {
            return mp(v, u);
        }
    }

    return {-1, -1};
}

void no() {
    cout << "No\n";
    exit(0);
}

bool dfs(int u, int p = -1) {
    for (int v : g[u]) {
        if (v == p) continue;
        if (e.count({u, v}) && e.count({v, u})) {
            if (dfs(v, u)) return true;
        } else {
            if (e.count({u, v})) {
                if (sz[v] & 1) {
                    auto p = down(v, u);
                    if (p.first == -1) no();
                    ans.emplace_back(mp(u, v), p);
                    rm.emplace_back(u, v);
                    rm.emplace_back(p);
                    return true;
                } else {
                    getsz(u);
                    auto p = up(u, v);
                    if (p.first == -1) no();
                    ans.emplace_back(p, mp(u, v));
                    rm.emplace_back(u, v);
                    rm.emplace_back(p);
                    return true;
                }
            } else {
                if (sz[v] & 1) {
                    auto p = up(v, u);
                    if (p.first == -1) no();
                    ans.emplace_back(p, mp(v, u));
                    rm.emplace_back(v, u);
                    rm.emplace_back(p);
                    return true;
                } else {
                    getsz(u);
                    auto p = down(u, v);
                    if (p.first == -1) no();
                    ans.emplace_back(mp(v, u), p);
                    rm.emplace_back(v, u);
                    rm.emplace_back(p);
                    return true;
                }
            }
        }
    }

    return false;
}


bool suka[SZ];

void paint(int u, int p = -1, bool z = true) {
    suka[u] = z;
    for (int v : g[u]) {
        if (v == p) continue;
        paint(v, u, !z);
    }
}

void solve() {
    vector<set<int>> g1(n);
    vector<set<int>> g2(n);
    set<pair<int, int>> e1;
    set<pair<int, int>> e2;
    for (auto [u, v] : e) {
        if (suka[v]) {
            g1[u].insert(v);
            g1[v].insert(u);
            e1.insert({u, v});
        } else {
            g2[u].insert(v);
            g2[v].insert(u);
            e2.insert({u, v});
        }
    }


    g = g1;
    e = e1;


    {
        set<int> s;
        for (int i = 0; i < n; ++i) {
            s.insert(i);
        }

        getsz(0);
        while (!s.empty() && dfs(*s.begin())) {
            for (auto[u, v] : rm) {
                e.erase({u, v});
                if (!e.count({v, u})) {
                    g[u].erase(v);
                    g[v].erase(u);
                    if (g[u].size() == 0) {
                        s.erase(u);
                    }
                    if (g[v].size() == 0) {
                        s.erase(v);
                    }
                }
            }
            rm.clear();
            getsz(0);
        }

        while (!e.empty()) {
            if (!e.count({e.begin()->second, e.begin()->first})) no();
            ans.emplace_back(mp(e.begin()->second, e.begin()->first), mp(e.begin()->first, e.begin()->second));
            e.erase({e.begin()->second, e.begin()->first});
            e.erase(e.begin());
        }
    }

    g = g2;
    e = e2;

    {
        set<int> s;
        for (int i = 0; i < n; ++i) {
            s.insert(i);
        }

        getsz(0);
        while (!s.empty() && dfs(*s.begin())) {
            for (auto[u, v] : rm) {
                e.erase({u, v});
                if (!e.count({v, u})) {
                    g[u].erase(v);
                    g[v].erase(u);
                    if (g[u].size() == 0) {
                        s.erase(u);
                    }
                    if (g[v].size() == 0) {
                        s.erase(v);
                    }
                }
            }
            rm.clear();
            getsz(0);
        }

        while (!e.empty()) {
            if (!e.count({e.begin()->second, e.begin()->first})) no();
            ans.emplace_back(mp(e.begin()->second, e.begin()->first), mp(e.begin()->first, e.begin()->second));
            e.erase({e.begin()->second, e.begin()->first});
            e.erase(e.begin());
        }
    }

    if (ans.size() * 2 < m) no();
    cout << "Yes\n";
    for (int i = 0; i * 2 < m; ++i) {
        cout << ans[i].first.first + 1 << " " << ans[i].first.second + 1 << " " << ans[i].second.first + 1 << " " << ans[i].second.second + 1 << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    read();
    solve();

    return 0;
}