#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;
#define int long long
#define mp make_pair
const int SZ = 3e5 + 4;
const int inf = 2e18;

int n, m;
vector<pair<int, pair<int, int>>> e;

void read() {
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;
        --u, --v;

        e.emplace_back(t, mp(u, v));
    }
}

int p[SZ];
int r[SZ];

int find(int u) {
    if (p[u] == u) return u;
    return p[u] = find(p[u]);
}

void unite(int u, int v) {
    u = find(u);
    v = find(v);

    if (r[u] > r[v]) {
        p[v] = u;
    } else {
        p[u] = v;
        r[v] += r[u] == r[v];
    }
}

void solve() {
    sort(e.begin(), e.end());
    for (int i = 0; i < n; ++i) {
        p[i] = i;
        r[i] = 1;
    }

    int cnt = 0;
    int mn = inf;

    for (int i = 0; i < e.size() && cnt < n - 1; ++i) {
        int u = find(e[i].second.first);
        int v = find(e[i].second.second);

        if (u == v) continue;
        unite(u, v);

        ++cnt;
        mn = min(mn, e[i].first);
    }

    assert(cnt == n - 1);

    for (int i = 1; i < n; ++i) {
        cout << mn + 1000000000 << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    read();
    solve();

    return 0;
}
