#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;
#define int long long
#define mp make_pair
const int SZ = 3e5 + 4;
const int inf = 2e18;

int n, m;
vector<pair<int, int>> g[SZ];

void read() {
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;
        --u, --v;

        g[u].emplace_back(v, t);
        g[v].emplace_back(u, t);
    }
}

int ans[SZ];

void dfs(int u, int mn = inf, int mx = -inf, int p = -1) {
    ans[u] = mn + mx;
    for (auto [v, w] : g[u]) {
        if (v == p) continue;
        dfs(v, min(mn, w), max(mx, w), u);
    }
}

void solve() {
    dfs(0);
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    read();
    solve();

    return 0;
}
