#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <random>
#include <iomanip>
#include <fstream>
#include <queue>
#include <numeric>
#include <deque>
#include <set>
#include <map>
#include <ctime>
// #pragma GCC optimize("Ofast,O2,O3")
// #define int long long
using namespace std;
typedef long long ll;
typedef long double ld;
const int inf = 1e9 + 7;
const ll l_inf = (ll)inf * (ll)inf;
const ld eps = 1e-6;
const int MAXN = 3e5;
vector<int> P, R;
vector<vector<int>> G;


void setup(int n) {
    P.resize(n);
    iota(P.begin(), P.end(), 0);
    R.assign(n, 1);
    G.resize(n);
}


int get_root(int v) {
    if (P[v] == v) {
        return v;
    }
    return get_root(P[v]);
}


bool unite(int a, int b) {
    a = get_root(a);
    b = get_root(b);
    if (a == b) {
        return false;
    }
    if (R[a] < R[b]) {
        swap(a, b);
    }
    R[a] += R[b];
    P[b] = a;
    G[a].push_back(b);
    return true;
}


vector<int> res(MAXN);


void update(int v, int val) {
    res[v] = val;
    for (int u : G[v]) {
        update(u, val);
    }
}


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    int n, m;
    cin >> n >> m;
    setup(n);
    vector<tuple<int, int, int>> E(m);
    for (int i = 0; i < m; ++i) {
        int a, b, t;
        cin >> a >> b >> t;
        --a;
        --b;
        E[i] = make_tuple(t, a, b);
    }
    sort(E.begin(), E.end());
    for (auto [t, a, b] : E) {
        if (get_root(a) == get_root(b)) {
            continue;
        }
        if (get_root(0) == get_root(a)) {
            update(get_root(b), t);
        }
        if (get_root(0) == get_root(b)) {
            update(get_root(a), t);
        }
        unite(a, b);
    }
    //
    for (int v = 1; v < n; ++v) {
        cout << res[v] << "\n";
    }
    cerr << 1.0 * clock() / CLOCKS_PER_SEC << "\n";
    return 0;
}