#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define size(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

int str = 0;

int n, q;
vector<int> x, h;
vector<vector<int> > req;
vector<int> ans;

int bl = 700;

bool cmp(vector<int> &a, vector<int> &b) {
    if (a[0] / bl < b[0] / bl) return true;
    if (a[0] / bl > b[0] / bl) return false;
    if (a[1] < b[1]) return true;
    return false;
}

int fn(int ri, stack<int> &st, int lft, vector<int> &mn) {
    int l = ri - 1, r = size(st);
    while (l + 1 < r) {
        int mid = (l + r) / 2;
        if (mn[mid] < lft) r = mid;
        else l = mid;
    }
    return r;
}

vector<int> slow(int n, int q, vector<int> x, vector<int> h, vector<vector<int> > req) {
    vector<int> ans(q);
    for (int pq = 0; pq < q; ++pq) {
        int a = req[pq][0], b = req[pq][1];
        --a, --b;
        stack<int> st;

        for (int i = a; i <= b; ++i) {
            while (!st.empty()) {
                int v = st.top();
                if (x[v] + h[v] <= x[i]) {
                    st.pop();
                } else break;
            }
            int le = x[0];
            if (a != 0) le = x[a - 1];
            if (!st.empty()) le = x[st.top()];
            if (le + h[i] > x[i]) st.push(i);
        }
        int ri = x[n - 1];
        if (b != n - 1) ri = x[b + 1];
        while (!st.empty()) {
            int v = st.top();
            if (x[v] + h[v] <= ri) {
                st.pop();
            } else break;
        }
        ans[pq] = b - a + 1 - size(st);
    }
    return ans;

}

vector<int> fast(int n, int q, vector<int> x, vector<int> h, vector<vector<int> > req) {
    vector<int> ans(q);
    for (int i = 0; i < q; ++i) {
        req[i][0]--;
    }
    sort(all(req), cmp);

    stack<int> st;
    vector<int> pos(n, 0);
    vector<int> mn(n, 1e9);

    int l = bl, r = bl;
    int curbl = 0;
    for (int i = 0; i < q; ++i) {
        int a = req[i][0], b = req[i][1];
        if (a / bl != curbl) {
            while (!st.empty()) st.pop();
            l = (a / bl + 1) * bl;
            r = (a / bl + 1) * bl;
        }

        while (r < req[i][1]) {
            while (!st.empty()) {
                int v = st.top();
                if (x[v] + h[v] <= x[r]) {
                    st.pop();
                } else break;
            }
            int le = x[0];
            if (l > 0) le = x[l - 1];
            if (!st.empty()) le = x[st.top()];
            if (le + h[r] > x[r]) {
                mn[size(st)] = x[r] - h[r];
                if (size(st) != 0) mn[size(st)] = min(mn[size(st) - 1], mn[size(st)]);
                pos[size(st)] = x[r];
                st.push(r);
            }
            r++;
        }
        int ri = x[n - 1];
        if (b != n) ri = x[b];
        while (!st.empty()) {
            int v = st.top();
            if (x[v] + h[v] <= ri) {
                st.pop();
            } else break;
        }

        stack<int> lft_st;
        for (int j = a; j < min(b, l); ++j) {
            while (!lft_st.empty()) {
                int v = lft_st.top();
                if (x[v] + h[v] <= x[j]) {
                    lft_st.pop();
                } else break;
            }
            int le = x[0];
            if (a != 0) le = x[a - 1];
            if (!lft_st.empty()) le = x[lft_st.top()];
            if (le + h[j] > x[j]) {
                lft_st.push(j);
            }
        }

        ri = 0;
        while (true) {
            bool ch = false;

            int lft = x[0];
            if (a != 0) lft = x[a - 1];
            if (!lft_st.empty()) lft = x[lft_st.top()];
            ri = fn(ri, st, lft, mn);

            if (!lft_st.empty()) {
                int v = lft_st.top();
                int rgh = x[n - 1];
                if (b != n) rgh = x[b];
                if (ri != size(st)) rgh = pos[ri];
                if (x[v] + h[v] <= rgh) {
                    lft_st.pop();
                    ch = true;
                }
            }

            if (!ch) break;
        }

        ans[req[i][2]] = b - a - size(lft_st) - (size(st) - ri);
    }

    return ans;
}

signed main() {
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    if (str == 1) {
        for (int i = 0; i < 1000; ++i) {
            mt19937 rnd(i);
            n = 10, q = 10;
            x.resize(n), h.resize(n);
            for (int j = 0; j < n; ++j) {
                x[j] = 1 + rnd() % 20;
                if (j != 0) x[j] += x[j - 1];
                h[j] = 1 + rnd() % 20;
            }
            req.resize(q);
            for (int j = 0; j < q; ++j) {
                int l = rnd() % n, r = rnd() % n;
                if (l > r) swap(l, r);
                req[j] = {l + 1, r + 1, j};
            }

            auto one = fast(n, q, x, h, req);
            auto two = slow(n, q, x, h, req);
            for (int j = 0; j < q; ++j) {
                if (one[j] != two[j]) {
                    cout << n << " " << q << "\n";
                    for (int k = 0; k < n; ++k) {
                        cout << x[k] << " " << h[k] << "\n";
                    }
                    for (int k = 0; k < q; ++k) {
                        cout << req[k][0] << " " << req[k][1] << "\n";
                    }
                    for (int k = 0; k < q; ++k) {
                        cout << one[k] << " ";
                    }
                    cout << "\n";
                    for (int k = 0; k < q; ++k) {
                        cout << two[k] << " ";
                    }
                    exit(0);
                }
            }
        }
        exit(0);
    }

    cin >> n >> q;
    x.resize(n), h.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> h[i];
    }

    ans.resize(q);
    for (int i = 0; i < q; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        req.push_back({a, b, i});
    }

    sort(all(req), cmp);

    stack<int> st;
    vector<int> pos(n, 0);
    vector<int> mn(n, 1e9);

    int l = bl, r = bl;
    int curbl = 0;
    for (int i = 0; i < q; ++i) {
        int a = req[i][0], b = req[i][1];
        if (a / bl != curbl) {
            while (!st.empty()) st.pop();
            l = (a / bl + 1) * bl;
            r = (a / bl + 1) * bl;
        }

        while (r < req[i][1]) {
            while (!st.empty()) {
                int v = st.top();
                if (x[v] + h[v] <= x[r]) {
                    st.pop();
                } else break;
            }
            int le = x[0];
            if (l > 0) le = x[l - 1];
            if (!st.empty()) le = x[st.top()];
            if (le + h[r] > x[r]) {
                mn[size(st)] = x[r] - h[r];
                if (size(st) != 0) mn[size(st)] = min(mn[size(st) - 1], mn[size(st)]);
                pos[size(st)] = x[r];
                st.push(r);
            }
            r++;
        }
        int ri = x[n - 1];
        if (b != n) ri = x[b];
        while (!st.empty()) {
            int v = st.top();
            if (x[v] + h[v] <= ri) {
                st.pop();
            } else break;
        }

        stack<int> lft_st;
        for (int j = a; j < min(b, l); ++j) {
            while (!lft_st.empty()) {
                int v = lft_st.top();
                if (x[v] + h[v] <= x[j]) {
                    lft_st.pop();
                } else break;
            }
            int le = x[0];
            if (a != 0) le = x[a - 1];
            if (!lft_st.empty()) le = x[lft_st.top()];
            if (le + h[j] > x[j]) {
                lft_st.push(j);
            }
        }

        ri = 0;
        while (true) {
            bool ch = false;

            int lft = x[0];
            if (a != 0) lft = x[a - 1];
            if (!lft_st.empty()) lft = x[lft_st.top()];
            ri = fn(ri, st, lft, mn);

            if (!lft_st.empty()) {
                int v = lft_st.top();
                int rgh = x[n - 1];
                if (b != n) rgh = x[b];
                if (ri != size(st)) rgh = pos[ri];
                if (x[v] + h[v] <= rgh) {
                    lft_st.pop();
                    ch = true;
                }
            }

            if (!ch) break;
        }

        ans[req[i][2]] = b - a - size(lft_st) - (size(st) - ri);
    }

    for (int i = 0; i < q; ++i) {
        cout << ans[i] << "\n";
    }
}