#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

const long long inf = 1e15;

void dfs(int v, vector < vector < pair < int, long long > > >& g,
	vector < pair < long long, long long > >& f, int prev = -1) {
	for (auto to : g[v]) {
		if (to.first == prev) continue;
		f[to.first] = f[v];
		f[to.first].first = min(f[to.first].first, to.second);
		f[to.first].second = max(f[to.first].second, to.second);
		dfs(to.first, g, f, v);
	}
	return;
}

void uwu(int n, int m, vector < vector < pair < int, long long > > >& g) {
	vector < pair < long long, long long > > f(n);
	f[0] = { inf, 0 };
	dfs(0, g, f);
	for (int i = 1; i < n; i++) cout << f[i].first + f[i].second << "\n";
	return;
}

int main()
{
	int n, m;
	cin >> n >> m;

	vector < vector < pair < int, long long > > > g(n);
	int v, u;
	long long t;
	for (int i = 0; i < m; i++) {
		cin >> v >> u >> t;
		v--; u--;
		g[v].push_back({ u, t });
		g[u].push_back({ v, t });
	}

	if (m == n - 1) {
		uwu(n, m, g);
		return 0;
	}

	vector < long long > dist(n, inf);
	dist[1] = 0;
	set < pair < long long, int > > se;
	for (int i = 0; i < n; i++)
		se.insert({ dist[i], i });
	while (se.size()) {
		int v = se.begin()->second;
		se.erase(se.begin());
		for (auto to : g[v]) {
			long long val = max(dist[v], to.second);
			if (val < dist[to.first]) {
				se.erase({ dist[to.first], to.first });
				dist[to.first] = val;
				se.insert({ dist[to.first], to.first });
			}
		}
	}

	for (int i = 1; i < n; i++) {
		cout << dist[i] << "\n";
	}
}