#include <map>
#include <set>
#include <deque>
#include <vector>
#include <cstdio>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

const int MAXN = 500500;
const int K = 437;

int x[MAXN];
int h[MAXN];

struct kek{
  deque<int> rest;
  int ll, rr;
  vector<pair<int, int>> history;
  kek (int _ll, int _rr) {
    ll = _ll;
    rr = _rr;
  }
  void push_back() {
    history.emplace_back(2, rr);
    rest.emplace_back(rr);
    ++rr;
    while (!rest.empty()) {
      if (x[rest.back()] + h[rest.back()] <= x[rr]) {
        history.emplace_back(-2, rest.back());
        rest.pop_back();
      } else if (x[rest.back()] - h[rest.back()] >= (rest.size() == 1 ? x[ll - 1] : rest[rest.size() - 2])) {
        history.emplace_back(-2, rest.back());
        rest.pop_back();
      } else {
        break;
      }
    }
  }
  void push_front() {
    --ll;
    history.emplace_back(1, ll);
    rest.emplace_front(ll);
    while (!rest.empty()) {
      if (x[rest.front()] - h[rest.front()] >= x[ll - 1]) {
        history.emplace_back(-1, rest.front());
        rest.pop_front();
      } else if (x[rest.back()] + h[rest.back()] <= (rest.size() == 1 ? x[rr] : rest[1])) {
        history.emplace_back(-1, rest.front());
        rest.pop_front();
      } else {
        break;
      }
    }
  }
  int get() {
    return rr - ll - (int) rest.size();
  }
  void rollback(int sz = 0) {
    while (history.size() > sz) {
      if (history.back().first == 1) {
        rest.pop_front();
      } else if (history.back().first == -1) {
        rest.push_front(history.back().second);
      } else if (history.back().first == 2) {
        rest.pop_back();
      } else {
        rest.push_back(history.back().second);
      }
      history.pop_back();
    }
  }
};

int ans[MAXN];
vector<pair<int, pair<int, int>>> buckets[(MAXN + K - 1) / K];

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n, q;
  cin >> n >> q;
  for (int i = 1; i <= n; ++i)
    cin >> x[i] >> h[i];
  x[0] = x[1];
  x[n + 1] = x[n];
  kek lol(0, 0);
  for (int i = 0; i < q; ++i) {
    int l, r;
    cin >> l >> r;
    if (l / K == r / K) {
      lol.ll = l;
      lol.rr = l;
      for (int i = l; i <= r; ++i)
        lol.push_back();
      ans[i] = lol.get();
      lol.rollback();
    } else {
      buckets[l / K].emplace_back(r, make_pair(l, i));
    }
  }
  for (int i = 0; i * K <= n; ++i) {
    sort(buckets[i].begin(), buckets[i].end());
    lol.ll = (i + 1) * K;
    lol.rr = (i + 1) * K;
    for (auto query : buckets[i]) {
      while (lol.rr <= query.first)
        lol.push_back();
      int tmp = lol.history.size();
      while (lol.ll > query.second.first)
        lol.push_front();
      ans[query.second.second] = lol.get();
      lol.rollback(tmp);
    }
    lol.rollback();
  }
  for (int i = 0; i < q; ++i)
    cout << ans[i] << '\n';
  return 0;
}
