#include <map>
#include <set>
#include <deque>
#include <vector>
#include <cstdio>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

const int MAXN = 500500;
const int K = 450;

int x[MAXN];
int h[MAXN];

struct kek{
  deque<int> rest;
  int ll, rr;
  vector<pair<int, int>> history;
  kek (int _ll, int _rr) {
    ll = _ll;
    rr = _rr;
  }
  void push_back() {
    history.emplace_back(2, rr);
    rest.emplace_back(rr);
    ++rr;
    while (!rest.empty()) {
      if (x[rest.back()] + h[rest.back()] <= x[rr]) {
        history.emplace_back(-2, rest.back());
        rest.pop_back();
      } else if (x[rest.back()] - h[rest.back()] >= (rest.size() == 1 ? x[ll - 1] : x[rest[rest.size() - 2]])) {
        history.emplace_back(-2, rest.back());
        rest.pop_back();
      } else {
        break;
      }
    }
  }
  void push_front() {
    --ll;
    history.emplace_back(1, ll);
    rest.emplace_front(ll);
    while (!rest.empty()) {
      if (x[rest.front()] - h[rest.front()] >= x[ll - 1]) {
        history.emplace_back(-1, rest.front());
        rest.pop_front();
      } else if (x[rest.front()] + h[rest.front()] <= (rest.size() == 1 ? x[rr] : x[rest[1]])) {
        history.emplace_back(-1, rest.front());
        rest.pop_front();
      } else {
        break;
      }
    }
  }
  int get() {
    return rr - ll - (int) rest.size();
  }
  void rollback(int sz = 0) {
    while (history.size() > sz) {
      if (history.back().first == 1) {
        rest.pop_front();
        ++ll;
      } else if (history.back().first == -1) {
        rest.push_front(history.back().second);
      } else if (history.back().first == 2) {
        rest.pop_back();
        --rr;
      } else {
        rest.push_back(history.back().second);
      }
      history.pop_back();
    }
  }
};

int n, q;
pair<int, int> queries[MAXN];
int ans1[MAXN];
vector<pair<int, pair<int, int>>> buckets[(MAXN + K - 1) / K];

void solve_smart() {
  x[0] = x[1];
  x[n + 1] = x[n];
  kek lol(0, 0);
  for (int i = 0; i < q; ++i) {
    int l = queries[i].first;
    int r = queries[i].second;
    if (l / K == r / K) {
      lol.ll = l;
      lol.rr = l;
      for (int j = l; j <= r; ++j)
        lol.push_back();
      ans1[i] = lol.get();
      lol.rollback();
    } else {
      buckets[l / K].emplace_back(r, make_pair(l, i));
    }
  }
  for (int i = 0; i * K <= n; ++i) {
    sort(buckets[i].begin(), buckets[i].end());
    lol.ll = (i + 1) * K;
    lol.rr = (i + 1) * K;
    for (auto query : buckets[i]) {
      while (lol.rr <= query.first)
        lol.push_back();
      int tmp = lol.history.size();
      while (lol.ll > query.second.first)
        lol.push_front();
      ans1[query.second.second] = lol.get();
      lol.rollback(tmp);
    }
    lol.rollback();
    buckets[i].clear();
  }
}

int ans2[MAXN];
const int MAXM = 5000;
bool dp[MAXM][MAXM];
int dp2[MAXM][MAXM];
int ll[MAXM];
int rr[MAXM];

void solve_dumb() {
  for (int i = 0; i < n; ++i)
    fill(dp[i], dp[i] + n, false);
  for (int i = 0; i < n; ++i) {
    ll[i] = upper_bound(x + 1, x + n + 1, x[i + 1] - h[i + 1]) - x - 1;
    rr[i] = lower_bound(x + 1, x + n + 1, x[i + 1] + h[i + 1]) - x - 2;
  }
  for (int i = 0; i < n; ++i) {
    if (x[i + 1] - h[i + 1] < x[1])
      ll[i] = -1;
    if (x[i + 1] + h[i + 1] > x[n])
      rr[i] = n;
  }
  for (int i = n - 1; i >= 0; --i) {
    dp[i][i] = (ll[i] == i || rr[i] == i);
    for (int j = i + 1; j < n; ++j) {
      if (dp[i + 1][j] && j >= rr[i]) {
        dp[i][j] = true;
        continue;
      }
      if (dp[i][j - 1] && i <= ll[j]) {
        dp[i][j] = true;
        continue;
      }
      for (int k = i + 1; k < j; ++k) {
        if (dp[i][k - 1] && dp[k + 1][j] && (j >= rr[k] || i <= ll[k])) {
          dp[i][j] = true;
          break;
        }
      }
    }
  }
  for (int i = n - 1; i >= 0; --i) {
    for (int j = i; j < n; ++j) {
      if (dp[i][j]) {
        dp2[i][j] = j - i + 1;
        continue;
      }
      dp2[i][j] = 0;
      for (int k = j; k >= i; --k) {
        if ((k == j || dp[k + 1][j]))
          dp2[i][j] = max(dp2[i][j], (k == i ? 0 : dp2[i][k - 1]) + j - k);
      }
    }
  }
  for (int i = 0; i < q; ++i)
    ans2[i] = dp2[queries[i].first - 1][queries[i].second - 1];
}

void gen() {
  n = rand() % 7 + 2;
  x[1] = 0;
  for (int i = 2; i <= n; ++i)
    x[i] = rand() % 6 + x[i - 1] + 1;
  for (int i = 1; i <= n; ++i)
    h[i] = rand() % 8 + 1;
  q = n * (n + 1) / 2;
  for (int i = 0; i < n; ++i) {
    for (int j = i; j < n; ++j)
      queries[i * (2 * n - i + 1) / 2 + j - i] = make_pair(i + 1, j + 1);
  }
}

//#define STRESS

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

#ifdef STRESS
  srand(time(0));
  for (int _ = 0; _ < 100000; ++_) {
    gen();
    solve_smart();
    solve_dumb();
    bool ok = true;
    for (int i = 0; i < q; ++i) {
      if (ans1[i] != ans2[i])
        ok = false;
    }
    if (!ok) {
      cerr << "BUG!!\n";
      cerr << n << ' ' << q << '\n';
      for (int i = 1; i <= n; ++i)
        cerr << x[i] << ' ' << h[i] << '\n';
      for (int i = 0; i < q; ++i)
        cerr << queries[i].first << ' ' << queries[i].second << '\n';
      cerr << '\n';
      cerr << "wrong: ";
      for (int i = 0; i < q; ++i)
        cerr << ans1[i] << ' ';
      cerr << '\n';
      cerr << "right: ";
      for (int i = 0; i < q; ++i)
        cerr << ans2[i] << ' ';
      cerr << '\n';
      cerr << '\n';
    }
  }
#else
  cin >> n >> q;
  for (int i = 1; i <= n; ++i)
    cin >> x[i] >> h[i];
  for (int i = 0; i < q; ++i)
    cin >> queries[i].first >> queries[i].second;
  solve_smart();
  for (int i = 0; i < q; ++i)
    cout << ans1[i] << '\n';
#endif
  return 0;
}
