#include <map>
#include <set>
#include <deque>
#include <vector>
#include <cstdio>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

const int INF = 1e9;
const int MAXN = 300000;

vector<int> G[MAXN];

map<int, int> dp[MAXN];

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n, m;
  cin >> n >> m;
  for (int i = 0; i < m; ++i) {
    int a, b, c;
    cin >> a >> b >> c;
    G[min(a, b) - 1].emplace_back(c);
  }
  dp[0][INF] = 0;
  for (int i = 0; i + 1 < n; ++i) {
    for (auto t1 : dp[i]) {
      for (int x : G[i]) {
        int mn = min(t1.first, x);
        int mx = max(t1.second, x);
        if (!dp[i + 1].count(mn))
          dp[i + 1][mn] = mx;
        else
          dp[i + 1][mn] = min(dp[i + 1][mn], mx);
      }
    }
  }
  for (int i = 1; i < n; ++i) {
    int ans = 2 * INF;
    for (auto t : dp[i])
      ans = min(ans, t.first + t.second);
    cout << ans << '\n';
  }
  return 0;
}
