#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <utility>
#include <deque>
using namespace std;
#define int long long
const int INF = 1e10;
struct base {
	int u, v, cost;
	base() { u = 0, v = 0, cost = 0; }
	base(int u, int v, int cost) : u(u), v(v), cost(cost) {};
};

class Dsu {
private:
	vector <int> p;
	vector <int> rank;
	int n;
	int get(int u) {
		return (p[u] == u ? u : p[u] = get(p[u]));
	}
public:
	Dsu(int n) {
		p.resize(n);
		rank.resize(n);
		for (int i = 0; i < n; ++i) {
			p[i] = i;
			rank[i] = 1;
		}
	}
	void unite(int u, int v) {
		u = get(u);
		v = get(v);
		if (rank[u] > rank[v]) {
			swap(u, v);
		}
		p[u] = v;
	}

	bool equals(int u, int v) {
		return get(u) == get(v);
	}
};

void solve() {
	int n, m;
	cin >> n >> m;
	vector <vector <base>> w(n);
	vector <base> eg(m);
	for (int i = 0; i < m; ++i) {
		int u, v, cost;
		cin >> u >> v >> cost;
		--u, --v;
		w[u].emplace_back(u, v, cost);
		w[v].emplace_back(v, u, cost);
		eg[i] = base(u, v, cost);
	}
	sort(eg.begin(), eg.end(), [](base lhs, base rhs) { return lhs.cost < rhs.cost; });
	vector <int> ans(n, INF);
	for (int mn = 0; mn < n; ++mn) {
		Dsu dsu(n);
		for (int mx = mn; mx < n; ++mx) {
			dsu.unite(eg[mx].u, eg[mx].v);
			int nowAns = eg[mx].cost + eg[mn].cost;
			for (int u : {eg[mx].u, eg[mx].v}) {
				if (dsu.equals(u, 0) && ans[u] > nowAns) {
					ans[u] = nowAns;
				}
			}
		}
	}
	for (int i = 1; i < n; ++i) {
		cout << ans[i] << "\n";
	}
}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
#endif;
	int test = 1;
	//cin >> test;
	while (test--) solve();
}