#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <utility>
#include <deque>
using namespace std;
#define int long long
const int INF = 1e10;
struct base {
	int u, v, cost;
	base() { u = 0, v = 0, cost = 0; }
	base(int u, int v, int cost) : u(u), v(v), cost(cost) {};
};

int get(int u, vector <int>& p) {
	return p[u] == u ? u : p[u] = get(p[u], p);
}

void unite(int u, int v, vector <int>& p, vector <int>& sz, vector <vector <int>>& mnozh) {
	u = get(u, p);
	v = get(v, p);
	if (u == v) return;
	if (sz[u] > sz[v]) {
		swap(u, v);
	}
	p[u] = v;
	for (auto i : mnozh[u]) {
		mnozh[v].push_back(i);
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector <vector <base>> w(n);
	vector <base> eg(m);
	for (int i = 0; i < m; ++i) {
		int u, v, cost;
		cin >> u >> v >> cost;
		--u, --v;
		w[u].emplace_back(u, v, cost);
		w[v].emplace_back(v, u, cost);
		eg[i] = base(u, v, cost);
	}
	sort(eg.begin(), eg.end(), [](base lhs, base rhs) { return lhs.cost < rhs.cost; });
	vector <int> ans(n, INF);
	vector <int> p(n);
	vector <int> sz(n);
	vector <vector <int>> mnozh(n);
	for (int i = 0; i < n; ++i) {
		p[i] = i;
		sz[i] = 1;
		mnozh[i].push_back(i);
	}
	for (int mx = 0; mx < m; ++mx) {
		int u = eg[mx].u, v = eg[mx].v;
		int nowAns = eg[mx].cost;
		if (get(u, p) != 0 && get(v, p) != 0) {
			unite(u, v, p, sz, mnozh);
		}
		else if (get(u, p) == get(v, p)) {
			continue;
		}
		else if (get(u, p) == 0) {
			for (int i : mnozh[get(v, p)]) {
				ans[i] = nowAns;
			}
			unite(u, v, p, sz, mnozh);
		}
		else {
			for (int i : mnozh[get(u, p)]) {
				ans[i] = nowAns;
			}
			unite(u, v, p, sz, mnozh);
		}
	}
	for (int i = 1; i < n; ++i) {
		cout << ans[i] << "\n";
	}
}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
#endif;
	int test = 1;
	//cin >> test;
	while (test--) solve();
}