#include <iostream>
#include <vector>
//#include <random>
//#include <algorithm>
//#include <chrono>
#include <set>

using namespace std;

#define FOR(i, a, b) for(__typeof(b) i = (a); i < (b); ++i)
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

//#define int long long

typedef long long ll;
typedef long double ld;
typedef int32_t i32;
typedef pair<int, int> pii;
typedef vector<int> vi;

//mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

vector<vi> g, up;
vi h;

void dfs(int v, int p){
    up[v][0] = p;
    FOR(i, 1, 19){
        up[v][i] = up[up[v][i-1]][i-1];
    }
    for(int u : g[v]){
        if(u == p) continue;
        h[u] = h[v] + 1;
        dfs(u, v);
    }
}

int lca(int v, int u){
    if(h[v] > h[u]) swap(v, u);
    for(int i = 18; i >= 0; --i){
        if(h[u] - (1<<i) >= h[v]){
            u = up[u][i];
        }
    }
    if(v == u) return v;
    for(int i = 18; i >= 0; --i){
        if(up[v][i] != up[u][i]){
            v = up[v][i], u = up[u][i];
        }
    }
    return up[v][0];
}

void solve(){
    int n, m; cin >> n >> m;
    up.assign(n, vi(19));
    g.resize(n);
    h.assign(n, 0);
    vector<pair<int, int>> edges;
    set<pair<int, int>> remain;
    FOR(i, 0, m) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        if(remain.count({u, v})){
            remain.erase({u, v});
        }else{
            remain.emplace(v, u);
            edges.emplace_back(v, u);
            g[v].push_back(u);
            g[u].push_back(v);
        }
    }
    if(remain.empty()){
        cout << "Yes\n";
        for(auto [u, v] : edges){
            cout << u + 1 << ' ' << v + 1 << ' ' << v + 1 << ' ' << u + 1 << '\n';
        }
        return;
    }
    pair<int, int> e1 = *remain.begin();
    pair<int, int> e2 = *next(remain.begin());
    dfs(0, 0);
    int l = 0, d, p1, p2, p3, p4, k1, k2;
    int d1 = lca(e1.first, e2.first);
    int l1 = h[e1.first] + h[e2.first] - 2 * h[d1];
    if(l1 > l){
        d = d1;
        l = l1;
        p1 = e1.first;
        p2 = e1.second;
        p3 = e2.first;
        p4 = e2.second;
        k1 = 0;
        k2 = 0;
    }
    int d2 = lca(e1.first, e2.second);
    int l2 = h[e1.first] + h[e2.second] - 2 * h[d2];
    if(l2 > l){
        d = d2;
        l = l2;
        p1 = e1.first;
        p2 = e1.second;
        p3 = e2.second;
        p4 = e2.first;
        k1 = 0;
        k2 = 1;
    }
    int d3 = lca(e1.second, e2.first);
    int l3 = h[e1.second] + h[e2.first] - 2 * h[d3];
    if(l3 > l){
        d = d3;
        l = l3;
        p1 = e1.second;
        p2 = e1.first;
        p3 = e2.first;
        p4 = e2.second;
        k1 = 1;
        k2 = 0;
    }
    int d4 = lca(e1.second, e2.second);
    int l4 = h[e1.second] + h[e2.second] - 2 * h[d4];
    if(l4 > l) {
        d = d4;
        l = l4;
        p1 = e1.second;
        p2 = e1.first;
        p3 = e2.second;
        p4 = e2.first;
        k1 = 1;
        k2 = 1;
    }
    vi vs{d};
    while(p1 != d){
        vs.push_back(p1);
        p1 = up[p1][0];
    }
    while(p3 != d){
        vs.push_back(p3);
        p3 = up[p3][0];
    }
    set<pair<int, int>> used;
    FOR(i, 0, sz(vs)-1){
        used.emplace(vs[i], vs[i+1]);
        used.emplace(vs[i+1], vs[i]);
    }
    if(sz(vs) % 2 == 0){
        if(k1 != k2){
            cout << "No\n";
            return;
        }
        cout << "Yes\n";
        for(int i = 0; i != n - 2; i += 2){
            cout << vs[i] + 1 << ' ' << vs[i+1] + 1 << ' ' << vs[i+1] + 1 << ' ' << vs[i+2] + 1 << '\n';
        }
        for(int i = n-1; i != 1; i -= 2){
            cout << vs[i] + 1 << ' ' << vs[i-1] + 1 << ' ' << vs[i-1] + 1 << ' ' << vs[i-2] + 1 << '\n';
        }
    }else{
        if(k1 == k2){
            cout << "No\n";
            return;
        }
        cout << "Yes\n";
        for(int i = 0; i != n - 1; i += 2){
            cout << vs[i] + 1 << ' ' << vs[i+1] + 1 << ' ' << vs[i+1] + 1 << ' ' << vs[i+2] + 1 << '\n';
        }
        for(int i = n-2; i != 1; i -= 2){
            cout << vs[i] + 1 << ' ' << vs[i-1] + 1 << ' ' << vs[i-1] + 1 << ' ' << vs[i-2] + 1 << '\n';
        }
    }
    for(auto [u, v] : edges){
        if(used.count({u, v})) continue;
        cout << u + 1 << ' ' << v + 1 << ' ' << v + 1 << ' ' << u + 1 << '\n';
    }
}

i32 main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
//    int t; cin >> t; while(t--) solve();
}