#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

#define err(x) cerr << "["#x"]  " << (x) << '\n';
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n";

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template<typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// ::::::::::::::::::::::::::

const int C = 26;

ll prec[C];

inline ll cost(char x) {
    return prec[x - 'A'];
}

const ll INF = 3e18;

void solve() {
    string s;
    cin >> s;

    int n = s.size();
    vector<vector<ll>> dp(n + 1, vector<ll>(26, -INF));
    vector<vector<int>> from(n + 1, vector<int>(26, -1));
    dp[n][0] = 0;
    for (int i = n - 1; i >= 0; --i) {
        for (int j = 0; j < 26; ++j) {
            if (s[i] == '?') {
                for (int c = j; c < 26; ++c) {
//                    if (j > c) {
//                        if (strain(dp[i][j], dp[i + 1][j] - prec[c]))
//                            from[i][j] = j;
//                    }
//                    else {
                        if (strain(dp[i][c], dp[i + 1][j] + prec[c]))
                            from[i][c] = j;
//                    }
                }
            }
            else {
                if (j > s[i] - 'A') {
                    if (strain(dp[i][j], dp[i + 1][j] - prec[s[i] - 'A']))
                        from[i][j] = j;
                }
                else {
                    if (strain(dp[i][s[i] - 'A'], dp[i + 1][j] + prec[s[i] - 'A']))
                        from[i][s[i] - 'A'] = j;
                }
            }
        }
    }

    int cur = 0;
    for (int i = 1; i < 26; ++i)
        if (dp[0][i] > dp[0][cur])
            cur = i;
    cout << dp[0][cur] << '\n';
    string ans = "";
    for (int i = 0; i < n; ++i) {
        if (s[i] == '?') {
            ans += char(cur + 'A');
            cur = from[i][cur];
        }
        else {
            ans += s[i];
            cur = from[i][cur];
        }
    }
    cout << ans << '\n';
}

/*
4
BBBC
????
A?B?C?D
YYYYY?
*/

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr); cout.tie(nullptr);

    prec[0] = 1;
    for (int i = 1; i < C; ++i) {
        if (i % 2)
            prec[i] = prec[i - 1] * 5;
        else
            prec[i] = prec[i - 1] * 2;
    }

    int t = 1;
    cin >> t;
    while (t--)
        solve();
}

