#include <bits/stdc++.h>
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
#define FOR(i, n) for (int i = 0; i < (int)(n); ++i)
typedef long long ll;
const int N = 3e5 + 10, K = 26;
struct vertex
{
	int h, v;

	friend bool operator<(vertex a, vertex b) {
		if (a.h == b.h) {
			return a.v < b.v;
		}
		return a.h > b.h;
	}	
};
std::set<int> out[N], in[N];
std::set<vertex> outV[N], inV[N];

std::vector<int> cmp;
int used[N], pred[N], h[N];
void dfs(int v) {
	used[v] = 1;
	cmp.pb(v);
	for (auto e : out[v]) {
		if (!used[e]) {
			h[e] = h[v] + 1;
			dfs(e);
		}
	}
	for (auto e : in[v]) {
		if (!used[e]) {
			h[e] = h[v] + 1;
			dfs(e);
		}
	}
}
struct edge
{
	int a, b;
};
int main() {
	int n, m;
	std::cin >> n >> m;
	FOR(i, m) {
		int a, b;
		std::cin >> a >> b;
		--a; --b;
		out[a].insert(b);
		in[b].insert(a);
	}
	FOR(i, n) {
		if (!used[i]) {
			dfs(i);

		}
	}
	std::vector<int> vertexes(n);
	FOR(i, n) {
		for (auto e : out[i]) {
			outV[i].insert({h[e], e});
		}
		for (auto e : in[i]) {
			inV[i].insert({h[e], e});
		}
	}
	FOR(i, n) {
		vertexes[i] = i;
	}
	std::sort(vertexes.begin(), vertexes.end(), [&](int a, int b) {
		return h[a] > h[b];
	});
	std::vector<std::pair<edge, edge>> answ;
	auto del = [&](int a, int b) {
		outV[a].erase({h[b], b});
		inV[b].erase({h[a], a});
	};
	for (auto v : vertexes) {
		if (inV[v].size() == 0 && outV[v].size() == 0) continue; 
		if (inV[v].size() == 1 && outV[v].size() == 1) {
			edge e1 = {v, outV[v].begin()->v};
			edge e2 = {inV[v].begin()->v, v};
			answ.pb({e1, e2});
			del(e1.a, e1.b);
			del(e2.a, e2.b);
			continue;
		}
		else if (inV[v].size() == 1) {
			edge e2 = {inV[v].begin()->v, v};
			if (inV[e2.a].empty()) {
				std::cout << "No";
				return 0;
			}
			edge e1 = {inV[e2.a].begin()->v, e2.a};
			answ.pb({e1, e2});
			del(e1.a, e1.b);
			del(e2.a, e2.b);
			continue;
		}
		else if (outV[v].size() == 1) {
			edge e1 = {v, outV[v].begin()->v};
			if (outV[e1.b].empty()) {
				std::cout << "No";
				return 0;
			}
			edge e2 = {e1.b, outV[e1.b].begin()->v};
			answ.pb({e1, e2});
			del(e1.a, e1.b);
			del(e2.a, e2.b);
			continue;
		}
		// debug(inV[v].size() << ' ' << outV[v].size())
		assert(false);
	}
	std::cout << "Yes\n";
	for (auto e : answ) {
		std::cout << e.first.a + 1 << ' ' << e.first.b + 1 << ' ' 
				<< e.second.a + 1 << ' ' << e.second.b + 1 << '\n';
	}
}