#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<map>
#include<set>

using namespace std;

const long long INF = 4e18;

vector<vector<int>> g;
vector<int> top_sort, used;
vector<set<int>> in, out;
set<pair<int, int>> edges;
vector<pair<pair<int, int>, pair<int, int>>> ans;
void dfs(int v) {
	used[v] = 1;
	for (auto u : g[v]) {
		if (!used[u])
			dfs(u);
	}
	top_sort.push_back(v);

}

void hah(int v) {
	used[v] = 1;
	set<int> in_ch, out_ch;
	for (auto u : g[v]) {
		if (!used[u]) {
			hah(u);
			in_ch.insert(u);
			if (in[v].find(u) != in[v].end()) {
				out_ch.insert(u);
			}
		}
	}
	vector<pair<int, int>> in_edges, out_edges;
	for (auto ch : in_ch) {
		if (edges.find({ v, ch }) == edges.end()) {
			in_edges.push_back({ v, ch });
		}
	}
	for (auto ch : out_ch) {
		if (edges.find({ ch, v }) == edges.end()) {
			out_edges.push_back({ ch, v });
		}
	}
	while (!in_edges.empty() && !out_edges.empty()) {
		ans.push_back({ in_edges.back(), out_edges.back() });
		edges.insert(in_edges.back());
		edges.insert(out_edges.back());
		in[v].erase(out_edges.back().first);
		out[v].erase(in_edges.back().second);
		in_edges.pop_back();
		out_edges.pop_back();
	}

	while (!in_edges.empty() && !in[v].empty()) {
		ans.push_back({ { *in[v].begin(), v }, in_edges.back() });
		edges.insert(in_edges.back());
		edges.insert({ *in[v].begin(), v });
		out[*in[v].begin()].erase(v);
		in[v].erase(in[v].begin());
		in_edges.pop_back();
	}
	while (!out_edges.empty() && !out[v].empty()) {
		ans.push_back({ {v, *out[v].begin()}, out_edges.back() });
		edges.insert(out_edges.back());
		edges.insert({ v, *out[v].begin() });
		in[*out[v].begin()].erase(v);
		out[v].erase(out[v].begin());
		out_edges.pop_back();
	}
}
int main() {
	int n, m;
	cin >> n >> m;
	g.resize(n);
	in.resize(n);
	out.resize(n);
	for (int i = 0; i < m; ++i) {
		int v, u;
		cin >> v >> u;
		--v; --u;
		g[v].push_back(u);
		in[u].insert(v);
		out[v].insert(u);
	}
	used.assign(n, 0);
	for (int v = 0; v < n; ++v) {
		if (!used[v]) {
			dfs(v);
		}
	}
	reverse(top_sort.begin(), top_sort.end());
	used.assign(n, 0);
	for (auto v : top_sort) {
		if (!used[v]) {
			hah(v);
		}
	}
	if (edges.size() != m) {
		cout << "No";
	}
	else {
		cout << "Yes" << '\n';
		for (auto x : ans) {
			cout << x.first.first + 1 << ' ' << x.first.second + 1 << ' ' << x.second.first + 1 << ' ' << x.second.second + 1 << '\n';
		}
	}
}

//5 6
//1 2
//2 1 
//1 5
//2 3
//2 4
//4 2

//4 4
//2 1
//2 3
//2 4
//4 2

//4 4
//1 2
//2 1
//3 4
//4 3