#include <iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<map>

using namespace std;

vector<pair<long long, long long>> tree;
map<char, long long> m;

void build_tree(long long u, long long L, long long R, string& s) {
	if (R - L == 1) {
		if (s[L] == '?')
			tree[u] = { 0, L };
		else
			tree[u] = { m[s[L]], L };
		return;
	}
	long long M = (L + R) / 2;
	build_tree(2 * u + 1, L, M, s);
	build_tree(2 * u + 2, M, R, s);
	if (tree[2 * u + 1].first >= tree[2 * u + 2].first)
		tree[u] = tree[2 * u + 1];
	else
		tree[u] = tree[2 * u + 2];
}

pair<long long, long long> find_max(long long u, long long L, long long R, long long left, long long right) {
	if (left >= R || L >= right)
		return { -1, -1 };
	if (left <= L && R <= right)
		return tree[u];
	long long M = (L + R) / 2;
	auto f = find_max(2 * u + 1, L, M, left, right);
	auto s = find_max(2 * u + 2, M, R, left, right);
	if (f.first >= s.first)
		return f;
	else
		return s;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	m['A'] = 1;
	for (char i = 'B'; i <= 'Z'; ++i) {
		if (i % 2 == 'A' % 2)
			m[i] = m[i - 1] * 2;
		else
			m[i] = m[i - 1] * 5;
	}
	long long t;
	cin >> t;
	while (t--) {
		string s, ss;
		cin >> s;
		long long q = 0;
		for (long long i = 0; i < s.size(); ++i)
			if (s[i] == '?')
				++q;
		if (q == s.size()) {
			cout << m['Z'] * q << '\n';
			for (long long i = 0; i < q; ++i)
				cout << 'Z';
			cout << '\n';
			continue;
		}
		ss = s;
		long long n = s.size();
		tree.assign(4 * n, {-1, -1});
		build_tree(0, 0, n, s);
		long long ind = 0;
		vector<long long> ans1, ans2;
		vector<long long> blocks;
		ans1.reserve(n);
		ans2.reserve(n);
		blocks.reserve(n);
		while (ind < n) {
			auto [tr, en] = find_max(0, 0, n, ind, n);
			long long yes = 0;
			long long cnt = 0;
			for (long long i = ind; i < en; ++i) {
				if (s[i] == '?')
					++cnt;
				else
					yes += m[s[i]];
			}
			if (s[en] == '?') {
				ans1.push_back((cnt + 1) * m[s[ind - 1]]);
				for (long long i = ind; i <= en; ++i)
					s[i] = s[ind - 1];
				ans2.push_back(m['Z']);
			}
			else if (cnt == 0) {
				ans1.push_back(m[s[en]] - yes);
				if (s[en] == 'Z')
					ans2.push_back(m[s[en]] - yes);
				else
					ans2.push_back(-m[s[en]] - yes);
			}
			else {
				ans1.push_back(m[s[en]] * (cnt + 1) - yes);
				for (long long i = ind; i < en; ++i)
					if (s[i] == '?')
						s[i] = s[en];
				ans2.push_back(m['Z'] * cnt + m[s[en]] - yes);
			}
			blocks.push_back(en);
			ind = en + 1;
		}
		long long summ = 0;
		for (auto i : ans1)
			summ += i;
		vector<long long> ans(ans1.size() + 1);
		ans[0] = summ;
		for (long long i = 0; i < ans1.size(); ++i) {
			summ -= ans1[i];
			ans[i + 1] = summ + ans2[i];
		}
		auto it = max_element(ans.begin(), ans.end());
		if (it == ans.begin()) {
			cout << ans[0] << '\n' << s << '\n';
		}
		else {
			cout << *it << '\n';
			long long en = it - ans.begin();
			for (long long i = 0; i <= blocks[en - 1]; ++i) {
				if (ss[i] == '?')
					cout << 'Z';
				else
					cout << ss[i];
			}
			for (long long i = blocks[en - 1] + 1; i < n; ++i)
				cout << s[i];
			cout << '\n';
		}
	}
}