#pragma GCC target ("avx2")
#pragma GCC optimization ("O3")
#pragma GCC optimization ("unroll-loops")

#include <iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<map>
#include<random>
#include<ctime>

using namespace std;

vector<vector<int>> gr, rgr;
map<pair<int, int>, pair<int, int>> m;
map<pair<int, int>, bool> ex;
vector<int> used;

bool dfs(int u, int p) {
	used[u] = 1;
	vector<pair<int, int>> in, out;
	for (int v : gr[u]) {
		if (used[v])
			continue;
		bool res = dfs(v, u);
		if (!res)
			return false;
		if (ex[{u, v}])
			out.emplace_back(u, v);
		if (ex[{v, u}])
			in.emplace_back(v, u);
	}
	for (int v : rgr[u]) {
		if (used[v])
			continue;
		bool res = dfs(v, u);
		if (!res)
			return false;
		if (ex[{u, v}])
			out.emplace_back(u, v);
		if (ex[{v, u}])
			in.emplace_back(v, u);
	}
	for (int i = 0; i < min(in.size(), out.size()); ++i) {
		m[in[i]] = out[i];
	}
	int temp = min(in.size(), out.size());
	if (in.size() - temp > 1 || in.size() - temp > 0 && !ex[{u, p}])
		return false;
	if (out.size() - temp > 1 || out.size() - temp > 0 && !ex[{p, u}])
		return false;
	if (in.size() - temp > 0) {
		m[in.back()] = { u, p };
		ex[{u, p}] = false;
	}
	if (out.size() - temp > 0) {
		m[out.back()] = { p, u };
		ex[{p, u}] = false;
	}
	return true;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, mm;
	cin >> n >> mm;
	gr.resize(n);
	rgr.resize(n);
	used.resize(n);
	for (int i = 0; i < mm; ++i) {
		int u, v;
		cin >> u >> v;
		--u, --v;
		gr[u].push_back(v);
		rgr[v].push_back(u);
		ex[{u, v}] = true;
	}
	for (int i = 0; i < n; ++i) {
		if (used[i])
			continue;
		if (!dfs(i, -1)) {
			cout << "No";
			return 0;
		}
	}
	cout << "Yes\n";
	for (auto [a, b] : m)
		cout << a.first + 1 << ' ' << a.second + 1 << ' ' << b.first + 1 << ' ' << b.second + 1 << '\n';
}