#include <iostream>
#include<vector>
#include<algorithm>
#include<map>
#include<random>
#include<ctime>
#include <set>

using namespace std;

vector<vector<pair<int, int>>> gr;
vector<int> ans;

void treedfs(int u, int p, int minn, int maxx) {
	ans[u] = minn + maxx;
	for (auto [v, t] : gr[u])
		if (v != p) {
			treedfs(v, u, min(minn, t), max(maxx, t));
		}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	gr.resize(n);
	ans.resize(n);
	for (int i = 0; i < m; ++i) {
		int u, v, t;
		cin >> u >> v >> t;
		--u, --v;
		gr[u].emplace_back(v, t);
		gr[v].emplace_back(u, t);
	}
	if (m == n - 1) {
		treedfs(0, -1, 2e9, -1);
		for (int i = 1; i < n; ++i)
			cout << ans[i] << '\n';
		return 0;
	}
	set<pair<int, int>> s;
	map<int, int> mp;
	s.emplace(0, 0);
	mp[0] = 0;
	for (int i = 1; i < n; ++i) {
		s.emplace(2e9, i);
		mp[i] = 2e9;
	}
	while (!s.empty()) {
		auto [t, u] = *s.begin();
		ans[u] = t;
		s.erase(s.begin());
		for (auto [v, t2] : gr[u]) {
			if (mp[v] > max(t2, t)) {
				s.erase({ mp[v], v });
				mp[v] = max(t2, t);
				s.insert({ mp[v], v });
			}
		}
	}
	for (int i = 1; i < n; ++i)
		cout << ans[i] << '\n';
}