#include <bits/stdc++.h>

#define endl "\n"
using namespace std;

#define double long double
#define int long long

#ifdef int
#define IMIN INT64_MIN
#define IMAX INT64_MAX
#else
#define IMIN INT32_MIN
#define IMAX INT32_MAX
#endif

#ifdef LOCAL
ifstream fin; // NOLINT(cert-err58-cpp)
#define cin fin
#endif

struct rb_t {
    int a, b, t;
    bool is_brg;
};

int tin_timer = 0;

void find_brgs(int v, int p, bool *used, int *tin, int *tup, vector<int> *gr, rb_t *rbs) {
    tin[v] = tup[v] = tin_timer++;
    used[v] = true;
    for (int r : gr[v]) {
        int g = rbs[r].a + rbs[r].b - v;
        if (g == p) {
            p = -1;
            continue;
        }
        if (used[g]) {
            tup[v] = min(tup[v], tin[g]);
            continue;
        }
        find_brgs(g, v, used, tin, tup, gr, rbs);
        tup[v] = min(tup[v], tup[g]);
        if (tup[g] > tin[v]) {
            rbs[r].is_brg = true;
        }
    }
}

struct DSU {
    int *p, *s;

    explicit DSU(int n) {
        p = new int[n];
        s = new int[n];
        for (int i = 0; i < n; i++) {
            p[i] = i;
            s[i] = 1;
        }
    }

    int get(int v) {
        if (v == p[v]) {
            return v;
        }
        return p[v] = get(p[v]);
    }

    void unite(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) {
            return;
        }

        if (s[a] >= s[b]) {
            s[a] += s[b];
            p[b] = a;
            return;
        } else {
            s[b] += s[a];
            p[a] = b;
            return;
        }
    }
};


void dfs(int v, bool *used, int *res, vector<int> *gr, rb_t *rbs) {
    used[v] = true;
    for (int r : gr[v]) {
        int g = rbs[r].a + rbs[r].b - v;
        if (used[g]) {
            continue;
        }
        res[g] = min(res[g], min(res[v], rbs[r].t));
        dfs(g, used, res, gr, rbs);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> gr[n];
    rb_t rbs[m];
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;

        rbs[i] = {.a = a, .b = b, .t = c, .is_brg = false};

        gr[a].push_back(i);
        gr[b].push_back(i);
    }
    int tin[n];
    int tup[n];
    bool used[n];
    memset(used, false, sizeof(used));
    find_brgs(0, -1, used, tin, tup, gr, rbs);
    DSU d(n);
    for (int v = 0; v < n; v++) {
        for (int r : gr[v]) {
            if (!rbs[r].is_brg) {
                d.unite(rbs[r].a, rbs[r].b);
            }
        }
    }

    int cmp_min[n];
    for (int i = 0; i < n; i++) {
        cmp_min[i] = IMAX;
    }
    for (int v = 0; v < n; v++) {
        for (int r : gr[v]) {
            if (!rbs[r].is_brg) {
                cmp_min[d.get(v)] = min(rbs[r].t, cmp_min[d.get(v)]);
            }
        }
    }

    for (int v = 0; v < n; v++) {
        for (int r : gr[v]) {
            if (!rbs[r].is_brg) {
                rbs[r].t = cmp_min[d.get(v)];
            }
        }
    }

    int res[n];
    for (int i = 0; i < n; i++) {
        res[i] = IMAX;
    }
    memset(used, false, sizeof(used));
    dfs(0, used, res, gr, rbs);

//    for (int v = 0; v < n; v++) {
//        for (int r : gr[v]) {
//            if (!rbs[r].is_brg) {
//                res[v] = min(res[v], rbs[r].t);
//            }
//        }
//    }

    for (int i = 1; i < n; i++) {
        cout << res[i] + 1000000000ll << endl;
    }
}

//#define MULTITEST

int32_t main() {
#ifdef LOCAL
    fin.open("in.txt");
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef MULTITEST
    int32_t _t;
    cin >> _t;
    while (_t--)
#endif
    solve();
    return 0;
}
