#include <iostream>
#include <string>
#include <random>
#include <algorithm>

using namespace std;
using pi = pair<int, int>;

auto rswap(int n) {
    mt19937 rng(1337228);
    uniform_int_distribution<int> d(0, n-1);
    vector<pi> res;
    for (int i = n; i < n+17; ++i) {
        res.emplace_back(i, d(rng));
    }
    return res;
}

string compress(string s) {
    int n = s.size();

    if (n == 10) return s+s+s;

    string t = s;
    for (int i = 0; i < 17; ++i) {
        int x = 0;
        for (int j = 0; j < s.size(); j += 1 << i) {
            x ^= s[j] - '0';
        }
        t.push_back('0'+x);
    }

    cerr << " -> " << t << endl;

    auto rs = rswap(n);
    for (auto [i, j] : rs) swap(t[i], t[j]);
    return t;
}

string decompress(string t) {
    int m = t.size();
    if (m == 30) {
        string s(10, '0');
        for (int i = 0; i < 10; ++i) {
            if (t[i]=='1'&&t[i+10]=='1') s[i] = '1';
            if (t[i]=='1'&&t[i+20]=='1') s[i] = '1';
            if (t[i+20]=='1'&&t[i+10]=='1') s[i] = '1';
        }
        return s;
    }

    int n = m - 17;
    auto rs = rswap(n);
    reverse(rs.begin(), rs.end());
    for (auto [i, j] : rs) swap(t[i], t[j]);
    int d = 0;
    string s(n, '0');
    for (int i = 0; i < n; ++i) s[i] = t[i];


    cerr << " -> " << t << endl;

    for (int j = 0; j < 17; ++j) {
        int x = 0;
        for (int i = 0; i < n; i += 1 << j) x ^= t[i] - '0';
        if (x + '0' == t[n+j]) d |= 1 << j;
    }

    if (d < n) s[d] = s[d] == '0' ? '1' : '0';
    return s;
}

int main() { 
    int t; cin >> t;
    string s; cin >> s;
    cout << (t == 1 ? compress(s) : decompress(s)) << endl;
}