#include <bits/stdc++.h>

class bigInt {
private:
    std::vector<int> num;
    bool negative;
public:
    explicit bigInt(std::vector<int> num) : num(std::move(num)), negative(false) {}

    bigInt(std::vector<int> num, const bool &negative) : num(std::move(num)), negative(negative) {}

    bigInt(const std::string &s) {
        int ind = 0;
        if (s[0] == '-') negative = true, ind++;
        else negative = false;
        for (; ind < s.size(); ind++) num.push_back(s[ind] - '0');
    }

    std::vector<int> getNum() const {
        return num;
    }

    bigInt operator+(const bigInt &sec) const;

    bigInt operator-(const bigInt &sec) const;

    bigInt operator-() const {
        bigInt res = *this;
        res.negative ^= 1;
        return res;
    }

    std::string to_string() const {
        std::string res;
        for (auto &i : num) res += i + '0';

        while (res.size() > 1 && res.back() == '0') res.pop_back();
        std::reverse(res.begin(), res.end());
        if (res != "0" && negative) res = "-" + res;
        return res;
    }
};

bigInt bigInt::operator-(const bigInt &sec) const {
    return bigInt(sec);
}

bigInt bigInt::operator+(const bigInt &sec) const {
    bool neg = (negative && sec.negative);
    if (negative && !sec.negative) {
        return sec - *this;
    }
    if (!negative && sec.negative) {
        return *this - sec;
    }

    std::vector<int> ans = sec.getNum();
    ans.resize(std::max(sec.num.size() + 1, num.size() + 1));
    int shift = 0;
    for (int i = 0; i < ans.size(); i++) {
        int first = (i < num.size() ? num[i] : 0);
        int second = (i < sec.num.size() ? sec.num[i] : 0);
        int val = (first + second + shift);
        ans[i] = val % 10;
        shift = val / 10;
    }

    return bigInt(ans, neg);
}

int main() {
    int type;
    std::cin >> type;
    if (type == 1) {
        int n;
        std::cin >> n;
        int l = 1, r = n;
        while (l < r) {
            int mid = (l + r) / 2;
            std::cout << mid << std::endl;
            int res;
            std::cin >> res;
            if (res == 0) {
                l = r = mid;
                return 0;
            }
            if (res == 1) {
                l = mid + 1;
            } else {
                r = mid - 1;
            }
        }
        std::cout << r << std::endl;
        int res;
        std::cin >> res;
        assert(res == 0);
    } else {
        int n;
        std::cin >> n;
        int l = 1, r = n;
        int c;
        std::cin >> c;
        while (c--) {
            int mid = (l + r) / 2;
            int res;
            std::cin >> res;
            if (res == 0) {
                l = r = mid;
                break;
            }
            if (res == 1) {
                l = mid + 1;
            } else {
                r = mid + 1;
            }
        }

        std::cout << r << std::endl;
    }
}
