#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <sstream>
#include <cmath>

using namespace std;

int sum_row(const string &str, const int cols, const int row) {
    int res = 0;

    for (int i = row * cols; i < (row + 1) * cols && i < str.size(); ++i) {
        res += str[i] - '0';
        res %= 2;
    }

    return res;
}

int sum_col(const string &str, const int cols, const int col) {
    int res = 0;

    for (int i = col; i < str.size(); i += cols) {
        res += str[i] - '0';
        res %= 2;
    }

    return res;
}

string extras(string &str) {
    int rows = ceil(sqrt(str.length()));
    int cols = ceil(str.length() * 1.0 / rows);

    string res;

    for (int i = 0; i < rows; ++i) res.append(1, sum_row(str, cols, i) + '0');
    for (int i = 0; i < cols; ++i) res.append(1, sum_col(str, cols, i) + '0');

    int size = str.size() > 10 ? 1000 : 10;

    res.append(size - res.size(), '0');

    return res;
}

string restore(string &str_with_extras_and_errors) {
    int size = str_with_extras_and_errors.size() > 30 ? 1000 : 10;

    string str = str_with_extras_and_errors.substr(0, str_with_extras_and_errors.length() - size);

    auto extras1 = extras(str);
    auto extras = str_with_extras_and_errors.substr(str.length(), extras1.length());

    int rows = ceil(sqrt(str.length()));
    int cols = ceil(str.length() * 1.0 / rows);


    int row_error = -1;
    for (int i = 0; i < rows; ++i)
        if (extras1[i] != extras[i]) {
            row_error = i;
            break;
        }

    int col_error = -1;
    for (int i = rows; i < extras.length(); ++i)
        if (extras1[i] != extras[i]) {
            col_error = i;
            break;
        }

    if (col_error == -1 || row_error == -1) return str;

    int idx_error = row_error * cols + col_error;

    str[idx_error] = (str[idx_error] - '0' + 1) % 2 + '0';

    return str;
}

int main() {
    int mode;
    string str;
    cin >> mode >> str;

    if (mode == 1) cout << str << extras(str) << endl;
    else cout << restore(str) << endl;
}
