#include <iostream>
#include <string>
#include <cmath>

using namespace std;

int sum(const string &str, const int bit_idx) {
    int res = 0;

    for (int i = 0; i < str.size(); ++i) {
        if (((i >> bit_idx) & 1) != 0) continue;

        res += str[i] - '0';
        res %= 2;
    }

    return res;
}

string extras(string &str) {
    string res;

    for (int bit_idx = 0; bit_idx < 17; ++bit_idx) {
        res.append(1, sum(str, bit_idx) + '0');
    }

    res.append(17 - res.size(), '0');

    return res;
}

string restore(string &str_with_extras_and_errors) {
    string str = str_with_extras_and_errors.substr(0, str_with_extras_and_errors.length() - 17);

    auto extras1 = extras(str);
    auto extras = str_with_extras_and_errors.substr(str.length(), extras1.length());

    int errors = 0;
    int error_idx = 0;

    for (int i = 0; i < extras.size(); ++i) {
        if (extras[i] != extras1[i]) {
            ++errors;
            error_idx |= 1 << i;
        }
    }

    if (errors == 0) return str;
    else {
        error_idx = ~error_idx & ((1 << 17) - 1);

        if (error_idx >= str.size()) return str;

        str[error_idx] = (str[error_idx] - '0' + 1) % 2 + '0';
        return str;
    }
}

int main() {
    int mode;
    string str;
    cin >> mode >> str;

    if (mode == 1) cout << str << extras(str) << endl;
    else cout << restore(str) << endl;
}
