#include <bits/stdc++.h>
using namespace std;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

struct node {
    int x, y, sz;
    node * l, * r;
    node() {};
};

node * make_node(int xx) {
    node * ans = new node();
    ans->y = rnd();
    ans->x = xx;
    ans->sz = 1;
    ans->l = nullptr;
    ans->r = nullptr;
    return ans;
}

int get_sz(node * t) {
    if (t == nullptr) return 0;
    return t->sz;
}

void upd(node * t) {
    t->sz = get_sz(t->l) + get_sz(t->r) + 1;
}

node * merge(node * t1, node * t2) {
    if (t1 == nullptr) return t2;
    if (t2 == nullptr) return t1;
    if (t1->y > t2->y) {
        t1->l = merge(t1->l, t2);
        upd(t1);
        return t1;
    }
    else {
        t2->r = merge(t1, t2->r);
        upd(t2);
        return t2;
    }
}

void split(node * t, node * &t1, node * &t2, int x) {
    if (t == nullptr) {
        t1 = nullptr;
        t2 = nullptr;
        return;
    }
    if (get_sz(t->l) < x) {
        split(t->r, t1, t2, x - get_sz(t->l) - 1);
        t->r = t1;
        upd(t);
        t1 = t;
        return;
    }
    else {
        split(t->l, t1, t2, x);
        t->l = t2;
        upd(t);
        t2 = t;
        return;
    }
}

int get_elem(node * t, int x) {
    if (get_sz(t->l) == x) {
        return t->x;
    }
    else if (get_sz(t->l) > x) {
        return get_elem(t->l, x);
    }
    else {
        return get_elem(t->r, x - get_sz(t->l) - 1);
    }
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    node * c = make_node(0);
    int a;
    cin >> a;
    node * d = make_node(a);
    c = merge(c, d);
    cin >> a;
    d = make_node(a);
    c = merge(c, d);
    cout << get_elem(c, 1) + get_elem(c, 2);
}