#include <iostream>
#include <vector>
#include <algorithm>

bool num_less(std::string a, std::string b) {
    if(a.size() != b.size())
        return a.size() < b.size();
    return a < b;
}

std::string add(std::string a, std::string b) {
    std::string res;
    int32_t carry = 0;
    for(int32_t i = 0; i < std::max(a.size(), b.size()); i++) {
        int32_t digit1 = i < a.size() ? a[a.size() - i - 1] - '0' : 0;
        int32_t digit2 = i < b.size() ? b[b.size() - i - 1] - '0' : 0;

        res.push_back('0' + (digit1 + digit2 + carry) % 10);
        carry = (digit1 + digit2 + carry) / 10;
    }
    if(carry)
        res.push_back('1');
    std::reverse(res.begin(), res.end());
    return res;
}

std::string subtract(std::string a, std::string b) {
    std::string res;
    int32_t carry = 0;
    for(int32_t i = 0; i < a.size(); i++) {
        int32_t digit1 = i < a.size() ? a[a.size() - i - 1] - '0' : 0;
        int32_t digit2 = i < b.size() ? b[b.size() - i - 1] - '0' : 0;

        res.push_back('0' + (digit1 - digit2 + carry + 20) % 10);
        if(digit1 - digit2 + carry < 0)
            carry = -1;
        else
            carry = 0;
    }
    if(res.size() > 1) {
        int32_t z_cnt = 0;
        for(int32_t i = res.size() - 1; i > 0; i--)
            if(res[i] == '0')
                z_cnt++;
        res = res.substr(0, res.size() - z_cnt);
    }
    std::reverse(res.begin(), res.end());
    return res;
}

int main() {
    std::string a, b;
    std::cin >> a >> b;

    if(a[0] == '-' && b[0] == '-') {
        std::cout << '-';
        std::cout << add(a.substr(1), b.substr(1));
    } else if(a[0] != '-' && b[0] != '-') {
        std::cout << add(a, b);
    } else {
        if(a[0] == '-') {
            std::string tmp = a;
            a = b;
            b = tmp;
        }
        //now b is negative

        if(num_less(a, b.substr(1))) {
            std::cout << '-';
            std::cout << subtract(b.substr(1), a);
        } else {
            std::cout << subtract(a, b.substr(1));
        }
    }
    return 0;
}
