#pragma GCC optimize("Ofast,fast-math,unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#include <bits/stdc++.h>

template<class T>
std::istream& operator>>(std::istream &in, std::vector<T> &a) {
    for (auto &x : a)
        in >> x;
    return in;
}
template<class T>
std::ostream& operator<<(std::ostream &out, const std::vector<T> &a) {
    for (auto &x : a)
        out << x << " ";
    return out;
}
template<class T, class U>
std::istream& operator>>(std::istream &in, std::pair<T, U> &a) {
    in >> a.first >> a.second;
    return in;
}
template<class T, class U>
std::ostream& operator<<(std::ostream &out, const std::pair<T, U> &a) {
    out >> a.first >> " " >> a.second;
    return out;
}

bool prime(int32_t x) {
    for (int32_t i = 2; i * i <= x; ++i)
        if (x % i == 0)
            return false;
    return true;
}
const int START = 5713, ENDIT = 100000;
const int32_t K = 17, P = 114691;
int G = 2;

bool checkgenerator(int32_t p, int32_t g) {
    std::set<int32_t> s;
    for (int i = 1, lol = 0; lol < K; i = i * G % P, lol++) {
        s.emplace(i);
        s.emplace((2 * p - i) % p);
    }
//    for (auto &x : s)
//        std::cerr<<x<<" ";
//    std::cerr<<std::endl;
    for (int32_t i = 0, cur = START; i < ENDIT; ++i, cur = (cur * g) % p) {
        if (s.count(cur))
            return false;
        s.emplace(cur);
    }
    return true;
}
int root(int p, int x) {
    for (int t = 1; t < p; ++t)
        if ((x * t) % p == 1)
            return t;
        return -1;
}
int aaa = 3333, bbb = root(P, aaa);

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0), std::cout.tie(0);
    std::cerr << (aaa * bbb) % P << std::endl;
    int32_t type;
    std::cin >> type;
    if (type == 1) {
        std::string x;
        std::cin >> x;
        auto n = static_cast<int32_t>(x.size());
        std::vector<int32_t> a(n);
        int64_t lol = 0, cur = START;
        for (int32_t ind = 0; ind < n; ++ind) {
            lol = (lol + cur * (x[ind] - '0')) % P;
            cur = 2 * cur % P;
        }
        std::cerr << lol << std::endl;
        std::cout << x;
        std::cout << std::bitset<K>(lol * aaa % P);
    } else {
        std::string x;
        std::cin >> x;
        std::string to_bitset;
        for (int32_t ind = static_cast<int32_t>(x.size()) - K; ind < static_cast<int32_t>(x.size()); ++ind) {
            to_bitset.push_back(x[ind]);
        }
        int32_t hash = std::bitset<K>(to_bitset).to_ulong() * bbb % P;
        std::cerr << hash << std::endl;
        int32_t n = static_cast<int32_t>(x.size()) - K;
        int64_t lol = 0, cur = START;
        for (int32_t ind = 0; ind < n; ++ind) {
            lol = (lol + cur * (x[ind] - '0')) % P;
            cur = 2 * cur % P;
        }
        x.erase(x.end() - K, x.end());
        if (hash == lol) {
            std::cout << x;
            return 0;
        }
        cur = START;
        for (int32_t ind = 0; ind < n; ++ind, cur = (cur * 2) % P) {
            if (x[ind] == '1') {
                if ((lol - cur + P) % P == hash) {
                    x[ind] = '0';
                    std::cout << x;
                    return 0;
                }
            } else {
                if ((lol + cur + P) % P == hash) {
                    x[ind] = '1';
                    std::cout << x;
                    return 0;
                }
            }
        }
        std::cout << x;
    }
//    for (int i = 1000000000; ; ++i) {
//        if (prime(i) ) {
//            std::cout << i << " : " << checkgenerator(i, 2) << std::endl;
//            if (checkgenerator(i, G))
//                return 0;
//        }
//    }
    return 0;
}
/*
 *
! 100003 : 1
! 100019 : 1
! 100043 : 1
! 100049 : 0
! 100057 : 0
! 100069 : 0

 101723 : 1

00010101011100
0001010101110010111101101111100

 0101010101110010111101101111100
 */