#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

const ll pog = 17;
const ll mod = (1 << pog);
const ll base = 7;

ll add(ll a, ll b) {
  ll c = a + b;
  if (c >= mod) c -= mod;
  return c;
}
ll sub(ll a, ll b) {
  return add(a, mod - b);
}
ll mult(ll a, ll b) {
  return a * b % mod;
}

string convert_to_string(ll x) {
  string s;
  for (int i = 0; i < pog; ++i) {
    s += ('0' + (x % 2));
    x >>= 1;
  }
  return s;
}

ll convert_to_ll(string s) {
  ll rt = 0;
  for (int i = 0; i < pog; ++i)
    if (s[i] == '1')
      rt += (1 << i);
  return rt;
}

ll get_hash(string s) {
  ll H = 0;
  for (int i = 0; i < s.size(); ++i)
    H = (H * base + (s[i] - '0')) % mod;
  return H;
}

const int N = 1e5 + 5;
ll powers[N];

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);

  powers[0] = 1;
  for (int i = 1; i < N; ++i)
    powers[i] = mult(powers[i - 1], base);

  int t;
  cin >> t;
  if (t == 1) {
    string s;
    cin >> s;
    cout << convert_to_string(get_hash(s)) << s;
  } else {
    string in;
    cin >> in;
    string H = in.substr(0, pog);
    string s = in.substr(pog, (int) in.size() - pog);
    ll h = convert_to_ll(H);
    ll hs = get_hash(s);
    int n = s.size();
    for (int i = 0; i < n; ++i) {
      ll hns = hs;
      if (s[i] == '1')
        hns = sub(hns, powers[n - i - 1]);
      else
        hns = add(hns, powers[n - i - 1]);
      if (hns == h) {
        if (s[i] == '1') s[i] = '0';
        else s[i] = '1';
        cout << s;
        return 0;
      }
    }

    for (int i = 0; i < pog; ++i) {
      if (H[i] == '0') H[i] = '1';
      else H[i] = '0';
      ll hns = convert_to_ll(H);
      if (hns == hs) {
        cout << s;
        return 0;
      }
    }
    return 1;
  }

}