#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

ll pog = 27;
const ll mod = (1 << pog);
const ll base = 13;

ll add(ll a, ll b) {
  ll c = a + b;
  if (c >= mod) c -= mod;
  return c;
}
ll sub(ll a, ll b) {
  return add(a, mod - b);
}
ll mult(ll a, ll b) {
  return a * b % mod;
}

string convert_to_string(ll x) {
  string s;
  for (int i = 0; i < pog; ++i) {
    s += ('0' + (x % 2));
    x >>= 1;
  }
  return s;
}

ll convert_to_ll(string s) {
  ll rt = 0;
  for (int i = 0; i < pog; ++i)
    if (s[i] == '1')
      rt += (1 << i);
  return rt;
}

ll get_hash(string s) {
  ll H = 0;
  for (int i = 0; i < s.size(); ++i)
    H = (H * base + (s[i] - '0' + 1)) % mod;
  return H;
}

const int N = 3e5 + 5;
ll powers[N];

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  srand(time(0));

  powers[0] = 1;
  for (int i = 1; i < N; ++i)
    powers[i] = mult(powers[i - 1], base);

  int t;
  cin >> t;
  if (t == 1) {
    string s;
    cin >> s;
    if (s.size() == 10) {
      cout << s << s << s;
      return 0;
    }
    cout << convert_to_string(get_hash(s)) << s;
  } else {
    string in;
    cin >> in;
    if (in.size() == 30) {
      string s = in;
      int n = s.size() / 3;
      string s1 = s.substr(0, n), s2 = s.substr(n, n), s3 = s.substr(2 * n, n);
      if (s1 == s2 || s1 == s3)
        cout << s1;
      else
        cout << s2;
      return 0;
    }
    string H = in.substr(0, pog);
    string s = in.substr(pog, (int) in.size() - pog);
    ll h = convert_to_ll(H);
    ll hs = get_hash(s);
    if (h == hs) {
      cout << s;
      return 0;
    }
    int n = s.size();

    vector<int> anss;
    int cnt = 0;
    for (int i = 0; i < pog; ++i) {
      if (H[i] == '0') H[i] = '1';
      else H[i] = '0';
      ll hns = convert_to_ll(H);
      if (hns == hs) {
        cnt++;
      }
      if (H[i] == '0') H[i] = '1';
      else H[i] = '0';
    }

    for (int i = 0; i < n; ++i) {
      ll hns = hs;
      if (s[i] == '1')
        hns = sub(hns, powers[n - i - 1]);
      else
        hns = add(hns, powers[n - i - 1]);
      if (hns == h) {
        anss.push_back(i);
      }
    }

    bool ok1 = !anss.empty(), ok2 = cnt;
    assert(ok1 || ok2);
//    assert(!ok1 || !ok2);
    if (ok1 && ok2)
      ok1 = false;
    if (ok1) {
      assert(anss.size() == 1);
      int id = anss[rand() % anss.size()];
      if (s[id] == '1') s[id] = '0';
      else s[id] = '1';
      cout << s;
    }
    else if (ok2)
      cout << s;


    return 0;
  }

}