#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,mmx,tune=native")

#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

#define last last227

const int MAX_N = 100 * 1000 + 227;
const int MAX_K = 8;

int n;
vector<int> g[MAX_N];
int num_at[MAX_N];
bool is_leaf[MAX_N];
vector<int> all_coords;
int inf = 0;

struct fast_func {
    vector<int> vals;

    void init_from_cp(const vector<pair<int, int>>& cp, vector<int>& coords) {
        vals.resize(coords.size());
        int ptr = 0;
        for (int i = 0; i < (int)coords.size(); ++i) {
            while (ptr != (int)cp.size() - 1 && coords[i] >= cp[ptr + 1].first) {
                ++ptr;
            }
            vals[i] = cp[ptr].second;
        }

        ptr = 0;
        for (int i = 0; i < (int)vals.size(); ++i) {
            while (ptr < (int)coords.size() && coords[ptr] < vals[i]) {
                ++ptr;
            }
            vals[i] = ptr;
        }
    }
};

struct gg {
    int dp;
    int ls1;
    int ls2;
};

gg mdp[1 << MAX_K][MAX_N];
fast_func fast_f[MAX_N];

struct func {
    vector<int> vals;
    vector<int> on_vals;
    vector<array<int, MAX_K>> best_order;
    vector<pair<int, int>> cp;
    bool is_fake = false;
    const func* real_ptr = nullptr;

    void init_from_leaf(const vector<int>& arr) {
        vals.clear();
        on_vals.clear();
        best_order.clear();
        cp.clear();
        is_fake = false;
        real_ptr = nullptr;

        cp.push_back({0, arr[0]});
        for (int i = 0; i < (int)arr.size() - 1; ++i) {
            cp.push_back({arr[i] + 1, arr[i + 1]});
        }
        cp.push_back({arr.back() + 1, inf});
    }

    vector<int> get_coords() const {
        if (is_fake) {
            return real_ptr->get_coords();
        }

        vector<int> xx;
        vector<int> yy;
        xx.reserve(cp.size());
        yy.reserve(cp.size());
        for (auto& [x, y] : cp) {
            xx.push_back(x);
            yy.push_back(y);
        }

        vector<int> ret;
        ret.resize(xx.size() + yy.size());
        merge(xx.begin(), xx.end(), yy.begin(), yy.end(), ret.begin());
        ret.resize(unique(ret.begin(), ret.end()) - ret.begin());

        return ret;
    }

    void calc_from(const vector<const func*>& arr) {
        if ((int)arr.size() == 1) {
            vals.clear();
            on_vals.clear();
            best_order.clear();
            cp.clear();
            is_fake = true;
            real_ptr = arr[0];
            return;
        }
        is_fake = false;
        real_ptr = nullptr;

        const int k = (int)arr.size();

        on_vals.clear();
        for (const auto* f : arr) {
            vector<int> cr = f->get_coords();
            vector<int> nx_coord(on_vals.size() + cr.size());
            merge(on_vals.begin(), on_vals.end(), cr.begin(), cr.end(), nx_coord.begin());
            nx_coord.resize(unique(nx_coord.begin(), nx_coord.end()) - nx_coord.begin());
            on_vals.swap(nx_coord);
        }

        for (int i = 0; i < k; ++i) {
            fast_f[i].init_from_cp(arr[i]->get_cp(), on_vals);
        }

        const int cur_inf = (int)on_vals.size() - 1;
        for (int i = 0; i < (1 << k); ++i) {
            for (int j = 0; j < (int)on_vals.size(); ++j) {
                if (i == 0) {
                    mdp[i][j] = {j, -1, -1};
                } else {
                    mdp[i][j].dp = cur_inf;
                    for (int nx = 0; nx < k; ++nx) {
                        if ((i >> nx) & 1) {
                            int to_go = fast_f[nx].vals[j];
                            if (mdp[i ^ (1 << nx)][to_go].dp < mdp[i][j].dp) {
                                mdp[i][j].dp = mdp[i ^ (1 << nx)][to_go].dp;
                                mdp[i][j].ls1 = nx;
                                mdp[i][j].ls2 = to_go;
                            }
                        }
                    }
                }
            }
        }

        vals.resize(on_vals.size());
        best_order.resize(on_vals.size());
        for (int i = 0; i < (int)on_vals.size(); ++i) {
            vals[i] = mdp[(1 << k) - 1][i].dp;
            if (vals[i] != cur_inf) {
                int mask = (1 << k) - 1;
                int ptr = i;
                int kptr = 0;
                while (mask) {
                    int nx = mdp[mask][ptr].ls1;
                    int to_go = mdp[mask][ptr].ls2;
                    best_order[i][kptr++] = nx;
                    mask ^= (1 << nx);
                    ptr = to_go;
                }
            }
        }

        cp.clear();
        cp.push_back({on_vals[0], on_vals[vals[0]]});
        for (int i = 1; i < (int)on_vals.size(); ++i) {
            if (vals[i] != vals[i - 1]) {
                cp.push_back({on_vals[i], on_vals[vals[i]]});
            }
        }
    }

    const vector<pair<int, int>>& get_cp() const {
        if (is_fake) {
            return real_ptr->get_cp();
        }

        return cp;
    }

    const array<int, MAX_K>& get_order_at(int x) const {
        if (is_fake) {
            return real_ptr->get_order_at(x);
        }

        for (int i = 1; i < (int)on_vals.size(); ++i) {
            if (x < on_vals[i]) {
                return best_order[i - 1];
            }
        }
        assert(false);
    }

    int get_at(int x) const {
        if (is_fake) {
            return real_ptr->get_at(x);
        }

        if ((int)cp.size() == 1) {
            return cp[0].second;
        }
        for (int i = 1; i < (int)cp.size(); ++i) {
            if (x < cp[i].first) {
                return cp[i - 1].second;
            }
        }
        assert(false);
    }
};

func dp[MAX_N];

void dfs(int v) {
    if (is_leaf[v]) {
        dp[v].init_from_leaf(g[v]);
    } else {
        vector<const func*> arr;
        for (int u : g[v]) {
            dfs(u);
            arr.emplace_back(&dp[u]);
        }

        dp[v].calc_from(arr);
    }
}

void dfs_restore(int v, int from) {
    if (is_leaf[v]) {
        num_at[v] = -1;
        for (int x : g[v]) {
            if (x >= from) {
                num_at[v] = x;
                break;
            }
        }
    } else if (dp[v].is_fake) {
        dfs_restore(g[v][0], from);
    } else {
        const array<int, MAX_K>& p = dp[v].get_order_at(from);

        vector<int> new_ch(g[v].size());
        for (int i = 0; i < (int)g[v].size(); ++i) {
            new_ch[i] = g[v][p[i]];
        }
        g[v].swap(new_ch);

        for (int i = 0; i < (int)g[v].size(); ++i) {
            dfs_restore(g[v][i], from);
            from = dp[g[v][i]].get_at(from);
        }
    }
}

void solve() {
    scanf("%d", &n);
    all_coords.clear();
    for (int i = 0; i < n; ++i) {
        int type, sz;
        scanf("%d%d", &type, &sz);
        is_leaf[i] = (type == 2);
        g[i].resize(sz);
        for (int j = 0; j < sz; ++j) {
            scanf("%d", &g[i][j]);
            if (is_leaf[i]) {
                all_coords.push_back(g[i][j]);
            } else {
                --g[i][j];
            }
        }
    }

    all_coords.push_back(-INF);
    all_coords.push_back(INF);
    sort(all_coords.begin(), all_coords.end());
    all_coords.resize(unique(all_coords.begin(), all_coords.end()) - all_coords.begin());
    inf = (int)all_coords.size() - 1;

    for (int i = 0; i < n; ++i) {
        if (is_leaf[i]) {
            for (int j = 0; j < (int)g[i].size(); ++j) {
                g[i][j] = lower_bound(all_coords.begin(), all_coords.end(), g[i][j]) - all_coords.begin();
            }
        }
        sort(g[i].begin(), g[i].end());
        g[i].resize(unique(g[i].begin(), g[i].end()) - g[i].begin());
    }

    dfs(0);
    if (dp[0].get_at(0) == inf) {
        printf("No\n");
        return;
    }

    dfs_restore(0, 0);
    printf("Yes\n");
    for (int i = 0; i < n; ++i) {
        if (is_leaf[i]) {
            printf("%d\n", all_coords[num_at[i]]);
        } else {
            for (int j = 0; j < (int)g[i].size(); ++j) {
                printf("%d%c", g[i][j] + 1, " \n"[j == (int)g[i].size() - 1]);
            }
        }
    }
}

int main() {
#ifdef CH_EGOR
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#else
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
#endif

    int t = 1;
    while (t--) {
        solve();
    }

    return 0;
}
